'use strict';

const cmnAsync = {};

const cmnlocDetails = {
  full_hostname:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    location.pathname,
  partial_hostname:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : ''),
  partial_homefolder:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/' +
    location.pathname.split('/')[1] +
    '/',
  service:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/',
  nlcservice:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/nlc/v1/models/',
  nluservice:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/nlu/v1/models/',
  analyticservice:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/analytics/',
  lexiconservice:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/lexicon/',
  voiceaudservice:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/voicemodel/',
  discoveryservice:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/discovery/',
  discoveryservicetemp:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/lexicon/',
  discoverymodel:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/discoverymodel/',
  batchjob:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/SIFSModelServices/job/',
  dicoveryEntity:
    location.protocol +
    '//' +
    location.hostname +
    (location.port ? ':' + location.port : '') +
    '/dicoveryEntity/'
};

const cmnFunc = {};
cmnAsync.asynccall = function(obj) {
  let jrquest,
    asyncVal,
    param = obj.param ? obj.param : null,
    refObj = {
      url: obj.url,
      async: false,
      headers: {
        // 'Access-Control-Allow-Origin': '*',
        'content-type': 'application/json'
      },
      success: function(data, statusResponse, responseObject) {
        cmnFunc.tokenHeader = responseObject.getResponseHeader(
          'x-access-token'
        );
        if (obj.func && obj.ref) {
          if (param != null) {
            obj.ref[obj.func].apply(obj.ref, [data, param]);
          } else {
            obj.ref[obj.func].apply(obj.ref, [data]);
          }
        } else if (obj.func) {
          if (param != null) {
            obj.func.apply(obj.ref, [data, param]);
          } else {
            obj.func.apply(obj.ref, [data]);
          }
        }

        jrquest = data;
      },
      error: function(error) {
        cmnFunc.tokenHeader = error.getResponseHeader('x-access-token');
        if (obj.func && obj.ref) {
          if (param != null) {
            obj.ref[obj.func].apply(obj.ref, [error, param]);
          } else {
            obj.ref[obj.func].apply(obj.ref, [error]);
          }
        } else if (obj.func) {
          if (param != null) {
            obj.func.apply(obj.ref, [error, param]);
          } else {
            obj.func.apply(obj.ref, [error]);
          }
        }
      }
    };
  if (obj.func) {
    refObj.async = true;
  }
  if (obj.dataType) {
    refObj.dataType = obj.dataType;
  }
  if (obj.data) {
    refObj.data = obj.data;
  }
  if (obj.type.toUpperCase() == 'GET') {
    refObj.type = 'GET';
    $.ajax(refObj);
    return jrquest;
  } else if (obj.type.toUpperCase() == 'POST') {
    refObj.type = 'POST';
    $.ajax(refObj);
  } else if (obj.type.toUpperCase() == 'PUT') {
    refObj.type = 'PUT';
    $.ajax(refObj);
  } else if (obj.type.toUpperCase() == 'DELETE') {
    refObj.type = 'DELETE';
    $.ajax(refObj);
  } else {
    return false;
  }
};
/*******common func starts Here *************/

cmnFunc.dtFormatter = function(refObj) {
  let date = refObj.date,
    dr = refObj.delimiter,
    yr,
    mn,
    mnVal,
    dt;
  yr = date.split(dr)[2];
  mnVal = date.split(dr)[0];
  if (refObj.noMod) {
    mn = mnVal;
  } else {
    mn = mnVal == '01' ? 0 : mnVal - 1;
  }

  dt = date.split(dr)[1];
  return new Date(yr, mn, dt);
};

cmnFunc.addEventListeners = function(objNode) {
  let param = objNode.params ? objNode.params : null;
  $(objNode.node).on(objNode.listener, function(eve) {
    eve.stopPropagation();
    if (objNode.ref && objNode.func) {
      if (param != null) {
        objNode.ref[objNode.func].apply(objNode.ref, [param, eve]);
      } else {
        objNode.ref[objNode.func].apply(objNode.ref, [eve]);
      }
    } else if (objNode.func) {
      objNode.func.apply(null, [eve, param]);
    }
  });
};
cmnFunc.createDmNode = function(objNode) {
  let resultNode;
  resultNode = $('<' + objNode.node + '>');
  if (objNode.attr) {
    for (let i = 0; i < objNode.attr.length; i++) {
      resultNode.attr(objNode.attr[i].node, objNode.attr[i].value);
    }
  }
  if (objNode.html) {
    resultNode.html(objNode.html);
  }
  if (objNode.appendTo) {
    resultNode.appendTo(objNode.appendTo);
  }
  return resultNode;
};
cmnFunc.createElemnt = function(elmNode) {
  let elm;
  elm = $('<' + elmNode.node + '/>');
  if (elmNode.attr) {
    for (let i = 0; i < elmNode.attr.length; i++) {
      elm.attr(elmNode.attr[i].node, elmNode.attr[i].value);
    }
  }
  if (elmNode.appendTo) {
    elm.appendTo(elmNode.appendTo);
  }
  return elm;
};
cmnFunc.getQueryParameters = function(str) {
  return (str || document.location.search)
    .replace(/(^\?)/, '')
    .split('&')
    .map(
      function(n) {
        return (n = n.split('=')), (this[n[0]] = n[1]), this;
      }.bind({})
    )[0];
};

cmnFunc.errorDialog = function() {
  let outerDiv = cmnFunc.createDmNode({ node: 'div' });
  let newDiv = cmnFunc.createDmNode({ node: 'div' });
  let btnNode = cmnFunc.createDmNode({ node: 'button' });
  btnNode.addClass('popUpBtn');
  btnNode.html('Return');
  btnNode.on('click', function() {
    window.history.back();
  });
  outerDiv.addClass('mdldialog');
  newDiv.html("<p>Record doesn't Exist</p>");
  newDiv.appendTo(outerDiv);
  btnNode.appendTo(newDiv);
  outerDiv.appendTo($('body'));
  //$(newDiv).dialog({modal:false});
};

cmnFunc.trncEllipsis = function(d, lnNode) {
  let len = lnNode ? lnNode : 50;
  if (d.length > len) return d.substring(0, len) + '...';
  else return d;
};
/*Notes Func Ends Here */
/*Vaidator*/
cmnFunc.dateValidator = function(format, date) {
  let result;
  try {
    $.datepicker.parseDate(format, date);
    result = true;
  } catch (exp) {
    result = false;
  }
  return result;
};
(cmnFunc.validateMdlDtls = function(l) {
  let result = [],
    k = Object(l).keys;
  for (let prop in l) {
    if (l[prop] != '') {
      result.push(true);
    } else {
      result.push(false);
    }
  }

  return result.indexOf(false) > -1 ? false : true;
}),
  (cmnFunc.fieldValidator = function(obj) {
    //let result;
    if (obj.required) {
      if (
        obj.node.val() != '' &&
        obj.node.val() != 'null' &&
        obj.node.val() != 'undefined'
      ) {
        return true;
      }
      return false;
    }
    return true;
    //return result;
  });
cmnFunc.convertNotesTime = function(objdt) {
  var dt = new Date(objdt);
  var month = [
    'Jan',
    'Feb',
    'Mar',
    'Apr',
    'May',
    'Jun',
    'Jul',
    'Aug',
    'Sep',
    'Oct',
    'Nov',
    'Dec'
  ];
  var date_str = '';
  var n = month[dt.getMonth()];
  date_str = n + ' ' + dt.getDate() + ', ' + dt.getFullYear();
  let h = dt.getHours();
  let mi = dt.getMinutes();
  let t =
    (h > 12 ? h - 12 : h) +
    ':' +
    (mi > 9 ? mi : '0' + mi) +
    ' ' +
    (h >= 12 ? 'PM' : 'AM');
  return date_str + ' ' + t;
};
/*cookie related stuff*/
cmnFunc.setCookie = function(cname, cvalue, exdays) {
  var d = new Date();
  d.setTime(d.getTime() + exdays * 24 * 60 * 60 * 1000);
  var expires = 'expires=' + d.toUTCString();
  document.cookie = cname + '=' + cvalue + ';' + expires + ';path=/';
};
cmnFunc.getCookie = function(nm) {
  var name = nm + '=';
  var ca = document.cookie.split(';');
  for (var i = 0; i < ca.length; i++) {
    var c = ca[i];
    while (c.charAt(0) == ' ') {
      c = c.substring(1);
    }
    if (c.indexOf(name) == 0) {
      return c.substring(name.length, c.length);
    }
  }
  return '';
};
cmnFunc.clrCookies = function() {
  var cookies = document.cookie.split(';');
  for (var i = 0; i < cookies.length; i++) {
    var spcook = cookies[i].split('=');
    cmnFunc.deleteCookie(spcook[0]);
  }
};
cmnFunc.deleteCookie = function(n) {
  var d = new Date();
  d.setDate(d.getDate() - 1);
  var expires = ';expires=' + d;
  var name = n;
  var value = '';
  document.cookie = name + '=' + value + expires + '; path=/';
};
String.prototype.capitalize = function() {
  return this.charAt(0).toUpperCase() + this.slice(1);
};
cmnFunc.inactivityTimeout = function() {
  let _sc = 0;
  document.onclick = function() {
    _sc = 0;
  };
  document.onmousemove = function() {
    _sc = 0;
  };
  document.onkeypress = function() {
    _sc = 0;
  };

  var myInterval = window.setInterval(function() {
    _sc++;
    if (_sc > 13) {
      logOutfunc.cnfrmLogout();
    }
  }, 1000 * 60 * 60);
};
/**locale info**/
$(document).ready(function() {
  cmnFunc.inactivityTimeout();
});
/******common func ends here **************/
