const adminMdl = {};
adminMdl.init = function() {
    header.init("adm-adv-hdrcnt");
    adminMdl.initEvnts();
    adminMdl.getAllList();

}
adminMdl.loader = $("#cover-spin");
adminMdl.initEvnts = function() {
    $("#adm-stopAll").on("click", function(evt) {
        evt.stopPropagation();
        adminMdl.loader.removeClass("hide");
        adminMdl.stopAllJobs().done((res) => {
            adminMdl.loader.addClass("hide");
            cmnFunc.stsdialog(res.message);
            adminMdl.getAllList();
        }).fail((res) => {
            adminMdl.loader.addClass("hide");
            if (res.responseJSON.error) {
                cmnFunc.stsdialog(res.responseJSON.error);
            }
            console.log(`API FAILURE - ${res.statusText} - ${res.responseText}`)
        });
    });
}
adminMdl.locDetails = function() {
    adminMdl.init();
}
adminMdl.tableGen = function(obj) {
    if (obj.length > 0) {
        $("#adminTblCntr").removeClass("hide");
        $("#adminCmntCntr").addClass("hide");
    } else {
        $("#adminTblCntr").addClass("hide");
        $("#adminCmntCntr").removeClass("hide");
    }
    var obj = {
        tblId: 'adminJobDetail',
        pagination: {
            node: 'pageCmpnnt',
            'recPerPg': 10
        },
        dataObj: obj,
        tblObj: {
            headerObj: [{
                    field: "Job Name",
                    sortFld: {
                        field: "name"
                    }
                },
                {
                    field: "Description",
                    sortFld: {
                        field: "description"

                    }
                },
                {
                    field: "Actions"
                }
            ],
            tbdyobj: [{
                    field: "name",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "description",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "",
                    format: function(fld, data, obj) {
                        let start, stop, status,
                            argFlag = (obj.arguments == "Y") ? true : false;
                        fld.attr('data-jobid', obj.id);
                        start = adminMdl.genBtn({ html: "Start", node: fld });
                        stop = adminMdl.genBtn({ html: "Stop", node: fld });
                        status = adminMdl.genBtn({ html: "Status", node: fld });
                        adminMdl.getJobProgress({ "classname": { "classname": obj.classname }, "start": start, "stop": stop, "status": status });
                        /** Click Events **/
                        $(start).on("click", function(evt) {
                            // adminMdl.loader.removeClass("hide");
                            evt.stopPropagation();
                            if (argFlag) {
                                adminMdl.aMntDlg(obj, start, stop, status);
                            } else {
                                let o = { "path": obj.path, "job": obj.id };
                                adminMdl.loader.removeClass("hide");
                                adminMdl.startJob(o).done((res) => {
                                    adminMdl.loader.addClass("hide");
                                    adminMdl.enbdisBtn({
                                        "enable": [stop, status],
                                        "disable": [start]
                                    });
                                    cmnFunc.stsdialog(res.message);
                                }).fail((res) => {
                                    adminMdl.loader.addClass("hide");
                                    if (res.responseJSON.error) {
                                        cmnFunc.stsdialog(res.responseJSON.error);
                                    }
                                    console.log(`API FAILURE - ${res.statusText} - ${res.responseText}`)
                                });
                            }


                        });
                        $(stop).on("click", function(evt) {
                            evt.stopPropagation();
                            adminMdl.loader.removeClass("hide");
                            let o = { "classname": obj.classname };
                            adminMdl.stopJob(o).done((res) => {
                                adminMdl.loader.addClass("hide");
                                cmnFunc.stsdialog(res.message);
                                adminMdl.enbdisBtn({
                                    "enable": [start, status],
                                    "disable": [stop]
                                });
                            }).fail((res) => {
                                adminMdl.loader.addClass("hide");
                                //adminMdl.procDataObj([]);
                                if (res.responseJSON.error) {
                                    cmnFunc.stsdialog(res.responseJSON.error);
                                }
                                console.log(`API FAILURE - ${res.statusText} - ${res.responseText}`)
                            });
                        });
                        $(status).on("click", function(evt) {
                            evt.stopPropagation();
                            adminMdl.loader.removeClass("hide");
                            let o = { "classname": obj.classname };
                            adminMdl.jobProgress(o).done((res) => {
                                adminMdl.loader.addClass("hide");
                                let result = res.appid.join(",");
                                cmnFunc.stsdialog((result.length > 0) ? "Job is running" : "Job is not running");
                                // adminMdl.tableGen(adminMdl.procDataObj(res));
                            }).fail((res) => {
                                adminMdl.loader.addClass("hide");
                                // adminMdl.procDataObj([]);
                                if (res.responseJSON.error) {
                                    cmnFunc.stsdialog(res.responseJSON.error);
                                }

                                console.log(`API FAILURE - ${res.statusText} - ${res.responseText}`)
                            });
                        });
                        /** Click Events **/
                        return fld;
                    }
                }

            ],
            trRowClickFunc: function(tr, obj) {}
        }
    }
    tableFunc.create(obj);
}
adminMdl.enbdisBtn = function(obj = { "eanble": [], "disable": [] }) {
    for (let i = 0; i < obj.enable.length; i++) {
        let n, o = obj.enable[i];
        if (o == null) {
            continue;
        }
        n = $(o);
        if (n.length > 0) {
            n.prop("disabled", false);
        }
    }
    for (let i = 0; i < obj.disable.length; i++) {
        let n, o = obj.disable[i];
        if (o == null) {
            continue;
        }
        n = $(o);
        if (n.length > 0) {
            n.prop("disabled", true);
        }
    }
}
adminMdl.getAllList = function() {
    adminMdl.listAllJobs().done((res) => {
        adminMdl.tableGen(adminMdl.procDataObj(res));
    }).fail((res) => {
        adminMdl.procDataObj([]);
        console.log(`API FAILURE - ${res.statusText} - ${res.responseText}`)
    });
}
adminMdl.procDataObj = function(data) {
    adminMdl.data = data;
    let d = $.extend(true, [], data),
        res = [];
    $.each(d, function(index, node) {
        $.each(Object.keys(node), function(ind, nd) {
            d[index][nd]["id"] = nd;
            res.push(d[index][nd]);
        });
    });
    return res;
}
adminMdl.genBtn = function(btnObj) {
    let b = cmnFunc.createDmNode({
        node: "button",
        html: btnObj.html,
        attr: [{
            node: "class",
            value: "priButton"
        }, {
            node: "disabled",
            value: true
        }],
        appendTo: btnObj.node
    });
    return b;
}
adminMdl.getJobProgress = function(o) {
    adminMdl.jobProgress(o.classname).done((res) => {
        let result = res.appid.join(",");
        (result.length > 0) ? adminMdl.enbdisBtn({
            "enable": [o.stop, o.status],
            "disable": [o.start]
        }): adminMdl.enbdisBtn({
            "enable": [o.start, o.status],
            "disable": [o.stop]
        });

    }).fail((res) => {
        adminMdl.enbdisBtn({
            "enable": [o.stop, o.status, o.start],
            "disable": []
        });

        console.log(`API FAILURE - ${res.statusText} - ${res.responseText}`)
    });
}
adminMdl.aMntDlg = function(obj, start, stop, status) {

    let inCntr = 0,
        ndcntr, temp = "<div class=\"modal argMdl\" id=\"argMdl\"><div class=\"modal-content\">" +
        "<div class=\"title\">" +
        "<h2>Provide Arguments for Job Start</h2>" +
        "</div><div class=\"errHldr hide\">Fields can't be Empty</div>" +
        "<div class=\"admin-argCntr\">" +
        "<div class=\"row\">" +
        "<div class=\"col-sm-2 lblHldr\"><label>Arguments:</label></div>" +
        "<div class=\"col-sm-8 \"><div id=\"admnInpuCntr\"></div></div>" +
        "<div class=\"col-sm-2\"><span class=\"glyphicon glyphicon-plus admplus\"></span></div>" +
        "</div>" +
        "<div class=\"adminButtonSec\">" +
        "<button id=\"adminCancel\" class=\"secButton\">Cancel</button>" +
        "<button id=\"adminSubmit\" class=\"priButton\">Submit</button>" +
        "</div>" +
        "</div></div></div>";
    $(temp).appendTo($("body"));
    ndcntr = $("#admnInpuCntr");
    adminMdl.createInputElem(ndcntr);
    //Events
    $("#adminCancel").on("click", function(evt) {
        $("#argMdl").remove();
    });
    $("#adminSubmit").on("click", function(evt) {
        let valStatus = adminMdl.validateArvFlds();
        if (valStatus.indexOf(false) > -1) {
            return false;
        }
        let o = { "path": obj.path, "job": obj.id, "args": valStatus };
        adminMdl.loader.removeClass("hide");
        adminMdl.startJob(o).done((res) => {
            $("#argMdl").remove();
            adminMdl.loader.addClass("hide");
            adminMdl.enbdisBtn({
                "enable": [stop, status],
                "disable": [start]
            });
            cmnFunc.stsdialog(res.message);
        }).fail((res) => {
            adminMdl.loader.addClass("hide");
            if (res.responseJSON.error) {
                cmnFunc.stsdialog(res.responseJSON.error);
            }
            console.log(`API FAILURE - ${res.statusText} - ${res.responseText}`)
        });

    });
    $(".admplus").on("click", function(evt) {
        let flg = true;
        $.each($(".adminInFLd"), function(index, node) {
            if ($(node).val().trim() == "") {
                flg = false;
                $(node).addClass("errFld");
                return false;
            }
        });
        if (!flg) {
            return false;
        }
        if (inCntr == 10) {
            $(".admplus").css("pointer-events", "none");
            return false;
        }
        adminMdl.createInputElem(ndcntr);
        inCntr++;
    });
    $("#argMdl").css("display", "block");
}
adminMdl.validateArvFlds = function() {
    let flg = [];
    $.each($(".adminInFLd"), function(index, node) {
        if ($(node).val().trim() == "") {
            flg.push(false);
            $(node).addClass("errFld");
            return false;
        } else {
            flg.push($(node).val().trim());
        }
    });
    return flg;
}
adminMdl.createInputElem = function(pNode) {
    let node;
    node = cmnFunc.createElemnt({
        node: "input",
        attr: [{
            node: "type",
            value: "text"
        }, {
            node: "class",
            value: "form-control inputTxt adminInFLd"
        }, {
            node: "placeholder",
            value: "Please enter arguments"
        }],
        appendTo: pNode
    });
    $(node).focus(function() {
        if ($(this).hasClass("errFld")) {
            $(this).removeClass("errFld");
        }
    });
    $(node).blur(function() {
        if ($(this).val().trim() == "") {
            $(this).addClass("errFld");
            $(".admplus").css("pointer-events", "none");
        } else {
            if ($(".errFld").length > 0) {
                $(".admplus").css("pointer-events", "none");
            } else {
                $(".admplus").css("pointer-events", "");
            }

        }
    });
    return node;
}

/** Ajax calls Section Starts **/
adminMdl.listAllJobs = function() {
    return $.ajax({
        url: cmnlocDetails.jobService + "list/all",
        type: 'GET',
        contentType: 'application/json'
    });
}
adminMdl.startJob = function(postData) {
    return $.ajax({
        type: 'POST',
        url: cmnlocDetails.jobService + "start",
        data: JSON.stringify(postData),
        contentType: 'application/json'
    });
}
adminMdl.stopJob = function(postData) {
    return $.ajax({
        type: 'POST',
        url: cmnlocDetails.jobService + "stop",
        data: JSON.stringify(postData),
        contentType: 'application/json'
    });
}
adminMdl.stopAllJobs = function() {
    return $.ajax({
        type: 'POST',
        url: cmnlocDetails.jobService + "stop/all",
        contentType: 'application/json'
    });
}
adminMdl.jobProgress = function(postData) {
        return $.ajax({
            type: 'POST',
            url: cmnlocDetails.jobService + "running",
            data: JSON.stringify(postData),
            contentType: 'application/json'
        });
    }
    /** Ajax calls Section Ends **/
$(document).ready(function() {
    cmnFunc.localeStr({ ref: adminMdl, func: "locDetails" });
});