/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const alertOvrView = {
    dataObj: {},
    storeVal: {},
    alert: {},
    tst: {}
};

let SELECTED_NODE_FILTER = null; //select node for filtering graph

$(document).ready(function () {
    cmnFunc.localeStr({
        ref: alertOvrView,
        func: "initDtObj"
    });
});

/*******alertOverview Starts Here *************/
alertOvrView.initDtObj = function (data, l) {
    alertOvrView.lc = data;
    autoHeader.generate('mnuOverView');
    alertOvrView.fillLoc(data);
    alertOvrView.alert = cmnFunc.getQueryParameters();
    let urlref = cmnlocDetails.alertOvrSrvc + alertOvrView.alert.alertid;
    //let urlref = cmnlocDetails.partial_homefolder + "alert/json/ecomm.json";
    //urlref = "http://localhost:8888/surveillance/alert/test.json";
    let objRef = {
        type: "GET",
        url: urlref,
        dataType: "json",
        ref: alertOvrView,
        func: "asyncData"
    };
    cmnAsync.asynccall(objRef);

}
alertOvrView.fillLoc = function (d) {
    let s = [{
        id: "alrtRsngGrph",
        txt: d.reasoningGrph.replace(/ /g, '\u00a0')
    }, {
        id: "noscore",
        txt: d.noScoreC
    }, {
        id: "alrtLow",
        txt: d.lowC
    }, {
        id: "alrtMedium",
        txt: d.mediumC
    },
    {
        id: "alrtHgh",
        txt: d.highC
    }, {
        id: "alrtEvd",
        txt: d.evidence
    }, {
        id: "alrtCmntCntr",
        txt: d.nrecordavl
    }
    ],
        lbl = [{
            id: "alrt-strtDt",
            txt: d.startdt.replace(/ /g, '\u00a0')
        }, {
            id: "alrt-endDt",
            txt: d.enddt.replace(/ /g, '\u00a0')
        }];
    for (let i = 0; i < s.length; i++) {
        cmnFunc.fillIdNode(s[i]);
    }
    for (let i = 0; i < lbl.length; i++) {
        cmnFunc.fillLblNode(lbl[i]);
    }
}
alertOvrView.convertNotesTime = function (objdt) {
    var dt = new Date(objdt);
    var month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var date_str = "";
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    let h = dt.getHours();
    let mi = dt.getMinutes();
    let sec = dt.getSeconds();
    let t = (h + ":" + ((mi > 9) ? mi : "0" + mi) + ":" + ((sec > 9) ? sec : "0" + sec));
    return date_str + " " + t;
}
alertOvrView.initEvts = function (obj) {

    let startdate = obj.alert.startdate;
    let enddate = obj.alert.enddate;

    $("#alrt-endDt").datepicker({
        beforeShow: function (input, inst) {
            $('#ui-datepicker-div').addClass("alrtDtpick");
        },
        minDate: new Date(startdate),
        maxDate: new Date(enddate),
        onSelect: function (val) {
            $(this).prop('data-val', val);
            $(this).val(cmnFunc.convertNotesDate(val));
            let count = 0;
            let date = val;

            alertOvrView.clearInterval();
            alertOvrView.updateSlider();
            alertOvrView.loadTimePeriodData();
        }

    }).attr('readonly', 'readonly');
    $("#alrt-endDt").prop('data-val', enddate);
    $("#alrt-endDt").val(cmnFunc.convertNotesDate(enddate));
    $('#alrt-strtDt').datepicker({
        beforeShow: function (input, inst) {
            $('#ui-datepicker-div').addClass("alrtDtpick");
        },
        minDate: new Date(startdate),
        maxDate: new Date(enddate),
        onSelect: function (val) {
            $(this).prop('data-val', val);
            $(this).val(cmnFunc.convertNotesDate(val));

            alertOvrView.clearInterval();
            alertOvrView.updateSlider();
            alertOvrView.loadTimePeriodData();
        }

    }).attr('readonly', 'readonly');
    $("#alrt-strtDt").prop('data-val', startdate);
    $("#alrt-strtDt").val(cmnFunc.convertNotesDate(startdate));

    //set action for play pause
    $("#alrtSlPly").on("click", function () {
        if (!$("#alrtSlPly").hasClass('disabled')) {
            $("#alrtSlPly").addClass("hide");
            $("#alrtSlPau").removeClass("hide");
            alertOvrView.sliderControl();
        }
    });
    $("#alrtSlPau").on("click", function () {
        $("#alrtSlPly").removeClass("hide");
        $("#alrtSlPau").addClass("hide");
        alertOvrView.clearInterval();
    });

    //initial sliderdata
    alertOvrView.sliderData();
}
alertOvrView.clearInterval = function () {
    if (alertOvrView.storeVal.intrvlVal) {
        clearInterval(alertOvrView.storeVal.intrvlVal);
    }
    $("#alrtSlPly").removeClass("hide");
    $("#alrtSlPau").addClass("hide");
}
alertOvrView.chrtTblGen = function (d) {
    SELECTED_NODE_FILTER = d; //set the current selected node

    let selectedDate, stusNod, stsubNd, resNode = $("#alrtSlRes");
    if ($("#alrtFltId").length > 0) {
        $("#alrtFltId").remove();
    }
    stusNode = cmnFunc.createDmNode({
        node: "span",
        attr: [{
            node: "class",
            value: "cmnStCnt"
        }, {
            node: "id",
            value: "alrtFltId"
        }],
        html: d.name,
        appendTo: $("#alrtFltrSec")
    });

    if (resNode.html() != "") {
        selectedDate = resNode.attr("data-val");
    }

    let dtarray = [];
    let startDate = $('#alrt-strtDt').prop("data-val");
    let typRes = JSON.parse(sessionStorage.getItem("alertMetaData"));
    let childNodeList = alertOvrView.getLevelThreeId(d);
    alertOvrView.dataObj.alert.evidences.forEach(function (evidence) {
        childNodeList.forEach(function (childNode, i) {
            /**Fix for front running defect. will remove once backend is corrected. */
            if (selectedDate && typRes.alert.type.toLowerCase() != "frontrunning") {
                let evdDt = new Date(evidence.date).getTime(),
                    startTm = new Date(startDate).getTime(),
                    selTm = new Date(selectedDate).getTime();
                if (evdDt >= startTm && evdDt <= selTm &&
                    evidence.riskindicatorid == childNode.id) {
                    dtarray.push(evidence);
                }
            } else {
                if (evidence.riskindicatorid == childNode.id) {
                    dtarray.push(evidence);
                }
            }

        });
    });

    alertOvrView.dynTblData({
        data: dtarray
    }, false);
}


//get level 3 children id
alertOvrView.getLevelThreeId = function (obj) {
    var idList = new Array();

    function traverseTree(obj) {
        if (obj.parents.length > 0) {
            for (var i = 0; i < obj.parents.length; i++) {
                alertOvrView.dataObj.reasoning.network.nodes.forEach(function (d, e) {
                    if (obj.parents[i] == d.id) {
                        traverseTree(d);
                    }
                });
            }
        } else {
            idList.push(obj);
        }
    }
    traverseTree(obj);
    return idList;
}

//get all child nodes for parent node
alertOvrView.getAllChildNodes = function (obj) {
    var childList = new Array();

    function traverseTree(obj) {
        if (obj.parents.length > 0) {
            childList = childList.concat(obj.parents);
            for (var i = 0; i < obj.parents.length; i++) {
                alertOvrView.dataObj.reasoning.network.nodes.forEach(function (d, e) {
                    if (obj.parents[i] == d.id) {
                        traverseTree(d);
                    }
                });
            }
        }
    }

    traverseTree(obj);
    return childList;
}
alertOvrView.sliderData = function () {
    let _t = alertOvrView.storeVal;
    //if (_t.resultArr === undefined || (_t.resultArr && _t.resultArr.length == 0)) {
    _t.startDt = $('#alrt-strtDt').val();
    _t.endDt = $("#alrt-endDt").val();

    _t.rData = $.extend(true, {}, alertOvrView.dataObj.reasoning);
    _t.dataMap = alertOvrView.genResponseObj(_t.rData.evidence);
    _t.dataMapArr = _t.dataMap.keys();
    _t.dtVal = alertOvrView.genDtRange(_t);
    _t.intrvlVal = 0;
    _t.currDtVal = $("#alrtRundt");
    _t.sliderNode = $("#slider .sliderComp");
    _t.sliderDtFld = $("#alrtSlRes");
    _t.refIndex = 1;

    //generate timeline circle
    alertOvrView.createTimeLine(_t.dtVal);

    alertOvrView.updatePlayPauseStatus();
}
alertOvrView.sliderControl = function () {
    let _t = alertOvrView.storeVal;

    if (_t.refIndex == 1) {
        alertOvrView.updateSlider();
        alertOvrView.resetTimeline();
        NodeGraph.zeroLevel();
        alertOvrView.dynTblData({
            data: []
        });
    } else {
        alertOvrView.animateSlider(); //animate initial
    }

    _t.intrvlVal = setInterval(function () {
        if (_t.refIndex <= _t.dtVal.length) {
            alertOvrView.animateSlider();
        } else {
            alertOvrView.clearInterval();
            _t.refIndex = 1;
        }
    }, 1500);
}
alertOvrView.resetTblView = function () {
    //console.log('resetTblView');
    alertOvrView.dynTblData({
        data: alertOvrView.dataObj.alert.evidences
    });
    $("#alrtFltrSec").html('');
}
alertOvrView.hdrGendata = function (obj) {
    header.init("alrtOvr-headerNode");
    breadCrumb.init("rghtContent", obj.alert);
    menuOverview.init({
        idnode: $("#rghtContent"),
        hglghtNode: "mnuOverView"
    });
    cmnFunc.tglMenu();
}


alertOvrView.asyncData = function(obj) {
    let alert_type = obj.alert.type,
        arrType = ["party behavior risk", "spoofing"];
    alert_type = alert_type.toLowerCase();
    if (arrType.indexOf(alert_type) > -1) {
        $(".backLinkBtn").addClass("bckScreenFix");
    }

    if ((obj.statusText && obj.statusText.toLowerCase() != "success")) {
        $(".alrtContent").css("display", "none");
        cmnFunc.errorDialog();
        return;
    }
    if (Object.keys(obj).length == 0) {
        $(".alrtContent").css("display", "none");
        cmnFunc.errorDialog();
        return;
    }
    let node = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "alrtStCont clearfix"
        }],
        appendTo: $("#alrtOvrStatus")
    });

    //filter the data and put the latest date at the top of evidence list
    obj.reasoning.evidence.sort(function (a, b) {
        if (a.date < b.date) {
            return 1;
        }
        if (a.date > b.date) {
            return -1;
        }
        return 0;
    });
    let evidences = obj.alert.evidences.sort(tableFunc.sortData("date", true, function (a) { return new Date(a).getTime(); }));
    alertOvrView.dataObj = $.extend(true, {}, obj);
    alertOvrView.initEvts(obj);

    alertOvrView.dynTblData({
        data: evidences
    })

    alertOvrView.initReasoningGrph({
        idNode: "alrt-reasoning",
        dt: obj.reasoning
    });

}
alertOvrView.genResponseObj = function (obj) {
    var dateMap = d3.map(obj, function (d, i) {
        return d.date;
    });
    return dateMap;
}
alertOvrView.genDtRange = function (_t) {

    let end = $("#alrt-endDt"),
        startDt = $('#alrt-strtDt'),
        val, refNode = {},
        le = _t.dataMapArr.length,
        resultArr = [],
        endVal = new Date(end.prop('data-val')).getTime(),
        startVal = new Date(startDt.prop('data-val')).getTime();

    if (endVal == startVal) {
        val = 0;
    } else if (endVal < startVal) {
        val = 0;
        end.prop('data-val', startVal);
        end.val(cmnFunc.convertNotesDate(startDt.prop('data-val')));
    } else {
        val = Math.round((new Date(end.prop('data-val')) - new Date(startDt.prop('data-val'))) / (1000 * 60 * 60 * 24));
    }
    _t.startDt = startDt.prop('data-val');
    // $("#alrtStrtSlRes").removeClass("hide");

    //$("#alrtStrtSlRes").html(cmnFunc.convertNotesDate(_t.startDt));
    //$("#alrtEndSlRes").html(cmnFunc.convertNotesDate(end.prop('data-val')));

    //console.log('date range - ' + val);
    for (let i = 0; i <= val; i++) {
        let day;
        let index = $.inArray(_t.startDt, _t.dataMapArr);
        if (index >= 0) {
            resultArr.push(_t.startDt);
        }
        day = new Date(_t.startDt.split("/")[2], _t.startDt.split("/")[0] == "01" ? 0 : _t.startDt.split("/")[0] - 1, _t.startDt.split("/")[1]);
        day = day.setDate(day.getDate() + 1);
        day = new Date(day);
        let mn = day.getMonth() + 1;
        let dy = day.getDate();
        _t.startDt = (mn > 9 ? mn : "0" + mn) + "/" + (dy > 9 ? dy : "0" + dy) + "/" + day.getFullYear();
    }

    refNode.percent = 100 / (resultArr.length);
    refNode.length = resultArr.length;
    refNode.dates = resultArr;
    return refNode;
}

alertOvrView.initReasoningGrph = function (l) {
    //console.log('evidence 0 - ', l.dt.evidence[0], l.dt.evidence);

    NodeGraph.init('alrt-reasoning', l.dt.network, l.dt.evidence[0]);
    //reset table data
    alertOvrView.resetTblView();

    $("#alrtEndSlRes").html(alertOvrView.formartTime(l.dt.evidence.length * 1.5));
    alertOvrView.loadTimePeriodData();
}


/*
 * Table data
 */
alertOvrView.tblLinkGen = function (obj) {

    let anchor, link, qData, dObj = alertOvrView.dataObj,
        thisRef = sessionStorage.getItem("alertMetaData") ? JSON.parse(sessionStorage.getItem("alertMetaData")) : {};
    thisRef = thisRef.alert;

    qData = "?loc=" + cmnEvidences.loc + "&alertid=" + thisRef.alertid + "&evidenceid=" + obj.evidenceid + "&partyid=" + obj.partyid;
    if (obj.type && obj.type.trim().toLowerCase() == "e-mail") {
        link = cmnlocDetails.partial_homefolder + "email/index.html" + qData;
    } else if (obj.type && obj.type.trim().toLowerCase() == "voice") {
        link = cmnlocDetails.partial_homefolder + "voice/index.html" + qData;
    } else if (obj.type && obj.type.trim().toLowerCase() == "chat") {
        link = cmnlocDetails.partial_homefolder + "chat/index.html" + qData;
    } else if (obj.type && obj.type.trim().toLowerCase() == "anomaly") {
        link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + qData + "&startdate=" + dObj.alert.startdate + "&enddate=" + dObj.alert.enddate + "&source=anomaly";
    } else if (obj.type && obj.type.trim().toLowerCase() == "sentiment") {
        link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + qData + "&startdate=" + dObj.alert.startdate + "&enddate=" + dObj.alert.enddate + "&source=sentiment";
    } else if (obj.type && obj.type.trim().toLowerCase() == "emotion") {
        link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + qData + "&startdate=" + dObj.alert.startdate + "&enddate=" + dObj.alert.enddate + "&source=emotion";
    } else if (obj.type && obj.type.trim().toLowerCase() == "network") {
        link = cmnlocDetails.partial_homefolder + "network/index.html" + qData;
    } else if (obj.type && obj.type.trim().toLowerCase() == "trade") {
        if (thisRef.type == "Off-Market" || thisRef.type == "FrontRunning") {
            link = cmnlocDetails.partial_homefolder + "tradedetail/index.html" + qData;
        }

    }
    if (link) {
        /*anchor = cmnFunc.createDmNode({
            node: "a",
            attr: [{
                node: "href",
                value: link
            }],
            html: data
        });
        fld.html(anchor);
        return fld;*/
        return link;
    } else {
        /*fld.html(data);
        return fld;*/
        return false;
    }

}
alertOvrView.dynTblData = function (obj, flag = true) {
    let thisRef = alertOvrView.alert,
        l = alertOvrView.lc;
    if (obj.data.length > 0) {
        $("#alrtTblCntr").removeClass("hide");
        $("#alrtCmntCntr").addClass("hide");
    } else {
        $("#alrtTblCntr").addClass("hide");
        $("#alrtCmntCntr").removeClass("hide");
    }
    var obj = {
        tblId: 'evidencedetail',
        pagination: {
            node: 'pageCmpnnt',
            'recPerPg': 10
        },
        dataObj: obj.data,
        tblObj: {
            headerObj: [{
                field: l.weight,
                sortFld: {
                    dataType: "numeric",
                    field: "riskscore",
                    func: function (dt) {
                        let dtRef = parseInt(dt * 100);
                        return parseInt(dtRef);
                    }
                },
                class: "tw10"
            },
            {
                field: l.type,
                sortFld: {
                    field: "type"

                },
                class: "tw13"
            },
            {
                field: l.date,
                class: "tw20 frstSrtFld",
                sortFld: {
                    dataType: "numeric",
                    field: "epochtime",
                    func: function (dt) {
                        return new Date(dt);
                    }
                },
            },
            {
                field: l.descrip,
                class: "tw50"
            }
            ],
            tbdyobj: [{
                field: "riskscore",
                format: function (fld, data, obj) {
                    let dtRef = parseInt(data * 100);
                    cmnFunc.scoreColor({
                        score: dtRef
                    });

                    fld.addClass(cmnFunc.scoreColor({
                        "score": dtRef
                    }));

                    return fld.html(dtRef + "%");
                }
            },
            {
                field: "type",
                format: function (fld, data, obj) {

                    fld.attr("title", data);
                    fld.html(data)
                    return fld;
                }
            },
            {
                field: "date",
                format: function (fld, data, obj) {
                    return fld.html(alertOvrView.convertNotesTime(obj.epochtime));
                }
            },
            {
                field: "description",
                format: function (fld, data, obj) {
                    fld.attr("title", data);
                    return fld.html(data);
                }
            }
            ],
            trRowClickFunc: function (tr, obj) {
                let flg = alertOvrView.tblLinkGen(obj);
                let t = $(tr);
                if (flg) {
                    t.on("click", function () {
                        window.location = flg;
                    });
                    t.addClass("evidenceTbl");
                } else {
                    // t.addClass("evidenceTbl");
                    // t.on("click", function() {
                    //     let dNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "cfmDlg" }], appendTo: $("body") });
                    //     alertOvrView.genDynDialogdt(dNode, obj);
                    //     let dialog = $(dNode).dialog({
                    //         modal: true,
                    //         width: "500",
                    //         title: "Details",
                    //         closeOnEscape: false,
                    //         buttons: {
                    //             Close: function() {
                    //                 dialog.remove();
                    //             }
                    //         },
                    //         close: function() {
                    //             dialog.remove();
                    //         },
                    //         open: function(event, ui) {
                    //             $(".ui-dialog-titlebar-close", ui.dialog | ui).hide();
                    //         }

                    //     });

                    //});
                }

            }
        }
    }
    tableFunc.create(obj);
    if (flag) {
        $('.frstSrtFld .tblDsc.tblUsrt').click();
    }

}
alertOvrView.priceDialogdt = function (node, obj) {
    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Time": "Fri Jul 17 2015 01:25:00",
        "Symbol": "SPHA",
        "Price": "42.88",
        "Event": "price drop of more than 10%"
    }
    alertOvrView.tblCntGenr(node, org);
}
alertOvrView.hrDialogdt = function (node, obj) {
    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Time": "Mon Feb 02 2015 10:47:27",
        "Employee": "Mike.Cohen@bestbank.com",
        "Period": "01-JAN-2014 to 31-DEC-2014",
        "Bonus Achievment": "65%"
    }
    alertOvrView.tblCntGenr(node, org);
}
alertOvrView.warningDialogdt = function (node, obj) {
    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Time": "Thu Feb 26 2015 20:46:03",
        "Warning": "\"Language used with customers must not promise or guarantee an outcome.\""
    }
    alertOvrView.tblCntGenr(node, org);
}

alertOvrView.suspLoginDialogdt = function (node, obj) {
    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Date": obj.date,
        "Employee": "Jason Smith",
        "Body": obj.description
    }
    alertOvrView.tblCntGenr(node, org);
}

alertOvrView.customerConcDialogdt = function (node, obj) {
    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Time": "Sun May 01 2016 09:00:00",
        "Employee": "Jason Smith",
        "Details": "Unusual Customer distribution. Low income seniors segments each constitute more than 10% share"
    }
    alertOvrView.tblCntGenr(node, org);
}

alertOvrView.reversalDialogdt = function (node, obj) {

    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Date": obj.date,
        "Details": obj.description.replaceAll(/,/g, "<br>")
    }
    alertOvrView.tblCntGenr(node, org);
}

alertOvrView.complaintsDialogdt = function (node, obj) {

    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Date": obj.date,
        "Details": obj.description.replaceAll(/,/g, "<br>")
    }
    alertOvrView.tblCntGenr(node, org);
}



alertOvrView.rankingsDialogdt = function (node, obj) {
    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Time": "Tue Mar 01 2016 09:00:00",
        "Employee": "Jason Smith",
        "Issue": "Unusual Jump in ranking",
        "Details": obj.description
    }
    alertOvrView.tblCntGenr(node, org);
}

alertOvrView.insidertradeDialogdt = function (node, obj) {
    let org = {
        "Type": obj.type,
        "Evidence Id": obj.evidenceid,
        "Time": "Thu Jul 16 2015 00:00:11",
        "Order": "\"Sell@Mkt 1000 SPHA - Mike Cohen\"",
        "Account": "BB-Priv_11032134",
        "Symbol": "SPHA",
        "Quantity": 1000,
        "Price": "47.10"
    }
    alertOvrView.tblCntGenr(node, org);
}


alertOvrView.tblCntGenr = function (t, obj) {
    let o = Object.keys(obj),
        l = o.length;
    for (let i = 0; i < l; i++) {
        let tr = $("<tr></tr>")
        tdl = $("<td></td>"), tdr = $("<td></td>");
        tr.append(tdl);
        tr.append(tdr);
        tdl.html(o[i].capitalize());
        tdr.html(obj[o[i]]);
        t.append(tr);

    }
}
alertOvrView.genDynDialogdt = function (node, obj) {
    let t = $("<table class='alrtDtlsTbl'></table>");
    node.html(t);
    switch (obj.type.toLowerCase()) {
        case "price":
            alertOvrView.priceDialogdt(t, obj);
            break;
        case "hr":
            alertOvrView.hrDialogdt(t, obj);
            break;
        case "warning":
            alertOvrView.warningDialogdt(t, obj);
            break;
        case "suspicious logins":
            alertOvrView.suspLoginDialogdt(t, obj);
            break;
        case "ranking":
            alertOvrView.rankingsDialogdt(t, obj);
            break;
        case "trade":
            alertOvrView.insidertradeDialogdt(t, obj);
            break;
        case "customer concentrati":
            alertOvrView.customerConcDialogdt(t, obj);
            break;
        case "reversal":
            alertOvrView.reversalDialogdt(t, obj);
            break;
        case "customer complaint":
            alertOvrView.complaintsDialogdt(t, obj);
            break;


    }

}
/*
Create timeline */
alertOvrView.createTimeLine = function (dateData) {
    //remove old dates
    $('#slider .timeline-date-circle').remove();

    //if the dates length is equal to one don't build the timeline
    if (dateData.dates.length <= 1) {
        return;
    }


    //append date div
    $('#slider').append('<div class="timeline-dates"></div>');

    // //console.log('building time line - ', dates, dates.length);
    let template = '<div class="timeline-date-circle"></div>';

    let percent = dateData.percent;
    // //console.log('percent  -  ', percent, dates.length);

    dateData.dates.forEach(function (date, index) {
        let position = percent * (index + 1);

        // //console.log(date, index, position);
        let div = $("<div>", {
            class: "timeline-date-circle"
        })
            .attr('data-date-value', date)
            .css('left', position + '%');

        //register click event
        div.click(function () {
            //console.log('date', date);
            $("#alrtSlPly").removeClass("hide");
            $("#alrtSlPau").addClass("hide");
            alertOvrView.clearInterval();

            alertOvrView.storeVal.refIndex = index + 1;
            alertOvrView.animateSlider();

            //if user click on the last date on the timeline, reset the next index to 1
            if (alertOvrView.storeVal.refIndex > dateData.dates.length) {
                alertOvrView.storeVal.refIndex = 1;
            }
        });

        //mouseover, mouseout
        div.mouseover(function () {
            $('#alrtRundt').addClass('colorTxtGrey')
                .html(cmnFunc.convertNotesDate(date).replace(/ /g, '\u00a0')).show();
        }).mouseout(function () {
            $('#alrtRundt').removeClass('colorTxtGrey').hide();
            let currTimelineDateValue = $('#alrtSlRes').attr('data-val');

            //if the player is currently active set the old value
            if (currTimelineDateValue) {
                $('#alrtRundt')
                    .html(cmnFunc.convertNotesDate(currTimelineDateValue).replace(/ /g, '\u00a0')).show();
            }
        })

        //append list of dates to div
        $('#slider .timeline-dates').append(div);
    });
}

/*
 * Update timeline dates
 */
alertOvrView.updateTimeline = function (date) {
    $('#slider .timeline-dates').children().each(function () {
        //console.log($(this).attr('data-date-value'), date);
        let dtVal = new Date($(this).attr('data-date-value')).getTime(),
            dVal = new Date(date).getTime();
        if (dtVal == dVal) {
            $(this).removeClass('passed');
            $(this).addClass('active');
        } else if (dtVal < dVal) {
            $(this).removeClass('active').addClass('passed');
        } else {
            $(this).removeClass('passed active');
        }
    });
}

/*
 * When the date is changed, reset timeline, stop slider and update slider data
 */
alertOvrView.updateSlider = function () {
    alertOvrView.sliderData();
    alertOvrView.updatePlaybackTime();
}

/*
 * Reset timeline
 */
alertOvrView.resetTimeline = function () {
    NodeGraph.updateGraph(alertOvrView.dataObj.reasoning.evidence[0]);
    alertOvrView.storeVal.currDtVal.html('');
    alertOvrView.storeVal.sliderDtFld.html(cmnFunc.convertNotesDate($('#alrt-strtDt').val()));
    alertOvrView.storeVal.sliderDtFld.attr("data-val", null);
    alertOvrView.storeVal.sliderNode.css("width", (0 + "%"));

    alertOvrView.resetTblView();
    $("#alrtStrtSlRes").removeClass("colorTxtBlu");
}

/*
 * Animate the slider
 */
alertOvrView.animateSlider = function () {
    let _t = alertOvrView.storeVal;
    //console.log('playing timeline - ', _t.dtVal.length, _t.refIndex);


    //update time
    $("#alrtStrtSlRes").html(alertOvrView.formartTime(_t.refIndex * 1.5));

    let currDateIndex = (_t.refIndex - 1); //index for current date

    if (!$("#alrtRundt").hasClass("colorTxtBlu")) {
        $("#alrtRundt").addClass("colorTxtBlu");
    }
    let objdt = _t.rData;
    let resdata = {
        "network": objdt.network
    }
    resdata.evidence = [_t.dataMap.get(_t.dtVal.dates[currDateIndex])];

    _t.sliderNode.css("width", (_t.dtVal.percent * _t.refIndex) + "%");
    _t.currDtVal.html(cmnFunc.convertNotesDate(_t.dtVal.dates[currDateIndex]).replace(/ /g, '\u00a0'))
        .show().removeClass('colorTxtGrey');
    _t.sliderDtFld.html(cmnFunc.convertNotesDate(_t.dtVal.dates[currDateIndex]));
    _t.sliderDtFld.attr("data-val", _t.dtVal.dates[currDateIndex]);
    _t.refIndex++;


    //console.log('updating data - ', SELECTED_NODE_FILTER);

    //update node evidence
    //console.log('updating graph with evidence score  - ' , resdata.evidence[0]);

    //if there is evidence for the selected date update the graph
    if (resdata.evidence[0]) {
        NodeGraph.updateGraph(resdata.evidence[0]);
    } else {
        NodeGraph.zeroLevel();
        $('#alrtRundt').removeClass('colorTxtGrey').hide();
        _t.sliderNode.css("width", 0 + '%');
        _t.sliderDtFld.attr("data-val", "-1");
    }

    //filter evidence
    alertOvrView.chrtTblGen(SELECTED_NODE_FILTER);

    //update timeline date
    alertOvrView.updateTimeline(_t.dtVal.dates[currDateIndex]);
}

/*
 * Format time to minutes and seconds
 */
alertOvrView.formartTime = function (time) {
    var sec_num = parseInt(time, 10);
    var hours = Math.floor(sec_num / 3600);
    var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
    var seconds = sec_num - (hours * 3600) - (minutes * 60);

    if (hours < 10) {
        hours = "0" + hours;
    }
    if (minutes < 10) {
        minutes = "0" + minutes;
    }
    if (seconds < 10) {
        seconds = "0" + seconds;
    }
    return minutes + ':' + seconds;
}

/*
 * Updates playback time (end time)
 */
alertOvrView.updatePlaybackTime = function () {
    $("#alrtStrtSlRes").html('00:00'); //reset time
    $("#alrtEndSlRes").html(alertOvrView.formartTime(alertOvrView.storeVal.dtVal.length * 1.5));
}

/*
 * Load complete data for a selected time period
 */
alertOvrView.loadTimePeriodData = function () {
    //console.log('loading time period data');
    //update timeline dates and set initial timeline width to 100%
    alertOvrView.updateTimeline(alertOvrView.storeVal.endDt);
    alertOvrView.storeVal.refIndex = alertOvrView.storeVal.dtVal.length; //update current selected index to the end date
    alertOvrView.animateSlider();
    alertOvrView.storeVal.refIndex = 1;
}

/*
 * Update the play/pause status
 */
alertOvrView.updatePlayPauseStatus = function () {
    //console.log('updating play pause status');
    let _t = alertOvrView.storeVal;

    //if startdate equals enddate disable the play feature
    //also if there no evidence for the selected time period disable the play button
    if ($('#alrt-strtDt').prop('data-val') == $("#alrt-endDt").prop('data-val') ||
        _t.dtVal.length == 0) {
        $("#alrtSlPly").addClass('disabled');
    } else {
        $("#alrtSlPly").removeClass('disabled');
    }
}