/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const chtCnt = {
    chtCntDtObj: {},
    tagArr: [],
    allTags: []

};
chtCnt.init = function(data, l) {
    let thisRef = chtCnt.chtCntDtObj,
        objRef;
    thisRef.qData = cmnFunc.getQueryParameters();
    if (thisRef.qData.alertid) {
        objRef = {
            type: "GET",
            url: cmnlocDetails.alertOvrSrvc + thisRef.qData.alertid + "/commevidences/" + thisRef.qData.evidenceid,
            dataType: "json",
            ref: chtCnt,
            func: "initBdyDt"
        };

    } else {
        objRef = {
            type: "GET",
            url: cmnlocDetails.service + "/commservice/v1/communication/" + thisRef.qData.commid,
            dataType: "json",
            ref: chtCnt,
            func: "initBdyDt"
        };

    }
    cmnAsync.asynccall(objRef);
    if (thisRef.qData.search) {
        header.init("headerNode");
        $(".brdCrumSec").addClass("brdAdvVoiceSec");
        $("body").addClass("srchTrue");

    } else {
        autoHeader.generate('mnuOverView', false);
    }
}

chtCnt.initBdyDt = function(obj) {

    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.modelService + "tag/alltags",
        dataType: "json",
        ref: cmnEvidences,
        func: "crTagFunc",
        params: {
            "commId": obj.communicationDetails.communicationId,
            "alertId": chtCnt.chtCntDtObj.qData.alertid
        }
    };
    if (obj.statusText && obj.statusText.toLowerCase() != "success") {
        $(".alrtContent").css("display", "none");
        cmnFunc.errorDialog();
        return;
    }
    if (Object.keys(obj).length == 0) {
        $(".alrtContent").css("display", "none");
        cmnFunc.errorDialog();
        return;
    }
    chtCnt.chtCntDtObj.commId = obj.communicationDetails.communicationId;
    chtCnt.createDtlCnt(obj, $("#emlDlCnt"));
    if (chtCnt.chtCntDtObj.qData.search) {
        chtCnt.evDtlsSec();
    }

    cmnAsync.asynccall(objhdrRef);
    chtCnt.initAnnotate();
    chtCnt.initEvnts();
}
chtCnt.convertNotesDate = function(objdt) {
    var dt = new Date(objdt);
    var month = new Array();
    var date_str = "";
    month[0] = "Jan";
    month[1] = "Feb";
    month[2] = "Mar";
    month[3] = "Apr";
    month[4] = "May";
    month[5] = "Jun";
    month[6] = "Jul";
    month[7] = "Aug";
    month[8] = "Sep";
    month[9] = "Oct";
    month[10] = "Nov";
    month[11] = "Dec";
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    return date_str;
}
chtCnt.convertNotesTime = function(objdt) {
    var dt = new Date(objdt);
    var month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var date_str = "";
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    let h = dt.getHours();
    let mi = dt.getMinutes();
    let t = (((h > 12) ? h - 12 : h) + ":" + ((mi > 9) ? mi : "0" + mi)) + " " + ((h >= 12) ? "pm" : "am");
    return date_str + " @ " + t;
}
chtCnt.removeUnwantedCharacters = function(d) {
    let email_str = d;
    if (email_str == undefined || email_str == "" || email_str == null) {
        return "";
    }
    email_str = email_str.replace(/\\n|\\r\\n|\\r/g, '<br/>');
    email_str = email_str.replace(/\\uFFFD/g, "'");
    return email_str;
}

chtCnt.createDtlCnt = function(obj, idNode) {
    let lc = chtCnt.lc,
        alrt = chtCnt.chtCntDtObj.qData,
        objRef, pNobj, dtLstObj, adtldt, tagsArray, tagsElem, tglstObj = { node: "Tags", val: "tags", locstr: lc.tags },
        lstArr = [{ node: "Date", val: "date", locstr: lc.date },
            { node: "ID", val: "partyid", locstr: lc.id },
            { node: "Type", val: "type", locstr: lc.type },
            { node: "Weight", val: "riskscore", locstr: lc.weight },
            { node: "Involved", val: "partyname", locstr: lc.involved },
            { node: "Mentioned", val: "mentioned", locstr: lc.mentioned }
        ],
        len = lstArr.length;
    obj.riskscore = Math.round(cmnFunc.roundScore(obj.riskscore)) + "%";
    objRef = obj;
    chtCnt.evidenceIndicators = [];
    pNobj = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "emlDesc" }], html: objRef.description, appendTo: idNode });
    dtLstObj = cmnFunc.createDmNode({ node: "dl", attr: [{ node: "class", value: "emlDtLst dl-horizontal" }], appendTo: idNode });
    let rpObj = cmnFunc.getQueryParameters();
    if (alrt.alertid) {
        for (let i = 0; i < len; i++) {
            let result = lstArr[i];
            cmnFunc.createDmNode({ node: "dt", attr: [{ node: "class", value: "emlDtLstdt" }], html: result.locstr + ":", appendTo: dtLstObj });
            if (result.val == "partyname") {
                let party_url = cmnlocDetails.partial_homefolder + "involvedemployees/index.html?alertid=" + rpObj.alertid + "&partyid=" + objRef["partyid"];
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: "<a href='" + party_url + "'>" + objRef[result.val] + "</a>", appendTo: dtLstObj });
            } else if (result.val == "date") {
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: chtCnt.convertNotesDate(objRef[result.val]), appendTo: dtLstObj });
            } else if (result.val == "mentioned") {
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: chtCnt.removeUnwantedCharacters(objRef[result.val]), appendTo: dtLstObj });
            } else {
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: objRef[result.val], appendTo: dtLstObj });
            }
            //cmnFunc.createDmNode({node:"dd",attr:[{node:"class",value:"emlDtLstdd"}],html:objRef[result.val],appendTo:dtLstObj});
        }
    } else {
        let evType, dType;
        dType = cmnFunc.createDmNode({ node: "dt", attr: [{ node: "class", value: "emlDtLstdt emlEvdFld hide" }], html: "Evidence Type:", appendTo: dtLstObj });
        evType = cmnFunc.createDmNode({
            node: "dd",
            attr: [{ node: "class", value: "emlDtLstdt" }, { node: "id", value: "emlTypeCnt" }],
            html: "",
            appendTo: dtLstObj
        });
        if (typeof obj.evidences !== "undefined" && obj.evidences.length > 0) {
            dType.removeClass("hide");
            for (let i = 0; i < obj.evidences.length; i++) {
                let e = obj.evidences[i];
                chtCnt.evidenceIndicators.push(e.riskindicatorid);
                $("<p>" + e.riskindicator + "</p>").appendTo(evType);
            }
        }
    }
    cmnFunc.createDmNode({ node: "dt", attr: [{ node: "class", value: "emlDtLstdt" }], html: tglstObj.locstr + ":", appendTo: dtLstObj });
    tagsElem = cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdt" }, { node: "id", value: "emlStsIdCnt" }], appendTo: dtLstObj });
    /**Tag Functionality**/
    // chtCnt.chtCntDtObj.tagArr=
    chtCnt.tagArr = objRef.communicationDetails.tags ? objRef.communicationDetails.tags.tags : [];
    cmnEvidences.setTagArr(chtCnt.tagArr);
    for (let i = 0; i < chtCnt.tagArr.length; i++) {
        let div, spn;
        div = cmnFunc.createStatusNode();
        div.html(chtCnt.tagArr[i]);
        div.removeClass("cmnStCnt");
        div.addClass("delTagNode");
        spn = cmnFunc.createDmNode({
            node: "span",
            attr: [{
                    node: "class",
                    value: "delTagNd"
                },
                {
                    node: "data-id",
                    value: chtCnt.tagArr[i]
                }
            ],
            html: "&nbsp;",
            appendTo: div
        });
        cmnFunc.addEventListeners({
            node: spn,
            listener: "click",
            ref: cmnEvidences,
            func: "crDynTagRemoveNodes"
        });
        div.appendTo(tagsElem);
    }
    adtldt = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "cmnStCnt tag-plus"
        }, {
            node: "id",
            value: "tagPlus"
        }],
        "html": '<span class="glyphicon glyphicon-plus"></span>',
        appendTo: tagsElem
    });

    cmnFunc.addEventListeners({
        node: adtldt,
        listener: "click",
        ref: cmnEvidences,
        func: "genTagsCnt"
    });

}


/**Tag Functionality**/
chtCnt.createEmailCntDtl = function(obj, idNode) {
    let objRef, pNobj, dtLstObj, emailContainer,
        lstArr = JSON.parse(obj.body),
        len = lstArr.length;
    //   let node=cmnFunc.createDmNode({node:"div",attr:[{node:"class",value:"emlDtDescCnt clearfix"}],appendTo:$("#emlDetailCnt")}); 
    //   if(typeof obj == "object"){
    //	   node.html(obj.body);
    //   }else{
    //	   node.html("No records found"); 
    //   }


    for (let i = 0; i < len; i++) {
        let result = lstArr[i],
            tmcnt;
        tmcnt = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "chatSpchCnt" }], appendTo: $("#emlDetailCnt") });
        cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "chatSpkr" }], html: result.Speaker, appendTo: tmcnt });
        cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "chatSpch" }], html: chtCnt.genEntityData(result.Speech), appendTo: tmcnt });
        cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "timesup" }], html: chtCnt.convertNotesTime(result.Time), appendTo: tmcnt });
    }

}
chtCnt.initLocaleStr = function(data, l) {
    chtCnt.lc = data;
    chtCnt.fillLoc(data);
    chtCnt.init(data, l);
}
chtCnt.fillLoc = function(d) {
    let s = [{ id: "chatDtlTxt", txt: d.details }, { id: "chatTrnsptTxt", txt: d.chatTranscript }];
    for (let i = 0; i < s.length; i++) {
        cmnFunc.fillIdNode(s[i]);
    }
}
chtCnt.accorDtglMnu = function(evt) {
        let pNode = $(evt.target.parentNode),
            node = $(evt.target),
            n = $(node);
        if (n.hasClass("accrDwn")) {
            n.removeClass("accrDwn");
            n.addClass("accrUp");
            if ((pNode.parent()[0].id) == "vcAnnotations") {
                $("#vEvidenceSec").addClass("adjHght");
            }
            $("#" + pNode.parent()[0].id).find("[data-rcv='" + pNode.attr("data-src") + "']").addClass("hide");
        } else if (n.hasClass("accrUp")) {
            n.addClass("accrDwn");
            n.removeClass("accrUp");
            if ((pNode.parent()[0].id) == "vcAnnotations") {
                $("#vEvidenceSec").removeClass("adjHght");
            }
            $("#" + pNode.parent()[0].id).find("[data-rcv='" + pNode.attr("data-src") + "']").removeClass("hide");
        }

    },
    chtCnt.initEvnts = function() {
        let alrt = chtCnt.chtCntDtObj.qData;

        $(".tglArwNode").on("click", function(evt) {
            evt.stopPropagation();
            chtCnt.accorDtglMnu(evt);
        });
        $("#eviSelbtn").on("click", function(evt) {
            evt.stopPropagation();
            if ($("#evidenceSelFld").val() != "") {
                chtCnt.submitEvidences();

            } else {
                alert("Please select Evidence type");
            }

        });

        $("#vc-annotate").on("click", function() {
            if (chtCnt.annotation) {
                chtCnt.annotateResult(chtCnt.annotation);
            } else {
                chtCnt.annotationApi({ ref: chtCnt, func: "annotateResult" })
            }

        });
    }
chtCnt.initAnnotate = function(obj) {
    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.service + "/communicationservice/v1/communication/" + chtCnt.chtCntDtObj.commId + "/getallcommunicationedits/",
        dataType: "json",
        func: function(d) {

            if (chtCnt.chtCntDtObj.qData.search) {
                if (d.communication && d.communication.reviewstatus == 0 && (cmnFunc.getCookie("id") == d.communication.reviewerid)) {
                    chtCnt.createCompleteBtn();
                    chtCnt.annotationApi(false);
                } else {
                    chtCnt.createEditBtn();
                    chtCnt.annotationApi(true);
                }
            } else {
                chtCnt.annotationApi(true);
            }
            chtCnt.annotationEvObj = d;
            let objEmRef = {
                type: "GET",
                url: cmnlocDetails.partial_hostname + "/CommServices/data/commevidence/" + chtCnt.chtCntDtObj.commId,
                dataType: "json",
                ref: chtCnt,
                func: "createEmailCntDtl"
            };
            cmnAsync.asynccall(objEmRef, $("#emlDetailCnt"));




        }

    };
    cmnAsync.asynccall(objhdrRef);
}
chtCnt.genEntityData = function(s) {
    let k = chtCnt.annotationEvObj.communication.entityjson ? chtCnt.annotationEvObj.communication.entityjson.annotations : "",
        len = k.length,
        r = null;


    for (let i = 0; i < k.length; i++) {
        let t = k[i],
            c, bck, nSpan;
        t.entitytext = t.entitytext.trim();
        if (s.toLowerCase().search(cmnFunc.escape(t.entitytext.toLowerCase())) >= 0 && t.entitytext.trim() != "") {
            if (r == null) {
                r = s;
            }
            nSpan = "<span class=\"&secCls\" style=\"background:&secBck\" onclick=\"chtCnt.onSpanEvent(this)\">&inHtml</span>";
            nSpan = nSpan.replace("&secCls", "sec" + t.entitytypeid);
            nSpan = nSpan.replace("&secBck", t.entitycolorcode);

            let searchMask = t.entitytext;
            let regEx = new RegExp('(' + cmnFunc.escape(searchMask) + ')', "ig");
            let replaceMask = t.entitytext;
            nSpan = nSpan.replace("&inHtml", "$1");
            r = r.replace(regEx, nSpan);
            // r = r.replaceAll(t.entitytext.trim(), nSpan);
        }
    }
    if (r == null) {
        r = s;
    }
    return r;
}

chtCnt.evDtlsSec = function() {
    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.service + "/alertservice/v1/alert/getallriskentitymaster",
        dataType: "json",
        func: function(data) {
            if (data.riskindicator) {
                chtCnt.genEvidences(data);

            }

        }

    };
    cmnAsync.asynccall(objhdrRef);
    let evidence_url = cmnlocDetails.service + "/surveillanceui/v1/index/search/fl=commparticipantsid,comminitiatorid&indent=on&q=commid:" + chtCnt.chtCntDtObj.commId + "%20AND%20doctype:comm&wt=json";
    let objBehEvidencedata = {
        type: "GET",
        url: evidence_url,
        dataType: "json",
        func: function(res) {
            chtCnt.chtCntDtObj.resObj = (res.response.numFound > 0) ? res.response.docs[0] : [];
        }

    };
    cmnAsync.asynccall(objBehEvidencedata);
}
chtCnt.genEvidences = function(d) {
    let n = $("#vEvidenceSec"),
        r = d.riskindicator,
        lbl, sel, div, input, p, risk = chtCnt.evidenceIndicators ? chtCnt.evidenceIndicators : [];

    n.empty();
    lbl = $("<label for='evidenceSelFld'>Evidence Type</label>");
    lbl.appendTo(n);
    sel = $("<select name=\"evidenceSelFld\" id=\"evidenceSelFld\" class=\"inputTxt\"></select>");
    sel.appendTo(n);
    $('<option>').val("").text("Select").appendTo(sel);
    for (let i = 0; i < r.length; i++) {
        let o = r[i];

        if ((risk.indexOf(o["riskindicatorid"])) == -1) {
            $('<option>').val(o["risk_lookup_code"]).text(o["risk_indicator_name"]).appendTo(sel);
        }

    }
    div = $("<div id=\"slidecontainer\" class=\"posrel\"></div>");
    $("<label for='myRange'>Risk Probability</label>").appendTo(div);
    input = $("<div class = \"slider\" id =\"myRange\"></div>");
    p = $("<p>Value: <span id = \"demo\">0</span></p>");
    $(sel).on("change", function() {
        if ($(this).val() == "") {
            $("#eviSelbtn").prop("disabled", true);
        } else {
            $("#eviSelbtn").prop("disabled", false);
        }
    });
    div.appendTo(n);
    input.appendTo(div);
    p.appendTo(div);
    let uiSlider = noUiSlider.create($('#myRange')[0], {
        start: 0,
        step: 1,
        connect: [true, false],
        range: {
            'min': 0,
            'max': 10
        }
    });

    uiSlider.on('change', function(d) {
        $("#demo").html((parseInt(d[0]) / 10));
    });

    //    document.getElementById("myRange").oninput = function() {
    //        $("#demo").html(this.value);
    //    }
}
chtCnt.submitEvidences = function() {
    let resArr = [],
        e = chtCnt.chtCntDtObj.resObj,
        d = new Date();
    if (e.commparticipantsid) {
        for (let i = 0; i < e.commparticipantsid.length; i++) {
            let obj = { role: "participant", partyid: parseInt(e.commparticipantsid[i]) };
            resArr.push(obj);
        }
    }
    if (e.comminitiatorid) {
        resArr.push({ role: "primary", partyid: parseInt(e.comminitiatorid) });
    }

    let reqObj = {
        alert: {
            evidences: [{
                involvedparties: resArr,
                riskindicator: $("#evidenceSelFld").val(),
                riskscore: parseFloat($("#demo").html()),
                description: $("#evidenceSelFld option:selected").text(),
                commid: chtCnt.chtCntDtObj.commId,
                type: "Chat",
                timestamp: (d.getMonth() + 1) + "/" + d.getDate() + "/" + d.getFullYear() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds()
            }]
        }
    };
    let objhdrRef = {
        type: "POST",
        url: cmnlocDetails.service + "/alertservice/v1/alert/createEvidence",
        dataType: "json",
        data: JSON.stringify(reqObj),
        func: function(data) {
            if (data.status == 200) {
                $(".emlEvdFld").removeClass("hide");
                $("#emlTypeCnt").append("<p>" + reqObj.alert.evidences[0]["description"] + "</p>")
                $("#evidenceSelFld option[value='" + $("#evidenceSelFld").val() + "']").remove();
                $("#eviSelbtn").prop("disabled", true);
            } else {
                alert(data.message);
            }

        }

    };
    cmnAsync.asynccall(objhdrRef);
}
chtCnt.editCmpltToggle = function(t) {
    let vc = $("#vcEvidences"),
        ra = $("#rmvAnnot");
    if (t) {
        vc.addClass("vcDisNone");
        ra.addClass("vcDisNone");
    } else {
        vc.removeClass("vcDisNone");
        ra.removeClass("vcDisNone");
    }
}
chtCnt.createEditBtn = function() {
    $(".vsStatsHdrBtn").remove();
    chtCnt.editCmpltToggle(false);
    let b = $("<button class='vsStatsHdrBtn priButton'>Edit</button>");
    $(".backLinkBtn").after(b);
    $(b).on("click", function() {
        let objhdrRef = {
            type: "POST",
            url: cmnlocDetails.service + "/communicationservice/v1/communication/" + chtCnt.chtCntDtObj.commId + "/createreviewlock/",
            dataType: "json",
            data: JSON.stringify({
                "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : "10138"
            }),
            func: function(data) {
                if (data["review_lock_created"]) {
                    chtCnt.editStatus = true;
                    chtCnt.createCompleteBtn();
                    chtCnt.btndisEnable(false);
                } else {
                    alert(data.message);
                }

            }

        };
        cmnAsync.asynccall(objhdrRef);
    });

}
chtCnt.btndisEnable = function(val) {
    $(".vcAntBtn").prop("disabled", val);
    chtCnt.editCmpltToggle(!val);
}
chtCnt.createCompleteBtn = function() {
    $(".vsStatsHdrBtn").remove();
    chtCnt.editCmpltToggle(true);
    let b = $("<button class='vsStatsHdrBtn priButton'>Finish Editing</button>");
    $(".backLinkBtn").after(b);
    $(b).on("click", function() {
        let objhdrRef = {
            type: "POST",
            url: cmnlocDetails.service + "/communicationservice/v1/communication/" + chtCnt.chtCntDtObj.commId + "/updatereviewstatus/",
            dataType: "json",
            data: JSON.stringify({
                "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138,
                "reviewstatus": 1
            }),
            func: function(data) {
                if (data["review_lock_updated"]) {
                    chtCnt.createEditBtn();
                    chtCnt.editStatus = false;
                    chtCnt.btndisEnable(true);

                } else {
                    alert(data);
                }

            }

        };
        cmnAsync.asynccall(objhdrRef);

    });
}
chtCnt.annotationApi = function(o) {
    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.service + "/alertservice/v1/alert/allentitytypes",
        dataType: "json",
        func: function(data) {
            chtCnt.annotation = data;
            chtCnt.genAnntLegend(o);


        }

    };
    cmnAsync.asynccall(objhdrRef);
}
chtCnt.genAnntLegend = function(flag) {
    let o = chtCnt.annotation,
        node = $("#vcAnnotBtns");
    node.empty();

    for (let i = 0; i < o.length; i++) {
        let r = o[i],
            b, s;
        b = $("<button class='vcAntBtn'></button>");
        b.appendTo(node);
        s = $("<span class='vcBtnSec'></span>");
        s.appendTo(b);
        s.html((r.entitytypename.capitalize()).replace(/([A-Z])/g, ' $1').trim());
        s.css('color', cmnFunc.HSLColorContrast(r.entitycolorcode));
        b.attr("id", "vc_" + r.entitytypeid);
        b.attr("data-txt", r.entitydesc);
        b.attr("data-color", r.entitycolorcode);
        b.css("background", r.entitycolorcode);

        $(b).on("click", function(evt) {
            evt.stopPropagation();
            chtCnt.sendAnnotate($(this));
        });

    }
    let b = $("<button class='vcAntBtn secButton' id='rmvAnnot'></button>");
    b.appendTo(node);
    b.html("Remove Annotation");

    $(b).on("click", function(evt) {
        evt.stopPropagation();
        chtCnt.removeAnnotate($(this));
    });
    chtCnt.btndisEnable(flag);


}
chtCnt.sendAnnotate = function(n) {
    let id = n.attr("id"),
        txt = n.attr("data-txt"),
        colr = n.attr("data-color"),
        objhdrRef, sel, objAnotate = {
            "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138,
            "entityjson": {
                "entitytypeid": "",
                "entitytext": "",
                "entitytype": txt
            }
        };
    sel = window.getSelection();
    let source = $(sel.focusNode).parents(".chatSpch");
    if (source.length == 0) {
        return false;
    }
    let selLen = sel.toString();
    selLen = selLen.trim();
    if (selLen.length > 0) {
        objAnotate.entityjson.entitytext = (sel.toString()).trim();
    } else {
        alert("Please select Text");
        return false;
    }
    objAnotate.entityjson.entitytypeid = id ? id.split("_")[1] : null;

    objhdrRef = {
        type: "POST",
        url: cmnlocDetails.service + "/communicationservice/v1/communication/" + chtCnt.chtCntDtObj.commId + "/createcommunicationannotations/",
        dataType: "json",
        data: JSON.stringify(objAnotate),
        func: function(data) {
            if (data.status == 200) {
                let dsource = $(sel.focusNode).parents(".chatSpch");
                let spnArray = dsource.find("span").map(function() {
                    let o = {};
                    o.text = $(this).text()
                    o.class = $(this).attr("class");
                    o.color = $(this).css('backgroundColor')
                    return o;
                }).get();
                let d = dsource.text();
                d = d.replace(/  +/g, ' ');
                let reg = new RegExp(cmnFunc.escape(objAnotate.entityjson.entitytext.trim()), "gi");
                let resStr = sel.toString();
                d = d.replaceAll(reg, "<span style=background:" + colr + " onclick=\"chtCnt.onSpanEvent(this)\" class=sec" + objAnotate.entityjson.entitytypeid + ">" + resStr.trim() + "</span>");
                for (let i = 0; i < spnArray.length; i++) {
                    let reg = new RegExp(cmnFunc.escape(spnArray[i]["text"]), "gi"),
                        nSpan;
                    nSpan = "<span class=\"&secCls\" style=\"background:&secBck\" onclick=\"chtCnt.onSpanEvent(this)\">&inHtml</span>";
                    nSpan = nSpan.replace("&secCls", spnArray[i]["class"]);
                    nSpan = nSpan.replace("&secBck", spnArray[i]["color"]);
                    nSpan = nSpan.replace("&inHtml", spnArray[i]["text"]);
                    d = d.replaceAll(reg, nSpan);
                }

                dsource.html(d);

            } else {
                alert(data ? data.message : "No response");
            }

        }

    };
    cmnAsync.asynccall(objhdrRef);
}
chtCnt.removeAnnotate = function(n) {
    let objhdrRef, sel, objAnotate = {
        "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138,
        "entityjson": {
            "entitytypeid": "",
            "entitytext": ""
        }
    };
    sel = window.getSelection();
    if (sel.anchorNode == null) {
        alert("Please select annotation to remove");
    }
    let dsource = $(sel.anchorNode).parents(".chatSpch");
    let source = $(sel.focusNode).parents(".chatSpch");
    if (source.length == 0) {
        return false;
    }
    let c;
    if (sel.anchorNode.nodeName == "SPAN") {
        c = $(sel.anchorNode).attr("class");
        objAnotate.entityjson.entitytext = sel.toString();
    } else {
        c = $(sel.anchorNode.parentElement).attr("class");
        if (sel.anchorNode.parentElement.nodeName == "SPAN" && c.search("sec") >= 0) {
            objAnotate.entityjson.entitytext = sel.toString();
        } else {
            alert("Please select Annotation");
            return false;
        }
    }


    let selLen = sel.toString();
    selLen = selLen.trim();

    objAnotate.entityjson.entitytypeid = c ? c.split("sec")[1] : null;

    objhdrRef = {
        type: "DELETE",
        url: cmnlocDetails.service + "/communicationservice/v1/communication/" + chtCnt.chtCntDtObj.commId + "/removecommunicationannotations/",
        dataType: "json",
        data: JSON.stringify(objAnotate),
        func: function(data) {
            if (data.status == 200 && data["annotation_removed"]) {
                let dsource = $(sel.anchorNode).parents(".chatSpch");
                let spnArray = dsource.find("span").map(function() {
                    let o = {};
                    o.text = $(this).text()
                    o.class = $(this).attr("class");
                    o.color = $(this).css('backgroundColor')
                    return o;
                }).get();
                let d = dsource.text();
                d = d.replace(/  +/g, ' ');
                let reg = new RegExp(cmnFunc.escape(objAnotate.entityjson.entitytext.trim()), "gi");
                let resStr = sel.toString();
                for (let i = 0; i < spnArray.length; i++) {

                    let reg = new RegExp(cmnFunc.escape(spnArray[i]["text"]), "gi"),
                        nSpan;
                    if (spnArray[i]["class"] == c) {
                        d = d.replaceAll(reg, resStr);
                        continue;
                    }
                    nSpan = "<span class=\"&secCls\" style=\"background:&secBck\" onclick=\"chtCnt.onSpanEvent(this)\">&inHtml</span>";
                    nSpan = nSpan.replace("&secCls", spnArray[i]["class"]);
                    nSpan = nSpan.replace("&secBck", spnArray[i]["color"]);
                    nSpan = nSpan.replace("&inHtml", spnArray[i]["text"]);
                    d = d.replaceAll(reg, nSpan);
                }

                dsource.html(d);


            } else {
                alert(data.message);
            }

        }

    };
    cmnAsync.asynccall(objhdrRef);
}
chtCnt.onSpanEvent = function(el) {
    var sel = window.getSelection(),
        range;
    window.setTimeout(function() {
        range = document.createRange(); //range object
        range.selectNodeContents(el); //sets Range
        sel.removeAllRanges(); //remove all ranges from selection
        sel.addRange(range); //add Range to a Selection.
    }, 1);
}
$(document).ready(function() {
    cmnFunc.localeStr({ ref: chtCnt, func: "initLocaleStr" });
});