/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const dashboard = {};
let obj = {};
obj.data = "";
let alerts_list;
dashboard.call_tab = "alerts";

dashboard.tblLinkGen = function(obj) {
    let anchor, link, qData;
    qData = "?loc=" + cmnEvidences.loc + "&alertid=" + obj.alertid;
    link = cmnlocDetails.partial_homefolder + "alert/index.html" + qData;
    if (link) {
        return link;
    } else {
        return false;
    }
}
dashboard.emptblLinkGen = function(obj) {
    let anchor, link, qData;
    qData = "?loc=" + cmnEvidences.loc + "&partyid=" + obj.partyid;
    link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + qData;
    if (link) {
        return link;
    } else {
        return false;
    }
}


dashboard.callAjax = function(obj) {
    var url = "";
    var callBackFunction = "";
    if (dashboard.call_tab == "alerts") {
        //url = "../json/dashboard_alerts.json";
        url = cmnlocDetails.alertOvrSrvc + "alerts";
        callBackFunction = "getAlertsResponse";
    } else if (dashboard.call_tab == "employees") {
        //url = "../json/dashboard_employee.json";
        url = cmnlocDetails.service + "/surveillanceui/v1/party/topParties";
        callBackFunction = "getEmployeesResponse";
    }

    let objRef = {
        type: "GET",
        url: url,
        dataType: "json",
        data: obj.data,
        ref: dashboard,
        func: callBackFunction
    };
    cmnAsync.asynccall(objRef);
}

dashboard.getAlertsResponse = function(o) {
    let lc = dashboard.loc;
    $('#alerts_list').empty();
    $('#employees_list').empty();
    $("#employees_viewall").hide();
    $("#alertTblcntr").removeClass("height100");
    if (o.alerts.length > 14) {
        var anchor_view_all = document.createElement("a");
        anchor_view_all.setAttribute("href", "#");
        anchor_view_all.innerHTML = lc.viewAll;
        anchor_view_all.addEventListener("click", function(evt) {
            $("#alertTblcntr").addClass("height100");
            $(evt.target).hide();
        });
        $("#alerts_viewall").html(anchor_view_all);
        $("#alerts_viewall").show();
    } else {

        $("#alerts_viewall").hide();
    }

    var obj = {
        tblId: 'alerts_list',
        dataObj: o.alerts,
        tblObj: {
            headerObj: [{
                    field: lc.score,
                    sortFld: {
                        dataType: "numeric",
                        field: "alertscore",
                        func: function(dt) {
                            let dtRef = parseInt(dt * 100);
                            return parseInt(dtRef);
                        }
                    },
                    class: "tw10"
                },
                {
                    field: lc.type,
                    sortFld: {
                        field: "type"

                    },
                    class: "tw13"
                },
                {
                    field: lc.date,
                    class: "tw20",
                    sortFld: {
                        dataType: "numeric",
                        field: "date",
                        func: function(dt) {
                            return new Date(dt);
                        }
                    },
                },
                {
                    field: lc.id,
                    class: "tw10",
                    sortFld: {
                        dataType: "numeric",
                        field: "alertid",
                        func: function(dt) {
                            return parseInt(dt);
                        }
                    },
                },
                {
                    field: lc.ticker,
                    class: "tw10",
                    sortFld: {
                        field: "ticker"
                    },
                },
                {
                    field: lc.assestClass,
                    class: "tw10",
                    sortFld: {
                        field: "assetclass"
                    },
                },
                {
                    field: lc.status,
                    class: "tw10",
                    sortFld: {
                        field: "status"
                    },
                }
            ],
            tbdyobj: [{
                    field: "alertscore",
                    format: function(fld, data, obj) {
                        let dtRef = parseInt(data * 100);
                        cmnFunc.scoreColor({
                            score: dtRef
                        });

                        fld.addClass(cmnFunc.scoreColor({ "score": dtRef }));

                        return fld.html(dtRef + "%");
                    }
                },
                {
                    field: "type",
                    format: function(fld, data, obj) {

                        fld.attr("title", data);
                        fld.html(data)
                        return fld;
                    }
                },
                {
                    field: "date",
                    format: function(fld, data, obj) {
                        return fld.html(cmnFunc.convertNotesDate(data));
                    }
                },
                {
                    field: "alertid",
                    format: function(fld, data, obj) {
                        fld.attr("title", data);
                        return fld.html(data);
                    }
                },
                {
                    field: "ticker",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "assetclass",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "status",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                }
            ],
            trRowClickFunc: function(tr, obj) {
                let flg = dashboard.tblLinkGen(obj);
                let t = $(tr);
                if (flg) {
                    t.on("click", function() {
                        window.location = flg;
                    });
                }
                t.addClass("evidenceTbl");
            }
        }
    }
    tableFunc.create(obj);
}

dashboard.getEmployeesResponse = function(o) {
    let lc = dashboard.loc;
    $('#employees_list').empty();
    $('#alerts_list').empty();
    $("#alerts_viewall").hide();
    $("#empTblcntr").removeClass("height100");
    $("#employees_viewall").show();
    o.parties.sort(tableFunc.sortData("partyname", false));
    if (o.parties.length > 14) {
        var anchor_view_all = document.createElement("a");
        anchor_view_all.setAttribute("href", "#");
        anchor_view_all.innerHTML = lc.viewAll;
        anchor_view_all.addEventListener("click", function(evt) {
            $("#empTblcntr").addClass("height100");
            $(evt.target).hide();
        });
        $("#employees_viewall").html(anchor_view_all);
    } else {
        $("#employees_viewall").hide();
    }

    var obj = {
        tblId: 'employees_list',
        dataObj: o.parties,
        tblObj: {
            headerObj: [{
                    field: lc.employeeName,
                    sortFld: {
                        field: "partyname",
                        order: "asc"
                    },
                    class: "tw10"
                },
                {
                    field: lc.score,
                    sortFld: {
                        dataType: "numeric",
                        field: "riskrating",
                        func: function(dt) {
                            let dtRef = parseInt(dt * 100);
                            return parseInt(dtRef);
                        }
                    },
                    class: "tw13"
                },
                {
                    field: lc.role,
                    class: "tw10",
                    sortFld: {
                        field: "role"
                    },
                },
                {
                    field: lc.email,
                    class: "tw50",
                    sortFld: {
                        field: "email"
                    },
                },
                {
                    field: lc.location,
                    class: "tw10",
                    sortFld: {
                        field: "location"
                    },
                },
                {
                    field: lc.activeAlerts,
                    class: "tw10 activealerts",
                    sortFld: {
                        dataType: "numeric",
                        field: "activealerts",
                        func: function(dt) {
                            return parseInt(dt);
                        }
                    },
                },
                {
                    field: lc.pastViolations,
                    class: "tw10 pastviolations",
                    sortFld: {
                        dataType: "numeric",
                        field: "pastviolations",
                        func: function(dt) {
                            return parseInt(dt);
                        }
                    },
                }
            ],
            tbdyobj: [{
                    field: "partyname",
                    format: function(fld, data, obj) {
                        let dtRef = parseInt(obj.riskrating * 100);
                        cmnFunc.scoreColor({
                            score: dtRef
                        });

                        fld.addClass(cmnFunc.scoreColor({ "score": dtRef }));

                        return fld.html(data);
                    }
                },
                {
                    field: "riskrating",
                    format: function(fld, data, obj) {
                        fld.html(parseInt(data * 100) + "%");
                        return fld;
                    }
                },
                {
                    field: "role",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "email",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "location",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "activealerts",
                    class: "tw10 activealerts",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                },
                {
                    field: "pastviolations",
                    class: "tw10 pastviolations",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                }
            ],
            trRowClickFunc: function(tr, obj) {
                let flg = dashboard.emptblLinkGen(obj);
                let t = $(tr);
                if (flg) {
                    t.on("click", function() {
                        window.location = flg;
                    });
                }
                t.addClass("evidenceTbl");
            }
        }
    }
    tableFunc.create(obj);
}

dashboard.initObj = function() {
    header.init("alrtOvr-headerNode");
    $("#tabs ul").css("display", "block");
    $("#tabs").tabs();
    $(".tab_alerts").click(function() {
        dashboard.call_tab = "alerts";
        dashboard.callAjax(obj);
    });

    $(".tab_employees").click(function() {
        dashboard.call_tab = "employees";
        dashboard.callAjax(obj);
    });


    dashboard.callAjax(obj);
}

dashboard.locDetails = function(data, l) {
    dashboard.loc = data;
    dashboard.fillLoc();

}

dashboard.fillLoc = function() {
    let lc = dashboard.loc;
    $("#tab_alerts").html(lc.alerts);
    $("#tab_employees").html(lc.employees);
    dashboard.initObj();

}

$(document).ready(function() {
    cmnFunc.localeStr({ ref: dashboard, func: "locDetails" });
});