/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const involvedEmployee = {};
involvedEmployee.data = {};
involvedEmployee.alert_id = '';
involvedEmployee.party_id = '';
involvedEmployee.data.communcationAnomaly = {};
involvedEmployee.data.behavior = {};
involvedEmployee.page = "";
involvedEmployee.source = "";
involvedEmployee.alert_start_date = '';
involvedEmployee.alert_end_date = '';


involvedEmployee.showLabelToolTip = function(txt) {
    // langauge code for label text
    let div1_obj = cmnFunc.createDmNode({
        node: "div"
    });
    let div2_obj = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "label_tooltip_data"
        }],
        html: txt,
        appendTo: div1_obj
    });
    let div3_obj = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "label_pointer"
        }],
        appendTo: div1_obj
    });
    //let img_obj = cmnFunc.createDmNode({node:"img",attr:[{node:"src",value:cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_desc_active.png"}],appendTo:div3_obj});
    return div1_obj.html();
}
involvedEmployee.dynTooltip = function() {
    d3.select(".svgtip").remove();
    let tooldiv = d3.select("body").append("div")
        .attr("class", "svgtip");

    return tooldiv;
}
involvedEmployee.datetimeConverter = function(dx, timeflag = 1, fmt = "mm/dd/yyyy") {
    let tmp = "";
    let dt = new Date(dx);
    tmp = dt.getMonth() + 1;
    if (tmp < 10) {
        tmp = "0" + tmp
    };
    let mm = tmp;
    tmp = dt.getDate();
    if (tmp < 10) {
        tmp = "0" + tmp
    };
    let dd = tmp;
    let yyyy = dt.getFullYear().toString();
    let yy = yyyy.substring(2);
    tmp = dt.getHours();
    if (tmp < 10) {
        tmp = "0" + tmp
    };
    let hrs = tmp;
    tmp = dt.getMinutes();
    if (tmp < 10) {
        tmp = "0" + tmp
    };
    let mins = tmp;
    tmp = dt.getSeconds();
    if (tmp < 10) {
        tmp = "0" + tmp
    };
    let secs = tmp;
    if (timeflag == 1) {
        return mm + "/" + dd + "/" + yyyy + " " + hrs + ":" + mins + ":" + secs;
    } else {
        if (fmt == "mm/dd/yy") {
            return mm + "/" + dd + "/" + yy;
        }
        return mm + "/" + dd + "/" + yyyy;
    }
}

involvedEmployee.jsUcfirst = function(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

involvedEmployee.toolTip = function(obj) {
    let imgCnt, img, ulCnt, liCnt, arr, cnt, tooltip_data, o, tmp;
    arr = [];
    $.each(obj, function(k, v) {
        o = {};
        o.text = involvedEmployee.jsUcfirst(k) + ":";
        if (k == "date" || k == "datetime") {
            if (k == "date") {
                o.val = involvedEmployee.datetimeConverter(v, 0);
            } else {
                o.val = involvedEmployee.datetimeConverter(v);
            }
        } else {
            if (k == "score") {
                tmp = v;
                o.val = tmp.toFixed(2);
            } else {
                o.val = v;
            }
        }
        arr.push(o);
    });
    cnt = cmnFunc.createDmNode({
        node: "div"
    });
    tooltip_data = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "tooltip_data"
        }],
        appendTo: cnt
    });
    ulCnt = cmnFunc.createDmNode({
        node: "ul",
        appendTo: tooltip_data
    });
    for (let i = 0; i < arr.length; i++) {
        let l = arr[i],
            li;
        li = cmnFunc.createDmNode({
            node: "li",
            appendTo: ulCnt
        });
        cmnFunc.createDmNode({
            node: "span",
            html: l.text + " ",
            appendTo: li
        });
        cmnFunc.createDmNode({
            node: "span",
            html: l.val,
            appendTo: li
        });
    }
    return cnt.html();
}




involvedEmployee.getTransform = function(str) {
    let obj = [];
    str = str.replace("translate", "");
    str = str.replace("(", "");
    str = str.replace(")", "");
    obj = str.split(",");
    return obj;
}

involvedEmployee.legendColor = function(d) {
    //d = d.toLowerCase();
    if (d.id == 4) {
        //return "#DEF4FF";
        return "#00B9A5";
    } else if (d.id == 5) {
        //return "#9BCBE9";
        return "#F7D527";
    } else if (d.id == 1) {
        //return "#FFDB00";
        return "#4CA2D4";
    } else if (d.id == 2) {
        //return "#42A9E9";
        return "#865397";
    } else if (d.id == 3) {
        //return "#B86BD7";
        return "#757AB5";
    } else if (d.id == 6) {
        //return "#FF8331";
        return "#FE8137"
    } else if (d.id == 7) {
        return "#00C3AD";
    }
}


involvedEmployee.showParty = function(id, first_time_flag) {
    involvedEmployee.party_id = id;
    $(".user_list ul li.active").removeClass("active");
    $(".user_list ul li[data-id=" + id + "]").addClass("active");
    let personalNavItem = $('.nav_section ul li').first();
    if (first_time_flag == 1) {

        involvedEmployee.showSection(personalNavItem, 'personal_info_section', 1);
    } else {
        let params, rplcSt, ar = [{
            t: ":",
            v: "="
        }, {
            t: ",",
            v: "&"
        }, {
            t: "{",
            v: ""
        }, {
            t: "}",
            v: ""
        }, {
            t: "\"",
            v: ""
        }];
        params = cmnFunc.getQueryParameters();
        params.partyid = id;
        rplcSt = JSON.stringify(params);
        for (let i = 0; i < ar.length; i++) {
            let r = ar[i];
            rplcSt = rplcSt.replace(new RegExp(r.t, "g"), r.v);
        }
        window.history.replaceState(null, null, "index.html?" + rplcSt);
        involvedEmployee.showSection(personalNavItem, 'personal_info_section');
    }
}




involvedEmployee.getRandomInt = function(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


involvedEmployee.emotion_brushed = function(o) {
    let emotion_x = o.emotion_x;
    let emotion_focus = o.emotion_focus;
    let emotion_browser = o.emotion_browser;
    let emotion_svg = o.emotion_svg;
    let emotion_width = o.emotion_width;
    let emotion_xAxis = o.emotion_xAxis;
    let emotion_d = o.emotion_d;
    let emotion_x2 = o.emotion_x2;
    let emotion_area = o.emotion_area;
    let emotion_area3 = o.emotion_area3;
    let emotion_zoom = o.emotion_zoom;
    let emotion_ticks_data = [],
        emotion_x_positions = [],
        emotion_x_values = [],
        emotion_y_positions = [],
        emotion_y_values = [];
    let unique_x_axis_dates = [];

    if (d3.event.sourceEvent && d3.event.sourceEvent.type === "zoom") return; // ignore brush-by-zoom
    let s = d3.event.selection || emotion_x2.range();
    emotion_x.domain(s.map(emotion_x2.invert, emotion_x2));

    emotion_focus.select(".area").attr("d", emotion_area);
    emotion_focus.select(".axis--x").call(emotion_xAxis);
    emotion_browser.select(".area").attr("d", emotion_area3);
    emotion_browser.select(".axis--x").call(emotion_xAxis);
    emotion_focus.select("g.grpCrcle").call(involvedEmployee.emotionCirclesPlot);
    if (s == null) {
        o.emotion_handle.attr("display", "none");
    } else {
        var sx = s.map(emotion_x.invert);
        o.emotion_handle.attr("display", null).attr("transform", function(d, i) {
            return "translate(" + [s[i], -30 / 4] + ")";
        });
    }
    emotion_svg.selectAll("g.focus g.axis.axis--x  g.tick").each(function(index, value) {
        if (unique_x_axis_dates.length == 0) {
            unique_x_axis_dates.push($(this)[0].childNodes[1].innerHTML);
        } else {
            if ($.inArray($(this)[0].childNodes[1].innerHTML, unique_x_axis_dates) != -1) {
                $(this).attr("opacity", "0");
            } else {
                unique_x_axis_dates.push($(this)[0].childNodes[1].innerHTML);
            }
        }
    });
    emotion_svg.select(".zoom").call(emotion_zoom.transform, d3.zoomIdentity
        .scale(emotion_width / (s[1] - s[0]))
        .translate(-s[0], 0));
}

involvedEmployee.emotion_zoomed = function(o) {
    let emotion_x = o.emotion_x;
    let emotion_focus = o.emotion_focus;
    let emotion_browser = o.emotion_browser;
    let emotion_context = o.emotion_context;
    let emotion_brush = o.emotion_brush;
    let emotion_svg = o.emotion_svg;
    let emotion_xAxis = o.emotion_xAxis;
    let emotion_x2 = o.emotion_x2;
    let emotion_area = o.emotion_area;
    let emotion_area3 = o.emotion_area3;
    let unique_x_axis_dates = [];
    if (d3.event.sourceEvent && d3.event.sourceEvent.type === "brush") return; // ignore zoom-by-brush
    let t = d3.event.transform;
    emotion_x.domain(t.rescaleX(emotion_x2).domain());
    emotion_focus.select(".area").attr("d", emotion_area);
    emotion_focus.select(".axis--x").call(emotion_xAxis);
    emotion_browser.select(".area").attr("d", emotion_area3);
    emotion_browser.select(".axis--x").call(emotion_xAxis);
    emotion_context.select(".brush").call(emotion_brush.move, emotion_x.range().map(t.invertX, t));

    emotion_svg.selectAll("g.focus g.axis.axis--x  g.tick").each(function(index, value) {
        if (unique_x_axis_dates.length == 0) {
            unique_x_axis_dates.push($(this)[0].childNodes[1].innerHTML);
        } else {
            if ($.inArray($(this)[0].childNodes[1].innerHTML, unique_x_axis_dates) != -1) {
                $(this).attr("opacity", "0");
            } else {
                unique_x_axis_dates.push($(this)[0].childNodes[1].innerHTML);
            }
        }
    });
}






involvedEmployee.dateConverter = function(date_str, format = "yy-mm-dd") {
    if (date_str == '' || date_str == null || date_str == undefined) {
        return false;
    }
    let curr_date = new Date(date_str);
    let dd = curr_date.getDate();
    let mm = curr_date.getMonth() + 1;
    let yy = curr_date.getFullYear();
    if (dd < 10) {
        dd = "0" + dd;
    }
    if (mm < 10) {
        mm = "0" + mm;
    }

    if (format == "yy-mm-dd") {
        return yy + "-" + mm + "-" + dd;
    } else if (format == "yy-dd-mm") {
        return yy + "-" + dd + "-" + mm;
    } else if (format == "mm-dd-yy") {
        return mm + "-" + dd + "-" + yy;
    } else if (format == "mm-yy-dd") {
        return mm + "-" + yy + "-" + dd;
    } else if (format == "dd-mm-yy") {
        return dd + "-" + mm + "-" + yy;
    } else if (format == "dd-yy-mm") {
        return dd + "-" + yy + "-" + mm;
    } else if (format == "yy/mm/dd") {
        return yy + "/" + mm + "/" + dd;
    } else if (format == "yy/dd/mm") {
        return yy + "/" + dd + "/" + mm;
    } else if (format == "mm/dd/yy") {
        return mm + "/" + dd + "/" + yy;
    } else if (format == "mm/yy/dd") {
        return mm + "/" + yy + "-" + dd;
    } else if (format == "dd/mm/yy") {
        return dd + "/" + mm + "/" + yy;
    } else if (format == "dd/yy/mm") {
        return dd + "/" + yy + "/" + mm;
    } else if (format == "yyyy/mm/dd") {
        return yy + "/" + mm + "/" + dd;
    } else if (format == "yyyy/dd/mm") {
        return yy + "/" + dd + "/" + mm;
    }
}




involvedEmployee.callAPIPartyProfile = function() {
    let objPartydata = {
        type: "GET",
        //url:cmnlocDetails.partial_homefolder+"json/party_profile.json",
        url: cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/profile',
        dataType: "json",
        ref: involvedEmployee,
        func: "loadPartyProfile"
    };
    cmnAsync.asynccall(objPartydata)
};
involvedEmployee.callAPIAlertOverview = function() {
    let obj = $.parseJSON(sessionStorage.getItem('alertMetaData'));
    involvedEmployee.loadAlertOverview(obj);
};
involvedEmployee.callAPIAlertSummary = function() {
    $("#alert_summary_chart").html('');
    let objHdata = {
        type: "GET",
        //url:cmnlocDetails.partial_homefolder+"json/party_alert_summary_history.json",
        url: cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/summary',
        dataType: "json",
        ref: involvedEmployee,
        func: "loadSummaryChart"
    };

    cmnAsync.asynccall(objHdata)
};
involvedEmployee.callAPIAlertSummaryDetails = function() {
    $("#alert_summary_chart").html('');
    $("#alert_history_list").html('');
    let objHdata = {
        type: "GET",
        //url:cmnlocDetails.partial_homefolder+"json/party_alert_summary_history.json",
        url: cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/summary',
        dataType: "json",
        ref: involvedEmployee,
        func: "loadSummaryDetailChart"
    };

    cmnAsync.asynccall(objHdata)
};
involvedEmployee.callAPIBehavior = function() {
    let emotion_svg = d3.select("#big_emotion_chart svg.chart");
    emotion_svg.selectAll("*").remove();
    let emotion_legends = d3.select("#big_emotion_chart svg.legends");
    emotion_legends.selectAll("*").remove();

    involvedEmployee.data.behavior = undefined;
    let api_url = '';

    if (($('#emotion-strtDt').val() != '') && ($('#emotion-endDt').val() != '')) {
        involvedEmployee.alert_start_date = involvedEmployee.dateConverter($('#emotion-strtDt').val(), "yy-mm-dd");
        involvedEmployee.alert_end_date = involvedEmployee.dateConverter($('#emotion-endDt').val(), "yy-mm-dd");
    } else {
        if (involvedEmployee.alert_start_date != "" && involvedEmployee.alert_start_date != undefined) {
            $('#emotion-strtDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"));
            $('#alrt-strtDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"));
        }
        if (involvedEmployee.alert_end_date != "" && involvedEmployee.alert_end_date != undefined) {
            $('#emotion-endDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
            $('#alrt-endDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
        }
    }

    if ((involvedEmployee.alert_start_date == '' || involvedEmployee.alert_start_date == undefined || involvedEmployee.alert_start_date == null ||
            involvedEmployee.alert_start_date == "NaN-NaN-NaN" || involvedEmployee.alert_start_date == false) && (involvedEmployee.alert_end_date == '' ||
            involvedEmployee.alert_end_date == undefined || involvedEmployee.alert_end_date == null || involvedEmployee.alert_end_date == "NaN-NaN-NaN" ||
            involvedEmployee.alert_end_date == false)) {
        api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/behaviourProfile';

    } else {
        if ((involvedEmployee.alert_start_date != '' && involvedEmployee.alert_start_date != undefined && involvedEmployee.alert_start_date != null) &&
            (involvedEmployee.alert_end_date != '' && involvedEmployee.alert_end_date != undefined && involvedEmployee.alert_end_date != null)) {
            api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/behaviourProfile?startDate=' + involvedEmployee.alert_start_date + '&endDate=' + involvedEmployee.alert_end_date;
        } else if ((involvedEmployee.alert_start_date != '' && involvedEmployee.alert_start_date != undefined && involvedEmployee.alert_start_date != null) &&
            (involvedEmployee.alert_end_date == '' || involvedEmployee.alert_end_date == undefined || involvedEmployee.alert_end_date == null)) {
            api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/behaviourProfile?startDate=' + involvedEmployee.alert_start_date;
        } else if ((involvedEmployee.alert_start_date == '' || involvedEmployee.alert_start_date == undefined || involvedEmployee.alert_start_date == null) &&
            (involvedEmployee.alert_end_date != '' && involvedEmployee.alert_end_date != undefined && involvedEmployee.alert_end_date != null)) {
            api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/behaviourProfile?endDate=' + involvedEmployee.alert_end_date;
        }
    }

    let objBehdata = {
        type: "GET",
        //url:cmnlocDetails.partial_homefolder+"json/beh_server.json",
        url: api_url,
        dataType: "json",
        ref: involvedEmployee,
        func: "loadBehaviorData"
    };

    cmnAsync.asynccall(objBehdata)
};
involvedEmployee.callAPIAnomalyDetails = function() {
    $(".communication_anomaly_chart").html("");
    if (($('#alrt-strtDt').val() != '') && ($('#alrt-endDt').val() != '')) {
        involvedEmployee.alert_start_date = involvedEmployee.dateConverter($('#alrt-strtDt').val(), "yy-mm-dd");
        involvedEmployee.alert_end_date = involvedEmployee.dateConverter($('#alrt-endDt').val(), "yy-mm-dd");
    } else {
        if (involvedEmployee.alert_start_date != "" && involvedEmployee.alert_start_date != undefined) {
            $('#emotion-strtDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"));
            $('#alrt-strtDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"));
        }
        if (involvedEmployee.alert_end_date != "" && involvedEmployee.alert_end_date != undefined) {
            $('#emotion-endDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
            $('#alrt-endDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
        }
    }


    if ((involvedEmployee.alert_start_date == '' || involvedEmployee.alert_start_date == undefined || involvedEmployee.alert_start_date == null ||
            involvedEmployee.alert_start_date == "NaN-NaN-NaN" || involvedEmployee.alert_start_date == false) && (involvedEmployee.alert_end_date == '' ||
            involvedEmployee.alert_end_date == undefined || involvedEmployee.alert_end_date == null || involvedEmployee.alert_end_date == "NaN-NaN-NaN" ||
            involvedEmployee.alert_end_date == false)) {
        api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/anomaly';

    } else {
        if ((involvedEmployee.alert_start_date != '' && involvedEmployee.alert_start_date != undefined && involvedEmployee.alert_start_date != null) &&
            (involvedEmployee.alert_end_date != '' && involvedEmployee.alert_end_date != undefined && involvedEmployee.alert_end_date != null)) {
            api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/anomaly?startDate=' + involvedEmployee.alert_start_date + '&endDate=' + involvedEmployee.alert_end_date;
        } else if ((involvedEmployee.alert_start_date != '' && involvedEmployee.alert_start_date != undefined && involvedEmployee.alert_start_date != null) &&
            (involvedEmployee.alert_end_date == '' || involvedEmployee.alert_end_date == undefined || involvedEmployee.alert_end_date == null)) {
            api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/anomaly?startDate=' + involvedEmployee.alert_start_date;
        } else if ((involvedEmployee.alert_start_date == '' || involvedEmployee.alert_start_date == undefined || involvedEmployee.alert_start_date == null) &&
            (involvedEmployee.alert_end_date != '' && involvedEmployee.alert_end_date != undefined && involvedEmployee.alert_end_date != null)) {
            api_url = cmnlocDetails.service + '/surveillanceui/v1/party/' + involvedEmployee.party_id + '/anomaly?endDate=' + involvedEmployee.alert_end_date;
        }
    }

    let objAnomalydata = {
        type: "GET",
        //url:cmnlocDetails.partial_homefolder+"json/anomaly_details.json",
        url: api_url,
        dataType: "json",
        ref: involvedEmployee,
        func: "loadAnomalyDetails"
    };
    cmnAsync.asynccall(objAnomalydata)
}

involvedEmployee.pieChartSettings = function() {
    $(".summary_tooltip").attr("src", cmnlocDetails.partial_homefolder + "dist/images/F0455AE0-90EB-4FAB-B836-2F1CD92550DC@2x.png");


    $(".summary_tooltip").on("click", function(event) {
        let tooltip = involvedEmployee.dynTooltip();
        let t = tooltip;
        t.transition()
            .duration(200);
        t.html(involvedEmployee.showLabelToolTip(involvedEmployee.lc.alertSummaryTooltip))
            .style("left", (event.pageX - 63) + "px")
            .style("top", (event.pageY - 160) + "px");
        $(".label_pointer").css("margin-top", "124px");
    }).on("mouseout", function(d) {
        d3.select(".svgtip").remove();
    });

    if (involvedEmployee.data == undefined || involvedEmployee.data.party == undefined || involvedEmployee.data.party.alertsummary == undefined) {
        return false;
    }
    let wd = $(window).width();
    let obj = {};
    obj.ht = 200;
    obj.radius = 80;
    obj.position_x = 80;
    obj.position_y = 100;
    obj.text_spacing_x = 15;
    obj.text_spacing_y = 10;
    obj.data = involvedEmployee.data.party.alertsummary;
    obj.key = 'status';
    obj.value = 'count';
    obj.showtext = 1;
    obj.legendtextclass = "piechart_legend_1 small";

    let summary_chart = "#alert_summary_chart";
    let history_chart = "#alert_history_chart";
    //if (involvedEmployee.source == "alert_summary") {
    obj.wd = $(summary_chart).width();
    obj.radius = 90;
    obj.position_x = 110;
    obj.destination = summary_chart;
    if (wd < 1240) {
        involvedEmployee.pieChartData(obj);
    } else {
        obj.radius = 90;
        obj.position_x = 90;
        obj.position_y = 80;
        obj.ht = 250;
        obj.legendtextclass = "piechart_legend_1";
        involvedEmployee.pieChartData(obj);
    }
    /*} else {
        obj.wd = $(history_chart).width();
        obj.wd = $(history_chart).width();
        obj.radius = 80;
        obj.position_x = 80;
        obj.destination = history_chart;
        if (wd < 1240) {
            involvedEmployee.pieChartData(obj);
        } else {
            obj.radius = 100;
            obj.position_x = 110;
            involvedEmployee.pieChartData(obj);
        }
    }*/
}
involvedEmployee.pieChartData = function(o) {
    $(o.destination).html('');
    let mypiechart1 = new PieChart(o);
}



involvedEmployee.alertHistoryTblLinkGen = function(obj) {
    let anchor, link, qData;
    qData = "?alertid=" + obj.alertid;
    link = cmnlocDetails.partial_homefolder + "alert/index.html" + qData;
    if (link) {
        return link;
    } else {
        return false;
    }
}
involvedEmployee.evidenceTblLinkGen = function(obj) {
    let anchor, link, qData;
    qData = "?alertid=" + obj.alertid + "&evidenceid=" + obj.evidenceid + "&partyid=" + obj.partyid;
    link = cmnlocDetails.partial_homefolder + "email/index.html" + qData;
    if (link) {
        return link;
    } else {
        return false;
    }
}

involvedEmployee.loadAlertHistory = function() {
    let l = involvedEmployee.lc,
        obj = {
            tblId: 'alert_history_list',
            dataObj: involvedEmployee.data.party.alerthistory,
            pagination: {
                node: 'pageCmpnnt',
                'recPerPg': 10
            },
            tblObj: {
                headerObj: [{
                        field: l.risk,
                        sortFld: {
                            dataType: "numeric",
                            field: "alertscore",
                            func: function(dt) {
                                let dtRef = parseInt(dt * 100);
                                return parseInt(dtRef);
                            }
                        },
                        class: "tw10"
                    },
                    {
                        field: l.id,
                        sortFld: {
                            field: "alertid"

                        },
                        class: "tw13"
                    },
                    {
                        field: l.date,
                        class: "tw20",
                        sortFld: {
                            dataType: "numeric",
                            field: "date",
                            func: function(dt) {
                                return new Date(dt);
                            }
                        },
                    },
                    {
                        field: l.type,
                        class: "tw10",
                        sortFld: {
                            field: "type"
                        },
                    },
                    {
                        field: l.status,
                        class: "tw10",
                        sortFld: {
                            field: "status"
                        },
                    }
                ],
                tbdyobj: [{
                        field: "alertscore",
                        format: function(fld, data, obj) {
                            let dtRef = parseInt(data * 100);
                            cmnFunc.scoreColor({
                                score: dtRef
                            });

                            fld.addClass(cmnFunc.scoreColor({
                                "score": dtRef
                            }));

                            return fld.html(dtRef + "%");
                        }
                    },
                    {
                        field: "alertid",
                        format: function(fld, data, obj) {
                            fld.html(data)
                            return fld;
                        }
                    },
                    {
                        field: "date",
                        format: function(fld, data, obj) {
                            return fld.html(cmnFunc.convertNotesDate(data));
                        }
                    },
                    {
                        field: "type",
                        format: function(fld, data, obj) {
                            fld.html(data)
                            return fld.html(data);
                        }
                    },
                    {
                        field: "status",
                        format: function(fld, data, obj) {
                            return fld.html(data);
                        }
                    }
                ],
                trRowClickFunc: function(tr, obj) {
                    let flg = involvedEmployee.alertHistoryTblLinkGen(obj);
                    let t = $(tr);
                    if (flg) {
                        t.on("click", function() {
                            window.location = flg;
                        });
                    }
                    t.addClass("evidenceTbl");
                }
            }
        }
    tableFunc.create(obj);
}
involvedEmployee.loadAnomalyDetails = function(obj) {

    involvedEmployee.data.communcationAnomaly = obj;
    $(".anomaly_tooltip").attr("src", cmnlocDetails.partial_homefolder + "dist/images/F0455AE0-90EB-4FAB-B836-2F1CD92550DC@2x.png");


    $(".anomaly_tooltip").on("click", function(event) {
        let tooltip = involvedEmployee.dynTooltip();
        let t = tooltip;
        t.transition()
            .duration(200);
        t.html(involvedEmployee.showLabelToolTip(involvedEmployee.lc.anomaliesTooltip))
            .style("left", (event.pageX - 63) + "px")
            .style("top", (event.pageY - 240) + "px");
        $(".label_pointer").css("margin-top", "185px");
    }).on("mouseout", function(d) {
        d3.select(".svgtip").remove();
    });
    let o = obj.commanomalies;
    if (o == undefined) {
        return false;
    }
    o.sort(function(a, b) {
        return new Date(a.date).getTime() - new Date(b.date).getTime()
    });
    obj = {};
    obj.commanomalies = o;

    let json_data = obj.commanomalies;
    let dates = [];
    let first_date = "";
    json_data.forEach(function(d) {
        if (first_date == "") {
            first_date = new Date(d.date);
        }
        if (dates.indexOf(d.date) === -1) {
            dates.push(d.date);
        }
    });
    let tmp_date = new Date(first_date);
    tmp_date.setDate(tmp_date.getDate() - 1);
    let dd = tmp_date.getDate();
    let mm = tmp_date.getMonth() + 1;
    let yy = tmp_date.getFullYear();
    if (dd < 10) {
        dd = "0" + dd;
    }
    if (mm < 10) {
        mm = "0" + mm;
    }

    tmp_date = new Date(dates[dates.length - 1]);
    tmp_date.setDate(tmp_date.getDate() + 1);
    dd = tmp_date.getDate();
    mm = tmp_date.getMonth() + 1;
    yy = tmp_date.getFullYear();
    if (dd < 10) {
        dd = "0" + dd;
    }
    if (mm < 10) {
        mm = "0" + mm;
    }


    dates.sort(function(a, b) {
        a = a.split('-').join('');
        b = b.split('-').join('');
        return a > b ? 1 : a < b ? -1 : 0;
    });


    if (dates.length >= 1) {
        if ($('#alrt-strtDt').val() == "" || $('#alrt-strtDt').val() == undefined || $('#alrt-strtDt').val() == null) {
            $('#alrt-strtDt').val(involvedEmployee.dateConverter(dates[0], "mm/dd/yy"));
        }
        if ($('#alrt-endDt').val() == "" || $('#alrt-endDt').val() == undefined || $('#alrt-endDt').val() == null) {
            $('#alrt-endDt').val(involvedEmployee.dateConverter(dates[dates.length - 1], "mm/dd/yy"));
        }
    }


    // Legend Data
    let legendData = [],
        legend_names = [];
    for (i = 0; i < json_data.length; i++) {
        for (j = 0; j < json_data[i].anomalies.length; j++) {
            if (legend_names.indexOf(json_data[i].anomalies[j].name) === -1) {
                legendData.push(json_data[i].anomalies[j]);
                legend_names.push(json_data[i].anomalies[j].name);
            }
        }
    }

    let translate = 100;
    let anomaly_chart = ".communication_anomaly_chart";
    let svg;
    anomaly_chart = ".communication_anomaly_chart";
    translate = 10;
    let width = $(anomaly_chart).width(),
        height = 440;
    let total_width = width * (80 / 100);
    let margin_left = 80,
        margin_right = 0,
        margin_top = 20,
        margin_bottom = 80;
    $(anomaly_chart).html("");
    svg = d3.select(anomaly_chart).append("svg")
        .attr("width", width)
        .attr("height", height)
        .attr("border", "1px solid red");
    //}

    if (json_data.length == 0) {
        svg.on("mouseover", function() {
            $(this).css("cursor", "default");
        });
        svg.append("text")
            .attr("x", width / 2)
            .attr("y", (height / 2))
            .style("text-anchor", "start")
            .text("No Data")
            .style("font-family", "'IBM Helvetica Medium'")
            .style("font-size", "1em")
            .style("fill", "#777677")
            .style("font-weight", "normal");
        return;

    }
    // X Axis

    let x = d3.scaleBand()
        .domain(dates)
        .rangeRound([0, total_width]);

    let xAxis = d3.axisBottom(x).ticks(5);

    // Y Axis
    let y = d3.scaleLinear()
        .domain([1.0, 0.0])
        .range([margin_top, height - margin_bottom]);

    let yAxis = d3.axisLeft(y).ticks(5);


    //if (involvedEmployee.source == "anomaly") {
    svg.append("g").attr("class", "x axis").attr("transform", "translate(8," + (height - margin_bottom + translate + 15) + ")").call(xAxis)
        .style("font-family", "'IBM Helvetica Light'")
        .style("font-size", "0.825em")
        .style("fill", "#777677")
        .style("font-weight", "normal")
        .append("text")
        .attr("class", "label")
        .attr("x", parseInt(((width / 6) * 5) / 2) - 16)
        .attr("y", 40)
        .style("text-anchor", "middle")
        .text("Date")
        .style("font-family", "'IBM Helvetica Medium'")
        .style("font-size", "1em")
        .style("fill", "#777677")
        .style("font-weight", "normal");


    svg.append("g").attr("class", "y axis").attr("transform", "translate(" + (margin_left - 25) + ",0)").call(yAxis)
        .style("font-family", "'IBM Helvetica Light'")
        .style("font-size", "0.825em")
        .style("fill", "#777677")
        .style("font-weight", "normal")
        .append("text")
        .attr("class", "label")
        .attr("transform", "translate(" + (-100) + "," + (height / 2) + ")rotate(-90)")
        .attr("y", -5)
        .attr("dy", ".71em")
        .style("text-anchor", "middle")
        .text("COMMUNICATION ANOMALIES")
        .style("font-family", "'IBM Helvetica Bold'")
        .style("font-size", "1em")
        .style("fill", "#245966")
        .style("font-weight", "normal");

    svg.append("text")
        .attr("x", 5)
        .attr("y", 15)
        .style("text-anchor", "start")
        .text("Score")
        .attr("transform", "translate(" + (translate - 14) + "," + (height / 2) + ")rotate(-90)")
        .style("font-family", "'IBM Helvetica Medium'")
        .style("font-size", "0.925em")
        .style("fill", "#777677")
        .style("font-weight", "normal");

    /*} else {
        svg.append("g").attr("class", "x axis").attr("transform", "translate(8," + (height - margin_bottom + 15) + ")").call(xAxis)
            .style("font-family", "'IBM Helvetica Light'")
            .style("font-size", "0.525em")
            .style("fill", "#777677")
            .style("font-weight", "normal")
            .append("text")
            .attr("class", "label")
            .attr("x", parseInt(((width / 6) * 5) / 2)-16)
            .attr("y", 40)
            .style("text-anchor", "middle")
            .text("Date")
            .style("font-family", "'IBM Helvetica Medium'")
            .style("font-size", "1em")
            .style("fill", "#777677")
            .style("font-weight", "normal");

        svg.append("g").attr("class", "y axis").attr("transform", "translate(" + (margin_left - 25) + ",0)").call(yAxis)
            .style("font-family", "'IBM Helvetica Light'")
            .style("font-size", "0.525em")
            .style("fill", "#245966")
            .style("font-weight", "normal");

        svg.append("text")
            .attr("x", 5)
            .attr("y", 15)
            .style("text-anchor", "start")
            .text("Score")
            .attr("transform", "translate(" + (translate - 15) + "," + (height / 2) + ")rotate(-90)")
            .style("font-family", "'IBM Helvetica Medium'")
            .style("font-size", "0.525em")
            .style("fill", "#777677")
            .style("font-weight", "normal");
    }*/

    let yGridLines = [],
        yGridIndex = 0;
    svg.select(".y.axis").selectAll(".tick").each(function(data) {
        let tick = d3.select(this);
        let transform = involvedEmployee.getTransform(tick.attr("transform"));
        let obj = Object();
        obj.position = transform[1];
        obj.value = data;
        yGridLines[yGridIndex++] = obj;

    });

    let xGridLines = [],
        xGridIndex = 0;
    svg.select(".x.axis").selectAll(".tick").each(function(data) {
        let tick = d3.select(this);
        let transform = involvedEmployee.getTransform(tick.attr("transform"));
        let obj = Object();
        obj.position = transform[0];
        obj.value = data;
        xGridLines[xGridIndex++] = obj;
    });
    // Data Circles
    let valueline = d3.line()
        .x(function(d) {
            return x(d.date);
        })
        .y(function(d) {
            return y(d.score);
        });
    let area = d3.area()
        .x(function(d) {
            return x(d.date);
        })
        .y0(height - (margin_bottom))
        .y1(function(d) {
            return y(d.score);
        });
    let draw_data = [];

    for (let i = 0; i < json_data.length; i++) {
        let arr = json_data[i].anomalies;
        let res = arr.sort(function(a, b) {
            return (b.volume > a.volume) ? 1 : ((a.volume > b.volume) ? -1 : 0);
        });
        for (let j = 0; j < json_data[i].anomalies.length; j++) {
            let anomaly_obj = json_data[i].anomalies[j];
            anomaly_obj.date = json_data[i].date;
            draw_data.push(anomaly_obj);
        }
    }
    let minMax = d3.scaleLinear()
        .domain(d3.extent(draw_data, function(d) {
            return d.volume;
        }))
        .range([5, 20]);
    $(".communication_anomaly_chart .grid .tick line:odd").css("display", "none");

    svg.selectAll("circle").data(draw_data).enter()
        .append("circle")
        .style("opacity", "0.9")
        .attr("cx", function(d, i) {
            for (let l = 0; l < xGridLines.length; l++) {
                if (xGridLines[l].value == d.date) {
                    return (parseInt(xGridLines[l].position) + 8);
                }
            }
        })
        .attr("cy", function(d, i) {
            return y(d.score);
        })
        .attr("r", function(d, i) {
            return minMax(d.volume);

        })
        .attr("class", function(d, i) {
            let str = d.name;
            str = str.replace(/ /g, "_");
            return str = str.toLowerCase();
        })
        .style("fill", function(d, i) {
            let color = involvedEmployee.legendColor(d);
            return color;
        })
        .on("mouseover", function(d) {
            d3.select(this).style("fill-opacity", 1);
            d3.select(this).style("opacity", 1);
            d3.select(".tooltip").remove();
            let tooltip = d3.select("body").append("div")
                .classed("tooltip", true).classed("custom-tooltip", true)
                .style("opacity", 1);
            tooltip.transition()
                .duration(200);
            tooltip.html(involvedEmployee.toolTip(d))
                //tooltip.html(getAnomalyToolTipContent(d))
                .style("left", (d3.event.pageX + 10) + "px")
                .style("top", (d3.event.pageY - 28) + "px");
        })
        .on("mouseout", function(d) {
            d3.select(".tooltip").remove();
            d3.select(this).style("fill-opacity", "1");
            d3.select(this).style("opacity", "0.9");
        });

    //if (involvedEmployee.source == "anomaly") {

    let position_x = total_width,
        position_y = 20,
        legendtextclass = "legend_text",
        text_spacing_x = 35,
        text_spacing_y = 15;
    let bubblechart_legend_div = svg.append("g").attr("class", "legend").selectAll(".legend");

    let score_circle_position = 0;
    bubblechart_legend_div.data(legendData).enter().append("circle")
        .attr("cx", function(d, i) {
            return position_x;
        }).attr("cy", function(d, i) {
            score_circle_position = (i + 1) * 30 - position_y + 25;
            return (i + 1) * 30 - position_y + 25;
        }).attr("r", 5).style("fill", function(d, i) {
            return involvedEmployee.legendColor(d);
        });

    bubblechart_legend_div.data(legendData).enter().append("text")
        .attr("class", legendtextclass).attr("transform", function(d, i) {
            return "translate(" + (position_x + text_spacing_x - 20) + ")";
        }).attr("dy", function(d, i) {
            return (i + 1) * 30 - (position_y - text_spacing_y - 14);
        }).text(function(d) {
            return (d.name).toUpperCase();
        })
        .style("font-family", "'IBM Helvetica Medium'")
        .style("font-size", "0.625em")
        .style("fill", "#777677")
        .style("font-weight", "normal");

    score_circle_position = score_circle_position + 60;
    position_x = position_x + 13;
    let legCirRad = minMax.domain();
    svg.append("circle").attr("cx", position_x).attr("cy", score_circle_position).attr("r", 18).attr("fill", "#E9E8E5");
    svg.append("circle").attr("cx", position_x + 45).attr("cy", score_circle_position).attr("r", 14).attr("fill", "#E9E8E5");
    svg.append("line").attr("x1", position_x).attr("x2", position_x + 80).attr("y1", score_circle_position).attr("y2", score_circle_position).attr("stroke", "#E9E8E5");
    svg.append("circle").attr("cx", position_x + 80).attr("cy", score_circle_position).attr("r", 10).attr("fill", "#E9E8E5");
    svg.append("text").attr("transform", "translate(" + (position_x - 13) + ")").attr("dy", score_circle_position + 40).text("Volume")
        .style("font-family", "'IBM Helvetica Medium'")
        .style("font-size", "0.625em")
        .style("fill", "#777677")
        .style("font-weight", "normal");
    //}
}
involvedEmployee.loadPartyList = function(obj) {
    let involved_parties = obj.alert.involvedparties;
    if (involvedEmployee.alert_start_date == undefined || involvedEmployee.alert_start_date == '') {
        involvedEmployee.alert_start_date = involvedEmployee.dateConverter(obj.alert.startdate);
    }
    if (involvedEmployee.alert_end_date == undefined || involvedEmployee.alert_end_date == '') {
        involvedEmployee.alert_end_date = involvedEmployee.dateConverter(obj.alert.enddate);
    }


    let active_str = '';
    let list_str = '';
    let img = '';

    if (involved_parties.length == 0) {
        active_str = 'class="active"';
        img = cmnlocDetails.partial_homefolder + 'images/' + (involvedEmployee.url_party_id) + '.png';
        list_str += '<li ' + active_str + '><div id="user_outer_circle_' + involvedEmployee.url_party_id + '" class="userHglt"></div><img src="' + img + '"/></li>';
    }

    for (let i = 0; i < involved_parties.length; i++) {
        img = cmnlocDetails.partial_homefolder + 'images/' + (involved_parties[i].partyid) + '.png';
        //get employee initials
        let employeeName = involved_parties[i].partyname.split(" ")
        let initials = employeeName[0].substr(0, 1) + employeeName[1].substr(0, 1);
        if (involvedEmployee.url_party_id != undefined) {
            if (involvedEmployee.url_party_id == involved_parties[i].partyid) { //involvedEmployee.party_id==involved_parties[i].partyid ||
                active_str = 'class="active"';
                list_str += '<li ' + active_str + ' data-id="' + involved_parties[i].partyid + '"><div class="userHglt" id="user_outer_circle_' + involved_parties[i].partyid + '" onClick="involvedEmployee.showParty(' + involved_parties[i].partyid + ',0)"><p>' + initials + '</p></div></li>';
            } else {
                active_str = '';
                list_str += '<li ' + active_str + ' data-id="' + involved_parties[i].partyid + '"><div class="userHglt" id="user_outer_circle_' + involved_parties[i].partyid + '" onClick="involvedEmployee.showParty(' + involved_parties[i].partyid + ',0)"><p>' + initials + '</p></div></li>';
            }
        } else {
            if (i == 0) { //involvedEmployee.party_id==involved_parties[i].partyid ||
                active_str = 'class="active"';
                list_str += '<li ' + active_str + ' data-id="' + involved_parties[i].partyid + '"><div class="userHglt" id="user_outer_circle_' + involved_parties[i].partyid + '" onClick="involvedEmployee.showParty(' + involved_parties[i].partyid + ',0)"><p>' + initials + '</p></div></li>';
            } else {
                active_str = '';
                list_str += '<li ' + active_str + ' data-id="' + involved_parties[i].partyid + '"><div class="userHglt" id="user_outer_circle_' + involved_parties[i].partyid + '" onClick="involvedEmployee.showParty(' + involved_parties[i].partyid + ',0)"><p>' + initials + '</p></div></li>';
            }
        }
    }
    $(".user_list ul").html(list_str);

};
involvedEmployee.loadSummaryChart = function(obj) {
    involvedEmployee.data = obj;
    involvedEmployee.pieChartSettings();
};
involvedEmployee.loadSummaryDetailChart = function(obj) {
    involvedEmployee.data = obj;
    involvedEmployee.pieChartSettings();
    involvedEmployee.loadAlertHistory();
};
involvedEmployee.loadAlertOverview = function(obj) {
    let params = cmnFunc.getQueryParameters();
    if (params.alertid == undefined) {
        return;
    }
    let NavItem;
    if (involvedEmployee.alert_start_date == undefined || involvedEmployee.alert_start_date == '') {
        involvedEmployee.alert_start_date = involvedEmployee.dateConverter(obj.alert.startdate);
    }
    if (involvedEmployee.alert_end_date == undefined || involvedEmployee.alert_end_date == '') {
        involvedEmployee.alert_end_date = involvedEmployee.dateConverter(obj.alert.enddate);
    }

    $(".brdCrumSec").css("display", "block");

    involvedEmployee.setDates(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"), involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));

    if (involvedEmployee.source == "sentiment" || involvedEmployee.source == "emotion") {
        involvedEmployee.setDates(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"), involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
        $('#emotion-strtDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"));
        $('#emotion-endDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
        NavItem = $('.nav_section ul li:nth-child(4)');
        window.setTimeout(function() {
            involvedEmployee.showSection(NavItem, 'emotion_analysis_section', 1);
        }, 0);

    } else if (involvedEmployee.source == "anomaly") {
        involvedEmployee.setDates(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"), involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
        $('#alrt-strtDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_start_date, "mm/dd/yy"));
        $('#alrt-endDt').val(involvedEmployee.dateConverter(involvedEmployee.alert_end_date, "mm/dd/yy"));
        NavItem = $('.nav_section ul li:nth-child(3)');
        window.setTimeout(function() {
            involvedEmployee.showSection(NavItem, 'anomalies_section', 1);
        }, 0);
    } else if (involvedEmployee.source == "alert_summary") {
        NavItem = $('.nav_section ul li:nth-child(2)');
        window.setTimeout(function() {
            involvedEmployee.showSection(NavItem, 'history_section', 1);
        }, 0);
    } else {
        involvedEmployee.party_id = involvedEmployee.url_party_id;
        involvedEmployee.showParty(involvedEmployee.party_id, 1);
    }




    involvedEmployee.loadPartyList(obj);

};

involvedEmployee.convertPhoneNoFormat = function(phno) {
    let tmp = phno,
        t = [];
    tmp = tmp.replace("(", "");
    tmp = tmp.replace(")", "");
    t = tmp.split("-");
    if (t.length == 4) {
        return t[0] + "&nbsp;(" + t[1] + ")&nbsp;" + t[2] + "-" + t[3];
    } else {
        return phno;
    }
}
involvedEmployee.humanise = function(diff) {
    let str = '';
    let values = [
        [' year', 365]
    ];
    for (let i = 0; i < values.length; i++) {
        let amount = Math.floor(diff / values[i][1]);
        if (amount >= 1) {
            str += amount + values[i][0] + (amount > 1 ? 's' : '') + ' ';
            diff -= amount * values[i][1];
        }
    }

    return str;
}
involvedEmployee.loadPartyProfile = function(obj) {
    involvedEmployee.setDates();
    let party = obj.partyprofile;
    if (party == undefined) {
        return false;
    }
    let img;

    involvedEmployee.partyname = party.firstname + " " + party.lastname
    if (involvedEmployee.partyname != undefined && involvedEmployee.partyname != "") {
        $(".username").html(involvedEmployee.partyname);
    }

    img = cmnlocDetails.partial_homefolder + 'images/' + (party.partyid) + '.png';
    if (involvedEmployee.url_party_id != undefined && involvedEmployee.page == "party") {
        let list_str = '';
        active_str = 'class="active"';
        //get employee initials
        let employeeName = involvedEmployee.partyname.split(" ")
        let initials = employeeName[0].substr(0, 1) + employeeName[1].substr(0, 1);
        list_str += '<li ' + active_str + ' data-id="' + involvedEmployee.url_party_id + '"><div class="userHglt" id="user_outer_circle_' + involvedEmployee.partyid + '" onClick="involvedEmployee.showParty(' + involvedEmployee.url_party_id + ',0)"><p>' + initials + '</p></div></li>';
        $(".user_list ul").html(list_str);
    }
    let cls = "";
    let risk_value = parseInt(Math.round(party.riskrating * 100));
    if (risk_value >= 75) {
        cls = "filledred";
    } else if (risk_value >= 35 && risk_value < 75) {
        cls = "filledyellow";
    } else {
        cls = "filledgreen";
    }
    $(".float_left.circle.posrel").removeClass("filledgreen");
    $(".float_left.circle.posrel").removeClass("filledyellow");
    $(".float_left.circle.posrel").removeClass("filledred");
    $(".float_left.circle.posrel").addClass(cls);
    $(".risk_rating").html(risk_value);
    $(".active_alerts").html(party.activealerts);
    $(".past_violations").html(party.pastviolations);

    $(".user_profile .job_role").html(party.personalinfo.role);
    //party.personalinfo.timeinrole = 2707;
    if (party.personalinfo.hasOwnProperty('timeinrole') == true) {
        $(".user_profile .time_in_role").html(involvedEmployee.humanise(party.personalinfo.timeinrole));
    }

    $(".user_profile .emp_id").html(party.personalinfo.employeeid);
    $(".user_profile .location").html(party.personalinfo.city + ", " + party.personalinfo.state); //+" "+party.personalinfo.statecode
    $(".user_profile .desk_no").html(party.personalinfo.deskno);
    $(".user_profile .address").html(party.personalinfo.street + "<br/>" + party.personalinfo.city + ", " + party.personalinfo.state + "<br/>" + party.personalinfo.postalcode); //"+party.personalinfo.statecode+"
    $(".user_profile .phone_no").html(involvedEmployee.convertPhoneNoFormat(party.personalinfo.phone));
    $(".user_profile .email").html(party.personalinfo.email);
    $(".supervisor .name").html(party.supervisor.name);
    $(".supervisor .phone_no").html(involvedEmployee.convertPhoneNoFormat(party.supervisor.phone));
    $(".supervisor .email").html(party.supervisor.email);
}
involvedEmployee.loadBehaviorData = function(obj) {
    involvedEmployee.data.behavior = obj;
    involvedEmployee.emotionChartSettings();
}
involvedEmployee.callEvidenceAPI = function(emt, dt) {
    let classname = emt.toLowerCase();
    let evidence_url = cmnlocDetails.service;
    evidence_url += "/surveillanceui/v1/index/search/indent=on&q=comminitiatorid:" + involvedEmployee.party_id + "%20AND%20";
    evidence_url += "commstarttime:[" + involvedEmployee.dateConverter(dt) + "T00:00:00Z%20TO%20";
    evidence_url += involvedEmployee.dateConverter(dt) + "T11:59:59Z]%20AND%20commtags:" + classname + "&wt=json";
    //evidence_url += '/surveillanceui/v1/index/search/indent=on&q=partyid:10010%20AND%20comm_dt%20:[2017-04-04T00:00:00Z%20TO%202017-04-04T11:59:59Z]%20AND%20tags:sad&wt=json';

    let objBehEvidencedata = {
        type: "GET",
        //url:cmnlocDetails.partial_homefolder+"json/evidences.json",
        url: encodeURI(evidence_url),
        dataType: "json",
        ref: involvedEmployee,
        func: "behaviorEvidenceData",
        params: dt
    };

    cmnAsync.asynccall(objBehEvidencedata);
};
involvedEmployee.emotionEmotionAreaMouseEvnt = function(obj) {
    let emotion_mousex, emotion_x = obj.emotion_x,
        classname, all_data = obj.all_data,
        select_dt, tmp_dt, all_dt, tooltip, _this = obj.this,
        t_obj = {};
    emotion_mousex = d3.mouse(_this);
    emotion_mousex = emotion_mousex[0];

    invertedx = emotion_x.invert(emotion_mousex);
    classname = $(_this).attr("class");
    classname = classname.replace("browser ", "");

    select_dt = '', tmp_dt = '', all_dt = '';
    for (let k = 0; k < all_data.length; k++) {
        tmp_dt = invertedx;
        select_dt = (tmp_dt.getMonth() + 1) + "/" + tmp_dt.getDate() + "/" + tmp_dt.getFullYear();
        tmp_dt = all_data[k].date;
        all_dt = (tmp_dt.getMonth() + 1) + "/" + tmp_dt.getDate() + "/" + tmp_dt.getFullYear();
        if (select_dt == all_dt) {

            emotions = all_data[k].emotions;
            d3.select(".tooltip").remove();
            tooltip = d3.select("body").append("div")
                .classed("tooltip", true).classed("custom-tooltip", true)
                .style("opacity", 1);
            tooltip.transition()
                .duration(0);
            t_obj.emotion = classname.capitalize();
            t_obj.date = select_dt;
            t_obj.communications = all_data[k].totalcommunications ? all_data[k].totalcommunications : "0";
            t_obj.score = all_data[k].emotions[classname];
            tooltip.html(involvedEmployee.toolTip(t_obj))
                .style("left", (d3.event.pageX + 28) + "px")
                .style("top", (d3.event.pageY - 15) + "px");
        }
    }
}
involvedEmployee.emotionAreaMouseEvnt = function(obj) {
    let emotion_mousex, emotion_x = obj.emotion_x,
        classname, all_data = obj.all_data,
        select_dt, tmp_dt, all_dt, tooltip, _this = obj.this,
        tc_obj = {};
    emotion_mousex = d3.mouse(_this);
    emotion_mousex = emotion_mousex[0];
    invertedx = emotion_x.invert(emotion_mousex);
    classname = $(_this).attr("class");
    classname = classname.replace("browser ", "");

    select_dt = '', tmp_dt = '', all_dt = '';
    for (let k = 0; k < all_data.length; k++) {
        tmp_dt = invertedx;
        select_dt = (tmp_dt.getMonth() + 1) + "/" + tmp_dt.getDate() + "/" + tmp_dt.getFullYear();
        tmp_dt = all_data[k].date;
        all_dt = (tmp_dt.getMonth() + 1) + "/" + tmp_dt.getDate() + "/" + tmp_dt.getFullYear();
        if (select_dt == all_dt) {

            d3.select(".tooltip").remove();
            tooltip = d3.select("body").append("div")
                .classed("tooltip", true).classed("custom-tooltip", true)
                .style("opacity", 1);
            tooltip.transition()
                .duration(0);
            tc_obj.date = select_dt;
            tc_obj.communications = all_data[k].totalcommunications;
            tooltip.html(involvedEmployee.toolTip(tc_obj))
                .style("left", (d3.event.pageX + 28) + "px")
                .style("top", (d3.event.pageY - 15) + "px");
        }
    }
}
involvedEmployee.emotionChartSettings = function() {
    let tbl_obj = cmnFunc.createDmNode({
        node: "table",
        attr: [{
            node: "width",
            value: "100%"
        }]
    });
    let tbdy_obj = cmnFunc.createDmNode({
        node: "tbody",
        appendTo: tbl_obj
    });
    let tr_obj = cmnFunc.createDmNode({
        node: "tr",
        appendTo: tbdy_obj
    });
    let td1_obj = cmnFunc.createDmNode({
        node: "td",
        attr: [{
            node: "class",
            value: "header_title"
        }],
        html: "Date",
        appendTo: tr_obj
    });
    let td2_obj = cmnFunc.createDmNode({
        node: "td",
        attr: [{
            node: "class",
            value: "header_title"
        }],
        html: "Type",
        appendTo: tr_obj
    });
    let td3_obj = cmnFunc.createDmNode({
        node: "td",
        attr: [{
            node: "class",
            value: "header_title"
        }],
        html: "Description",
        appendTo: tr_obj
    });
    $(".evidence_list").append(tbl_obj);

    let emotion_indicator_position = [],
        mid_position, emotion_point_data, tmp_dt, select_dt, tooltip, tmp = {},
        tmp_obj = [],
        unique_dates = [];
    let wd = $(window).width(),
        amount_of_comm_font_size, amount_of_comm_position_x, emotion_legends, emotion_stack, translate;
    let emotion_stack_data = [],
        emotion_d, font_size, t_obj = {},
        tc_obj = {},
        invertedx, classname, all_data;
    let emotion_xGridLines = [],
        emotion_xGridIndex = 0,
        emotion_xaxisticks, emotion_keys, total_width, position_x;
    let position_y, legendtextclass, text_spacing_x, text_spacing_y, emotionchart_legend_div, emotions;
    let evidence_riskid, evidence_date, evidence_url, objBehEvidencedata;
    emRefdate = [];
    let emotion_color = [];
    emotion_color["anger"] = "#FF6259";
    emotion_color["anticipation"] = "#FF8248";
    emotion_color["disgust"] = "#8757A9";
    emotion_color["fear"] = "#00C3A6";
    emotion_color["joy"] = "#FFC73E";
    emotion_color["sadness"] = "#41A1CD";
    emotion_color["surprise"] = "#FF9B57";
    emotion_color["trust"] = "#BB80AC";

    $(".emotion_tooltip").attr("src", cmnlocDetails.partial_homefolder + "dist/images/F0455AE0-90EB-4FAB-B836-2F1CD92550DC@2x.png");
    $(".emotion_tooltip").on("click", function(event) {
        tooltip = involvedEmployee.dynTooltip();
        let t = tooltip;
        t.transition()
            .duration(200);

        t.html(involvedEmployee.showLabelToolTip(involvedEmployee.lc.emotionTooltip))
            .style("left", (event.pageX - 63) + "px")
            .style("top", (event.pageY - 190) + "px");
        $(".label_pointer").css("margin-top", "155px");
    }).on("mouseout", function(d) {
        d3.select(".svgtip").remove();
    });
    o = involvedEmployee.data.behavior.behaviorprofile;
    if (o == undefined) {
        return false;
    }
    o.sort(function(a, b) {
        return new Date(a.date).getTime() - new Date(b.date).getTime()
    });


    o.forEach(function(d) {
        if (unique_dates.length == 0) {
            unique_dates.push(d.date);
        } else {
            if ($.inArray(d.date, unique_dates) == -1) {
                unique_dates.push(d.date);
            }
        }
        tmp = {};
        tmp.sentiment = d.sentiment;
        tmp.totalcommunications = d.totalcommunications;
        tmp.date = d.date;
        tmp.emotions = {};
        tmp.emotions.sadness = d.emotions.sadness;
        tmp.emotions.joy = d.emotions.joy;
        tmp.emotions.fear = d.emotions.fear;
        tmp.emotions.disgust = d.emotions.disgust;
        tmp.emotions.anger = d.emotions.anger;
        // if (d.emotions.sadness != undefined) {
        //     tmp.emotions.sadness = d.emotions.sadness;
        // } else if (d.emotions.joy != undefined) {
        //     tmp.emotions.joy = d.emotions.sadness;
        // } else if (d.emotions.fear != undefined) {
        //     tmp.emotions.fear = d.emotions.sadness;
        // } else if (d.emotions.disgustevidence != undefined) {
        //     tmp.emotions.disgust = d.emotions.sadness;
        // } else if (d.emotions.angerevidence != undefined) {
        //     tmp.emotions.anger = d.emotions.sadness;
        // }
        tmp_obj.push(tmp);
    });
    obj = {};
    obj.behaviorprofile = tmp_obj;
    if (unique_dates.length >= 2) {
        if ($('#emotion-strtDt').val() == "" || $('#emotion-strtDt').val() == undefined || $('#emotion-strtDt').val() == null) {
            $('#emotion-strtDt').val(involvedEmployee.dateConverter(unique_dates[0], "mm/dd/yy"));
        }
        if ($('#emotion-endDt').val() == "" || $('#emotion-endDt').val() == undefined || $('#emotion-endDt').val() == null) {
            $('#emotion-endDt').val(involvedEmployee.dateConverter(unique_dates[unique_dates.length - 1], "mm/dd/yy"));
        }
    }
    //if (involvedEmployee.source == "sentiment") {
    d3.select("#big_emotion_chart svg.chart").attr("width", parseInt(wd / 1.7));

    emotion_svg = d3.select("#big_emotion_chart svg.chart");
    emotion_svg.selectAll("*").remove();
    emotion_svg = d3.select("#big_emotion_chart svg.chart");
    amount_of_comm_font_size = "1rem";
    amount_of_comm_position_x = 9;
    amount_of_comm_position_y = -118;

    d3.select("#big_emotion_chart svg.legends").attr("width", 85).style('transform', 'translateX(50px)');
    emotion_legends = d3.select("#big_emotion_chart svg.legends");
    emotion_legends.selectAll("*").remove();
    emotion_legends = d3.select("#big_emotion_chart svg.legends");

    emotion_margin = {
            top: 20,
            right: 60,
            bottom: 110,
            left: 60
        },
        emotion_margin2 = {
            top: 300,
            right: 60,
            bottom: 0,
            left: 60
        },
        emotion_width = +emotion_svg.attr("width") - emotion_margin.left - emotion_margin.right,
        emotion_height = +emotion_svg.attr("height") - emotion_margin.top - emotion_margin.bottom,
        emotion_height2 = +emotion_svg.attr("height") - emotion_margin2.top - emotion_margin2.bottom - 2;

    //}


    if (obj.behaviorprofile.length == 0) {
        emotion_svg.on("mouseover", function() {
            $(this).css("cursor", "default");
        });

        emotion_svg.append("text")
            .attr("x", emotion_width / 2)
            .attr("y", (emotion_height / 2))
            .style("text-anchor", "start")
            .text("No Data")
            .style("font-family", "'IBM Helvetica Medium'")
            .style("font-size", "1em")
            .style("fill", "#777677")
            .style("font-weight", "normal");
        return;
    }





    emotion_x = d3.scaleTime().range([0, emotion_width]),
        emotion_x2 = d3.scaleTime().range([0, emotion_width]),
        emotion_y = d3.scaleLinear().range([emotion_height, 0]),
        emotion_yr = d3.scaleLinear().range([emotion_height, 0]),
        emotion_y2 = d3.scaleLinear().range([emotion_height2, 0]);

    let ticks_count = 8;
    if (ticks_count > unique_dates.length) {
        ticks_count = unique_dates.length;
    }
    emotion_xAxis = d3.axisBottom(emotion_x).tickFormat(d3.timeFormat("%m/%d/%y")).ticks(ticks_count),
        emotion_xAxis2 = d3.axisBottom(emotion_x2),
        emotion_yAxis = d3.axisLeft(emotion_y).ticks(7),
        emotion_yAxis2 = d3.axisRight(emotion_yr).ticks(5);



    emotion_area = d3.area().curve(d3.curveMonotoneX)
        .x(function(d) {
            if (emotion_x(d.date) < 0) {
                return false;
            }
            return emotion_x(d.date);
        })
        .y0(emotion_height)
        .y1(function(d) {
            return emotion_y(d.totalcommunications);
        });

    emotion_area2 = d3.area()
        .curve(d3.curveMonotoneX)
        .x(function(d) {
            return emotion_x2(d.date);
        })
        .y0(emotion_height2)
        .y1(function(d) {
            return emotion_y2(d.totalcommunications);
        });



    emotion_focus = emotion_svg.append("g")
        .attr("class", "focus")
        .style("cursor", "default")
        .style("border", "1px solid red")
        .attr("transform", "translate(" + emotion_margin.left + "," + emotion_margin.top + ")");


    emotion_context = emotion_svg.append("g")
        .attr("class", "context")
        .attr("transform", "translate(" + emotion_margin2.left + "," + (emotion_margin2.top) + ")");


    emotion_stack = d3.stack();
    emotion_area3 = d3.area()
        .x(function(d) {
            if (emotion_x(d.data.date) >= 0) {
                return emotion_x(d.data.date);
            } else {
                return false;
            }
        })
        .y0(function(d) {
            return emotion_yr(d[0]);
        })
        .y1(function(d) {
            return emotion_yr(d[1]);
        });

    emotion_browser = emotion_svg.selectAll('.browser');

    emotion_ticks_data = [];
    emotion_svg.append("clipPath").attr("id", "clip").append("rect").attr("width", emotion_width).attr("height", emotion_height);
    emotion_svg.append("clipPath").attr("id", "clip-circle").append("rect").attr('x', '-15px').attr('y', '-50px').attr("width", emotion_width + 30).attr("height", emotion_height + 100);

    translate = 1;
    // add the X gridlines
    emotion_svg.append("g").attr("class", "grid").attr("transform", "translate(" + emotion_margin.left + "," + emotion_margin.top + ")").call(d3.axisLeft(emotion_y).tickSize(-emotion_width).tickFormat(""));

    $("#big_emotion_chart .chart .grid")[0].lastChild.setAttribute("opacity", "0");


    emotion_svg.append("text").attr("x", amount_of_comm_position_y).attr("y", amount_of_comm_position_x).style("text-anchor", "start").text("Amount of Communication").attr("transform", "translate(" + (translate + 2) + "," + (emotion_height / 2) + ") rotate(-90)").style("font-family", "'IBM Helvetica Medium'").style("font-size", amount_of_comm_font_size).style("fill", "#777677").style("font-weight", "normal");
    emotion_svg.append("text").attr("x", (emotion_height / 2.5)).attr("y", (emotion_width + 105) * -1).style("text-anchor", "start").text("Emotion Score").attr("transform", "rotate(90)").style("font-family", "'IBM Helvetica Medium'").style("font-size", amount_of_comm_font_size).style("fill", "#777677").style("font-weight", "normal");

    emotion_focus = emotion_svg.select("g.focus").attr("transform", "translate(" + emotion_margin.left + "," + emotion_margin.top + ")");
    emotion_context = emotion_svg.select("g.context").attr("transform", "translate(" + emotion_margin2.left + "," + (emotion_margin2.top) + ")");

    emotion_d = obj.behaviorprofile;


    $.each(emotion_d, function(index, value) {
        emotion_d[index].date = new Date(emotion_d[index].date);
        let obj = {};
        obj.date = emotion_d[index].date;
        obj.joy = emotion_d[index].emotions.joy;
        obj.anger = emotion_d[index].emotions.anger;
        obj.fear = emotion_d[index].emotions.fear;
        obj.disgust = emotion_d[index].emotions.disgust;
        obj.sadness = emotion_d[index].emotions.sadness;
        emotion_stack_data[index] = obj;
    });


    emotion_x.domain(d3.extent(emotion_d, function(d) {
        emRefdate.push(d.date);
        return new Date(d.date);
    }));
    emotion_y.domain([0, d3.max(emotion_d, function(d) {
        return d.totalcommunications;
    })]);
    emotion_yr.domain([0, 3]);
    emotion_x2.domain(emotion_x.domain());
    emotion_y2.domain([0, d3.max(emotion_d, function(d) {
        return d.totalcommunications;
    })]);



    t_obj = {};
    tc_obj = {};

    //if (involvedEmployee.source == "sentiment") {
    emotion_focus.append("path")
        .datum(emotion_d)
        .attr("class", "area")
        .attr("d", emotion_area)
        .on("mouseover", function(d, i) {
            let o = {};
            o.emotion_x = emotion_x;
            o.this = this;
            o.all_data = obj.behaviorprofile;
            involvedEmployee.emotionAreaMouseEvnt(o);
        })
        .on("mousemove", function(d, i) {
            let o = {};
            o.emotion_x = emotion_x;
            o.this = this;
            o.all_data = obj.behaviorprofile;
            involvedEmployee.emotionAreaMouseEvnt(o);
        })
        .on("mouseout", function(d, i) {
            d3.select(".tooltip").remove();
        });


    font_size = "1rem";

    involvedEmployee.emotionCirclesPlot = function() {
        let emotion_indicator_position = [];
        d3.select("g.grpCrcle").remove();
        d3.select(".emotions_points_circle").remove();
        let currentCircle = '';
        emotion_svg.append("g").attr("class", "grpCrcle").attr("transform", "translate(60,20)").attr("clip-path", "url(#clip-circle)").selectAll(".emotions_points_circle")
            .data(emotion_d)
            .enter()
            .append("circle")
            .classed("emotions_points_circle", true)
            .style("fill", "rgba(255, 255, 255, 0.7)")
            .style("stroke", "black")
            .attr("cx", function(d, i) {
                emotion_indicator_position[i] = {};
                emotion_indicator_position[i].x = emotion_x(d.date);
                return emotion_indicator_position[i].x;
            })
            .attr("cy", function(d, i) {
                mid_position = emotion_height / 2;
                emotion_indicator_position[i].y = emotion_y(d.totalcommunications);
                return emotion_indicator_position[i].y;
            })
            .attr("r", function(d, i) {
                emotion_point_data = emotion_d[i].emotions;

                if ((emotion_point_data.hasOwnProperty("joy") == true) || (emotion_point_data.hasOwnProperty("anger") == true) ||
                    (emotion_point_data.hasOwnProperty("sadness") == true) || (emotion_point_data.hasOwnProperty("disgust") == true) ||
                    (emotion_point_data.hasOwnProperty("fear") == true)) {
                    return 7;
                } else {
                    return 0;
                }
            })

            .on("mouseover", function(d, ind) {
                currentCircle = this;
                let _this = this;
                let _d = {
                    date: d.date,
                    Sentiment: d.sentiment.type.capitalize(),
                    Communication: "" + d.totalcommunications
                };
                d3.select(this).style("opacity", 0);
                d3.select(".emotions_circle").remove();
                d3.select(".emoCrcle").remove();

                emotion_point_data = emotion_d[ind].emotions;

                var emotionCircleGroup = d3.select("body")
                    .append("div")
                    .classed('emotion-circle-group', true)
                    .attr("clip-path", "url(#clip-circle-group)");


                emotionCircleGroup.on("mouseleave", function(d, ind) {
                    d3.select(".tooltip").remove();
                    d3.select('.emotion-circle-group').remove();
                    d3.select(_this).style("opacity", 1);
                });

                var cy = emotion_indicator_position[ind].y;
                var cx = emotion_indicator_position[ind].x;
                var matrix = d3.select(this).node().getScreenCTM().translate(+cx, +cy);

                emotionCircleGroup
                    .style("top", function() {
                        return (matrix.f - 35) + 'px';
                    })
                    .style("left", function() {
                        return (matrix.e - 35) + 'px';
                    });

                Object.keys(emotion_point_data).forEach(function(key, index) {
                    index++;
                    emotionCircleGroup.append("div")
                        .classed(key + "_circle emoCrcle", true)
                        .style("background-color", emotion_color[key])
                        .on("click", function() {
                            tmp_dt = emotion_d[ind].date;
                            select_dt = (tmp_dt.getMonth() + 1) + "/" + tmp_dt.getDate() + "/" + tmp_dt.getFullYear();
                            involvedEmployee.callEvidenceAPI(key, select_dt);
                        }).on("mouseleave", function(d) {
                            d3.select(".tooltip").remove();
                        }).on("mouseenter", function(d) {
                            d3.select(".tooltip").remove();
                            let tooltip = d3.select("body").append("div")
                                .classed("tooltip", true).classed("custom-tooltip", true)
                                .style("opacity", 1);
                            tooltip.transition()
                                .duration(200);
                            _d.Emotion = key.capitalize();
                            tooltip.html(involvedEmployee.toolTip(_d)).style("left", (d3.event.pageX + 20) + "px")
                                .style("top", (d3.event.pageY - 15) + "px");
                        });
                });

            });

            //if the page is scrolled hide any visible circles
            $(window).on('scroll', function() {
                if (currentCircle) {
                    d3.select(".tooltip").remove();
                    d3.select('.emotion-circle-group').remove();
                    d3.select(currentCircle).style("opacity", 1);
                }
            })
    }
    emotion_focus.append("g")
        .attr("class", "axis axis--x")
        .attr("transform", "translate(0," + (emotion_height + 10) + ")")
        .call(emotion_xAxis)
        .attr("text-anchor", "middle")
        .style("font-family", "'IBM Helvetica Light'")
        .style("font-size", font_size)
        .style("fill", "#245966")
        .style("font-weight", "normal")
        .selectAll(".tick text")
        .attr('fill', '#555D5A');

    emotion_focus.append("g")
        .attr("class", "axis aoc-axis--y")
        .attr("transform", "translate(0,0)")
        .call(emotion_yAxis)
        .style("font-family", "'IBM Helvetica Light'")
        .style("font-size", font_size)
        .style("fill", "#245966")
        .style("font-weight", "normal")
        .style('transform', 'translateX(-10px)')
        .selectAll(".tick text")
        .attr("x", -4).attr('fill', '#555D5A');

    emotion_focus.append("g")
        .attr("class", "axis emotion-score-axis-y")
        .attr("transform", "translate(0,0)")
        .call(emotion_yAxis2)
        .style("font-family", "'IBM Helvetica Light'")
        .style("font-size", font_size)
        .style("fill", "#245966")
        .style("font-weight", "normal")
        .style('transform', 'translateX('+ (emotion_width + 20) +'px)')
        .selectAll(".tick text")
        .attr("x", -4).attr('fill', '#555D5A');

    emotion_context.append("path")
        .datum(emotion_d)
        .attr("class", "area")
        .attr("d", emotion_area2);


    //Grid Lines
    emotion_xaxisticks = emotion_svg.select(".axis.axis--x").selectAll(".tick");
    emotion_keys = [];
    $.each(emotion_d[0].emotions, function(index, value) {
        // if (index != "sadness" && index != "joy" && index != "anger" && index != "disgust" && index != "fear") {
        emotion_keys.push(index);
        // }
    });

    emotion_stack.keys(emotion_keys);
    emotion_stack.order(d3.stackOrderNone);
    emotion_stack.offset(d3.stackOffsetWiggle);


    emotion_keys = emotion_keys.sort(function(a, b) {
        return a > b;
    });

    //if (involvedEmployee.source == "sentiment") {
    total_width = parseInt(wd / 9);
    position_x = 20;
    position_y = 20;
    legendtextclass = "legend_text";
    text_spacing_x = 15;
    text_spacing_y = 15;
    emotionchart_legend_div = emotion_legends.append("g").attr("class", "legend").selectAll(".legend");
    emotionchart_legend_div.data(emotion_keys).enter().append("circle")
        .attr("cx", function(d, i) {
            return position_x;
        }).attr("cy", function(d, i) {
            return (i + 1) * 30 - position_y + 20;
        }).attr("r", 5).style("fill", function(d, i) {
            return emotion_color[d];
        });

    emotionchart_legend_div.data(emotion_keys).enter().append("text")
        .attr("class", legendtextclass).attr("transform", function(d, i) {
            return "translate(" + (position_x + text_spacing_x) + ")";
        }).attr("dy", function(d, i) {
            return (i + 1) * 30 - (position_y - text_spacing_y - 8);
        }).text(function(d) {
            return d.toUpperCase();
        })
        .style("font-family", "'IBM Helvetica Medium'")
        .style("font-size", "0.625em")
        .style("fill", "#777677")
        .style("font-weight", "normal");



    t_obj = {};
    emotion_browser = emotion_svg.selectAll('.browser')
        .data(emotion_stack(emotion_stack_data))
        .enter().append('g')
        .attr('class', function(d) {
            return 'browser ' + d.key;
        })
        .attr("transform", "translate(" + emotion_margin.left + "," + emotion_margin.top + ")")
        .attr('fill-opacity', 1)
        .on("mouseout", function(d, i) {
            d3.select(".tooltip").remove();
        })
        .on("mousemove", function(d, i) {
            let o = {};
            o.emotion_x = emotion_x;
            o.this = this;
            o.all_data = obj.behaviorprofile;
            involvedEmployee.emotionEmotionAreaMouseEvnt(o);
        })
        .on("mouseover", function(d, i) {
            let o = {};
            o.emotion_x = emotion_x;
            o.this = this;
            o.all_data = obj.behaviorprofile;
            involvedEmployee.emotionEmotionAreaMouseEvnt(o);
        });

    emotion_browser.append('path')
        .attr('class', 'area')
        .attr('d', emotion_area3)
        .style('cursor', "pointer")
        .style('fill', function(d) {
            return emotion_color[d.key];
        });



    emotion_brush = d3.brushX().extent([
            [0, 0],
            [emotion_width, emotion_height2]
        ])
        .on("brush end", function() {
            let obj = {};
            obj.emotion_x = emotion_x;
            obj.emotion_focus = emotion_focus;
            obj.emotion_browser = emotion_browser;
            obj.emotion_svg = emotion_svg;
            obj.emotion_width = emotion_width;
            obj.emotion_xAxis = emotion_xAxis;
            obj.emotion_d = emotion_d;
            obj.emotion_x2 = emotion_x2;
            obj.emotion_area = emotion_area;
            obj.emotion_area3 = emotion_area3;
            obj.emotion_zoom = emotion_zoom;
            obj.emotion_handle = emotion_handle;
            obj.emotion_color = emotion_color;
            involvedEmployee.emotion_brushed(obj);
        });

    emotion_zoom = d3.zoom().scaleExtent([1, Infinity]).translateExtent([
            [0, 0],
            [emotion_width, emotion_height]
        ]).extent([
            [0, 0],
            [emotion_width, emotion_height]
        ])
        .on("zoom", function() {
            let obj = {};
            obj.emotion_x = emotion_x;
            obj.emotion_focus = emotion_focus;
            obj.emotion_browser = emotion_browser;
            obj.emotion_svg = emotion_svg;
            obj.emotion_width = emotion_width;
            obj.emotion_xAxis = emotion_xAxis;
            obj.emotion_d = emotion_d;
            obj.emotion_x2 = emotion_x2;
            obj.emotion_area = emotion_area;
            obj.emotion_area3 = emotion_area3;
            obj.emotion_zoom = emotion_zoom;
            obj.emotion_handle = emotion_handle;
            obj.emotion_color = emotion_color;
            involvedEmployee.emotion_zoomed(obj);
        });

    emotion_gBrush = emotion_context.append("g")
        .attr("class", "brush")
        .call(emotion_brush);
    emotion_handle = emotion_gBrush.selectAll(".handle--custom")
        .data([{
            type: "w"
        }, {
            type: "e"
        }])
        .enter().append("path")
        .attr("class", "handle--custom")
        .attr("fill-opacity", 0.8)
        .attr("cursor", "ew-resize")
        .attr("d", function(d) {
            var e = +(d.type == "e"),
                x = 1,
                y = (emotion_height2 / 2) - 9;
            /*return "M" + (.5 * x) + "," + y + "A6,6 0 0 " + e + " " + (6.5 * x) + "," + (y + 6) + "V" + (2 * y - 6) + "A6,6 0 0 " + e + " " + (.5 * x) + "," + (2 * y) + "Z" + "M" + (2.5 * x) + "," + (y + 8) + "V" + (2 * y - 8) + "M" + (4.5 * x) + "," + (y + 8) + "V" + (2 * y - 8);*/
            if (!e) {
                return 'M 0 7 l 0, 59 l 22, -29 z';
            } else {
                return 'M 0 7 l -22, 30 l 22, 29 z';
            }

            //M0,0 L0,6 L9,3 M -1 30 l 0, 15 l 19, -7 z
        });

    emotion_gBrush.call(emotion_brush.move, emotion_x.range());
}



involvedEmployee.behaviorEvidenceData = function(o, select_dt) {
    $("#evidence_list").html('');

    let evidences_obj = {},
        l = involvedEmployee.lc,
        data_obj = [],
        desc, desc_obj, obj = o || {},
        res = obj.response;
    let id = $("#evidence_records");
    if (res.numFound == 0) {
        id.removeClass("hide");
        id.html(l.nrecordavl);
    } else {
        id.addClass("hide");
        id.html(" ");
    }
    for (let i = 0; i < res.numFound; i++) {
        let d = res.docs[i];
        if ((d != undefined) && (d.alertid != undefined) && (d.alertevidenceids !=undefined)) {
			let o={};
            o.evidenceid = d.evidenceids ? d.evidenceids[0] : null;
            o.alertid = involvedEmployee.alert_id ? involvedEmployee.alert_id : d.alertid;
            if (involvedEmployee.party_id == null || involvedEmployee.party_id == undefined) {
                if (involvedEmployee.url_party_id == null || involvedEmployee.url_party_id == undefined) {
                    o.partyid = d.partyid[0];
                } else {
                    o.partyid = involvedEmployee.url_party_id;
                }
            } else {
                o.partyid = involvedEmployee.party_id;
            }
            desc_obj = d;
            desc = "";
            if (desc_obj.hasOwnProperty("description") == true) {
                desc = d.description;
            }
            o.description = desc;
            o.date = involvedEmployee.dateConverter(select_dt, "yyyy/mm/dd");
            o.type = d.commtype ? d.commtype.capitalize() : "NA";
			data_obj.push(o);
        }
    }
    evidences_obj.evidences = data_obj;


    obj = {
        tblId: 'evidence_list',
        dataObj: data_obj,
        tblObj: {
            headerObj: [{
                    field: l.date,
                    class: "tw10",
                    sortFld: {
                        dataType: "numeric",
                        field: "date",
                        func: function(dt) {
                            return new Date(dt);
                        }
                    },
                },
                {
                    field: l.type,
                    class: "tw10",
                    sortFld: {
                        field: "type"
                    },
                },
                {
                    field: l.descrip,
                    class: "tw70",
                    sortFld: {
                        field: "description"
                    },
                }
            ],
            tbdyobj: [{
                    field: "date",
                    format: function(fld, data, obj) {
                        return fld.html(cmnFunc.convertNotesDate(data));
                    }
                },
                {
                    field: "type",
                    format: function(fld, data, obj) {
                        fld.html(data)
                        return fld.html(data);
                    }
                },
                {
                    field: "description",
                    format: function(fld, data, obj) {
                        return fld.html(data);
                    }
                }
            ],
            trRowClickFunc: function(tr, obj) {
                let flg = involvedEmployee.evidenceTblLinkGen(obj);
                let t = $(tr);
                if (flg) {
                    t.on("click", function() {
                        window.location = flg;
                    });
                }
                t.addClass("evidenceTbl");
            }
        }
    }
    tableFunc.create(obj);
};


involvedEmployee.callParty = function() {
    header.init("headerNode");
    $(".brdCrumSec.alertmetadatabar").css("display", "none");
    involvedEmployee.party_id = involvedEmployee.url_party_id;
    involvedEmployee.callAPIPartyProfile();
};


involvedEmployee.setDates = function(startdate = '', enddate = '') {

    if (startdate != '' && enddate != '') {
        $('#alrt-strtDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#alrt-endDt').datepicker('option', 'minDate', date);
                if ($("#alrt-endDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.source = "anomaly";
                    involvedEmployee.callAPIAnomalyDetails();
                }
            }
        });
        $('#alrt-endDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#alrt-strtDt').datepicker('option', 'maxDate', date);
                if ($("#alrt-strtDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.source = "anomaly";
                    involvedEmployee.callAPIAnomalyDetails();
                }
            }
        });

        $('#emotion-strtDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#emotion-endDt').datepicker('option', 'minDate', date);
                if ($("#emotion-endDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.source = "sentiment";
                    involvedEmployee.callAPIBehavior();
                }
            }
        });
        $('#emotion-endDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#emotion-strtDt').datepicker('option', 'maxDate', date);
                if ($("#emotion-strtDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.souce = "sentiment";
                    involvedEmployee.callAPIBehavior();
                }
            }
        });
    } else {
        $('#alrt-strtDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#alrt-endDt').datepicker('option', 'minDate', date);
                if ($("#alrt-endDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.source = "anomaly";
                    involvedEmployee.callAPIAnomalyDetails();
                }
            }
        });
        $('#alrt-endDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#alrt-strtDt').datepicker('option', 'maxDate', date);
                if ($("#alrt-strtDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.source = "anomaly";
                    involvedEmployee.callAPIAnomalyDetails();
                }
            }
        });

        $('#emotion-strtDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#emotion-endDt').datepicker('option', 'minDate', date);
                if ($("#emotion-endDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.source = "sentiment";
                    involvedEmployee.callAPIBehavior();
                }
            }
        });
        $('#emotion-endDt').datepicker({
            beforeShow: function(input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            onSelect: function(date) {
                //$('#emotion-strtDt').datepicker('option', 'maxDate', date);
                if ($("#emotion-strtDt").val() != "" && $(this).val() != "") {
                    involvedEmployee.source = "sentiment";
                    involvedEmployee.callAPIBehavior();
                }
            }
        });

    }


    $('*[data-id="alrt-strtDt"]').on("click", function(evt) {
        evt.stopPropagation();
        $("#alrt-strtDt").datepicker("show");
    });
    $('*[data-id="alrt-endDt"]').on("click", function(evt) {
        evt.stopPropagation();
        $("#alrt-endDt").datepicker("show");
    });
    $("#alrt-strtDt").on("change", function() {
        if ($("#alrt-endDt").val() != "" && $(this).val() != "") {
            involvedEmployee.source = "anomaly";
            involvedEmployee.callAPIAnomalyDetails();
        }
    });
    $("#alrt-endDt").on("change", function() {
        if ($("#alrt-strtDt").val() != "" && $(this).val() != "") {
            involvedEmployee.source = "anomaly";
            involvedEmployee.callAPIAnomalyDetails();
        }
    });

    $('*[data-id="emotion-strtDt"]').on("click", function(evt) {
        evt.stopPropagation();
        $("#emotion-strtDt").datepicker("show");
    });
    $('*[data-id="emotion-endDt"]').on("click", function(evt) {
        evt.stopPropagation();
        $("#emotion-endDt").datepicker("show");
    });
    $("#emotion-strtDt").on("change", function() {
        if ($("#emotion-endDt").val() != "" && $(this).val() != "") {
            involvedEmployee.source = "sentiment";
            involvedEmployee.callAPIBehavior();
        }
    });
    $("#emotion-endDt").on("change", function() {
        if ($("#emotion-strtDt").val() != "" && $(this).val() != "") {
            involvedEmployee.source = "sentiment";
            involvedEmployee.callAPIBehavior();
        }
    });
}
involvedEmployee.afterInit = function(obj) {

    involvedEmployee.url_party_id = involvedEmployee.url_party_id ? involvedEmployee.url_party_id : obj.alert.involvedparties[0].partyid;
    let params = cmnFunc.getQueryParameters();
    if (params.startdate != undefined) {
        involvedEmployee.alert_start_date = involvedEmployee.dateConverter(params.startdate);
    }
    if (params.enddate != undefined) {
        involvedEmployee.alert_end_date = involvedEmployee.dateConverter(params.enddate);
    }

    if (params.alertid != undefined) {
        involvedEmployee.page = "alert";
        if (involvedEmployee.url_party_id != undefined) {
            involvedEmployee.party_id = involvedEmployee.url_party_id;
        }
        involvedEmployee.callAPIAlertOverview();
    } else if (params.partyid != undefined) {
        involvedEmployee.page = "party";
        involvedEmployee.party_id = involvedEmployee.url_party_id;
        $(".main_section").css("margin-top", "0px");
        involvedEmployee.callAPIAlertOverview();
        involvedEmployee.callParty();
    } else if (params.source != undefined) {
        involvedEmployee.page = "source";
        involvedEmployee.party_id = involvedEmployee.url_party_id;
        involvedEmployee.callAPIAlertOverview();
    }
}
involvedEmployee.fillLoc = function(d) {
    let s = [{
            id: "invLpersonal",
            txt: d.personalC
        }, {
            id: "invHPersoInfo",
            txt: d.personalInformation
        }, {
            id: "invHHistory",
            txt: d.history
        }, {
            id: "invHAnomaly",
            txt: d.anamolies
        }, {
            id: "invHEmotAnalysis",
            txt: d.emotionAnalysis
        },
        {
            id: "invHPersoInfo",
            txt: d.personalC.toLowerCase()
        }, {
            id: "invLJobRole",
            txt: d.jobRole + ":"
        }, {
            id: "invLempId",
            txt: d.employeeId + ":"
        }, {
            id: "invLlocation",
            txt: d.location + ":"
        },
        {
            id: "invLDeskNo",
            txt: d.deskNo + ":"
        }, {
            id: "invLAddress",
            txt: d.address + ":"
        }, {
            id: "invPhone",
            txt: d.phone + ":"
        }, {
            id: "invLemail",
            txt: d.email + ":"
        },
        {
            id: "invHsuperV",
            txt: d.supervisorC
        }, {
            id: "invLsupervisor",
            txt: d.supervisor + ":"
        }, {
            id: "invLPhone",
            txt: d.phone + ":"
        }, {
            id: "invLEmail",
            txt: d.email + ":"
        },
        {
            id: "invHSumamry",
            txt: d.summaryC
        }, {
            id: "invRiskRt",
            txt: d.riskRatingC
        }, {
            id: "invActvAlerts",
            txt: d.activeAlerts
        }, {
            id: "invPastViol",
            txt: d.pastViolations
        },
        {
            id: "invAlerSumm",
            txt: d.alertSummary
        }, {
            id: "invAlrtHistory",
            txt: d.alertHistory
        }, {
            id: "invAanamoly",
            txt: d.anamoliesC
        }, {
            id: "invEvidnc",
            txt: d.evidenceC
        },
        {
            id: "invEmAnalys",
            txt: d.emoAnalysis
        }, {
            id: "invTminRl",
            txt: d.timeInRole
        }
    ];
    let lbl = [{
        id: "alrt-strtDt",
        txt: d.startdt
    }, {
        id: "alrt-endDt",
        txt: d.enddt
    }, {
        id: "emotion-strtDt",
        txt: d.startdt
    }, {
        id: "emotion-endDt",
        txt: d.enddt
    }];
    for (let i = 0; i < s.length; i++) {
        cmnFunc.fillIdNode(s[i]);
    }
    for (let i = 0; i < lbl.length; i++) {
        cmnFunc.fillLblNode(lbl[i]);
    }
}
involvedEmployee.initDtObj = function(data, l) {
    //drawHeader object
    involvedEmployee.fillLoc(data);
    involvedEmployee.lc = data;
    let params = cmnFunc.getQueryParameters();
    if (params.alertid != undefined && params.alertid != "" && params.alertid != null) {
        autoHeader.generate("mnuInvEmp", true, {
            ref: involvedEmployee,
            func: "initDetails",
            param: params
        });
    } else {
        involvedEmployee.initDetails(params, data);
    }

}
involvedEmployee.initDetails = function(params, data) {
    let alert_obj = $.parseJSON(sessionStorage.getItem('alertMetaData'));

    //let NavItem;
    involvedEmployee.alert_id = params.alertid;
    involvedEmployee.url_party_id = params.partyid;
    involvedEmployee.source = params.source;


    $("#invHPersoInfo").click(function() {
        involvedEmployee.showSection(this, 'personal_info_section');
    });
    $("#invHHistory").click(function() {
        involvedEmployee.showSection(this, 'history_section');
    });
    $("#invHAnomaly").click(function() {
        involvedEmployee.showSection(this, 'anomalies_section');
    });
    $("#invHEmotAnalysis").click(function() {
        involvedEmployee.showSection(this, 'emotion_analysis_section');
    });

    let url_path = window.location.href;
    base_path = url_path.split("#");
    if (base_path[1] != undefined && base_path[1] != null && base_path[1] != '') {
        if (base_path[1] == "personal_info_section") {
            involvedEmployee.source = "personal_info";
        } else if (base_path[1] == "history_section") {
            involvedEmployee.source = "alert_summary";
        } else if (base_path[1] == "anomalies_section") {
            involvedEmployee.source = "anomaly";
        } else if (base_path[1] == "emotion_analysis_section") {
            involvedEmployee.source = "sentiment";
        }
    }



    involvedEmployee.afterInit(alert_obj);
}


$(document).ready(function() {
    cmnFunc.localeStr({
        ref: involvedEmployee,
        func: "initDtObj"
    });
});



//function for showing and hiding sections
involvedEmployee.showSection = function(navItem, section) {
    console.log('showing section');

    //show selected tab section in navigation
    $('.nav_section ul li').each(function(index, elem) {
        $(elem).removeClass('active');
    });
    $(navItem).addClass('active');

    let url_path = window.location.href;
    let base_path = url_path.split("#")[0];

    //show selected section
    $('.info_container section').each(function(index, elem) {
        if (!$(elem).hasClass(section)) {
            $(elem).hide();
        } else {
            $(elem).fadeIn();
        }
    });

    window.location.href = base_path + "#" + section;

    if (section === 'personal_info_section') {
        involvedEmployee.callAPIPartyProfile();
    }

    if (section === 'history_section') {
        involvedEmployee.callAPIPartyProfile();
        involvedEmployee.source = "alert_summary";
        involvedEmployee.callAPIAlertSummaryDetails();
    }

    if (section == 'anomalies_section') {
        involvedEmployee.callAPIPartyProfile();
        involvedEmployee.source = "anomaly";
        involvedEmployee.callAPIAnomalyDetails();
    }

    if (section === 'emotion_analysis_section') {
        involvedEmployee.callAPIPartyProfile();
        involvedEmployee.source = "sentiment";
        involvedEmployee.callAPIBehavior();
    }


    $('.info_container').scrollTop(0);
}


//Reset panel section to Personal Information when the involved employee changes
involvedEmployee.resetSection = function() {
    let personalNavItem = $('.nav_section ul li').first();
    involvedEmployee.showSection(personalNavItem, 'personal_info_section');
}
