/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
"use strict";

const cmnAsync = {};

const cmnlocDetails = {
    full_hostname: location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : ''),
    partial_hostname: location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : ''),
    partial_homefolder: location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '') + "/" + location.pathname.split("/")[1] + "/",
    service: location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '') + "/SIFSServices",
    imgService: location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '') + "/" + location.pathname.split("/")[1] + "/images/",
    modelService: location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '') + "/SIFSModelServices/",
    jobService: location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '') + "/SIFSServices/job/"
};
cmnlocDetails.alertOvrSrvc = cmnlocDetails.service + "/alertservice/v1/alert/";
cmnlocDetails.notesSrvc = cmnlocDetails.service + "/noteservice/v2/alert/";

const cmnFunc = {
    //solrQuery:cmnlocDetails.service+"/surveillanceui/v1/solr/sifs/select?indent=on&wt=json&rows=3&start=0&q=doctype:party AND name:"
    solrQuery: cmnlocDetails.partial_homefolder + "solr/sifs/select?indent=on&wt=json&rows=3&start=0&q=doctype:party AND name:"
};
const cmnEvidences = {}
cmnAsync.asynccall = function (obj) {
    let jrquest,
        asyncVal,
        param = obj.params ? obj.params : null,
        refObj = {
            'url': obj.url,
            'headers': {
                // 'Access-Control-Allow-Origin': '*',
                'content-type': 'application/json'
            },
            'success': function (data) {
                if (obj.func && obj.ref) {
                    if (param != null) {
                        obj.ref[obj.func].apply(obj.ref, [data, param]);
                    } else {
                        obj.ref[obj.func].apply(obj.ref, [data]);
                    }

                } else if (obj.func) {
                    if (param != null) {
                        obj.func.apply(obj.ref, [data, param]);
                    } else {
                        obj.func.apply(obj.ref, [data]);
                    }
                }

                jrquest = data;
            },
            'error': function (error) {
                if (obj.func && obj.ref) {
                    if (param != null) {
                        obj.ref[obj.func].apply(obj.ref, [error, param]);
                    } else {
                        obj.ref[obj.func].apply(obj.ref, [error]);
                    }

                } else if (obj.func) {
                    if (param != null) {
                        obj.func.apply(obj.ref, [error, param]);
                    } else {
                        obj.func.apply(obj.ref, [error]);
                    }
                }


            }
        };
    if (obj.func) {
        refObj.async = true;
    }
    if (obj.dataType) {
        refObj.dataType = obj.dataType;
    }
    if (obj.data) {
        refObj.data = obj.data;
    }
    if (obj.type.toUpperCase() == "GET") {
        refObj.type = "GET";
        $.ajax(refObj);
        return jrquest;
    } else if (obj.type.toUpperCase() == "POST") {
        refObj.type = "POST";
        $.ajax(refObj);
    } else if (obj.type.toUpperCase() == "PUT") {
        refObj.type = "PUT";
        $.ajax(refObj);
    } else if (obj.type.toUpperCase() == "DELETE") {
        refObj.type = "DELETE";
        $.ajax(refObj);
    } else {
        return false;
    }

}
/*******common func starts Here *************/
cmnFunc.roundScore = function (data) {
    return data * 100;
}
cmnFunc.cnstrctDateformat = function (dtObj) {
    let delimiter = "/";
    let year = dtObj.getFullYear(),
        month = dtObj.getMonth() + 1,
        dt = dtObj.getDate();
    if (dt < 10) {
        dt = '0' + dt;
    }
    if (month < 10) {
        month = '0' + month;
    }
    return month + delimiter + dt + delimiter + year;
},
    cmnFunc.scoreColor = function (obj) {
        if (obj.shape) {
            if (obj.score >= 75) {
                return "filledred";
            } else if (obj.score >= 35 && obj.score < 75) {
                return "filledyellow";
            } else if (obj.score < 35) {
                return "filledgreen";
            }
        } else {
            if (obj.score >= 75) {
                return "redBrdr";
            } else if (obj.score >= 35 && obj.score < 75) {
                return "yelwBrdr";
            } else if (obj.score < 35) {
                return "greenwBrdr";
            }
        }

    }
cmnFunc.bckBtn = false;
cmnFunc.sessionObj = function (obj) {
    if (sessionStorage.getItem("backStack") === null) {
        sessionStorage.setItem("backStack", JSON.stringify([]));
    }

    window.onbeforeunload = function (e) {
        if (!cmnFunc.bckBtn) {
            let i = JSON.parse(sessionStorage.getItem("backStack"));
            i.push(window.location.href);
            if (window.location.pathname.split("/")[2] == "search") {
                sessionStorage.setItem("searchStack", JSON.stringify(srchObj.srchSessionFlds));
            }
            sessionStorage.setItem("backStack", JSON.stringify(i));
        }
    }
}
cmnFunc.bckBtnEvent = function () {
    cmnFunc.bckBtn = true;
    let obj = JSON.parse(sessionStorage.getItem("backStack"));
    if (obj.length > 0) {
        let d = obj.pop();
        sessionStorage.setItem("backStack", JSON.stringify(obj));
        window.location.href = d;
    }

}
cmnFunc.bckFuncValidate = function () {
    let obj = JSON.parse(sessionStorage.getItem("backStack"));
    if (obj && obj.length > 0) {
        return true;
    }
    return false;
}
cmnFunc.showPDF = function () {
    let qData = cmnFunc.getQueryParameters();
    window.open(cmnlocDetails.partial_homefolder + "api/alert/" + qData.alertid + "/commevidencesPDF/" + qData.evidenceid);
    return false;
}
cmnFunc.createPrintBtn = function (nodeRef) {
    let btNode = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "prntBtn"
        }, {
            node: "onClick",
            value: "cmnFunc.showPDF()"
        }],
        html: "<img class='printImg' src='" + cmnlocDetails.partial_homefolder + "dist/images/print.png'/><span >Print</span>",
        appendTo: nodeRef
    });
    return btNode;
}
cmnFunc.dtFormatter = function (refObj) {
    let date = refObj.date,
        dr = refObj.delimiter,
        yr, mn, mnVal, dt;
    yr = date.split(dr)[2];
    mnVal = date.split(dr)[0];
    if (refObj.noMod) {
        mn = mnVal;
    } else {
        mn = (mnVal == "01" ? 0 : mnVal - 1);
    }

    dt = date.split(dr)[1];
    return new Date(yr, mn, dt);
}
cmnFunc.tglMenu = function (rObj) {
    let r = rObj || {};
    $(".mnBrCrumbCnt").on("click", function (evt) {
        evt.stopPropagation();
        r.id = evt.target.id;
        cmnFunc.displayTabs(r);
    });
}
cmnFunc.createStatusNode = function () {
    let pCnt;
    pCnt = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "cmnStCnt"
        }]
    });
    return pCnt;
}
cmnFunc.addEventListeners = function (objNode) {
    let param = objNode.params ? objNode.params : null;
    $(objNode.node).on(objNode.listener, function (eve) {
        eve.stopPropagation();
        if (objNode.ref && objNode.func) {
            if (param != null) {
                objNode.ref[objNode.func].apply(objNode.ref, [eve, param]);
            } else {
                objNode.ref[objNode.func].apply(objNode.ref, [eve]);
            }
        } else if (objNode.func) {
            objNode.func.apply(null, [eve]);
        }
    });
}
cmnFunc.accordPnGen = function (idNode) {
    let n = {};

    // n.h = cmnFunc.createDmNode({
    //     node: "h3",
    //     appendTo: idNode
    // });
    n.d = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "bn-accrDiv"
        }],
        appendTo: idNode
    });

    return n;
}
cmnFunc.chkBoxCnt = function (pNode) {
    let c = {};
    c.t = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "checkbox"
        }],
        appendTo: pNode
    });
    c.l = cmnFunc.createDmNode({
        node: "label",
        attr: [{
            node: "class",
            value: "alsChkFnt"
        }],
        appendTo: c.t
    });
    c.in = cmnFunc.createElemnt({
        node: "input",
        attr: [{
            node: "type",
            value: "checkbox"
        }],
        appendTo: c.l
    });
    return c;
}
cmnFunc.createDmNode = function (objNode) {
    let resultNode;
    resultNode = $("<" + objNode.node + ">");
    if (objNode.attr) {
        for (let i = 0; i < objNode.attr.length; i++) {
            resultNode.attr(objNode.attr[i].node, objNode.attr[i].value);
        }
    }
    if (objNode.html) {
        resultNode.html(objNode.html);
    }
    if (objNode.appendTo) {
        resultNode.appendTo(objNode.appendTo);
    }
    return resultNode;
}
cmnFunc.createElemnt = function (elmNode) {
    let elm;
    elm = $("<" + elmNode.node + "/>");
    if (elmNode.attr) {
        for (let i = 0; i < elmNode.attr.length; i++) {
            elm.attr(elmNode.attr[i].node, elmNode.attr[i].value);
        }
    }
    if (elmNode.appendTo) {
        elm.appendTo(elmNode.appendTo);
    }
    return elm;
}
cmnFunc.getQueryParameters = function (str) {
    return (str || document.location.search).replace(/(^\?)/, '').split("&").map(
        function (n) {
            return n = n.split("="),
                this[n[0]] = n[1], this
        }.bind({}))[0];
}
cmnFunc.displayTabs = function (refObj) {
    let r = refObj,
        rtrnObj = "";
    r.ref = r.ref || window;
    if ($(".hglghtMnu #" + r.id).length > 0) {
        return false;
    }
    $(".brdcrumbMnu").each(function (index, node) {
        $(node).addClass("hide");
    });
    $(".hglghtMnu").each(function (index, node) {
        $(node).removeClass("hglghtMnu");
    });
    $('.brdcrumbMnu[data-ref="' + r.id + '"]').removeClass("hide");
    $("#" + r.id).parent().addClass("hglghtMnu");
    if (r.func) {
        rtrnObj = r.ref[r.func].apply(r.ref, [r.id]);
    } else {
        let rpObj = cmnFunc.getQueryParameters();
        rtrnObj = "?loc=" + cmnEvidences.loc + "&alertid=" + rpObj.alertid;
    }

    switch (r.id) {
        case 'mnuOverView':
            window.location = "/surveillance/alert/index.html" + rtrnObj;
            break;
        case 'mnuMarketReply':
            mrktRply.initObj();
            break;
        case 'mnuTradeDetail':
            window.location = "/surveillance/tradedetail/index.html" + rtrnObj;
            break;
        case 'mnuNetwork':
            window.location = "/surveillance/network/index.html" + rtrnObj;
            break;
        case 'mnuInvEmp':
            window.location = "/surveillance/involvedemployees/index.html" + rtrnObj;
            break;
        case 'default':
            break;
    }
}
cmnFunc.errorDialog = function () {
    let outerDiv = cmnFunc.createDmNode({
        node: "div"
    });
    let newDiv = cmnFunc.createDmNode({
        node: "div"
    });
    let btnNode = cmnFunc.createDmNode({
        node: "button"
    });
    btnNode.addClass("popUpBtn");
    btnNode.html("Return");
    btnNode.on("click", function () {
        window.history.back();
    });
    outerDiv.addClass("mdldialog");
    newDiv.html("<p>Record doesn't Exist</p>");
    newDiv.appendTo(outerDiv);
    btnNode.appendTo(newDiv);
    outerDiv.appendTo($("body"));
    //$(newDiv).dialog({modal:false});
}
/*Global Search function codes here*/
cmnFunc.globalSrchFunc = function (evt) {
    window.location = cmnlocDetails.partial_homefolder + "search/index.html" + "?loc=" + cmnEvidences.loc;
}

/*Global Search function ends Here*/
/*Notes Func Starts Here*/
cmnFunc.notesGen = function (evt) {
    notesFunc.init();
}
cmnFunc.trncEllipsis = function (d, lnNode) {
    if (d == null || d == 'null') {
        return d;
    }
    let len = lnNode ? lnNode : 50;
    if (d.length > len)
        return d.substring(0, len) + '...';
    else
        return d;
}
/*Notes Func Ends Here */
/*Vaidator*/
cmnFunc.dateValidator = function (format, date) {
    let result;
    try {
        $.datepicker.parseDate(format, date);
        result = true;
    } catch (exp) {
        result = false;
    }
    return result;
}
cmnFunc.setCookie = function (cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
    var expires = "expires=" + d.toUTCString();
    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}
cmnFunc.getCookie = function (nm) {
    var name = nm + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}
cmnFunc.clrCookies = function () {
    var cookies = document.cookie.split(";");
    for (var i = 0; i < cookies.length; i++) {
        var spcook = cookies[i].split("=");
        cmnFunc.deleteCookie(spcook[0]);
    }
}
cmnFunc.deleteCookie = function (n) {
    var d = new Date();
    d.setDate(d.getDate() - 1);
    var expires = ";expires=" + d;
    var name = n;
    var value = "";
    document.cookie = name + "=" + value + expires + "; path=/";

}
cmnFunc.inactivityTimeout = function () {
    let _sc = 0;
    document.onclick = function () {
        _sc = 0;
    };
    document.onmousemove = function () {
        _sc = 0;
    };
    document.onkeypress = function () {
        _sc = 0;
    };

    var myInterval = window.setInterval(function () {
        _sc++;
        if (_sc > 13) {
            logOutfunc.cnfrmLogout();
        }
    }, 1000 * 60 * 60);


}
cmnFunc.fieldValidator = function (obj) {
    //let result;
    if (obj.required) {
        if (obj.node.val() != "" && obj.node.val() != "null" && obj.node.val() != "undefined") {
            return true;
        }
        return false;
    }
    return true;
    //return result;
}
cmnFunc.initials = function (name) {
    let fulName = name.split(" "),
        initials = "";
    if (fulName.length > 1) {
        initials = fulName[0].substr(0, 1) + fulName[1].substr(0, 1);
    } else {
        initials = name.substr(0, 1);
    }

    return initials;
}
cmnFunc.convertNotesDate = function (objdt) {
    var dt = new Date(objdt);
    var month = new Array();
    var date_str = "";
    month[0] = "Jan";
    month[1] = "Feb";
    month[2] = "Mar";
    month[3] = "Apr";
    month[4] = "May";
    month[5] = "Jun";
    month[6] = "Jul";
    month[7] = "Aug";
    month[8] = "Sep";
    month[9] = "Oct";
    month[10] = "Nov";
    month[11] = "Dec";
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    return date_str;
}


/*cmnFunc.validator=function(obj){
	let result;
	switch(obj.type){
	case "date":
					try{
						$.datepicker.parseDate(obj.format,obj.date);
						obj.node.removeClass("highlighterRed");
						result=true;
					}catch(exp){
							obj.node.addClass("highlighterRed");
						result=false;
					}
					return result;

				break;
	}

}*/
/*Validator*/
cmnFunc.setEndOfContenteditable = function (contentEditableElement) {
    var range, selection;
    if (document.createRange) //Firefox, Chrome, Opera, Safari, IE 9+
    {
        range = document.createRange(); //Create a range (a range is a like the selection but invisible)
        range.selectNodeContents(contentEditableElement); //Select the entire contents of the element with the range
        range.collapse(false); //collapse the range to the end point. false means collapse to end rather than the start
        selection = window.getSelection(); //get the selection object (allows you to change selection)
        selection.removeAllRanges(); //remove any selections already made
        selection.addRange(range); //make the range you have just created the visible selection
    } else if (document.selection) //IE 8 and lower
    {
        range = document.body.createTextRange(); //Create a range (a range is a like the selection but invisible)
        range.moveToElementText(contentEditableElement); //Select the entire contents of the element with the range
        range.collapse(false); //collapse the range to the end point. false means collapse to end rather than the start
        range.select(); //Select the range (make it the visible selection
    }

}
/******common func ends here **************/
/******core prototype functions***********/
String.prototype.truncate = String.prototype.truncate ||
    function (n) {
        return this.substr(0, n - 1) + (this.length > n ? '...' : '');
    };
String.prototype.capitalize = function () {
    return this.charAt(0).toUpperCase() + this.slice(1);
}
String.prototype.replaceAll = function (search, replacement) {
    var target = this;
    return target.replace(new RegExp(search, 'g'), replacement);
};
/******core prototype functions***********/

/**Tag Functionality email voice &chat **/
cmnEvidences.setTagArr = function (data) {
    cmnEvidences.tagArr = data;
}
cmnEvidences.crDynTagRemoveNodes = function (eve) {
    let index = cmnEvidences.tagArr.indexOf(eve.target.dataset.id);
    if (index > -1) {
        cmnEvidences.tagArr.splice(index, 1);
    }
    cmnEvidences.dynCrtStsNodes(null, "delete");
    $(eve.target).parent().remove();
}
cmnEvidences.crTagFunc = function (data, p) {
    cmnEvidences.allTags = data;
    cmnEvidences.commId = p.commId;
    cmnEvidences.alertId = p.alertId;
}
cmnEvidences.genTagsCnt = function (eve) {
    let pNode = $("#emlStsIdCnt"),
        acNode, mnCnt, totLen = 0,
        srchInFld, srchCnt, data = $.extend(true, [], cmnEvidences.allTags);
    if ($("#tag-accordian").length > 0) {
        $("#tag-accordian").remove();
    }
    acNode = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "id",
            value: "tag-accordian"
        }],
        appendTo: pNode
    });
    cmnFunc.addEventListeners({
        node: acNode,
        listener: "mouseleave",
        func: function (eve) {
            eve.stopPropagation();
            acNode.remove();
        }
    });
    srchCnt = cmnFunc.createDmNode({
        node: "p",
        attr: [{
            node: "class",
            value: "posrel"
        }],
        appendTo: acNode
    });

    srchInFld = cmnFunc.createElemnt({
        node: "input",
        attr: [{
            node: "type",
            value: "text"
        },
        {
            node: "id",
            value: "searchFld"
        }, {
            node: "class",
            value: "searchFld"
        }, {
            node: "placeHolder",
            value: "Search"
        }
        ],
        appendTo: srchCnt
    });
    cmnFunc.createDmNode({
        node: "span",
        attr: [{
            node: "class",
            value: "searchimg"
        }],
        appendTo: srchCnt
    });
    $(srchInFld).on("keyup", function (evt) {
        let opt;
        setTimeout(function () {
            let vl = $(srchInFld).val();
            opt = cmnEvidences.getwords(vl, data);
            cmnEvidences.genaccrDtpns({ dt: opt, nd: acNode });
        }, 30);
    });
    cmnEvidences.genaccrDtpns({ dt: data, nd: acNode });

}
cmnEvidences.getwords = function (valDt, data) {
    if (valDt.length > 0) {
        var ob = [];
        for (let d = 0; d < data.tags.length; d++) {
            let o = data.tags[d],
                words = "";
            let nref = 0;
            if (o) {
                var j = -1;
                var correct = 1;
                while (correct == 1 && ++j < valDt.length) {
                    if ((o.charAt(j)).toLowerCase() != (valDt.charAt(j)).toLowerCase()) {
                        correct = 0;
                    }
                }
                if (correct == 1) {
                    words = o;
                }

            }
            if (words.length > 0) {
                ob.push(words);
            }

        }

        return { tags: ob };


    } else {
        return data;
    }

}
cmnEvidences.genaccrDtpns = function (objNode) {
    if ($("#taAccMnCnt").length > 0) {
        $("#taAccMnCnt").remove();
    }
    let data = objNode.dt.tags,
        mnCnt = cmnFunc.createDmNode({
            node: "div",
            attr: [{
                node: "id",
                value: "taAccMnCnt"
            }],
            appendTo: objNode.nd
        });
    for (let i = 0; i < data.length; i++) {
        let o = data[i],
            nd;
        let nref = 0;
        if (o) {
            nd = cmnFunc.accordPnGen(mnCnt);
            if (cmnEvidences.tagArr.indexOf(o) == -1) {
                nref++;
                let cObj = cmnFunc.chkBoxCnt(nd.d);
                cObj.l.append(o.capitalize());
                cObj.in.attr("value", o);
                cmnFunc.addEventListeners({
                    node: cObj.in,
                    listener: "click",
                    ref: cmnEvidences,
                    func: "dynCrtStsNodes",
                    params: "create"
                });
            }

        }

    }
}
cmnEvidences.dynCrtStsNodes = function (evt, param) {
    let node = $("#tagPlus"),
        stNode, rObj;
    if (param == "create") {
        cmnEvidences.tagArr.push(evt.target.value);
    }
    rObj = {
        "tags": cmnEvidences.tagArr
    };
    let objRef = {
        type: "PUT",
        url: cmnlocDetails.alertOvrSrvc + (cmnEvidences.alertId ? cmnEvidences.alertId : -1) + "/commevidences/" + cmnEvidences.commId,
        data: JSON.stringify(rObj),
        dataType: "json",
        func: function (data) {
            if (data.status == 200) {
                if (param == "create") {
                    stNode = cmnFunc.createStatusNode();
                    stNode.html(evt.target.value);
                    stNode.removeClass("cmnStCnt");
                    stNode.addClass("delTagNode");
                    node.before(stNode);
                    let spn = cmnFunc.createDmNode({
                        node: "span",
                        attr: [{
                            node: "class",
                            value: "delTagNd"
                        },
                        {
                            node: "data-id",
                            value: evt.target.value
                        }
                        ],
                        html: "&nbsp;",
                        appendTo: stNode
                    });
                    cmnFunc.addEventListeners({
                        node: spn,
                        listener: "click",
                        ref: cmnEvidences,
                        func: "crDynTagRemoveNodes"
                    });
                    let refNode = $(evt.target).parent().parent();
                    let pRefNode = refNode.parent();
                    if ((pRefNode.find($("input[type='checkbox']"))).length > 1) {
                        refNode.remove();
                    } else {
                        let pParent = pRefNode.parent();
                        let dNode = pParent.find($("#" + pRefNode.attr("data-id")));
                        pRefNode.remove();
                        dNode.remove();
                    }



                }
            }

        }
    };
    cmnAsync.asynccall(objRef);

}

/**Tag Functionality email voice &chat **/

/**static cookie
 * desc: when SAML is deactiveted will be setting cookies in order make notes functionbality to work
 **/
cmnFunc.statCookie = function () {
    let k = ["partyid", "displayName"],
        l = ["10138", "SIFS Officer"];
    for (let i = 0; i < k.length; i++) {
        cmnFunc.setCookie(k[i], l[i], 1);
    }
}
/**static cookie*/

/**Locale info**/
cmnFunc.localeStr = function (o) {
    let l, sessionData;
    l = cmnFunc.getQueryParameters();
    if (!l.loc) {
        l.loc = "en-in";
    }
    sessionData = JSON.parse(sessionStorage.getItem(l.loc));
    if (sessionData == null) {
        let urlref = cmnlocDetails.partial_homefolder + "json/" + l.loc + "/locale.json";
        let objRef = {
            type: "GET",
            url: urlref,
            dataType: "json",
            func: function (data) {
                cmnEvidences.loc = l.loc;
                sessionStorage.setItem(l.loc, JSON.stringify(data));
                o.ref[o.func].apply(o.ref, [data, l.loc])
            }
        };
        cmnAsync.asynccall(objRef);
    } else {
        cmnEvidences.loc = l.loc;
        o.ref[o.func].apply(o.ref, [sessionData, l.loc])
    }

}
cmnFunc.fillIdNode = function (o) {
    $("#" + o.id).html(o.txt);
}
cmnFunc.fillLblNode = function (o) {
    $("label[for='" + o.id + "']").html(o.txt);
}
cmnFunc.fillClassNode = function (o) {
    $("." + o.id).each(function (index, node) {
        $(node).html(o.txt);
    });
}
cmnFunc.empty = function (val, replaceVal = "NA") {
    if (val == null || val == "" || val == undefined) {
        return replaceVal ? replaceVal : "NA";
    }
    return val;
}
/**locale info**/
$(document).ready(function () {
    cmnFunc.inactivityTimeout();
    // cmnFunc.statCookie();
});
cmnFunc.HSLColorContrast = function (color) {
    //convert hex color to rgb
    function hexToRGB(hex) {
        const m = hex.match(/^#?([\da-f]{2})([\da-f]{2})([\da-f]{2})$/i);
        let r = parseInt(m[1], 16),
            b = parseInt(m[2], 16),
            g = parseInt(m[3], 16);
        return "rgb(" + r + "," + b + "," + g + ")";
    }

    let rgbcolor = (color.includes('#')) ? hexToRGB(color) : color;
    const rgb = rgbcolor.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
    const yiq = ((rgb[1] * 299) + (rgb[2] * 587) + (rgb[3] * 144)) / 1000;

    //returns true if the provided color has a light contrast
    return (yiq >= 160) ? "#000000" : "#ffffff";
}
//ecape special characters for regular expression
cmnFunc.escape = function (s) {
    return s.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');
};
cmnFunc.stsdialog = function (txt = "", cb = {}) {
    let temp;
    if (!($("#cmnSIModal").length > 0)) {
        temp = $("<div id=\"cmnSIModal\" class=\"modal\"><div class=\"modal-content\"> <span class=\"si-close\">&times;</span>" +
            "<p id=\"cmnSITxtCntr\"></p></div></div>");
        $(temp).appendTo($("body"));
        $(".si-close").on("click", function (evt) {
            $("#cmnSIModal").css("display", "none");
            if (Object.keys(cb).length > 1) {
                cb.ref[cb.func].apply(cb.ref);
            }
        });
    }
    $("#cmnSITxtCntr").html(txt);
    $("#cmnSIModal").css("display", "block");

}
cmnFunc.abtDialog = function () {
    if ($("#abtMdl").length > 0) {
        $("#abtMdl").css("display", "block");
        return false;
    }
    let temp = "<div class=\"modal abtMdl\" id=\"abtMdl\"><div class=\"modal-content\">" +
        "<div class=\"title\">" +
        "<h2>About</h2><span class=\"si-close close-icon\"></span>" +
        "</div>" +
        "<div class=\"license-container\">" +
        "<div class=\"logo\"><span>Watson Financial Services Solutions</span>" +
        "<h3>IBM Surveillance Insight for Financial Services, V 2.0.3</h3>" +
        "</div>" +
        "<p class=\"license-title\"><b>Licensed Materials</b></p>" +
        "<p class=\"license\">Licensed Materials - Property of IBM Corp. and others. 5725-Y79 , 5737-A59 © Copyright 2016, 2018 IBM Corporation. IBM and the IBM" +
        "logo are trademarks of IBM Corporation, registered in many jurisdictions worldwide. This Program is licensed under the terms of the license agreement" +
        "accompanying the Program. This license agreement may be either located in a Program directory folder or library identified as \"License\" or \"Non_IBM_License\", if applicable," +
        "or provided as a printed license agreement. Please read this agreement carefully before using the Program. By using the Program, you agree to these terms." +
        "</p>" +
        "</div></div></div>";
    $(temp).appendTo($("body"));
    $("#abtMdl .si-close").on("click", function (evt) {
        $("#abtMdl").css("display", "none");
    });
    $("#abtMdl").css("display", "block");
}