/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/

"use strict";

var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) defineProperties(Constructor.prototype, protoProps);
        if (staticProps) defineProperties(Constructor, staticProps);
        return Constructor;
    };
}();

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}

var pagination = function() {
    /*Name: Constructor initilization will take place here
     * Params:
     * node:- {String} Id of the ul where apgination should be created.
     * recPerpg:-{Number} rows per page should be present on pagination
     * disIdNode:-{String} the Id of the element where results should be displayed.
     * dataObj: Json Object which contains data which needs to published.
     */
    function pagination(obj) {
        _classCallCheck(this, pagination);

        var self = this;
        if (!arguments.length) {
            return self;
        }
        if (obj.node) {
            self.idNode = obj.node;
        }
        if (obj.recPerPg) {
            self.recPerPg = obj.recPerPg;
        }
        if (obj.dataObj) {
            self.dataObj = obj.dataObj;
        }
        if (obj.dataObj.data) {
            self.jsonObj = obj.dataObj.data;
        }
        if (obj.tblId) {
            self.tblId = obj.tblId;
        }
        if (obj.countId) {
            self.countId = obj.countId;
        }
        if (obj.calbckObj) {
            self.calbckObj = obj.calbckObj;
        }
        if (obj.popUpFunc) {
            self.popUpFunc = obj.popUpFunc;
        }
        if (obj.tblGentr) {
            self.tblGentr = obj.tblGentr;
        }
        self.modifiedObj = {};
        self.pageNuberCnt = obj.pageNuberCnt ? obj.pageNuberCnt : 5;




        self.initObj();
    }

    /*Name: initObj
     *Desc :- Pagination component creation process will be carried in this function
     *        creation of Li nodes
     */


    _createClass(pagination, [{
            key: "initObj",
            value: function initObj() {
                    var pgCnt = 0,
                        doc = document,
                        idRefNode = doc.getElementById(this.idNode),
                        self = this,
                        ulNode = "",
                        liRefNode = "";
                    idRefNode.innerHTML = "";
                    pgCnt = this.nPages();
                    if (pgCnt <= 1) {
                        self.activePage("default");
                        return false;
                    }
                    idRefNode.appendChild(self.nextPrevBtn({
                        id: "prev_" + this.idNode,
                        node: "a",
                        lclassName: "page-item",
                        aclassName: "page-link",
                        textNode: ' <span class="prevTblImg">&nbsp;</span><span class="sr-only">Previous</span>',
                        func: "prevPage"
                    }));
                    for (var i = 1; i < pgCnt; i++) {
                        if (i > (self.pageNuberCnt - 2) && i > 0) {
                            idRefNode.appendChild(self.nextPrevBtn({
                                id: this.idNode + "_hypen",
                                textNode: "--",
                                node: "a",
                                lclassName: "page-item  hypenClass",
                                aclassName: "page-link"

                            }));
                            break;
                        }
                        if (i == 1) {
                            idRefNode.appendChild(self.nextPrevBtn({
                                id: this.idNode + "_" + i,
                                textNode: i,
                                node: "a",
                                lclassName: "page-item fitem",
                                func: "activePage",
                                aclassName: "page-link",
                                param: i
                            }));
                        } else {
                            idRefNode.appendChild(self.nextPrevBtn({
                                id: this.idNode + "_" + i,
                                textNode: i,
                                node: "a",
                                lclassName: "page-item delPageItem",
                                func: "activePage",
                                aclassName: "page-link",
                                param: i
                            }));
                        }

                    }
                    idRefNode.appendChild(self.nextPrevBtn({
                        id: this.idNode + "_" + pgCnt,
                        textNode: pgCnt,
                        node: "a",
                        lclassName: "page-item lastLstnode",
                        func: "activePage",
                        aclassName: "page-link",
                        param: pgCnt
                    }));
                    idRefNode.appendChild(self.nextPrevBtn({
                        id: "next_" + this.idNode,
                        node: "a",
                        lclassName: "page-item",
                        textNode: '<span class="nexTblImg">&nbsp;</span> <span class="sr-only">Next</span>',
                        func: "nextPage",
                        aclassName: "page-link"
                    }));
                    self.activePage("default");
                }
                /*
                 * Name:nextPrevBtn
                 * Desc: this function is used to create Dom Elements of pagination component.
                 * Param: objNode :-Contains keys of id,text,node,dataid,function will needs to be called on click event,param represents keys for function.
                 *
                 */

        }, {
            key: "resetpagination",
            value: function resetpagination(nodeRef, posIndex) {
                var pgCnt = 0,
                    doc = document,
                    idRefNode = doc.getElementById(this.idNode),
                    self = this,
                    urefNode = "",
                    prefNode = "",
                    hypenNode = $("#" + this.idNode + "_hypen"),
                    totalPages = self.nPages(),
                    pageNumCnt = self.pageNuberCnt - 2,
                    nodeRefTmp, dotRef = 0;
                if (pageNumCnt >= totalPages) {
                    self.activePage(nodeRef, true);
                    return false;
                }
                if (posIndex == "next") {

                    $(".delPageItem").remove();
                    if ($("#" + this.idNode + "_lhypen").length > 0) {
                        $("#" + this.idNode + "_lhypen").remove();
                    }

                    if ((nodeRef + pageNumCnt) < totalPages && nodeRef > 1) {
                        urefNode = nodeRef;
                        for (var i = (nodeRef - pageNumCnt) + 1; i <= urefNode; i++) {
                            if (dotRef == 0 && nodeRef > 1) {

                                $(hypenNode).parent().before(self.nextPrevBtn({
                                    id: this.idNode + "_lhypen",
                                    textNode: "--",
                                    node: "a",
                                    lclassName: "page-item hypenClass",
                                    aclassName: "page-link"

                                }));
                                dotRef++;
                            }
                            $(hypenNode).parent().before(self.nextPrevBtn({
                                id: this.idNode + "_" + i,
                                textNode: i,
                                node: "a",
                                lclassName: "page-item delPageItem",
                                func: "activePage",
                                aclassName: "page-link",
                                param: i
                            }));
                        }
                    } else if ((nodeRef + pageNumCnt) >= totalPages) {
                        if ($(".delPageItem")) {
                            $(".delPageItem").remove();
                        }

                        if (hypenNode) {
                            hypenNode.parent().remove();

                        }
                        $("#" + this.idNode + "_" + self.nPages()).parent().before(self.nextPrevBtn({
                            id: this.idNode + "_lhypen",
                            textNode: "--",
                            node: "a",
                            lclassName: "page-item hypenClass",
                            aclassName: "page-link"

                        }));
                        for (var i = totalPages - pageNumCnt; i < totalPages && i > 0; i++) {
                            $("#" + this.idNode + "_" + self.nPages()).parent().before(self.nextPrevBtn({
                                id: this.idNode + "_" + i,
                                textNode: i,
                                node: "a",
                                lclassName: "page-item delPageItem",
                                func: "activePage",
                                aclassName: "page-link",
                                param: i
                            }));
                        }
                    } else if (nodeRef === 1) {
                        let lstNode = $(".lastLstnode");
                        if ($(".delPageItem")) {
                            $(".delPageItem").remove();
                        }
                        if (hypenNode.length == 0) {
                            $("#" + this.idNode + "_" + self.nPages()).parent().before(self.nextPrevBtn({
                                id: this.idNode + "_hypen",
                                textNode: "--",
                                node: "a",
                                lclassName: "page-item  hypenClass",
                                aclassName: "page-link"

                            }));
                            hypenNode = $("#" + this.idNode + "_hypen");
                        }
                        for (var i = ((nodeRef + 2) - pageNumCnt) + 2; i <= pageNumCnt; i++) {
                            $(hypenNode).parent().before(self.nextPrevBtn({
                                id: this.idNode + "_" + i,
                                textNode: i,
                                node: "a",
                                lclassName: "page-item delPageItem",
                                func: "activePage",
                                aclassName: "page-link",
                                param: i
                            }));
                        }
                    }

                    if (nodeRef == totalPages) {
                        self.activePage(nodeRef, true);
                    } else if (nodeRef == 1) {
                        self.activePage(nodeRef, true);
                    } else {
                        self.activePage(nodeRef);
                    }

                } else if (posIndex == "previous") {
                    if ($("#" + this.idNode + "_lhypen").length > 0 && nodeRef == 2) {
                        $("#" + this.idNode + "_lhypen").remove();
                    }

                    if ((nodeRef + pageNumCnt) == self.nPages() || (nodeRef + pageNumCnt) > self.nPages()) {
                        urefNode = nodeRef;
                        $(".delPageItem").remove();
                        hypenNode.remove();
                        $("#" + this.idNode + "_" + self.nPages()).parent().before(self.nextPrevBtn({
                            id: this.idNode + "_hypen",
                            textNode: "--",
                            node: "a",
                            lclassName: "page-item  hypenClass",
                            aclassName: "page-link"

                        }));
                        for (var i = totalPages - pageNumCnt; i <= totalPages - 1 && i > 0; i++) {
                            $("#" + this.idNode + "_hypen").parent().before(self.nextPrevBtn({
                                id: this.idNode + "_" + i,
                                textNode: i,
                                node: "a",
                                lclassName: "page-item delPageItem",
                                func: "activePage",
                                aclassName: "page-link",
                                param: i
                            }));
                        }
                    } else if (nodeRef < self.nPages() && nodeRef > 0) {
                        $(".delPageItem").eq($(".delPageItem").length - 1).remove();
                        if (hypenNode.length == 0) {
                            $("#" + this.idNode + "_" + self.nPages()).parent().before(self.nextPrevBtn({
                                id: this.idNode + "_hypen",
                                textNode: "--",
                                node: "a",
                                lclassName: "page-item  hypenClass",
                                aclassName: "page-link"

                            }));
                        }

                        $(".delPageItem").eq(0).before(self.nextPrevBtn({
                            id: this.idNode + "_" + nodeRef,
                            textNode: nodeRef,
                            node: "a",
                            lclassName: "page-item delPageItem",
                            func: "activePage",
                            aclassName: "page-link",
                            param: nodeRef
                        }));


                    }

                    self.activePage(nodeRef);

                }



            }
        },
        {
            key: "resetVal",
            value: function resetVal(objNode) {
                var self = this;
                self.dataObj = objNode;
                self["pDynCont"].apply(self, [Math.floor(objNode.response.start / self.recPerPg) + 1]);


            }

        },
        {
            key: "nextPrevBtn",
            value: function nextPrevBtn(objNode) {
                    var self = this;
                    var listItm = document.createElement('li');
                    var aItm = "";
                    if (objNode.node) {
                        aItm = document.createElement(objNode.node);
                    }
                    if (objNode.self) {
                        self = objNode.self;
                    }
                    if (objNode.lclassName) {
                        listItm.setAttribute("class", objNode.lclassName);
                    }
                    if (aItm.nodeName != "") {
                        if (objNode.node == "a" && objNode.href == undefined) {
                            aItm.setAttribute('href', "javascript:void(0);");
                        } else {
                            aItm.setAttribute('href', objNode.href);
                        }
                        if (objNode.aclassName) {
                            aItm.setAttribute("class", objNode.aclassName);
                        }
                        if (objNode.id) {
                            aItm.id = objNode.id;
                        }
                        if (objNode.textNode) {
                            aItm.innerHTML = objNode.textNode;
                        }
                        if (objNode.dataid) {
                            aItm.setAttribute("data-id", objNode.dataid);
                        }
                        aItm.addEventListener("click", function(evt) {
                            if (objNode.param) {
                                self[objNode.func].apply(self, [objNode.param]);
                            } else if (objNode.evt == "Required") {
                                self[objNode.func].apply(self, [evt]);
                            } else if (objNode.func) {
                                self[objNode.func].call(self);
                            }
                        }, false);
                        listItm.appendChild(aItm);
                    }


                    return listItm;
                }
                /*
                 * Name: prevPage
                 * Desc: Function is used to perform previous link functionality in pagination.
                 */

        }, {
            key: "prevPage",
            value: function prevPage() {
                    if (this._cPage >= 1) {
                        this._cPage--;
                        if (document.getElementById(this.idNode + "_" + this._cPage)) {
                            this.activePage(this._cPage);
                        } else {
                            this.resetpagination(this._cPage, "previous");
                        }

                    }
                }
                /*
                 * Name: prevPage
                 * Desc: Function is used to perform previous link functionality in pagination.
                 */

        }, {
            key: "nextPage",
            value: function nextPage() {
                if (this._cPage <= this.nPages()) {
                    this._cPage++;
                    if (document.getElementById(this.idNode + "_" + this._cPage)) {
                        this.activePage(this._cPage);
                    } else {
                        this.resetpagination(this._cPage, "next");
                    }

                }
            }
        }, {
            key: "activePage",
            value: function activePage(page, rtrnVal) {
                var self = this,
                    startDtPr = 0;
                //tableRef = document.getElementById(self.tblId).getElementsByTagName('tbody')[0];
                //tableRef.innerHTML = "";

                if (page.id) {
                    page = (page.id.split("_")[1] == "hypen") ? "hypen" : page.id.split("_")[1];
                }
                if (page == "default") {
                    self._cPage = 1;
                    self.pDynCont(1);
                } else {
                    if (page < 1) {
                        page = 1;
                    }
                    if (page > self.nPages() || page == self.nPages() && !rtrnVal) {
                        page = self.nPages();
                        self.resetpagination(page, "next");
                        return false;
                    }
                    if (page === 1 && !rtrnVal) {
                        self.resetpagination(page, "next");
                    }
                    self._cPage = page;
                    if (page === 1) {
                        startDtPr = 0;
                    } else {
                        startDtPr = (page - 1) * self.recPerPg;
                    }
                    if (self.calbckObj) {
                        self.calbckObj.ref[self.calbckObj.func].apply(self.calbckObj.ref, [{ "rowsPerpage": self.recPerPg, "start": startDtPr, "func": "resetVal", "ref": self }]);
                    } else {
                        self.pDynCont(page);
                    }
                }
            }
        }, {
            key: "pDynCont",
            value: function pDynCont(page) {
                var self = this,
                    pageRef = "",
                    refLen;
                if (self.calbckObj) {
                    pageRef = 1;
                } else {
                    pageRef = page;
                }
                if (self.dataObj.response.docs) {
                    refLen = self.dataObj.response.docs;
                } else if (self.dataObj.response.data) {
                    refLen = self.dataObj.response.data;
                } else {
                    refLen = self.dataObj.response;
                }
                if (refLen.length > 0) {
                    document.getElementById(self.tblId).classList.remove("hide");
                    //document.getElementById(self.countId).classList.remove("hide");
                    /*for (var i = (pageRef - 1) * self.recPerPg; i < pageRef * self.recPerPg; i++) {
                    	if (self.dataObj.response.data[i] != undefined) {
                    		self.tableGenerator(self.dataObj.response.data[i]);
                    	}
                    }*/
                    self.tableGenerator(refLen);
                    if (document.getElementById("" + self.countId)) {
                        let startref = self.dataObj.start,
                            refdt = self.dataObj.data.length,
                            totoalNumfound = self.dataObj.numFound;
                        if (self.calbckObj) {
                            if ((startref + refdt) > totoalNumfound) {
                                document.getElementById("" + self.countId).innerHTML = "Showing " + (startref + 1) + "-" + totoalNumfound + " of " + totoalNumfound;
                            } else {
                                document.getElementById("" + self.countId).innerHTML = "Showing " + (startref + 1) + "-" + (startref + refdt) + " of " + totoalNumfound;
                            }
                        } else {
                            if (page == 1) {
                                document.getElementById("" + self.countId).innerHTML = "Showing " + "1-" + (pageRef * self.recPerPg) + " of " + totoalNumfound;
                            } else if ((pageRef * self.recPerPg) <= totoalNumfound) {
                                document.getElementById("" + self.countId).innerHTML = "Showing " + ((pageRef * self.recPerPg) - (self.recPerPg - 1)) + "-" + (pageRef * self.recPerPg) + " of " + totoalNumfound;
                            } else {
                                document.getElementById("" + self.countId).innerHTML = "Showing " + ((pageRef * self.recPerPg) - (self.recPerPg - 1)) + "-" + totoalNumfound + " of " + totoalNumfound;
                            }
                        }

                    }
                    self.prevnxtBtn(page);
                } else {
                    document.getElementById(self.tblId).classList.add("hide");
                    if (self.countId) {
                        document.getElementById(self.countId).classList.add("hide");
                    }


                }
            }

        }, {
            key: "linkAnchorNode",
            value: function linkAnchorNode(txtObj) {
                var self = this;
                var aItm = document.createElement('a');
                aItm.setAttribute('href', "#");
                aItm.innerHTML = "" + txtObj.inHtml;
                aItm.setAttribute("data-id", txtObj.id);
                aItm.addEventListener("click", function(evt) {
                    self.popUpFunc.ref[self.popUpFunc.func].apply(self.popUpFunc.ref, [self.modifiedObj[evt.currentTarget.dataset.id]]);
                }, false);
                return aItm;
            }
        }, {
            key: "tableGenerator",
            value: function tableGenerator(tObj) {
                let self = this;
                if (this.tblGentr) {
                    self.tblGentr.ref[self.tblGentr.callbck].apply(self.tblGentr.ref, [self.dataObj.response]);
                }

            }
        }, {
            key: "prevnxtBtn",
            value: function prevnxtBtn(page) {
                if (document.getElementById("prev_" + this.idNode) && document.getElementById("prev_" + this.idNode)) {
                    if (page == 1) {
                        document.getElementById("prev_" + this.idNode).classList.add("hide");
                        document.getElementById("next_" + this.idNode).classList.remove("hide");
                    } else if (page == this.nPages()) {
                        document.getElementById("next_" + this.idNode).classList.add("hide");
                        document.getElementById("prev_" + this.idNode).classList.remove("hide");
                    } else {
                        document.getElementById("next_" + this.idNode).classList.remove("hide");
                        document.getElementById("prev_" + this.idNode).classList.remove("hide");
                    }
                    if (document.getElementsByClassName("page-item activePage")[0]) {
                        document.getElementsByClassName("page-item activePage")[0].classList.remove("activePage");
                    }
                    if (document.getElementById(this.idNode + "_" + page)) {
                        document.getElementById(this.idNode + "_" + page).parentNode.classList.add("activePage");
                    } else {
                        document.getElementById(this.idNode + "_" + (page - 1)).parentNode.classList.add("activePage");
                    }

                }
            }
        }, {
            key: "nPages",
            value: function nPages() {
                let total;
                if (this.dataObj.response.numFound) {
                    total = this.dataObj.response.numFound;
                } else {
                    total = this.dataObj.response.length;
                }
                return Math.ceil(total / this.recPerPg);
            }
        }, {
            key: "listResDt",
            value: function listResDt(evt) {
                var self = this;
                alert(JSON.stringify(self.modifiedObj[evt.dataset.id]));
            }
        }
    ]);

    return pagination;
}();

/********Table component start***********/
const tableFunc = {};
tableFunc.create = function(objRef) {
    return new tFunc(objRef);
}
class tFunc {
    constructor(objRef) {
        this.thisRef = this;
        this.create(objRef);

    }
    create(objRef) {
        this.refTblObj = objRef;
        let objtbl = {};
        if (objRef && objRef.dataObj) {
            this.tblData = objRef.dataObj || obj;
        }
        if (objRef.pagination) {
            let resDt = {
                    "start": objRef.pagination.start || 0,
                    "numFound": objRef.pagination.numFound || this.tblData.length,
                    "rowsPerpage": objRef.pagination.recPerPg || 10
                },
                tbldt = [];
            for (let i = parseInt(resDt.start); i < (parseInt(resDt.start) + parseInt(resDt.rowsPerpage)) && i < this.tblData.length; i++) {
                tbldt.push(this.tblData[i]);
            }
            resDt.data = tbldt;
            if (objRef.ref) {
                objRef.ref[objRef.func].apply(objRef.ref, [{ response: resDt }]);
            } else {
                this.tbldataGen({ response: resDt });
            }
        } else {
            this.tblGentr(this.tblData);
        }
    }
    tblDyndata(objRef) {
        let objtbl = {},
            self = this;
        let idNode = this.refTblObj;
        let pgNode = idNode.pagination;
        let resDt = {
                "start": objRef.start || 0,
                "numFound": objRef.numFound || this.tblData.length,
                "rowsPerpage": objRef.rowsPerpage || 10
            },
            tbldt = [];
        for (let i = parseInt(resDt.start); i < (parseInt(resDt.start) + parseInt(resDt.rowsPerpage)) && i < this.tblData.length; i++) {
            tbldt.push(this.tblData[i]);
        }
        resDt.data = tbldt;
        if (pgNode && pgNode.ref) {
            resDt.func = "resetVal", resDt.ref = this.refTblObj.pageObject;
            pgNode.ref[pgNode.func].apply(pgNode.ref, [{ response: resDt }]);
        } else if (objRef.ref) {
            objRef.ref[objRef.func].apply(objRef.ref, [{ response: resDt }]);
        } else {
            this.tbldataGen({ response: resDt });
        }

    }
    tbldataGen(obj) {
        let idNode = this.refTblObj;

        this.refTblObj.pageObject = new pagination({
            'node': idNode.pagination.node,
            'recPerPg': idNode.pagination.recPerPg,
            'tblId': idNode.tblId,
            'dataObj': {
                'response': obj.response
            },
            calbckObj: {
                'ref': this,
                'func': "tblDyndata"
            },
            'tblGentr': {
                'ref': this,
                'callbck': 'tblGentr'
            }
        });

    }
    hideShowSorting(t) {
        let uHglt = $(".tblUsrt", t),
            hglt = $(".tblsrt", t);
        $.each(uHglt, function(index, node) {
            if ($(node).hasClass("hide")) {
                $(node).removeClass("hide");
            }
        });
        $.each(hglt, function(index, node) {
            if (!$(node).hasClass("hide")) {
                $(node).addClass("hide");
            }
        });

    }
    hideShowSortIcons(ord, spanHAsc, spanAsc, spanHDsc, spanDsc) {
        if (ord == "asc") {
            spanHAsc.removeClass("hide");
            spanAsc.addClass("hide");
            spanHDsc.addClass("hide");
            spanDsc.removeClass("hide");
        } else {
            spanHAsc.addClass("hide");
            spanAsc.removeClass("hide");
            spanHDsc.removeClass("hide");
            spanDsc.addClass("hide");
        }

    }
    tblGentr(objdt) {
        var idNode = this.refTblObj;
        var thisref = this;
        let table = document.getElementById(idNode.tblId),
            sorInd = null;
        let tblObj = idNode.tblObj,
            thNode = $("thead", table);
        if (thNode.length > 0) {
            sorInd = $(table).attr("data-index");
            thNode.remove();
        }
        let header = table.createTHead();
        let row = header.insertRow(0);
        let hdrLength = tblObj.headerObj.length;
        for (let i = 0; i < hdrLength; i++) {
            let dtNode = tblObj.headerObj[i],
                dtObj = {},
                cell, arNode = [];
            dtObj.node = "th";
            arNode.push({ node: "data-index", value: i });
            if (dtNode.class) {
                arNode.push({ node: "class", value: dtNode.class });
            }
            dtObj.attr = arNode;
            dtObj.html = dtNode.field;
            cell = cmnFunc.createDmNode(dtObj);
            if (dtNode.format) {
                dtNode.format.apply(null, [cell, dtNode.field])
            }
            if (dtNode.sortFld) {
                let sortInfo = dtNode.sortFld,
                    sorthis = sortInfo.func;
                let div = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "tblSortDiv" }], appendTo: cell });
                let spanAsc = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "tblAsc tblUsrt " }], appendTo: div });
                let spanHAsc = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "tblHAsc tblsrt hide" }], appendTo: div });
                let spanDsc = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "tblDsc tblUsrt " }], appendTo: div });
                let spanHDsc = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "tblHDsc tblsrt hide custTbl" }], appendTo: div });

                spanAsc.on("click", (evt) => {
                    evt.stopPropagation();
                    $(table).attr("data-index", ($(evt.target).parent().parent()).attr("data-index") + "," + "asc");
                    if (sortInfo.ref) {
                        this.sortRef = {
                            ref: sortInfo.ref,
                            param: [sortInfo.param, "asc"],
                            func: sortInfo.func
                        };
                        sortInfo.ref[sortInfo.func].apply(sortInfo.ref, [sortInfo.param, "asc"]);
                    } else if (sortInfo.func) {
                        if (idNode.pagination) {
                            this.tblDyndata(this.tblData.sort(
                                tableFunc.sortData(sortInfo.field, false, function(a) {
                                    return sortInfo.func.apply(sortInfo, [a]);
                                })));
                        } else {
                            this.tblGentr(this.tblData.sort(
                                tableFunc.sortData(sortInfo.field, false, function(a) {
                                    return sortInfo.func.apply(sortInfo, [a]);
                                })));
                        }

                    } else {
                        if (idNode.pagination) {
                            this.tblDyndata(this.tblData.sort(tableFunc.sortData(sortInfo.field, false)));
                        } else {
                            this.tblGentr(this.tblData.sort(tableFunc.sortData(sortInfo.field, false)));
                        }
                    }
                    this.hideShowSorting(table);
                    this.hideShowSortIcons("asc", spanHAsc, spanAsc, spanHDsc, spanDsc);
                });
                spanDsc.on("click", (evt) => {
                    evt.stopPropagation();
                    $(table).attr("data-index", ($(evt.target).parent().parent()).attr("data-index") + "," + "desc");
                    if (sortInfo.ref) {
                        this.sortRef = {
                            ref: sortInfo.ref,
                            param: [sortInfo.param, "desc"],
                            func: sortInfo.func
                        };
                        sortInfo.ref[sortInfo.func].apply(sortInfo.ref, [sortInfo.param, "desc"]);
                    } else if (sortInfo.func) {
                        if (idNode.pagination) {
                            this.tblDyndata(this.tblData.sort(
                                tableFunc.sortData(sortInfo.field, true, function(a) {
                                    return sortInfo.func.apply(sortInfo, [a]);
                                })));
                        } else {
                            this.tblGentr(this.tblData.sort(
                                tableFunc.sortData(sortInfo.field, true, function(a) {
                                    return sortInfo.func.apply(sortInfo, [a]);
                                })));
                        }

                    } else {
                        if (idNode.pagination) {
                            this.tblDyndata(this.tblData.sort(tableFunc.sortData(sortInfo.field, true)));
                        } else {
                            this.tblGentr(this.tblData.sort(tableFunc.sortData(sortInfo.field, true)));
                        }
                    }
                    this.hideShowSorting(table);
                    this.hideShowSortIcons("dsc", spanHAsc, spanAsc, spanHDsc, spanDsc);
                });
                // if (sortInfo.order) {
                //     if (sortInfo.order == "asc") {
                //         this.hideShowSortIcons("asc", spanHAsc, spanAsc, spanHDsc, spanDsc);
                //         $(table).attr("data-index", i + "," + "asc");

                //     } else {
                //         this.hideShowSortIcons("dsc", spanHAsc, spanAsc, spanHDsc, spanDsc);
                //         $(table).attr("data-index", i + "," + "dsc");
                //     }
                // }
            }
            cell.appendTo(row);

        }
        if (sorInd != null) {
            setTimeout(function() {
                let index = sorInd.split(","),
                    v = $("th[data-index=" + index[0] + "]", table);
                thisref.hideShowSortIcons(index[1], $('.tblHAsc', v), $('.tblAsc', v), $('.tblHDsc', v), $('.tblDsc', v));
            }, 10);
        } else {
            let v = $("th[data-index=0]", table);
            thisref.hideShowSortIcons("dsc", $('.tblHAsc', v), $('.tblAsc', v), $('.tblHDsc', v), $('.tblDsc', v));
        }


        this.bdyGentr(table, tblObj, objdt);
    }
    bdyGentr(table, tblObj, objdt) {
        if ($("tbody", table).length > 0) {
            $("tbody", table).remove();
        }
        let Tbody = table.createTBody(),
            refDtobj = (objdt.data ? objdt.data : (objdt.docs ? objdt.docs : objdt)),
            lenObj = refDtobj.length,
            rowObj = tblObj.tbdyobj.length;
        for (let i = 0; i < lenObj; i++) {
            let tBrow = Tbody.insertRow(i);
            let obj = refDtobj[i];
            if (tblObj.trRowClickFunc) {
                tblObj.trRowClickFunc.apply(null, [tBrow, obj]);
            }
            for (let j = 0; j < rowObj; j++) {
                let dtNode = tblObj.tbdyobj[j],
                    dtObj = {},
                    cell, cellDt = obj[dtNode.field];
                dtObj.node = "td";
                if (dtNode.class) {
                    dtObj.attr = [{ node: "class", value: dtNode.class }];
                }
                dtObj.html = cellDt;
                cell = cmnFunc.createDmNode(dtObj);
                if (dtNode.format) {
                    cell = dtNode.format.apply(null, [cell, cellDt, obj])
                }
                cell.appendTo(tBrow);
            }
        }
    }
};




tableFunc.sortData = function(field, reverse, primer) {

    let key = primer ? function(x) { return primer(x[field]) } : function(x) { return x[field] };

    reverse = !reverse ? 1 : -1;

    return function(a, b) {
        return a = key(a), b = key(b), reverse * ((a > b) - (b > a));
    }
}