/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

Â© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const header = {
    headerObj: {}
};
const breadCrumb = {
    breadCrumbObj: {}
};
const menuOverview = {
    menuOvervwObj: {}
};
const logOutfunc = {};
logOutfunc.createNode = function (evt, lnode) {
    let tnode = $(evt.target),
        node, abtNode, ulNode = cmnFunc.createDmNode({ node: "ul", attr: [{ node: "class", value: "usrlogCrd" }, { node: "id", value: "usrlogMnuHldr" }], appendTo: $(tnode) });
    abtNode = cmnFunc.createDmNode({ node: "li", html: "About", appendTo: ulNode });
    node = cmnFunc.createDmNode({ node: "li", html: "Logout", appendTo: ulNode });

    cmnFunc.addEventListeners({
        node: node,
        listener: "click",
        func: function () {
            logOutfunc.cnfrmLogout();
        }
    });
    cmnFunc.addEventListeners({
        node: abtNode,
        listener: "click",
        func: function () {
            ulNode.remove();
            cmnFunc.abtDialog();
        }
    });
    cmnFunc.addEventListeners({
        node: tnode,
        listener: "mouseleave",
        func: function (evt) {
            ulNode.remove();
        }
    });

}
logOutfunc.usrname = function () {
    let fname = [];
    if (cmnFunc.getCookie("displayName").replace(/["']/g, "") != "") {
        fname.push(cmnFunc.getCookie("displayName"));
    }

    if (!cmnFunc.getCookie("id")) {
        logOutfunc.cnfrmLogout();
    }
    if (fname.join(" ").trim() == "") {
        logOutfunc.cnfrmLogout();
    }
    return fname.join(" ");

}
logOutfunc.cnfrmLogout = function () {
    logOutfunc.partRole = cmnFunc.getCookie("roles") ? cmnFunc.getCookie("roles") : "admin";
    let objRef = {
        type: "GET",
        url: cmnlocDetails.partial_homefolder + "logout",
        dataType: "html",
        ref: logOutfunc,
        func: "logoutredirect"
    };

    cmnAsync.asynccall(objRef);

}
logOutfunc.logoutredirect = function (data) {
    if (data.status != 404) {
        window.location = cmnlocDetails.partial_homefolder + "logout.html";
    }


}
menuOverview.init = function (idNode, backButton = '') {
    menuOverview.createMenuOuterDiv(idNode, backButton)
}
menuOverview.createMenuOuterDiv = function (objRef, backButton) {
    let hdrObj, hdrNode;
    hdrObj = {
        node: "div",
        attr: [{
            node: "class",
            value: "brdChl2"
        }],
        appendTo: $(objRef.idnode)
    }
    menuOverview.menuOvervwObj = objRef;
    hdrNode = cmnFunc.createDmNode(hdrObj);
    if (backButton == '') {
        menuOverview.mainContent(hdrNode);
    } else {
        //header.addBackButton(hdrNode);
    }
}
header.addBackButton = function (hdrNode) {
    let anchorNode = { node: "a", attr: [{ node: "class", value: "pull-left backLinkBtn" }, { node: "href", value: "#" }], appendTo: hdrNode };
    let aNode = cmnFunc.createDmNode(anchorNode);
    let imgNode = { node: "img", attr: [{ node: "src", value: "/surveillance/dist/images/back.png" }], appendTo: aNode };
    let iNode = cmnFunc.createDmNode(imgNode);
    let spanNode = { node: "span", attr: [{ node: "class", value: "backBtn" }], html: header.lc.backTxt, appendTo: aNode };
    let b = cmnFunc.createDmNode(spanNode);
    aNode.on("click", function (evt) {
        evt.preventDefault();
        cmnFunc.bckBtnEvent();
    });
}
menuOverview.mainContent = function (hdrNode) {
    let rghtCnt, pCnt, spCnt, sCnt, lc = header.lc,

        ulNode = { node: "ul", attr: [{ node: "class", value: "list-inline posrel menuOpt" }], appendTo: hdrNode },
        highLightTab, alrtType = header.headerObj.alert.type ? header.headerObj.alert.type.toLowerCase() : undefined;
    arrNodes = [{
        node: "span",
        attr: [
            { node: "id", value: "mnuOverView" },
            { node: "class", value: "txtMnhglt mnBrCrumbCnt" }
        ],
        "html": lc.overview
    },
    {
        node: "span",
        attr: [
            { node: "id", value: "mnuNetwork" },
            { node: "class", value: "txtMnhglt mnBrCrumbCnt" }
        ],
        "html": lc.network
    }, {
        node: "span",
        attr: [
            { node: "id", value: "mnuInvEmp" },
            { node: "class", value: "txtMnhglt mnBrCrumbCnt" }
        ],
        "html": lc.invlEMp.replace(/ /g, '\u00a0')
    }
    ];

    if (alrtType == "collusion" || alrtType == "washtrade" || alrtType == "wash trade" || alrtType == "frontrunning" || alrtType == "off-market") {
        arrNodes.splice(1, 0, {
            node: "span",
            attr: [
                { node: "class", value: "txtMnhglt mnBrCrumbCnt" },
                { node: "id", value: "mnuTradeDetail" },
            ],
            "html": lc.tradDtl.replace(/ /g, '\u00a0')
        });

    }
    rghtCnt = cmnFunc.createDmNode(ulNode);
    for (let i = 0; i < arrNodes.length; i++) {
        let lidt, liCnt, expNode;
        lidt = { node: "li", appendTo: rghtCnt };
        liCnt = cmnFunc.createDmNode(lidt);
        expNode = cmnFunc.createDmNode(arrNodes[i]);
        expNode.appendTo(liCnt);
    }
    if (menuOverview.menuOvervwObj.hglghtNode) {
        ($("#" + menuOverview.menuOvervwObj.hglghtNode).parent()).attr("class", "hglghtMnu");
    } else {
        ($("#mnuOverView").parent()).attr("class", "hglghtMnu");
    }
}
header.init = function (idNode, obj) {
    header.lc = JSON.parse(sessionStorage.getItem(cmnEvidences.loc));
    header.createOuterDiv(idNode);
}
header.createOuterDiv = function (idNode) {
    let hdrObj, hdrNode, bCnt;
    hdrObj = {
        node: "header",
        attr: [{
            node: "class",
            value: "container-fluid hdrCnt"
        }],
        appendTo: $("#" + idNode)
    }
    hdrNode = cmnFunc.createDmNode(hdrObj);
    header.mainContent(hdrNode);
    cmnFunc.sessionObj();
    if (window.location.pathname.split("/")[2] == "dashboard") {
        sessionStorage.setItem("backStack", JSON.stringify([]));
        sessionStorage.setItem("searchStack", JSON.stringify({}));
    }
    if (cmnFunc.bckFuncValidate()) {
        bCnt = cmnFunc.createDmNode({
            node: "div",
            attr: [{
                node: "class",
                value: "backBtnCntr pdLft32 clearfix"
            }],

        });
        $("#" + idNode).after(bCnt);
        header.addBackButton(bCnt);
    }

}
header.mainContent = function (hdrElm) {
    let divObj = {
        node: "div",
        attr: [{
            node: "class",
            value: "row"
        }],

    },
        resNode;
    resNode = cmnFunc.createDmNode(divObj);
    hdrElm.append(resNode);
    header.leftContent(resNode);
    header.rightContent(resNode);
}

header.leftContent = function (divCnt) {
    let lftCnt, pCnt, spCnt, sCnt, lftnode, pnode, spanNode, spNode, lc = header.lc;
    lftnode = { node: "div", attr: [{ node: "class", value: "col-sm-6" }], appendTo: divCnt };
    lftCnt = cmnFunc.createDmNode(lftnode);
    pnode = { node: "p", attr: [{ node: "class", value: "mrgt15 pdLft32 disInBLk" }], appendTo: lftCnt };
    pCnt = cmnFunc.createDmNode(pnode);
    header.createDashBrdLnk(lftCnt);
    spanNode = { node: "span", attr: [{ node: "class", value: "mrgnRght5" }], appendTo: pCnt };
    spCnt = cmnFunc.createDmNode(spanNode);
    cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "main-hdrTxt" }], html: lc.ibmTxt, appendTo: spCnt });
    cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "sub-hdrTxt" }], html: lc.surTxt, appendTo: spCnt });
    spNode = { node: "span", attr: [{ node: "class", value: "sub-hdrTxt" }], "html": lc.insTxt, appendTo: pCnt };
    sCnt = cmnFunc.createDmNode(spNode);

}
header.createDashBrdLnk = function (cnt) {

    //if(cmnFunc.getCookie("partyrole") == "Compliance Officer"){
    let pnode, hnode, pCnt, spanNd, hCnt, sCnt, adCnt, adminNode, ftrNode, ftrCnt, lc = header.lc;
    pnode = { node: "p", attr: [{ node: "class", value: "mrgLft40 disInBLk" }], appendTo: cnt };
    pCnt = cmnFunc.createDmNode(pnode);
    hnode = cmnFunc.createDmNode(pnode);
    adminNode = cmnFunc.createDmNode(pnode);

    spanNd = { node: "span", attr: [{ node: "class", value: "dsHdrTxt dsHghtr" }], "html": lc.dashTxt, appendTo: pCnt };
    sCnt = cmnFunc.createDmNode(spanNd);
    hCnt = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "dsHdrTxt dsHghtr" }], "html": "Health&nbsp;Check", appendTo: hnode });
    adCnt = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "dsHdrTxt dsHghtr" }], "html": "Admin", appendTo: adminNode });

    if (window.location.pathname.split("/")[2] == "dashboard") {
        sCnt.addClass("hglghtNd");
    } else {
        cmnFunc.addEventListeners({
            node: sCnt,
            listener: "click",
            func: function () {
                window.location.href = cmnlocDetails.partial_homefolder + "dashboard/index.html"
            }
        });

    }
    if (window.location.pathname.split("/")[2] == "healthcheck") {
        hCnt.addClass("hglghtNd");
    } else {
        cmnFunc.addEventListeners({
            node: hCnt,
            listener: "click",
            func: function () {
                window.location.href = cmnlocDetails.partial_homefolder + "healthcheck/index.html"
            }
        });
    }
    if (window.location.pathname.split("/")[2] == "admin") {
        adCnt.addClass("hglghtNd");
    } else {
        cmnFunc.addEventListeners({
            node: adCnt,
            listener: "click",
            func: function () {
                window.location.href = cmnlocDetails.partial_homefolder + "admin/index.html";
            }
        });
    }
    if (cmnFunc.getCookie("ftrenable") != "" && cmnFunc.getCookie("ftrenable") == "true") {
        ftrNode = cmnFunc.createDmNode(pnode);
        ftrCnt = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "dsHdrTxt dsHghtr" }], "html": "FTR", appendTo: ftrNode });
        if (window.location.pathname.split("/")[2] == "ftr") {
            ftrCnt.addClass("hglghtNd");
        } else {
            cmnFunc.addEventListeners({
                node: ftrCnt,
                listener: "click",
                func: function () {
                    window.location.href = cmnlocDetails.partial_homefolder + "ftr/index.html"
                }
            });
        }
    }



    //}

}
header.rightContent = function (divCnt) {
    let locdetail = cmnlocDetails.partial_homefolder,
        rghtCnt, pCnt, spCnt, sCnt, rghtNode, ulNode, arrNodes;
    rghtNode = { node: "div", attr: [{ node: "class", value: "col-sm-6" }], appendTo: divCnt };
    rghtCnt = cmnFunc.createDmNode(rghtNode);
    ulNode = { node: "ul", attr: [{ node: "class", value: "list-inline pull-right hdrImgMnu" }], appendTo: rghtCnt };
    ulNode = cmnFunc.createDmNode(ulNode);
    arrNodes = [{
        clbck: {
            ref: cmnFunc,
            func: "globalSrchFunc"
        },
        nodeRef: {
            node: "img",
            attr: [
                { node: "src", value: locdetail + "dist/images/Search_24px.png" },
                { node: "class", value: "bannericon" },
                { node: "id", value: "glbSrch" }
            ]
        }
    },
    {
        nodeRef: {
            node: "img",
            attr: [
                { node: "src", value: locdetail + "dist/images/User_24px.png" },
                { node: "class", value: "bannericon" }
            ]
        }
    },
    {
        clbck: {
            ref: logOutfunc,
            func: "createNode"
        },
        nodeRef: {
            node: "span",
            attr: [
                { node: "class", value: "banner-rt-title hdrdwnImg" },
                { node: "id", value: "hdrUsrNmDis" }
            ],
            "html": function () {
                return logOutfunc.usrname() +
                    '<img class="sign-on-dropdown-icon" src="../dist/images/combo-down.png"/>';
            }
        }
    },
        /* {
             nodeRef:{
                 node:"img",
                 attr:[
                     {node:"src",value:locdetail+"dist/images/combo-down.png"},
                     {node:"class",value:"bannercombo"}
                   ]
             }

         },{
             nodeRef:{
                 node:"img",
                 attr:[
                     {node:"src",value:locdetail+"dist/images/IBM_20px.png"},
                     {node:"class",value:"bannericon ibmLg"}
                   ]
             }

         }*/
    ];
    for (let i = 0; i < arrNodes.length; i++) {
        let lidt, liCnt, expNode, aNode = arrNodes[i];
        lidt = { node: "li", attr: [{ node: "class", value: "posrel" }] };
        liCnt = cmnFunc.createDmNode(lidt);
        liCnt.appendTo(ulNode);
        expNode = cmnFunc.createDmNode(aNode.nodeRef);
        if (aNode.clbck) {
            expNode.on("click", function (evt) {
                aNode.clbck.ref[aNode.clbck.func].apply(aNode.clbck.ref, [evt, liCnt]);
            });
        }
        expNode.appendTo(liCnt);
    }

}


breadCrumb.init = function (idNode, obj) {
    breadCrumb.createOuterDiv(idNode, obj);
}
breadCrumb.createOuterDiv = function (idNode, obj) {
    let hdrObj, hdrNode;
    hdrObj = {
        node: "div",
        attr: [{
            node: "class",
            value: "row brdChl1"
        }],
        appendTo: $("#" + idNode)

    }
    hdrNode = cmnFunc.createDmNode(hdrObj);
    breadCrumb.leftContent(hdrNode, obj);
    breadCrumb.rightContent(hdrNode, obj);
}
breadCrumb.convertNotesDate = function (objdt) {
    var dt = new Date(objdt);
    var month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var date_str = "";
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    return date_str;
}
breadCrumb.rightContent = function (node, obj) {

    let lc = header.lc,
        details, nodeRed, lftCnt = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "col-sm-7" }], appendTo: node });
    details = [{ node: "DATE ADDED", lanVal: lc.dtAdded, value: breadCrumb.convertNotesDate(obj.date) },
    { node: "ASSET CLASS", lanVal: lc.astClassC, value: cmnFunc.empty(obj.assetclass) },
    { node: "TICKER", value: cmnFunc.empty(obj.ticker), lanVal: lc.tickerC },
    { node: "INVOLVED EMPLOYEES", value: cmnFunc.empty(obj.involvedparties), lanVal: lc.invlEMp },
    { node: "ASSIGNED", value: cmnFunc.empty(obj.assigned), lanVal: lc.assngdC }
    ];
    for (let index = 0; index < details.length; index++) {
        let dt, pNdde, vNdde;
        dt = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "alrtSdiv" }], appendTo: lftCnt });
        pNdde = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "alrtShdr" }], "html": details[index].lanVal, appendTo: dt });
        let alert = cmnFunc.getQueryParameters();
        if (details[index].node == "INVOLVED EMPLOYEES") {
            let n = details[index],
                count = n.value.length;
            dt.addClass("mxwdth35");
            vNdde = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "alrtStxt posInvoEmp" }], appendTo: dt });
            for (let i = 0; i < n.value.length; i++) {
                if (i < 3) {
                    let obj = n.value[i],
                        aNode;

                    if ((i == (n.value.length - 1) || i == 2)) {
                        aNode = cmnFunc.createDmNode({ node: "a", attr: [{ node: "class", value: "anchrClck" }], "html": obj.partyname + "  ", appendTo: vNdde });
                        let link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + "?alertid=" + alert.alertid + "&partyid=" + obj.partyid;
                        aNode.prop("href", link);
                    } else {
                        aNode = cmnFunc.createDmNode({ node: "a", attr: [{ node: "class", value: "anchrClck" }], "html": obj.partyname + ", ", appendTo: vNdde });
                        let link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + "?alertid=" + alert.alertid + "&partyid=" + obj.partyid;
                        aNode.prop("href", link);
                    }

                    count--;
                }
                if (i == 2) {
                    if (count > 0) {
                        let obj = n.value[i],
                            aNode;
                        cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "" }], "html": "and ", appendTo: vNdde });
                        aNode = cmnFunc.createDmNode({ node: "a", attr: [{ node: "class", value: "anchrClck" }], "html": count + " others", appendTo: vNdde });
                        let link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + "?alertid=" + alert.alertid + "&partyid=" + n.value[0].partyid;
                        aNode.prop("href", link);
                    }
                    break;
                }
            }

        } else if (details[index].node == "ASSIGNED") {
            let n = details[index],
                aNode;
            dt.addClass("nomarRght");
            vNdde = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "alrtStxt" }], html: details[index].value, appendTo: dt });

        } else {
            vNdde = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "alrtStxt" }], "html": details[index].value, appendTo: dt });

        }
        if (vNdde.html() == "NA") {
            vNdde.addClass("txtCntr");
        }
    }


}
breadCrumb.leftContent = function (node, obj) {
    let lftCnt, oCnt, inCnt,
        lftnode = { node: "div", attr: [{ node: "class", value: "col-sm-5" }] },
        outerNode = { node: "div", attr: [{ node: "class", value: "row" }] };

    lftCnt = cmnFunc.createDmNode(lftnode);
    lftCnt.appendTo(node);
    oCnt = cmnFunc.createDmNode(outerNode);
    oCnt.appendTo(lftCnt);
    breadCrumb.leftRateContent(oCnt, obj);
    breadCrumb.leftStatusContent(oCnt, obj);
}
breadCrumb.leftRateContent = function (node, obj) {
    let inCont, leftCnt, snodeCont, spNodecnt,
        innerNode = { node: "div", attr: [{ node: "class", value: "brdCntLft" }] },
        leftNode = { node: "div", attr: [{ node: "class", value: "circle posrel " + cmnFunc.scoreColor({ score: cmnFunc.roundScore(obj.alertscore ? obj.alertscore : obj.score), shape: "yes" }) }] },
        sNode = { node: "span", attr: [{ node: "class", value: "scrFld" }], "html": Math.round(cmnFunc.roundScore(obj.alertscore ? obj.alertscore : obj.score)) };
    //spNode={node:"span",attr:[{node:"class",value:"sufFld"}],"html":"%"};
    inCont = cmnFunc.createDmNode(innerNode);
    inCont.appendTo(node);
    leftCnt = cmnFunc.createDmNode(leftNode);
    leftCnt.appendTo(inCont);
    snodeCont = cmnFunc.createDmNode(sNode);
    snodeCont.appendTo(leftCnt);
    /*spNodecnt=cmnFunc.createDmNode(spNode);
    spNodecnt.appendTo(leftCnt);*/
}
breadCrumb.leftStatusContent = function (node, obj) {
    let pCnt, pInpro, pPump, pAlert,
        rightInnerNode = { node: "div", attr: [{ node: "class", value: "brdCntRft padLft0" }] },
        rtNode = { node: "p", attr: [{ node: "class", value: "subStTxt" }, { node: "id", value: "brdStatusId" }], "html": obj.status },
        rmNode = { node: "p", attr: [{ node: "class", value: "mainTxt" }], "html": obj.type.replace(/ /g, '\u00a0') },
        rbNode = { node: "p", attr: [{ node: "class", value: "alrtIdst" }] },
        rsNode = { node: "span", attr: [{ node: "class", value: "" }], "html": "Alert ID:" },
        rspNode = { node: "span", attr: [{ node: "class", value: "" }], "html": " " + obj.alertid };
    pCnt = cmnFunc.createDmNode(rightInnerNode);
    pCnt.appendTo(node);
    (cmnFunc.createDmNode(rtNode)).appendTo(pCnt);
    (cmnFunc.createDmNode(rmNode)).appendTo(pCnt);
    (cmnFunc.createDmNode(rbNode)).append(cmnFunc.createDmNode(rsNode)).append(cmnFunc.createDmNode(rspNode)).appendTo(pCnt);
}
/****** Generate Alert Overview Data ***********/
const autoHeader = {};

autoHeader.generate = function (menuNode, navFlg = true, callbckObj = undefined) {
    autoHeader.menuNode = menuNode;
    autoHeader.menuDisply = navFlg ? true : false;
    let sessionData = JSON.parse(sessionStorage.getItem('alertMetaData'));
    autoHeader.queryParams = cmnFunc.getQueryParameters();
    //console.log(sessionData, autoHeader);

    if (sessionData && sessionData.alert && autoHeader.queryParams.alertid &&
        sessionData.alert.alertid == autoHeader.queryParams.alertid) {
        autoHeader.drawHeader(sessionData);
        if (callbckObj) {
            autoHeader.callBckfunc(sessionData, callbckObj);
        }

    } else {
        let objhdrRef = {
            type: "GET",
            url: cmnlocDetails.alertOvrSrvc + autoHeader.queryParams.alertid + "?forHeader=true",
            dataType: "json",
            ref: autoHeader,
            func: "saveData",
            params: callbckObj
        };
        cmnAsync.asynccall(objhdrRef);
    }
};

autoHeader.saveData = function (data, obj = undefined) {
    //save data then draw header

    sessionStorage.setItem('alertMetaData', JSON.stringify(data));
    autoHeader.drawHeader(data);
    if (obj) {
        autoHeader.callBckfunc(data, obj);
    }
}
autoHeader.callBckfunc = function (data, obj) {
    if (obj) {
        if (obj.func && obj.ref) {
            if (obj.param != null) {
                obj.ref[obj.func].apply(obj.ref, [obj.param, data]);
            } else {
                obj.ref[obj.func].apply(obj.ref, [data]);
            }

        } else if (obj.func) {
            if (param != null) {
                obj.func.apply(obj.ref, [obj.param, data]);
            } else {
                obj.func.apply(obj.ref, [data]);
            }
        }
    }
}
autoHeader.drawHeader = function (data) {
    header.headerObj = data;
    header.init("headerNode");
    breadCrumb.init("rghtContent", data.alert);
    if (autoHeader.menuDisply) {
        menuOverview.init({
            idnode: $("#rghtContent"),
            hglghtNode: autoHeader.menuNode
        });
        cmnFunc.tglMenu();
    }

}