/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
let notesFunc = {
    notesObj: {},
    ntsFldCtr: 0, //created for generating ids in order to track dynamically created notes div
    logUser: cmnFunc.getCookie("id")
};

drawNotesIcon = function() {
    let locdetail = cmnlocDetails.partial_homefolder;
    let notesIconDiv = cmnFunc.createDmNode({ node: 'div', attr: [{ node: 'class', value: 'notes_icon' }], appendTo: $('#rghtContent') });
    let icon = cmnFunc.createDmNode({
        node: "img",
        attr: [
            { node: "src", value: locdetail + "dist/images/notes_icon.png" }
        ],
        appendTo: notesIconDiv
    });

    cmnFunc.addEventListeners({ node: notesIconDiv, listener: "click", ref: cmnFunc, func: "notesGen" });
}

$(document).ready(function() {
    drawNotesIcon();
    if (typeof voiceCnt !== "undefined" || typeof emlCnt !== "undefined" || typeof chtCnt !== "undefined") {
        let qData = cmnFunc.getQueryParameters();
        notesFunc.voiceFlag = qData.search ? qData.search : false;
    }
});



notesFunc.init = function() {
    notesFunc.queryParams = cmnFunc.getQueryParameters();
    //console.log('initializing notes', notesFunc.queryParams);
    notesFunc.lc = JSON.parse(sessionStorage.getItem(cmnEvidences.loc))
    let node = $("#ntsMnCnt");
    if (node.length > 0) {
        node.remove();
    }
    notesFunc.create();

}
notesFunc.create = function() {
    let mnCnt, idNode = $(".brdCrumSec")[0];
    mnCnt = notesFunc.createMainContainer(idNode);
    mnCnt.css("top", (idNode.offsetHeight + idNode.offsetTop - 59) + "px");
    notesFunc.scrnTxt = notesFunc.screenTxtContainer(mnCnt);
    let spinN = cmnFunc.createDmNode({
        node: "div",
        attr: [{ node: "class", value: "survellianceLoader ntsLoader" }],
        appendTo: mnCnt
    });
    let urlref;
    let qData = cmnFunc.getQueryParameters();
    if (notesFunc.voiceFlag) {
        urlref = cmnlocDetails.service + "/noteservice/v2/communication/" + qData.commid + "/notes"
    } else {
        urlref = cmnlocDetails.notesSrvc + qData.alertid + "/notes";
    }
    let objRef = {
        type: "GET",
        url: urlref,
        data: JSON.stringify({ "authorname": logOutfunc.usrname() }),
        dataType: "json",
        ref: notesFunc,
        func: "getAsyncData",
        params: spinN
    }

    cmnAsync.asynccall(objRef);
}
notesFunc.getAsyncData = function(objData, p) {
    notesFunc.notesObj = objData;
    if (p.length > 0) {
        p.remove();
    }
    if (objData.notes && objData.notes.length > 0) {
        notesFunc.update(objData.notes, notesFunc.scrnTxt);
    }
}
notesFunc.update = function(objDt, idNode) {
    let hdrtxt, bdyTxt, aCnt, len = objDt.length,
        l = notesFunc.lc;
    notesFunc.ntsFldCtr = 0;
    //console.log(objDt, len);
    for (let i = 0; i < len; i++) {
        let obj = objDt[i];
        let ind = ++notesFunc.ntsFldCtr;
        let parentN = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "col-xs-12 item-border" }], appendTo: idNode });
        if (obj.attachment && obj.attachment.length > 0) {
            hdrtxt = notesFunc.createNtHdr(obj, parentN);
            hdrtxt.html(obj.notetitle);
            bdyTxt = notesFunc.createDivImgTxt(obj, parentN, ind);
            // bdyTxt.rNode.addClass("col-sm-12");
            // bdyTxt.lPNode.addClass("col-sm-9");
            if (obj.content && obj.content.length > 100) {
                aCnt = notesFunc.createShowLink(obj, parentN, ind);
                notesFunc.addAnchrListeners(aCnt);
            }
            notesFunc.createNoteInfo(obj, parentN);
        } else {
            notesFunc.createNtHdr(obj, parentN).html(l.referencing + " " + obj.reference);
            bdyTxt = notesFunc.createDivText(obj, parentN, ind);
            if (obj.content.length > 100) {
                aCnt = notesFunc.createShowLink(obj, parentN, ind);
                notesFunc.addAnchrListeners(aCnt);

            }

            notesFunc.createNoteInfo(obj, parentN);
        }
    }

}
notesFunc.showMoreFunc = function(evtNode, pNode, node) {
    $(evtNode).addClass("hide");
    $(pNode).find(".ntsShowLs").removeClass("hide");
    node.html(node[0].getAttribute("data-ref"));
}
notesFunc.showLessFunc = function(evtNode, pNode, node) {
    $(evtNode).addClass("hide");
    $(pNode).find(".ntsShowMr").removeClass("hide");
    node.html(cmnFunc.trncEllipsis(node[0].getAttribute("data-ref"), 100));
}
notesFunc.addAnchrListeners = function(nodeRef) {
    let aMNode = nodeRef.aMNode,
        aLNode = nodeRef.aLNode;
    aMNode.on("click", function(evt) {
        let pNode = $(evt.target.parentNode),
            evtNode = evt.target,
            node = $("#" + evtNode.getAttribute("data-id"));
        notesFunc.showMoreFunc(evtNode, pNode, node);
    });
    aLNode.on("click", function(evt) {
        let pNode = $(evt.target.parentNode),
            evtNode = evt.target,
            node = $("#" + evtNode.getAttribute("data-id"));
        notesFunc.showLessFunc(evtNode, pNode, node);
    });

}
notesFunc.createNtHdr = function(obj, idNode) {
    let parentN, pNode, snpNode, nmNode, tmNode;
    pNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsDivClr clearfix" }], appendTo: idNode });
    snpNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsSn nSec" }], appendTo: pNode });
    return snpNode;
}

notesFunc.convertNotesDate = function(objdt) {
    var dt = new Date(objdt);
    var month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var date_str = "";
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    let h = dt.getHours();
    let mi = dt.getMinutes();
    let t = (((h > 12) ? h - 12 : h) + ":" + ((mi > 9) ? mi : "0" + mi)) + " " + ((h >= 12) ? "pm" : "am");
    return date_str + " at " + t;
}
notesFunc.convertNotesTime = function(objtime) {
    var ampm = "am";
    if (parseInt(objtime.substr(0, 2)) < 12) {
        ampm = "am";
    } else {
        ampm = "pm";
    }
    return objtime.substr(0, 5) + " " + ampm;
}
let editNoteFlag = 0;
notesFunc.callEditNotes = function(id) {
    let obj = {},
        n;
    n = $("div").find("[data-ntid='" + id + "']");

    $(".posrel.col-xs-21.ntsBox").removeClass("hide");
    $(".txtHldr").html(n.html());
    $(".noteid").val(id);
    $(".posrel.col-xs-21.ntsBox .ntsBtn")[0].lastChild.innerHTML = "Update";
}

notesFunc.editNote = function(obj) {
    let imgNode = {
        node: "img",
        attr: [{ node: "src", value: "/surveillance/dist/images/notes_edit_icon.png" },
            { node: "data-id", value: obj.noteid }, { node: "class", value: "note_edit_icon" }
        ]
    };

    let iNode = cmnFunc.createDmNode(imgNode);
    return iNode;
}

notesFunc.createNoteInfo = function(obj, idNode) {
    let parentN, pNode, snpNode, nmNode, tmNode;
    pNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsDivClr clearfix" }], appendTo: idNode });
    nmNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsNm nSec" }], html: obj.authorname, appendTo: pNode });
    tmNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsTm nSec" }], html: notesFunc.convertNotesDate(obj.epochtime), appendTo: pNode });
    if (notesFunc.logUser == obj.authorid && !notesFunc.voiceFlag) {
        nmNode = notesFunc.editNote(obj);
        cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsNm nSec" }], html: nmNode, appendTo: pNode });
        nmNode.on("click", function() {
            if (editNoteFlag == 0) {
                notesFunc.callEditNotes($(this).attr("data-id"));
                editNoteFlag = 1;
            }
        });
    }



}

notesFunc.createDivText = function(obj, idNode, index) {
    let dNode = cmnFunc.createDmNode({
        node: "div",
        attr: [{ node: "class", value: "ntsBtxt ntstxtCnt cnNtsTxt" },
            { node: "id", value: "ntxtScrl" + index }, { node: "data-ref", value: obj.content }, { node: "data-ntId", value: obj.noteid }
        ],
        html: cmnFunc.trncEllipsis(obj.content, 100),
        appendTo: idNode
    });
    return dNode;
}
notesFunc.createDivImgTxt = function(obj, idNode, index) {
    let n = {},
        onjNode = "data:image/png;base64," + obj.attachment,
        aMNode, aLNode;
    n.pNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "clearfix ntstxtCnt" }], appendTo: idNode });
    n.rNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsRght clearfix" }], appendTo: n.pNode });
    n.lPNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsLft clearfix" }], appendTo: n.pNode });
    n.lNode = cmnFunc.createDmNode({
        node: "div",
        attr: [{ node: "class", value: "ntsBtxt ntstxtCnt cnNtsTxt" }, { node: "id", value: "ntxtScrl" + index },
            { node: "data-ref", value: obj.content }, { node: "data-ntId", value: obj.noteid }
        ],
        html: cmnFunc.trncEllipsis(obj.content, 100),
        appendTo: n.lPNode
    });
    n.imgNode = cmnFunc.createDmNode({ node: "img", attr: [{ node: "class", value: "ntsIngSnp" }, { node: "src", value: onjNode }, { node: "align", value: "left" }], appendTo: n.rNode });
    return n;
}
notesFunc.createShowLink = function(obj, idNode, index) {
    let n = {},
        aMNode, cnt, aLNode;
    n.cnt = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "nysExtCnt" }], appendTo: idNode })
    n.aMNode = cmnFunc.createDmNode({
        node: "a",
        attr: [{ node: "class", value: "ntsShowMr" }, { node: "data-id", value: "ntxtScrl" + index }],
        html: "Show more",
        appendTo: n.cnt
    });
    n.aLNode = cmnFunc.createDmNode({
        node: "a",
        attr: [{ node: "class", value: "ntsShowLs hide" }, { node: "data-id", value: "ntxtScrl" + index }],
        html: "Show less",
        appendTo: n.cnt
    });
    return n;

}
notesFunc.createMainContainer = function(idNode) {
    let locdetail = cmnlocDetails.partial_homefolder,
        l = notesFunc.lc;
    let mnCont, hdrCont, idNodeRef = idNode ? idNode : $("body");
    mnCont = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsMnCnt clearfix" }, { node: "id", value: "ntsMnCnt" }], appendTo: idNodeRef });
    hdrCont = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsHdrCnt clearfix" }], appendTo: mnCont });
    noteSummary = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsSummary" }], appendTo: mnCont });
    cmnFunc.createDmNode({ node: "p", html: l.gotoNoteSummry, appendTo: noteSummary });
    cmnFunc.createDmNode({
        node: "img",
        attr: [
            { node: "src", value: locdetail + "dist/images/notes_icon.png" }
        ],
        appendTo: hdrCont
    });
    lftCont = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "ntsntsCnt" }], html: l.notes, appendTo: hdrCont });

    rghtCont = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "ntsCloseCnt" }], html: "&nbsp", appendTo: hdrCont });

    noteSummary.on("click", function(evt) {
        evt.stopPropagation();
        let link = cmnlocDetails.partial_homefolder + 'notesummary/index.html?loc=' + cmnEvidences.loc + '&alertid=' + notesFunc.queryParams.alertid;
        window.location = link;
        //console.log('going to notes summary page');
    });

    rghtCont.on("click", function(evt) {
        evt.stopPropagation();
        mnCont.remove();
    });
    return mnCont;
}
notesFunc.canvasGen = function() {
    /*if(snapshot_obj==undefined){
    	snapshot_obj = new SnapshotScribble();
    }*/
    $("#snapshot_image").remove();
    $("#snapshot-container").remove();
    snapshot_obj.SnapshotScribble();
    snapshot_obj.showHighlighter();
}
notesFunc.screenTxtContainer = function(idNode) {

    let locdetail = cmnlocDetails.partial_homefolder,
        l = notesFunc.lc;
    let screenShotBtn, addNotesBtn, divBtn, txtHldr, saveNoteBtn, spanNode, parentN, scrlDiv, ntsDiv, cancelNoteBtn, txtHddn;
    parentN = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "clearfix posrel" }], appendTo: idNode });


    divBtn = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "col-xs-12" }], html: "", appendTo: parentN });

    addNotesBtn = cmnFunc.createDmNode({ node: "button", attr: [{ node: "class", value: "nts-btn col-xs-5" }], appendTo: divBtn });
    cmnFunc.createDmNode({
        node: "img",
        attr: [
            { node: "src", value: locdetail + "dist/images/add_note_icon.png" }
        ],
        appendTo: addNotesBtn
    });
    spanNode = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "ntScrimg" }], html: l.notes, appendTo: addNotesBtn });
    if (!notesFunc.voiceFlag) {
        screenShotBtn = cmnFunc.createDmNode({ node: "button", attr: [{ node: "class", value: "nts-btn col-xs-7" }], appendTo: divBtn });
        cmnFunc.createDmNode({
            node: "img",
            attr: [
                { node: "src", value: locdetail + "dist/images/screenshot_icon.png" }
            ],
            appendTo: screenShotBtn
        });
        spanNode = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "ntScrimg" }], html: l.screenshot, appendTo: screenShotBtn });

    }


    scrlDiv = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "scrlCnt col-xs-12" }], appendTo: parentN });
    ntsDiv = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "posrel col-xs-21 ntsBox hide" }], appendTo: scrlDiv });

    cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "ntsErrHndlr" }], appendTo: ntsDiv });
    txtHldr = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "txtHldr" }, { node: "contenteditable", value: "true" }], appendTo: ntsDiv });
    txtHddn = cmnFunc.createDmNode({ node: "input", attr: [{ node: "type", value: "hidden" }, { node: "class", value: "noteid" }, { node: "noteid", value: "" }], appendTo: ntsDiv });

    ntsBtns = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsBtn" }], html: "", appendTo: ntsDiv });
    cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "clearfix" }], html: "", appendTo: ntsDiv }); // add

    cancelNoteBtn = cmnFunc.createDmNode({ node: "button", attr: [{ node: "class", value: "ntsScrnCnt secButton" }], html: l.cancel, appendTo: ntsBtns });
    saveNoteBtn = cmnFunc.createDmNode({ node: "button", attr: [{ node: "class", value: "ntsScrnCnt priButton" }], html: l.add, appendTo: ntsBtns });
    // cmnFunc.addEventListeners({node:btnNode,listener:"click",func:function(){notesFunc.canvasGen();}});

    // Excempt keys(arrows, del, backspace, home, end);
    var excempt = [37, 38, 39, 40, 46, 8, 36, 35];
    $("[contenteditable='true']").each(function(index, elem) {
        var $elem = $(elem);
        var length = 250;
        //console.log("sdfsfd");
        if (!isNaN(length)) {
            $elem.on('keydown', function(evt) {
                if (excempt.indexOf(evt.which) === -1 && $elem.text().length > length) {
                    evt.preventDefault();
                    return false;
                }
            });
        }
    });
    addNotesBtn.on('click', function() {
        $('.scrlCnt').scrollTop(0);
        $(ntsDiv).removeClass('hide');
        $(".posrel.col-xs-21.ntsBox .ntsBtn")[0].lastChild.innerHTML = "Add";
        $(".noteid").val("");
        $(".txtHldr").html("");

    });

    cancelNoteBtn.on('click', function() {
        $(ntsDiv).addClass('hide');
        $(".posrel.col-xs-21.ntsBox .ntsBtn")[0].lastChild.innerHTML = "Add";
        $(".noteid").val("");
        $(".txtHldr").html("");
        editNoteFlag = 0;
        $(".ntsErrHndlr").html("");
    });
    if (!notesFunc.voiceFlag) {
        screenShotBtn.on("click", function(evt) {
            evt.stopPropagation();
            notesFunc.canvasGen();
            $('#snapshot_button').trigger('click');
        });
    }
    saveNoteBtn.on("click", function(evt) {
        evt.stopPropagation();
        notesFunc.submitNote(txtHldr);
        editNoteFlag = 0;
    });
    return scrlDiv;
}

notesFunc.submitNote = function(txtHldr) {
    let qData = cmnFunc.getQueryParameters(),
        dtObj = { note: {} },
        dt = new Date(),
        month, ntsvalue = txtHldr.text().trim();
    let basepath = cmnlocDetails.partial_homefolder;
    let current_page = window.location.href;
    let page = current_page.substring(basepath.length).split("/")[0],
        l = notesFunc.lc;
    if (page == "alert") {
        page = "Alert Overview";
    } else if (page == "network") {
        page = "Network";
    } else if (page == "involvedemployees") {
        page = "Involved Employee" + "/" +
            logOutfunc.usrname() + "/" + $(".nav_section ul").find('li.active').html();
    } else if (page == "email") {
        page = "Email";
    } else if (page == "voice") {
        page = "Voice";
    } else if (page == "chat") {
        page = "Chat";
    } else if (page == "tradedetail") {
        page = "Trade Detail";
    }
    dtObj.note.reference = page;
    if (ntsvalue.trim() == "") {
        $(".ntsErrHndlr").html(l.plzFNtsFld);
        return false;
    } else {
        $(".ntsErrHndlr").html();
    }

    dtObj.note.content = ntsvalue.replace(/\s\s+/g, ' ');
    dtObj.note.authorid = cmnFunc.getCookie("id");

    /*if(isNaN(dtObj.note.authorid)==true){
		 dtObj.note.authorid = 10001;
	 }*/
    month = parseInt(dt.getMonth());
    //dt.getFullYear()+"/"+((month+1 >= 10) ? month+1 :( "0"+(month+1) ))+"/"+dt.getDate();
    let objRef = {},
        urlref;

    if ($(".posrel.col-xs-21.ntsBox .ntsBtn")[0].lastChild.innerHTML == "Add") {
        notesFunc.status = l.add;
        dtObj.note.notetitle = "Note";
        dtObj.note.authorname = logOutfunc.usrname();
        if (notesFunc.voiceFlag) {
            urlref = cmnlocDetails.service + "/noteservice/v2/communication/" + qData.commid + "/note"
        } else {
            urlref = cmnlocDetails.notesSrvc + qData.alertid + "/note";
        }
        objRef = {
            type: "POST",
            url: urlref,
            dataType: "json",
            data: JSON.stringify(dtObj),
            ref: notesFunc,
            func: "submitFM"
        };
        cmnAsync.asynccall(objRef);
    } else {
        notesFunc.status = l.update;
        dtObj.note.notetitle = "Note";
        dtObj.note.authorname = logOutfunc.usrname();
        let obj = {};
        if (notesFunc.notesObj.notes) {
            for (let i = 0; i < notesFunc.notesObj.notes.length; i++) {
                if (notesFunc.notesObj.notes[i].noteid == $(".noteid").val()) {
                    obj = notesFunc.notesObj.notes[i];
                    dtObj.note.notetitle = obj.notetitle;
                }

            }
        }
        if (notesFunc.voiceFlag) {
            urlref = cmnlocDetails.service + "/noteservice/v2/communication/" + qData.commid + "/note/" + $(".noteid").val();
        } else {
            urlref = cmnlocDetails.notesSrvc + qData.alertid + "/note/" + $(".noteid").val();
        }
        //console.log(dtObj);
        objRef = {
            type: "PUT",
            url: urlref,
            dataType: "json",
            data: JSON.stringify(dtObj),
            ref: notesFunc,
            func: "submitFM"
        };
        cmnAsync.asynccall(objRef);
    }
}
notesFunc.saveOprDlg = function() {
    let n = {};
    n.pDiv = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsSaveDlg" }], appendTo: $("body") });
    n.cancelNt = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "ntsCloseCnt" }], html: "&nbsp", appendTo: n.pDiv });
    n.cntDiv = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "ntsSvCnt" }], appendTo: n.pDiv });
    n.txtDiv = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "ntsSvHdr" }], appendTo: n.cntDiv });
    n.closeDiv = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "ntsSvBdy" }], appendTo: n.cntDiv });

    cmnFunc.addEventListeners({
        node: n.cancelNt,
        listener: "click",
        func: function() {
            n.pDiv.remove();
        }
    });
    return n;
}
notesFunc.submitFM = function(idNode) {
    if (idNode && (typeof idNode.status !== "undefined") && idNode.status != "200") {

        $(".ntsErrHndlr").html(idNode.responseText.split(/:(.+)/)[1] ? idNode.responseText.split(/:(.+)/)[1] : idNode.responseText);
        return false;
    }

    /*$("#ntsMnCnt").remove();*/
    let status = "",
        qData = cmnFunc.getQueryParameters(),
        urlref;
    if (notesFunc.voiceFlag) {
        urlref = cmnlocDetails.service + "/noteservice/v2/communication/" + qData.commid + "/note/" + idNode.noteid;
    } else {
        urlref = cmnlocDetails.notesSrvc + qData.alertid + "/note/" + idNode.noteid;
    }
    if (notesFunc.status == "Add") {
        objRef = {
            type: "GET",
            url: urlref,
            data: JSON.stringify({ "authorname": logOutfunc.usrname() }),
            dataType: "json",
            ref: notesFunc,
            func: "asyncUpdtCnt"
        };
        cmnAsync.asynccall(objRef);
        status = "added";
    } else {
        let nd = $("div").find("[data-ntid='" + $(".noteid").val() + "']");
        nd.html($(".txtHldr").html());
        $(".txtHldr").html("");
        $(".ntsBox").addClass("hide");

        status = "updated";
    }
    notesFunc.notify(status);
}
notesFunc.asyncUpdtCnt = function(o) {
    let l = notesFunc.lc,
        parentN = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "col-xs-12 item-border" }] });
    $(".ntsBox").after(parentN), ind = ++notesFunc.ntsFldCtr, obj = o.note;
    notesFunc.createNtHdr(obj, parentN).html(l.referencing + " " + obj.reference);
    bdyTxt = notesFunc.createDivText(obj, parentN, ind);
    if (obj.content && obj.content.length > 100) {
        let aCnt = notesFunc.createShowLink(obj, parentN, ind);
        notesFunc.addAnchrListeners(aCnt);

    }

    notesFunc.createNoteInfo(obj, parentN);
    $(".txtHldr").html("");
    $(".ntsBox").addClass("hide");
}
notesFunc.notify = function(status) {
    let div_obj = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "notify_user" }] });
    let p_obj = cmnFunc.createDmNode({ node: "p", html: "Your note has been " + status, appendTo: div_obj });
    $('body').append(div_obj);
    $(".noteid").val("");
    window.setTimeout(function() {
        $('.notify_user').remove();
    }, 3000);
}