/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
var ScoreColor = function(status_value){
	var color = '';
	status_value = status_value.toUpperCase();
	if(status_value=="CLOSED"){
		color = "#649ABF";
	}else if(status_value=="NEW"){
		color = "#49AD64";
	}else if(status_value=="IN PROGRESS"){
		color = "#F4C44A";
	}else if(status_value=="MANUALLY ESCALATED"){
		color = "#FB7D4D";
	}else if(status_value=="REJECTED"){
		color = "#A47EA6";
	}else if(status_value=="AUTOMATICALLY ESCALATED"){
		color = "#26AEB4";
	}
	return color;
}

var PieChart = function(o){
	var width = o.wd;
	var height = o.ht;
	var destination = o.destination;
	var data = o.data;
	var radius = o.radius;
	var show_text  = o.showtext;
	var position_x = o.position_x;
	var position_y = o.position_y;
	var key = o.key;
	var value = o.value;
	var legendtextclass = o.legendtextclass;
	var text_spacing_x = o.text_spacing_x;
	var text_spacing_y = o.text_spacing_y;
	function getToolTipContent(d, total_data) {
		var total_count = 0;
		for(var i=0;i<total_data.length;i++){
			total_count+=total_data[i].count;
		}
		var num = d.data.count;

		var str = '';
		str += '<div class="pointer">';
		str += '<img src="'+cmnlocDetails.partial_homefolder+'dist/images/tooltippointer.png"/>';
		str += '</div>';
		str += '<div class="tooltip_data">';
		str += '<table>';
		str += '<tr>';
		str += '<td>';
		str += 'Count: ' + num ;
		str += '</td>';
		str += '</tr>';
		str += '<tr>';
		str += '<td>';
		str += 'Status: ' + d.data.status;
		str += '</td>';
		str += '</tr>';
		str += '</table>';
		str += '</div>';
		return str;
	}
	function titleCase(string) {
		var str_split = string.split(" ");
		var str = '';
		for(var i=0;i<str_split.length;i++){
			str += str_split[i].charAt(0).toUpperCase() + str_split[i].slice(1)+" ";
		}
		return str = str.substr(0,str.length-1);
	}


	///var color = d3.scaleOrdinal()
	//	.range(["#49AD64","#F4C44A","#FB7D4D","#A47EA6","#26AEB4","#649ABF"]);

	var arc = d3.arc()
		.outerRadius(radius - 10)
		.innerRadius(0);

	var labelArc = d3.arc()
		.outerRadius(radius - 40)
		.innerRadius(radius - 40);

	var pie = d3.pie()
		.sort(null)
		.value(function(d) { return d[value]; });

	var svg = d3.select(destination).append("svg")
		.attr("width", width)
		.attr("height", height)
		.append("g")
		.attr("transform", "translate(" + position_x + "," + position_y + ")");

	if(data==undefined || data.length==0){
			svg.append("text")
				.attr("x", width/2)
				.attr("y", (height / 2))
				.style("text-anchor", "start")
				.text("No Data")
				//.attr("transform", "translate(" + (translate) + "," + (height / 2) + ")")
				.style("font-family", "'IBM Helvetica Medium'")
				.style("font-size", "1em")
				.style("fill", "#777677")
				.style("font-weight", "normal");
			return;

	}

	  var g = svg.selectAll(".arc")
		  .data(pie(data))
		  .enter().append("g")
		  .attr("class", "arc");


	  //var tooltip_flag=0;
	  g.append("path")
			/*.transition()
			.delay(function(d, i) {
			  return i * 100;
			})
			.duration(500)*/
		  .attr("d", arc)
		  .style("fill", function(d) { return ScoreColor(d.data[key]); })

			.on("mouseover", function(d) {
				//console.log("MouseOver: "+tooltip_flag);
					d3.select(this).style("opacity", 1);
					d3.select(".tooltip").remove();
				  var tooltip = d3.select("body").append("div")
				  .classed("tooltip",true)
				  .style("opacity", 1);
					tooltip.transition()
						.duration(2000)
						.style("opacity", .9);
					tooltip.html(
							getToolTipContent(d,data)
						)
						.style("left", (d3.event.pageX+2) + "px")
						.style("top", (d3.event.pageY-10) + "px");
				//tooltip_flag++;
            })
            .on("mouseout", function(d) {
				//console.log("MouseOut: "+tooltip_flag);
				//tooltip_flag=0;
				d3.select(".tooltip").remove();
                //d3.select(this).style("fill-opacity", "1");
                //d3.select(this).style("opacity", "1");
            });

	//  if(show_text == 1){
	// 	g.append("text")
	// 		/*.transition()
	// 		.delay(function(d, i) {
	// 		  return i * 200;
	// 		})
	// 		.duration(500)		*/
	// 	  .attr("transform", function(d) { return "translate(" + labelArc.centroid(d) + ")"; })
	// 	  .attr("dy", ".35em")
	// 	  .attr("fill", "#fff")
	// 	  .text(function(d) { return d.data[value]; });
	//  }


	var piechart_legend_div = svg.selectAll(".arc")
								.data(pie(data))
								.enter().append("g")
								.attr("class", "arc");

	piechart_legend_div.data(pie(data)).enter().append("rect")
			/*.transition()
			.delay(function(d, i) {
			  return i * 200;
			})
			.duration(500)*/
			.attr("x",function(d,i){return position_x;}).attr("y",function(d,i){ return (i+1)*15-position_y+2;}).attr("width",10).attr("height",10).style("fill",function(d,i){ return ScoreColor(d.data[key]);});

	piechart_legend_div.data(pie(data)).enter().append("text")
			/*.transition()
			.delay(function(d, i) {
			  return i * 200;
			})
			.duration(500)*/
			.attr("class",legendtextclass).attr("transform",function(d,i){return "translate("+(position_x+text_spacing_x)+")";}).attr("dy",function(d,i){return (i+1)*15-(position_y-text_spacing_y);}).text(function(d) { return titleCase(d.data[key]); });

}
