/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
let snp_obj = {};
let fabObj = { idCount: 0 };
snp_obj.rectangle = {};
snp_obj.container;
snp_obj.canvas;
snp_obj.image;

let snapshot_obj = {};
let wd;
snapshot_obj.initEvts = function() {
    window.addEventListener("resize", function() {

        if (document.getElementById("snapshot-canvas-inner") != null) {
            wd = document.getElementById("snapshot-canvas-inner").offsetWidth;
        }
        if (wd != undefined) {
            if (document.getElementsByClassName("canvas-container") != null) {
                document.getElementsByClassName("canvas-container").offsetWidth = wd;
            }
            if (document.getElementById("snapshot-canvas") != null) {
                document.getElementById("snapshot-canvas").offsetWidth = wd;
            }
            if (document.getElementsByClassName("upper-canvas") != null) {
                document.getElementsByClassName("upper-canvas ").offsetWidth = wd;
            }
        }
    });
}
snapshot_obj.init = function() {
    if (document.getElementById("close-content") != null) {
        document.getElementById("close-content").addEventListener("click", function() {
            let params = cmnFunc.getQueryParameters();
            if (params.source == undefined || params.source == null || params.source == '') {
                document.getElementById("snapshot-container").style.display = "none";
                document.getElementById("snapshot-top-header").style.display = "none";
                snp_obj.canvas = undefined;
                $(".canvas-container").remove();
                $("#snapshot_image").remove();
                $("#snapshot-container").remove();
                $("#snapshot-top-header").remove();
            } else {
                window.location.reload();
            }
        });
    }
    if (document.getElementById("cancel") != null) {
        document.getElementById("cancel").addEventListener("click", function() {
            //document.getElementById("snapshot-container").style.display = "none";
            //snp_obj.canvas = undefined;
            //$(".canvas-container").remove();
            //window.location.reload();
            let params = cmnFunc.getQueryParameters();
            if (params.source == undefined || params.source == null || params.source == '') {
                document.getElementById("snapshot-container").style.display = "none";
                document.getElementById("snapshot-top-header").style.display = "none";
                snp_obj.canvas = undefined;
                $(".canvas-container").remove();
                $("#snapshot_image").remove();
                $("#snapshot-container").remove();
                $("#snapshot-top-header").remove();
            } else {
                window.location.reload();
            }
        });
    }
    if (document.getElementById("save") != null) {
        document.getElementById("save").addEventListener("click", function() {
            snapshot_obj.saveImage();
        });
    }
    snapshot_obj.initEvts();
}
snapshot_obj.SnapshotScribble = function() {
    let process_count = 0;
    let targetId = "";
    let _this = this;
    snapshot_obj.save_title = "";
    snp_obj.lc = JSON.parse(sessionStorage.getItem(cmnEvidences.loc));
}
snapshot_obj.loadImage = function() {
    $("#snapshot_img").css("border", "1px solid red");
};

snapshot_obj.exportAll = function(exportDivId, fileType) {
    let _this = this;
    $("#snapshot-highlighter").remove();
    $("body").attr("id", "highlighter");
    //$("#alrtOvrStatus").css("display","none");
    $(".legend_info").remove();
    let but = document.createElement("input");
    but.id = "temp";
    but.type = "button";
    but.value = "Temp";
    but.style.visibility = "hidden";
    document.body.appendChild(but);
    targetId = "snapshot-temp-container";
    $("#" + exportDivId).exportAll({
        callbackBeforeCanvg: { name: _this.callbackForExportAllBeforeCanvg, arguments: exportDivId },
        callbackOnRendered: { name: _this.callbackForExportAllOnRendered, arguments: exportDivId },
        fileName: "ExportImage",
        targetId: targetId,
        fileType: fileType,
        windowTitle: "Export window",
        listStyleToGet: ["fill", "stroke", "opacity", "fill-opacity", "shape-rendering", "stroke-opacity",
            "font", "font-size", "font-weight", "font-family", "color",
            "float", "height", "width"
        ]
    });
};
// Remove github logo and menu before export
snapshot_obj.callbackForExportAllBeforeCanvg = function(exportDivId, targetExportDivId) {
    $("#" + targetExportDivId + " #githubLink").remove();
    $("#" + targetExportDivId + " #exportMenu").remove();
};


snapshot_obj.callbackForExportAllOnRendered = function(exportDivId, targetExportDivId) {
    $("#temp").remove();
};

snapshot_obj.createSnapshotContainer = function(exportDivId, fileType) {
    _this = this;
    let l = snp_obj.lc;
    let snapshot_top_header_div = document.createElement('div');
    snapshot_top_header_div.id = "snapshot-top-header";
    snapshot_top_header_div.style.display = "none";
    document.body.appendChild(snapshot_top_header_div);


    let snapshot_container_div = document.createElement('div');
    snapshot_container_div.id = "snapshot-container";
    document.body.appendChild(snapshot_container_div);


    let snapshot_content_header_div = document.createElement('div');
    snapshot_content_header_div.id = "snapshot-content-header";
    let snapshot_canvas_container_div = document.createElement('div');
    snapshot_canvas_container_div.id = "snapshot-canvas-container";
    let snapshot_notes_container_div = document.createElement('div');
    snapshot_notes_container_div.id = "snapshot-notes-container";

    //notes header for screenshot div
    let locdetail = cmnlocDetails.partial_homefolder;
    let hdrCont = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "snapshotNotesHeader" }], appendTo: snapshot_top_header_div });
    cmnFunc.createDmNode({ node: "p", html: "Go to Note Summary", appendTo: noteSummary });
    cmnFunc.createDmNode({ node: "img", attr: [{ node: "src", value: locdetail + "dist/images/notes_icon.png" }], appendTo: hdrCont });
    cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "ntsntsCnt" }], html: l.notes, appendTo: hdrCont });

    let close = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "screenshotClose ntsCloseCnt" }], html: "&nbsp", appendTo: hdrCont });
    close.on('click', function() {
        _this.closeSnapShot();
    });

    snapshot_container_div.appendChild(snapshot_top_header_div);
    //snapshot_container_div.appendChild(snapshot_content_header_div);
    let loc = cmnlocDetails.partial_homefolder

    let editContainer = "<div class=\"scrnEditcont\"><div class=\"scrnIcnHldr\">" +
        "<div id=\"scrnArrow\" title=\"Pointer\"></div><div><div id=\"scrnCircle\" title=\"circle\">" +
        "</div></div><div id=\"scrnRemove\" title=\"Delete\"></div></div></div>";
    $(snapshot_container_div).append(editContainer);
    $('<img />', { src: loc + "dist/images/upscrnarrow.png", class: "scrnIcn", alt: "Arrow" }).appendTo($('#scrnArrow'));

    $('<img />', { src: loc + "dist/images/trash-icon.png", class: "trash-icon", alt: "delete" }).appendTo($('#scrnRemove'));

    $("#scrnArrow").on("click", function() {
        fabObj.arrowGen();
    });
    $("#scrnCircle").on("click", function() {
        fabObj.addCircle();
    });
    $("#scrnRemove").on("click", function() {
        let rObj = snp_obj.canvas.getActiveObject();
        if (rObj && rObj.className) {
            let o = snp_obj.canvas.getObjects(),
                c = rObj.className;
            rObj.remove();
            for (let i = 0; i < o.length; i++) {
                let p = o[i];
                if (p.className == c) {
                    p.remove();
                }
            }
            snp_obj.canvas.getActiveObject().remove();
        } else if (rObj) {
            snp_obj.canvas.getActiveObject().remove();
        }

    });
    snapshot_container_div.appendChild(snapshot_canvas_container_div);
    snapshot_container_div.appendChild(snapshot_notes_container_div);

    let snapshot_date_txt_content_div = document.createElement('div');
    let snapshot_buttons_content_div = document.createElement('div');
    let snapshot_close_content_div = document.createElement('div');
    snapshot_date_txt_content_div.id = "date-text-content";
    snapshot_buttons_content_div.id = "buttons-content";
    snapshot_close_content_div.id = "close-content";

    snapshot_content_header_div.appendChild(snapshot_date_txt_content_div);
    snapshot_content_header_div.appendChild(snapshot_buttons_content_div);
    snapshot_content_header_div.appendChild(snapshot_close_content_div);

    let curr_date = "";
    let c_date = new Date();
    let mm = c_date.getMonth() + 1;
    if (mm < 10) {
        mm = "0" + mm;
    }
    let dd = c_date.getDate();
    if (dd < 10) {
        dd = "0" + dd;
    }
    curr_date = c_date.getFullYear() + "-" + mm + "-" + dd;
    let snapshot_date_text_div = document.createElement('div');
    snapshot_date_text_div.id = "date-text";
    snapshot_date_text_div.innerHTML = curr_date;

    let snapshot_text_content_div = document.createElement('div');
    snapshot_text_content_div.id = "text-content";
    snapshot_text_content_div.innerHTML = "You can draw and make notes on the screen capture below";

    snapshot_date_txt_content_div.appendChild(snapshot_date_text_div);
    snapshot_date_txt_content_div.appendChild(snapshot_text_content_div);

    /*let img = document.createElement("img");
    img.id="left-cross";
    img.src="../dist/images/4F12A1BA-4C79-48AE-9A2B-180B71DD94DF@1x.png";
    snapshot_close_content_div.appendChild(img);

    img = document.createElement("img");
    img.id="right-cross";
    img.src="../dist/images/AD88486C-14C3-4C32-BBC4-C1977E4626BE@1x.png";
    snapshot_close_content_div.appendChild(img);*/



    let snapshot_canvas_inner_div = document.createElement("div");
    snapshot_canvas_inner_div.id = "snapshot-canvas-inner";
    snapshot_canvas_container_div.appendChild(snapshot_canvas_inner_div);

    let snapshot_canvas = document.createElement("CANVAS");
    snapshot_canvas.id = "snapshot-canvas";
    snapshot_canvas_inner_div.appendChild(snapshot_canvas);

    let snapshot_screen_err_layout_div = document.createElement("div");
    snapshot_screen_err_layout_div.id = "snapshot-screen-err-layout";
    let snapshot_screen_name_layout_div = document.createElement("div");
    snapshot_screen_name_layout_div.id = "snapshot-screen-name-layout";
    let snapshot_additional_notes_layout_div = document.createElement("div");
    snapshot_additional_notes_layout_div.id = "snapshot-additional-notes-layout";

    snapshot_notes_container_div.appendChild(snapshot_screen_err_layout_div);
    snapshot_notes_container_div.appendChild(snapshot_screen_name_layout_div);
    snapshot_notes_container_div.appendChild(snapshot_additional_notes_layout_div);

    let snapshot_screen_errHndlr_div = document.createElement("div");
    snapshot_screen_errHndlr_div.id = "snapshot-screen-errHndlr";
    snapshot_screen_errHndlr_div.className = "ntsErrHndlr hide";
    snapshot_screen_err_layout_div.appendChild(snapshot_screen_errHndlr_div);
    let snapshot_screen_name_label_div = document.createElement("div");
    snapshot_screen_name_label_div.id = "snapshot-screen-name-label";
    snapshot_screen_name_label_div.innerHTML = l.title;

    let snapshot_screen_name_input = document.createElement("input");
    snapshot_screen_name_input.type = "text"
    snapshot_screen_name_input.id = "snapshot-screen-name"
    snapshot_screen_name_input.value = l.screenshot + "-" + curr_date;

    snapshot_screen_name_layout_div.appendChild(snapshot_screen_name_label_div);
    snapshot_screen_name_layout_div.appendChild(snapshot_screen_name_input);


    let snapshot_additional_options_label = document.createElement("div");
    snapshot_additional_options_label.id = "snapshot-additional-options-label";
    snapshot_additional_options_label.innerHTML = l.comments;

    let snapshot_screen_notes = document.createElement("textarea");
    snapshot_screen_notes.id = "snapshot-screen-notes"
    snapshot_screen_notes.placeholder = l.addNotesHere + "...";

    snapshot_additional_notes_layout_div.appendChild(snapshot_additional_options_label);
    snapshot_additional_notes_layout_div.appendChild(snapshot_screen_notes);

    let snapshot_buttons_close = document.createElement('input');
    snapshot_buttons_close.type = "button";
    snapshot_buttons_close.id = "cancel";
    snapshot_buttons_close.value = l.cancel;
    snapshot_buttons_close.addEventListener('click', function() {
        _this.closeSnapShot();
    });
    snapshot_additional_notes_layout_div.appendChild(snapshot_buttons_close);


    snapshot_buttons_input = document.createElement('input');
    snapshot_buttons_input.type = "button";
    snapshot_buttons_input.id = "save";
    snapshot_buttons_input.value = l.save;
    snapshot_additional_notes_layout_div.appendChild(snapshot_buttons_input);

    if (document.getElementById("close-content") != null) {
        document.getElementById("close-content").addEventListener("click", function() {
            let params = cmnFunc.getQueryParameters();
            if (params.source == undefined || params.source == null || params.source == '') {
                document.getElementById("snapshot-container").style.display = "none";
                document.getElementById("snapshot-top-header").style.display = "none";
                snp_obj.canvas = undefined;
                $(".canvas-container").remove();
                $("#snapshot_image").remove();
                $("#snapshot-container").remove();
                $("#snapshot-top-header").remove();
            } else {
                window.location.reload();
            }
        });
    }

    if (document.getElementById("save") != null) {
        document.getElementById("save").addEventListener("click", function() {
            snapshot_obj.saveImage();
        });
    }
    window.addEventListener("resize", function() {
        if (document.getElementById("snapshot-canvas-inner") != null) {
            let wd = document.getElementById("snapshot-canvas-inner").offsetWidth;
        }
        if (document.getElementsByClassName("canvas-container") != null) {
            document.getElementsByClassName("canvas-container").offsetWidth = wd;
        }
        if (document.getElementById("snapshot-canvas") != null) {
            document.getElementById("snapshot-canvas").offsetWidth = wd;
        }
        if (document.getElementsByClassName("upper-canvas") != null) {
            document.getElementsByClassName("upper-canvas ").offsetWidth = wd;
        }
    });


    snapshot_obj.exportAll(exportDivId, fileType);
};

snapshot_obj.showHighlighter = function() {
    let _this = this;
    /*let snapshot_highlighter_div = document.createElement('div');
    snapshot_highlighter_div.id="snapshot-highlighter";
    snapshot_highlighter_div.style.marginTop = -(document.body.offsetHeight)+"px";
    snapshot_highlighter_div.style.width = (document.body.offsetWidth)+"px";
    snapshot_highlighter_div.style.height = (document.body.offsetHeight)+"px";
    let snapshot_button = document.createElement('input');
    snapshot_button.id="snapshot_button";
    snapshot_button.type = "button";
    snapshot_button.value = "Click to take a screenshot";
    snapshot_highlighter_div.appendChild(snapshot_button);*/
    //document.body.appendChild(snapshot_highlighter_div);
    $(".ntsCloseCnt").click();
    /*let snapshot_button = document.createElement("input");
    snapshot_button.setAttribute("id","snapshot_button");
    snapshot_button.setAttribute("type","button");
    snapshot_button.setAttribute("value","Click to take a screenshot");
    document.body.appendChild(snapshot_button);*/
    //$("#snapshot_button").click(function(){
    //_this.exportAll('highlighter', 'png');
    snapshot_obj.createSnapshotContainer('highlighter', 'png');
    //});
};
snapshot_obj.saveNotificationClose = function() {
    document.getElementsByClassName("notification")[0].remove();
};
snapshot_obj.showSavedNotification = function() {

    let _this = this;
    let save_notification = document.createElement("div");
    save_notification.className = "notification";
    document.body.appendChild(save_notification);

    let save_notification_border = document.createElement("div");
    save_notification_border.className = "notifcation-border";
    save_notification.appendChild(save_notification_border);

    let save_notification_title = document.createElement("div");
    save_notification_title.className = "notifcation-title";
    save_notification.appendChild(save_notification_title);

    let save_notification_message = document.createElement("div");
    save_notification_message.className = "notifcation-message";
    save_notification_message.innerHTML = "It will be saved in notes";
    save_notification.appendChild(save_notification_message);

    let save_title = document.createElement("div");
    save_title.className = "title";
    save_title.innerHTML = _this.save_title + " was saved!";
    save_notification_title.appendChild(save_title);

    let save_img_close = document.createElement("img");
    save_img_close.className = "save-close";
    save_img_close.src = "../dist/images/D34A4791-8778-440E-B955-117828C9BD93@1x.png";
    save_notification_title.appendChild(save_img_close);


    let mtop = document.body.offsetHeight - document.getElementsByClassName("hdrCnt")[0].offsetHeight - 20;

    //var current_page = "";
    //current_page = window.location.href;
    //var flag = current_page.indexOf("involvedemployees");
    //if(flag>=0){
    //mtop = mtop-677;
    //}
    document.getElementsByClassName("notification")[0].style.position = "absolute";
    document.getElementsByClassName("notification")[0].style.marginTop = -(mtop) + "px";
    document.getElementsByClassName("notification")[0].style.marginLeft = (document.body.offsetWidth - (document.getElementsByClassName("notification")[0].offsetWidth + 50)) + "px";


    if (document.getElementsByClassName("save-close")[0] != null) {
        document.getElementsByClassName("save-close")[0].addEventListener("click", function() {
            _this.saveNotificationClose();
        });
    }

};
snapshot_obj.responseSaveSnapshot = function(obj) {
    let _this = this;
    if (obj == undefined || obj == null) {
        alert("Data not saved error!");
        $('#snapshot-canvas').width($("#snapshot-canvas-inner").width());
        $('#snapshot-canvas').height($("#snapshot-canvas-inner").height());
        $(".canvas-container").width($("#snapshot-canvas-inner").width());
        $(".canvas-container").height($("#snapshot-canvas-inner").height());
        $(".upper-canvas").width($("#snapshot-canvas-inner").width());
        $(".upper-canvas").height($("#snapshot-canvas-inner").height());
        return false;
    } else {
        if (obj.status == 200 && obj.message == "Success") {
            $('#snapshot-canvas').hide();
            $(".canvas-container").hide();
            $(".upper-canvas").hide();
            document.getElementById("snapshot-container").remove();
            _this.notify();
        } else {
            alert("Response Error: " + obj.message);
            $('#snapshot-canvas').width($("#snapshot-canvas-inner").width());
            $('#snapshot-canvas').height($("#snapshot-canvas-inner").height());
            $(".canvas-container").width($("#snapshot-canvas-inner").width());
            $(".canvas-container").height($("#snapshot-canvas-inner").height());
            $(".upper-canvas").width($("#snapshot-canvas-inner").width());
            $(".upper-canvas").height($("#snapshot-canvas-inner").height());
            return false;
        }
    }
};
snapshot_obj.saveImage = function() {


    let _this = this;
    let title = document.getElementById("snapshot-screen-name").value;
    title = title.trim();
    if (title == "" || title == undefined || title == null) {
        title = null;
        $("#snapshot-screen-errHndlr").html("Please Provide Title");
        $("#snapshot-screen-errHndlr").removeClass("hide");
        return false;
    }
    snapshot_obj.save_title = title;

    let content = document.getElementById("snapshot-screen-notes").value;
    content = content.trim();
    if (content == "" || content == undefined || content == null) {
        content = null;
    }
    var data = snp_obj.canvas.toDataURL("image/png");
    var img_data = data;
    img_data = img_data.replace("data:image/png;base64,", "");
    let qData = cmnFunc.getQueryParameters(),
        dtObj = { note: {} };
    dtObj.note.notetitle = snapshot_obj.save_title;
    dtObj.note.content = content;
    dtObj.note.authorid = cmnFunc.getCookie("id");
    dtObj.note.attachment = img_data;
    dtObj.note.authorname = logOutfunc.usrname();
    let basepath = cmnlocDetails.partial_homefolder;
    let current_page = window.location.href;
    let page = current_page.substring(basepath.length).split("/")[0];
    if (page == "alert") {
        page = "Alert Overview";
    } else if (page == "network") {
        page = "Network";
    } else if (page == "involvedemployees") {
        page = $(".nav_section ul").find('li.active').html();
    } else if (page == "email") {
        page = "Email";
    } else if (page == "voice") {
        page = "Voice";
    } else if (page == "chat") {
        page = "Chat";
    }
    dtObj.note.reference = page;
    $('#snapshot-canvas').width($("#snapshot-canvas-inner").width());
    $('#snapshot-canvas').height($("#snapshot-canvas-inner").height());
    $(".canvas-container").width($("#snapshot-canvas-inner").width());
    $(".canvas-container").height($("#snapshot-canvas-inner").height());
    $(".upper-canvas").width($("#snapshot-canvas-inner").width());
    $(".upper-canvas").height($("#snapshot-canvas-inner").height());
    let objRef = {
        type: "POST",
        url: cmnlocDetails.notesSrvc + qData.alertid + "/note",
        dataType: "json",
        data: JSON.stringify(dtObj),
        ref: _this,
        func: "responseSaveSnapshot"
    }
    cmnAsync.asynccall(objRef);
};


snapshot_obj.showSnapshotContainer = function() {

    snp_obj.rectangle = new fabric.Rect({
        fill: 'transparent',
        originX: 'left',
        originY: 'top',
        stroke: 'none',
        strokeDashArray: [2, 2],
        opacity: 1,
        visible: true,
        width: 1,
        height: 1
    });


    let myElem = document.getElementById('snapshot-canvas');
    if (myElem === null) {
        let c = document.createElement('canvas');
        c.setAttribute("id", "snapshot-canvas");
        document.getElementById("snapshot-canvas-inner").appendChild(c);
    }


    snp_obj.container = document.getElementById('snapshot-canvas').getBoundingClientRect();
    snp_obj.canvas = new fabric.Canvas('snapshot-canvas');

    document.getElementById("snapshot-container").style.display = "block";
    document.getElementById("snapshot-top-header").style.display = "block";
    var dif = document.body.scrollHeight - document.body.clientHeight;

    var height = dif + document.body.scrollHeight + "px";
    document.getElementById("snapshot-top-header").style.marginTop = -(document.getElementById("snapshot-top-header").offsetTop) + "px";
    document.getElementById("snapshot-container").style.top = '210px';
    document.getElementById("snapshot-container").style.height = (document.body.offsetHeight) + "px";
    $('#snapshot-canvas').width($("#snapshot-canvas-inner").width());
    $('#snapshot-canvas').height($("#snapshot-canvas-inner").height());
    fabric.util.loadImage($("#snapshot_image").attr("src"), function(img) {
        snp_obj.image = new fabric.Image(img);
        snp_obj.image.selectable = false;
        snp_obj.canvas.setHeight(snp_obj.image.height);
        snp_obj.canvas.setWidth(snp_obj.image.width);
        snp_obj.canvas.add(snp_obj.image);
        snp_obj.canvas.renderAll();
        $('#snapshot-canvas').width($("#snapshot-canvas-inner").width());
        $('#snapshot-canvas').height($("#snapshot-canvas-inner").height());
        $(".canvas-container").width($("#snapshot-canvas-inner").width());
        $(".canvas-container").height($("#snapshot-canvas-inner").height());
        $(".upper-canvas").width($("#snapshot-canvas-inner").width());
        $(".upper-canvas").height($("#snapshot-canvas-inner").height());
    });
}


snapshot_obj.closeSnapShot = function() {
    let params = cmnFunc.getQueryParameters();
    if (params.source == undefined || params.source == null || params.source == '') {
        document.getElementById("snapshot-container").style.display = "none";
        document.getElementById("snapshot-top-header").style.display = "none";
        snp_obj.canvas = undefined;
        $(".canvas-container").remove();
        $("#snapshot_image").remove();
        $("#snapshot-container").remove();
        $("#snapshot-top-header").remove();
    } else {
        window.location.reload();
    }
}

snapshot_obj.notify = function() {
    let div_obj = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "notify_user" }] });
    let p_obj = cmnFunc.createDmNode({ node: "p", html: "Your screenshot has been saved", appendTo: div_obj });
    $('body').append(div_obj);
    window.setTimeout(function() {
        $('.notify_user').remove();
    }, 3000);
}

$(document).ready(function() {
    snapshot_obj.init();
});
fabObj.arrowGen = function() {
    fabObj.canvas = snp_obj.canvas;
    fabObj.idCount++;
    fabObj.addArrowToCanvas();
}
fabObj.addCircle = function() {
    circle = new fabric.Circle({
        left: 500,
        top: 400,
        radius: 100,
        strokeWidth: 10,
        stroke: 'red',
        fill: 'rgba(0,0,0,0)',
        opacity: "0.9",
        selectable: true,
        originX: 'center',
        originY: 'center'
    });
    snp_obj.canvas.add(circle);
}
fabObj.addArrowToCanvas = function() {
    var line,
        arrow,
        circle;

    line = new fabric.Line([300, 300, 400, 400], {
        stroke: '#000',
        selectable: true,
        strokeWidth: '5',
        padding: 5,
        hasBorders: false,
        hasControls: false,
        originX: 'center',
        originY: 'center',
        lockScalingX: true,
        lockScalingY: true,
        className: "arw" + fabObj.idCount
    });

    var centerX = (line.x1 + line.x2) / 2,
        centerY = (line.y1 + line.y2) / 2;
    deltaX = line.left - centerX,
        deltaY = line.top - centerY;

    arrow = new fabric.Triangle({
        left: line.get('x1') + deltaX,
        top: line.get('y1') + deltaY,
        originX: 'center',
        originY: 'center',
        hasBorders: false,
        hasControls: false,
        lockScalingX: true,
        lockScalingY: true,
        lockRotation: true,
        pointType: 'arrow_start',
        angle: -45,
        width: 40,
        height: 40,
        fill: '#000',
        className: "arw" + fabObj.idCount
    });
    arrow.line = line;

    circle = new fabric.Circle({
        left: line.get('x2') + deltaX,
        top: line.get('y2') + deltaY,
        radius: 3,
        stroke: '#000',
        strokeWidth: 3,
        originX: 'center',
        originY: 'center',
        hasBorders: false,
        hasControls: false,
        lockScalingX: true,
        lockScalingY: true,
        lockRotation: true,
        pointType: 'arrow_end',
        fill: '#000',
        className: "arw" + fabObj.idCount
    });
    circle.line = line;

    line.customType = arrow.customType = circle.customType = 'arrow';
    line.circle = arrow.circle = circle;
    line.arrow = circle.arrow = arrow;

    fabObj.canvas.add(line, arrow);

    function moveEnd(obj) {
        var p = obj,
            x1, y1, x2, y2;

        if (obj.pointType === 'arrow_end') {
            obj.line.set('x2', obj.get('left'));
            obj.line.set('y2', obj.get('top'));
        } else {
            obj.line.set('x1', obj.get('left'));
            obj.line.set('y1', obj.get('top'));
        }

        obj.line._setWidthHeight();

        x1 = obj.line.get('x1');
        y1 = obj.line.get('y1');
        x2 = obj.line.get('x2');
        y2 = obj.line.get('y2');

        angle = fabObj.calcArrowAngle(x1, y1, x2, y2);

        if (obj.pointType === 'arrow_end') {
            obj.arrow.set('angle', angle - 90);
        } else {
            obj.set('angle', angle - 90);
        }

        obj.line.setCoords();
        canvas.renderAll();
    }

    function moveLine() {
        var oldCenterX = (line.x1 + line.x2) / 2,
            oldCenterY = (line.y1 + line.y2) / 2,
            deltaX = line.left - oldCenterX,
            deltaY = line.top - oldCenterY;

        line.arrow.set({
            'left': line.x1 + deltaX,
            'top': line.y1 + deltaY
        }).setCoords();

        line.circle.set({
            'left': line.x2 + deltaX,
            'top': line.y2 + deltaY
        }).setCoords();

        line.set({
            'x1': line.x1 + deltaX,
            'y1': line.y1 + deltaY,
            'x2': line.x2 + deltaX,
            'y2': line.y2 + deltaY
        });

        line.set({
            'left': (line.x1 + line.x2) / 2,
            'top': (line.y1 + line.y2) / 2
        });
    }

    arrow.on('moving', function() {
        moveEnd(arrow);
    });

    circle.on('moving', function() {
        moveEnd(circle);
    });

    line.on('moving', function() {
        moveLine();
    });
}
fabObj.calcArrowAngle = function(x1, y1, x2, y2) {
    var angle = 0,
        x, y;

    x = (x2 - x1);
    y = (y2 - y1);

    if (x === 0) {
        angle = (y === 0) ? 0 : (y > 0) ? Math.PI / 2 : Math.PI * 3 / 2;
    } else if (y === 0) {
        angle = (x > 0) ? 0 : Math.PI;
    } else {
        angle = (x < 0) ? Math.atan(y / x) + Math.PI : (y < 0) ? Math.atan(y / x) + (2 * Math.PI) : Math.atan(y / x);
    }

    return (angle * 180 / Math.PI);
}