/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
let index = 0;
let objIndexArr = [], objKeysArr = [];

function tableList(){
	let tablelist = {};

	tablelist.settings = {};


	// Set the titles for the table list.
	let titles = {};
	titles.show = 0;
	titles.name = "";

	// Set the pagination for the table list.
	let pagination = {};
	pagination.show = 0;
	pagination.position = "top"; // top or bottombottom
	pagination.type = "normal"; // solr or normal
	pagination.records_per_page = 5;
	pagination.total_records = 0;
	pagination.page_no = 1;

	// Set the viewall for the table list.
	let viewall = {};
	viewall.show = 0;

	// Set the labels for the column headers
	let labels = {};
	//labels.alertid = "ID";
	//labels.assetclass = "Asset Class";

	// Set the positions for the columns headers
	let positions = {};
	/*positions.alertid = 4;
	positions.type = 2;
	positions.date = 3;
	positions.ticker = 5;
	positions.assetclass = 6;
	positions.status = 7;
	positions.score = 1;
	positions.details = 8;*/


	// Set the data transformation for the specific columns to change/show the text according to the need.
	/*let details_params = {};
	details_params.func = "detailsView(data_obj)";	

	let score_params = {};
	score_params.func = "convertScore(data_obj)";	

	let ticker_params = {};
	ticker_params.func = "replaceComma(data_obj)";	*/

	let specification = {};
	specification.header = {};
	//specification.score = score_params;
	//specification.details = details_params;
	//specification.ticker = ticker_params;

	let sorting = {};
	sorting.columns = [];
	sorting.current = [];
	
	// Set all the specifications for the table list.
	tablelist.settings.title = titles;
	tablelist.settings.pagination = pagination;
	tablelist.settings.viewall = viewall;
	tablelist.settings.sorting = sorting;
	tablelist.settings.labels = labels;
	tablelist.settings.positions = positions;
	tablelist.settings.columns_specification = specification;
	tablelist.settings.columns = 0;
	tablelist.settings.key = "";
	tablelist.settings.destination = "";
	tablelist.settings.destination_selector = "";
	tablelist.settings.url = "";
	tablelist.settings.index = 0;


	$(tablelist.settings.destination_selector+tablelist.settings.destination).css("overflow","hidden");

	tablelist.callAjax = function(obj){
		let objRef={
			type:"GET",
			url:tablelist.settings.url,
			dataType:"json",
			data: obj.data,
			ref:tablelist,
			func:"renderTableList"
		};
		cmnAsync.asynccall(objRef);
	}
	window.viewAll = function(i){
		tablelist = objIndexArr[i];
		// Set the pagination for the table list.
		tablelist.settings.pagination.records_per_page = tablelist.settings.pagination.total_records;
		tablelist.settings.pagination.page_no = 1;
		tablelist.settings.viewall.show = 0;
		$(tablelist.settings.destination_selector+tablelist.settings.destination).css("overflow","auto");
		if(tablelist.settings.pagination.type == "normal"){
			var current_column = tablelist.settings.sorting.current;
			if(current_column.length==1){
				var sorted_solumn_str = current_column[0];
				var sorted_params = sorted_solumn_str.split(",");
				window.callSort(sorted_params[0],sorted_params[1],sorted_params[2],sorted_params[3]);
			}else{
				tablelist.renderTableList(tablelist.data);
			}
		}else{
			let obj = {};
			obj.data = "";	
			tablelist.callAjax(obj);
		}
	}
	window.callPrev = function(i){
		tablelist = objIndexArr[i];
		tablelist.settings.pagination.page_no = tablelist.settings.pagination.page_no - 1;
		if(tablelist.settings.pagination.type == "normal"){
			tablelist.renderTableList(tablelist.data);
		}else{
			let obj = {};
			obj.data = "";	
			tablelist.callAjax(obj);
		}
	}
	window.callFirst = function(i){
		tablelist = objIndexArr[i];
		tablelist.settings.pagination.page_no = tablelist.settings.pagination.page_no - 1;
		if(tablelist.settings.pagination.type == "normal"){
			tablelist.renderTableList(tablelist.data);
		}else{
			let obj = {};
			obj.data = "";	
			tablelist.callAjax(obj);
		}
	}
	window.callSecond = function(i){
		tablelist = objIndexArr[i];
		tablelist.settings.pagination.page_no = tablelist.settings.pagination.page_no + 1;
		if(tablelist.settings.pagination.type == "normal"){
			tablelist.renderTableList(tablelist.data);
		}else{
			let obj = {};
			obj.data = "";	
			tablelist.callAjax(obj);
		}
	}
	window.callLast = function(i){
		tablelist = objIndexArr[i];
		var total_page = Math.ceil(tablelist.settings.pagination.total_records/tablelist.settings.pagination.records_per_page);
		tablelist.settings.pagination.page_no = total_page;
		if(tablelist.settings.pagination.type == "normal"){
			tablelist.renderTableList(tablelist.data);
		}else{
			let obj = {};
			obj.data = "";	
			tablelist.callAjax(obj);
		}
	}
	window.callNext = function(i){
		tablelist = objIndexArr[i];
		tablelist.settings.pagination.page_no = tablelist.settings.pagination.page_no + 1;
		if(tablelist.settings.pagination.type == "normal"){
			tablelist.renderTableList(tablelist.data);
		}else{
			let obj = {};
			obj.data = "";	
			tablelist.callAjax(obj);
		}
	}
	var sort_type_set = "desc";
	window.callSort = function(i,column_name,sort_type,sort_val){
		sort_type_set = sort_type;
		tablelist = objIndexArr[i];
		//console.log(i+' '+column_name+' '+sort_type+' '+sort_val);
		tablelist.settings.sorting.current[0] = i+','+column_name+','+sort_type+','+sort_val; 
		var sorted_arr = [];
		if(tablelist.settings.key!=''){
			var key_found_flag = 0;
			$.each( tablelist.data, function( key, value ) {
				if(tablelist.settings.key==key){
					key_found_flag = 1;
				}
			});
			if(key_found_flag==1){
				sorted_arr = tablelist.data[tablelist.settings.key];
			}else{
				sorted_arr = tablelist.data;
			}	
		}else{
			sorted_arr = tablelist.data;
		}		
		
		
		if(sort_val=="numeric"){
			if(sort_type=='asc'){
				sorted_arr = sorted_arr.sort(function (a, b) {
					return a[column_name] - b[column_name];
				});
			}else{
				sorted_arr = sorted_arr.sort(function (a, b) {
					return b[column_name] - a[column_name];
				});			
			}
		}else if(sort_val=="date"){
			if(sort_type=='asc'){
				sorted_arr = sorted_arr.sort(function (a, b) {
					return new Date(a[column_name]) - new Date(b[column_name]);
				});
			}else{
				sorted_arr = sorted_arr.sort(function (a, b) {
					return new Date(b[column_name]) - new Date(a[column_name]);
				});			
			}			
		}else if(sort_val=="alphabetic"){
			if(sort_type=='asc'){
				sorted_arr = sorted_arr.sort(function (a, b) {
					return a[column_name] > b[column_name];
				});
			}else{
				sorted_arr = sorted_arr.sort(function (a, b) {
					return b[column_name] > a[column_name];
				});			
			}			
		}
		var data = {};
		data[tablelist.settings.key] = sorted_arr;
		
		tablelist.renderTableList(data);				
	}

	tablelist.setAlertDataURL = function(data_obj){	
		var view_str = '';
		view_str += "../alert/index.html?alertid="+data_obj.alertid;
			//view_str += '<a href="../involvedemployees/index.html?partyid='+data_obj.partyid+'"  >'+score+'</div>';
		return view_str;
	}
	tablelist.setEmployeeDataURL = function(data_obj){
		var view_str = '';
		view_str += "../involvedemployees/index.html?partyid="+data_obj.partyid;
		return view_str;
	}
	tablelist.setEvidenceDataURL = function(data_obj){
		var view_str='';
		let qData=cmnFunc.getQueryParameters();
		var type = data_obj.type;
		type =type.trim();
		if(data_obj.type=="e-mail"){
			type =  "email";
		}else if(data_obj.type=="chat"){
			type =  "chat";
		}else if(data_obj.type=="voice"){
			type = "voice";
		}
		view_str += '../'+type+'/index.html?alertid='+qData.alertid+'&evidenceid='+data_obj.evidenceid+'&partyid='+data_obj.partyid;
		return view_str;
	}	
	
	tablelist.textTransformation = function(){
		var function_obj = {};
		var _this = this;
		function_obj.convertPhoneNoFormat = function(obj){
			var tmp = obj.phone, t = [];
			tmp =tmp.replace("(","");
			tmp =tmp.replace(")","");
			t = tmp.split("-");
			if(t.length==4){
			 return t[0]+"&nbsp;("+t[1]+")&nbsp;"+t[2]+"-"+t[3];
			}else{
				return obj.phone;
			}
		}		
		function_obj.detailsChannelIdView = function(data_obj){
				if(data_obj.channelId==1){
					return "Email";
				}else if(data_obj.channelId==2){
					return "Chat";
				}else if(data_obj.channelId==3){
					return "Voice";
				}
		}
		function_obj.detailsEvidenceView = function(data_obj,key){
			/*var type = data_obj.type;
			type = type.trim().toLowerCase();*/
			//var url_str = "";
			//var view_str = '';
			//view_str += '<a href="../../surveillance/'+type+'?evidenceid='+data_obj.evidenceid+'" class="view" >View</div>';
			var view_str='';
			let qData=cmnFunc.getQueryParameters();
			var type = data_obj.type;
			type =type.trim();
			if(data_obj.type=="e-mail"){
				type =  "email";
			}else if(data_obj.type=="chat"){
				type =  "chat";
			}else if(data_obj.type=="voice"){
				type = "voice";
			}
			if(key=='date'){
				//view_str += '<a href="../'+type+'/index.html?alertid='+qData.alertid+'&evidenceid='+data_obj.evidenceid+'&partyid='+data_obj.partyid+'" class="view" >';
				//view_str += function_obj.convertDateFormat(data_obj[key])+'</div>';
				view_str += function_obj.convertDateFormat(data_obj[key],'M d, Y');
				return view_str;
			}
			//view_str += '<a href="../'+type+'/index.html?alertid='+qData.alertid+'&evidenceid='+data_obj.evidenceid+'&partyid='+data_obj.partyid+'" class="view" >'+data_obj[key]+'</div>';
			view_str += data_obj[key];
			return view_str;
		}
		function_obj.detailsEmployeeView = function(data_obj,key){			
			var view_str = '';
			if(key == 'phone'){
				data_obj[key]=function_obj.convertPhoneNoFormat(data_obj);
			}else if(key == 'partyname'){
				data_obj[key] = function_obj.showUserImgName(data_obj);
			}
			view_str += data_obj[key];
			return view_str;
		}
		function_obj.detailsView = function(data_obj,key){	
			if(key=='date'){
				data_obj[key] = function_obj.convertDateFormat(data_obj.date,'M d, Y');
			}else if(key=='ticker'){
				data_obj[key] = function_obj.replaceComma(data_obj);
			}
			var view_str = '';
			view_str += data_obj[key];
			return view_str;
		}
		function_obj.convertDateFormat = function(date_str,format="mm/dd/yy"){
			var curr_date = new Date(date_str);
			var dd = curr_date.getDate();
			var mm = curr_date.getMonth()+1;
			var yy = curr_date.getFullYear().toString().substr(2, 2);
			var yyyy = curr_date.getFullYear().toString().substr(0, 4);
			var month = new Array();
			month[0] = "Jan";
			month[1] = "Feb";
			month[2] = "Mar";
			month[3] = "Apr";
			month[4] = "May";
			month[5] = "Jun";
			month[6] = "Jul";
			month[7] = "Aug";
			month[8] = "Sep";
			month[9] = "Oct";
			month[10] = "Nov";
			month[11] = "Dec";
			var M = month[curr_date.getMonth()];
			if(dd<10){ dd = "0"+dd; }
			if(mm<10){ mm = "0"+mm; }


			if(format=="yy-mm-dd"){
				return yy+"-"+mm+"-"+dd;		
			}else if(format=="yy-dd-mm"){
				return yy+"-"+dd+"-"+mm;		
			}else if(format=="mm-dd-yy"){
				return mm+"-"+dd+"-"+yy;		
			}else if(format=="mm-yy-dd"){
				return mm+"-"+yy+"-"+dd;		
			}else if(format=="dd-mm-yy"){
				return dd+"-"+mm+"-"+yy;		
			}else if(format=="dd-yy-mm"){
				return dd+"-"+yy+"-"+mm;		
			}else if(format=="yy/mm/dd"){
				return yy+"/"+mm+"/"+dd;		
			}else if(format=="yy/dd/mm"){
				return yy+"/"+dd+"/"+mm;		
			}else if(format=="mm/dd/yy"){
				return mm+"/"+dd+"/"+yy;		
			}else if(format=="mm/yy/dd"){
				return mm+"/"+yy+"-"+dd;		
			}else if(format=="dd/mm/yy"){
				return dd+"/"+mm+"/"+yy;		
			}else if(format=="dd/yy/mm"){
				return dd+"/"+yy+"/"+mm;		
			}else if(format=="M d, Y"){
				return M+" "+dd+", "+yyyy;		
			}

		}
		function_obj.convertScore = function(data_obj,key){			
			var score = Math.round(data_obj[key]*100)+"%";
			var view_str = '';
			if(key=='alertscore'){
				view_str += score;
			}else{
				view_str += score;
			}
			return view_str;
		}
		/*function_obj.convertAlertScore = function(data_obj){
			var score = data_obj.alertscore*100+"%";
			return score;
		}*/	
		function_obj.showUserImgName = function(data_obj){
			var user_str = "";
			/*user_str += "<div class='user_img'>";
			let img = cmnlocDetails.imgService+data_obj.partyid+".png";
			if(tablelist.doesFileExist(img)==true){
				user_str += "<img src='"+img+"' />";
			}else{
				user_str += "<img src='"+cmnlocDetails.partial_homefolder+"dist/images/User_24px.png' style='width:50;height:50;'/>";
			}
			
			user_str += "</div>";*/
			//user_str += "<div class='user_name'>";
			user_str += data_obj.partyname;
			//user_str += "</div>";
			return user_str;
		}
		function_obj.replaceComma = function(data_obj){
			var settings_key = tablelist.settings.key;
			if(settings_key=="alerts"){
				var ticker = data_obj.ticker;
				ticker=ticker.replace(/,/g,"/");
				return ticker;
			}
			return "-";
		}
		function_obj.viewAll = function(i){
			return '<a href="#" onClick="window.viewAll('+i+')">View all</div>';
		}			
		function_obj.setClassHeader = function(){
			return "row_header";
		}
		function_obj.highscore = 0.75;
		function_obj.mediumscore = 0.35;
		function_obj.lowscore = 0.35;
		function_obj.returnScoreClass = function(scr){
			var score = scr;
			if(score>=function_obj.highscore){
				return "border_red";
			}else if(score<=function_obj.highscore && score>=function_obj.mediumscore){
				return "border_yellow";
			}else if(score<function_obj.lowscore){
				return "border_green";
			}				
		}
		function_obj.returnBorderBottom = function(){
			return "border_bottom";
		}
		function_obj.setClassScore = function(data_obj){
			return "score_class "+function_obj.returnBorderBottom()+" "+function_obj.returnScoreClass(data_obj.alertscore);
		}
		function_obj.setClassScoreWithNoBorder = function(data_obj){
			return "score_class "+function_obj.returnBorderBottom();
		}
		function_obj.setClassEmployeeName = function(data_obj){
			return function_obj.returnScoreClass(data_obj.riskrating);
		}
		function_obj.setClassTicker = function(data_obj){
			return function_obj.returnBorderBottom();
		}
		function_obj.setClassDetails = function(data_obj){
			return function_obj.returnBorderBottom();
		}
		function_obj.setClassType = function(data_obj){
			return function_obj.returnBorderBottom();
		}
		function_obj.setClassDate = function(data_obj){
			return function_obj.returnBorderBottom();
		}
		function_obj.setClassAlertid = function(data_obj){
			return function_obj.returnBorderBottom();
		}
		function_obj.setClassAssetclass = function(data_obj){
			return function_obj.returnBorderBottom();
		}
		function_obj.setClassStatus = function(data_obj){
			return function_obj.returnBorderBottom();
		}
		
		return function_obj;
	}

	tablelist.renderTableTitle = function(title,wd){
		//console.log("Render title");
		var str ='';
		str += "<td width='"+wd+"' class='list_title'>";
		str += title;
		str += "</td>";				
		return  str;
	}
	tablelist.renderTablePagination = function(setting,wd){
		//console.log("Render Pagination");
		var str = '';
		str += "<td width='"+wd+"'";
		if(setting.pagination.position=="bottom"){
			setting.columns
			str += " colspan='"+setting.columns+"' class='"+tablelist.settings.key+" tbl_pagination'>";
		}else{
			str += " class='"+tablelist.settings.key+" tbl_pagination list_title'>";
		}
		
		var total_page = Math.ceil(setting.pagination.total_records/setting.pagination.records_per_page);
		
		if(total_page>1){
			if(setting.pagination.page_no>1){
				
				if(setting.pagination.page_no<total_page){
					str += "<div class='next' onClick='window.callNext("+setting.index+")' ><img src='"+cmnlocDetails.partial_homefolder+"dist/images/next.png' alst='Prev'/></div>";
					str += "<div class='last' onClick='window.callLast("+setting.index+")'>"+total_page+"</div>";
					str += "<div class='dot'>...</div>";
				}
				str += "<div class='two highlight'>"+setting.pagination.page_no+"</div>";
				str += "<div class='one' onClick='window.callFirst("+setting.index+")'>"+(setting.pagination.page_no-1)+"</div>";
				str += "<div class='prev' onClick='window.callPrev("+setting.index+")'><img src='"+cmnlocDetails.partial_homefolder+"dist/images/prev.png' alst='Prev'/></div>";
			}else if(setting.pagination.page_no<=1){
				str += "<div class='next' onClick='window.callNext("+setting.index+")'><img src='"+cmnlocDetails.partial_homefolder+"dist/images/next.png' alst='Next'/></div>";
				var total_page = Math.ceil(setting.pagination.total_records/setting.pagination.records_per_page);
				if(total_page>2){
					str += "<div class='last' onClick='window.callLast("+setting.index+")'>"+total_page+"</div>";
					str += "<div class='dot'>...</div>";
				}
				str += "<div class='two' onClick='window.callSecond("+setting.index+")'>"+(setting.pagination.page_no+1)+"</div>";
				if(setting.pagination.page_no==1){
					str += "<div class='one highlight'>1</div>";
				}else{
					str += "<div class='one' onClick='window.callFirst("+setting.index+")'>"+setting.pagination.page_no+"</div>";
				}			
			}
		}	
		str += "</td>";									
		return str;
	}
	tablelist.doesFileExist=function(urlToFile)
	{
		var xhr = new XMLHttpRequest();
		xhr.open('HEAD', urlToFile, false);
		xhr.send();

		if (xhr.status == "404") {
			return false;
		} else {
			return true;
		}
	}
	tablelist.callFunction=function(fnName,data_obj){
		//console.log(fnName);
		switch (fnName){ 
			case "setAlertDataURL(data_obj)":
				return tablelist.setAlertDataURL(data_obj);
				break;
			case "setEmployeeDataURL(data_obj)":
				return tablelist.setEmployeeDataURL(data_obj);
				break;
			case "setEvidenceDataURL(data_obj)":
				return tablelist.setEvidenceDataURL(data_obj);
				break;
			case "setClassScore(data_obj)":
				return tablelist.textTransformation().setClassScore(data_obj);
				break;
			case "setClassTicker(data_obj)":
				return tablelist.textTransformation().setClassTicker(data_obj);
				break;
			case "setClassDate(data_obj)":
				return tablelist.textTransformation().setClassDate(data_obj)
				break;
			case "setClassAlertid(data_obj)":
				return tablelist.textTransformation().setClassAlertid(data_obj)
				break;
			case "setClassAssetclass(data_obj)":
				return tablelist.textTransformation().setClassAssetclass(data_obj)
				break;
			case "setClassStatus(data_obj)":	
				return tablelist.textTransformation().setClassStatus(data_obj)				
				break
			case "setClassEmployeeName(data_obj)":
				return tablelist.textTransformation().setClassEmployeeName(data_obj);
				break;
			case "setClassScoreWithNoBorder(data_obj)":
				return tablelist.textTransformation().setClassScoreWithNoBorder(data_obj);				
				break;				
			case "setClassDetails(data_obj)":
				return tablelist.textTransformation().setClassDetails(data_obj);
				break;				
			case "convertScore(data_obj,'alertscore')":
				return tablelist.textTransformation().convertScore(data_obj,'alertscore');
				break;
			case "detailsView(data_obj,'type')":
				return tablelist.textTransformation().detailsView(data_obj,'type');
				break;
			case "detailsView(data_obj,'date')":
				return tablelist.textTransformation().detailsView(data_obj,'date');
				break;
			case "detailsView(data_obj,'alertid')":
				return tablelist.textTransformation().detailsView(data_obj,'alertid');
				break;
			case "detailsView(data_obj,'ticker')":
				return tablelist.textTransformation().detailsView(data_obj,'ticker');
				break;
			case "detailsView(data_obj,'assetclass')":
				return tablelist.textTransformation().detailsView(data_obj,'assetclass');
				break;
			case "detailsView(data_obj,'status')":
				return tablelist.textTransformation().detailsView(data_obj,'status');
				break;				
			case "detailsEmployeeView(data_obj)":
				return tablelist.textTransformation().detailsEmployeeView(data_obj);	
				break;
			case "convertScore(data_obj,'riskrating')":
				return tablelist.textTransformation().convertScore(data_obj,'riskrating');				
				break;
			case "detailsEmployeeView(data_obj,'partyname')":		
				return tablelist.textTransformation().detailsEmployeeView(data_obj,'partyname');		
				break;
			case "detailsEmployeeView(data_obj,'phone')":
				return tablelist.textTransformation().detailsEmployeeView(data_obj,'phone');							
				break;
			case "detailsEmployeeView(data_obj,'pastviolations')":
				return tablelist.textTransformation().detailsEmployeeView(data_obj,'pastviolations');
				break;
			case "detailsEmployeeView(data_obj,'email')":
				return tablelist.textTransformation().detailsEmployeeView(data_obj,'email');
				break;
			case "detailsEmployeeView(data_obj,'location')":
				return tablelist.textTransformation().detailsEmployeeView(data_obj,'location');
				break;
			case "detailsEmployeeView(data_obj,'activealerts')":
				return tablelist.textTransformation().detailsEmployeeView(data_obj,'activealerts');
				break;
			case "detailsEmployeeView(data_obj,'role')":
				return tablelist.textTransformation().detailsEmployeeView(data_obj,'role');
				break;
			case "detailsEvidenceView(data_obj,'type')":
				return tablelist.textTransformation().detailsEvidenceView(data_obj,'type');
				break;	
			case "detailsEvidenceView(data_obj,'description')":
				return tablelist.textTransformation().detailsEvidenceView(data_obj,'description');
				break;
			case "detailsEvidenceView(data_obj,'date')":
				return tablelist.textTransformation().detailsEvidenceView(data_obj,'date');
				break;	
			case "convertScore(data_obj,'alertscore')":	
				return tablelist.textTransformation().convertScore(data_obj,'alertscore');	
				break;
			case "detailsView(data_obj,'type')":
				return tablelist.textTransformation().detailsView(data_obj,'type');	
				break;
			case "detailsView(data_obj,'date')":
				return tablelist.textTransformation().detailsView(data_obj,'date');
				break;
			case "detailsView(data_obj,'alertid')":
				return tablelist.textTransformation().detailsView(data_obj,'alertid');	
				break;
			case "detailsView(data_obj,'status')":	
				return tablelist.textTransformation().detailsView(data_obj,'status');
				break;	
					
		}
	}
	tablelist.renderTableList = function(o){
		//console.log("Render Table List");
		var obj = o;
		var settings_key = tablelist.settings.key;
		if(settings_key!=''){
			$.each( obj, function( key, value ) {
				if(key==settings_key){
					obj = o[settings_key];
				}else{
					
					$.each( obj[key], function( k1, v1 ) {	
						if(settings_key==k1){
							obj = v1;
						}
					});
				}
			});			
		}else{
			obj = o;
		}

		tablelist.data = o;
		
		////console.log("INDEX: "+tablelist.settings.index);
		tablelist.settings.pagination.total_records =  obj.length;
		if(tablelist.settings.pagination.total_records==0){
			
			var table_html = "<table width='100%' style='margin-top:2%;'>";		
			table_html += "<tr><td class='no_data'>No Data</td></tr>";
			table_html += "</table>";		
			$(tablelist.settings.destination_selector+tablelist.settings.destination).html(table_html);
			return true;
		}
		var label_positions = [];
		var label_str = '';
		var data_obj_count = 0;
		//console.log(tablelist.settings.columns);
		for(var i=0;i<tablelist.settings.columns;i++){
			label_positions[i] = '';
		}
		

		var table_html = "<table width='100%'>";		
		// Title 
		//console.log("Title");
		if(tablelist.settings.title.show == 1 || tablelist.settings.pagination.show == 1){
			table_html += "<tr>";
				table_html += "<td colspan='"+tablelist.settings.columns+"'>";
				table_html += "<table width='100%'>";
					table_html += "<tr>";
						var width = '';
						// Title Show and Pagination Top -- Show
						if(tablelist.settings.title.show == 1 && tablelist.settings.pagination.show == 1 && tablelist.settings.pagination.position == "top"){
							width = "50%";
							table_html += this.renderTableTitle(tablelist.settings.title.name,width);
							table_html += this.renderTablePagination(this.settings,width);
						}
						// Title Show and Pagination Bottom  -- Hide
						if(tablelist.settings.title.show == 1 && (tablelist.settings.pagination.position == "bottom" || tablelist.settings.pagination.show == 0)){
							width = "100%";
							table_html += this.renderTableTitle(tablelist.settings.title.name,width);	
						}
						// Title Hide and Pagination Top -- Show
						if(tablelist.settings.title.show == 0 && tablelist.settings.pagination.show == 1 && tablelist.settings.pagination.position == "top"){
							width = "100%";
							table_html += this.renderTablePagination(this.settings,width);
						}
						// Title Hide and Pagination Bottom -- Hide
						// Do Nothing
					table_html += "</tr>";
				table_html += "</table>";
				table_html += "</td>";
			table_html += "</tr>";
		}
		////console.log('------------------------------------');
		////console.log(obj);
		// Header Row
		$.each( obj[0], function( key, value ) {
			$.each( tablelist.settings.positions, function( k1, v1 ) {
				if(key==k1){
					label_positions[v1-1] = key;
					data_obj_count++;
				}
			});
		});
		
		////console.log('------------------------------------');
		table_html += "<tr>";
		for(var i=0;i<label_positions.length;i++){
			label_str = '';
			$.each( tablelist.settings.labels, function( k1, v1 ) {
				if(label_positions[i]==k1){
					label_str = v1;
				}
			});
			if(label_positions[i]!=''){
				if(label_str!=''){ 					
					var sort_obj = tablelist.settings.sorting;
					var sort_flag = 0;
					var sort_val = '';
					for(var s=0;s<sort_obj.length;s++){
						$.each( sort_obj[s], function( k1, v1 ) {
							if(k1==label_positions[i]){
								sort_val = v1;
								sort_flag = 1;
							}
						});
					}
					var set_extra_class = label_str.toLowerCase();
					set_extra_class = set_extra_class.replace(" ","_");
					table_html += "<td class='header_title "+set_extra_class+"'>";
					if(sort_flag==1){
						//console.log("Sorting If");
						var asc = 'asc';
						var desc = 'desc';
						table_html += "<table width='100%'>";
							table_html += "<tr>";
								table_html += "<td class='header_sort_title "+set_extra_class+"'>";
								table_html += label_str;
								table_html += "</td>";
								table_html += "<td style='vertical-align:middle;'>";
									table_html += "<table width='100%'>";
										table_html += "<tr>";
											table_html += "<td height='10px;'>";
											if(sort_type_set=="asc"){
											table_html += '<img class="sort_asc" onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+asc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_asc_active.png?" + Math.random()+' />';
											}else{
												table_html += '<img class="sort_asc" onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+asc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_asc_inactive.png?" + Math.random()+' />';								
											}
											table_html += "</td>";
										table_html += "</tr>";
										table_html += "<tr>";
											table_html += "<td>";
											if(sort_type_set=="desc"){
											table_html += '<img class="sort_desc"  onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+desc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_desc_active.png?" + Math.random()+' />';
											}else{
											table_html += '<img class="sort_desc"  onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+desc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_desc_inactive.png?" + Math.random()+' />';
												
											}
											table_html += "</td>";
										table_html += "</tr>";
									table_html += "</table>";
								table_html += "</td>";
							table_html += "</tr>";
						table_html += "</table>";
					}else{
						table_html += label_str;
					}
					table_html += "</td>";
				}else{
					var set_extra_class = label_positions[i].toLowerCase();
					set_extra_class = set_extra_class.replace(" ","_");
					var sort_obj = tablelist.settings.sorting;
					//console.log("Sorting Else");
					var sort_flag = 0;
					var sort_val = '';
					for(var s=0;s<sort_obj.length;s++){
						$.each( sort_obj[s], function( k1, v1 ) {
							if(k1==label_positions[i]){
								sort_val = v1;
								sort_flag = 1;
							}
						});
					}
					
					table_html += "<td class='header_title "+set_extra_class+"'>";
					if(sort_flag==1){
						var asc = 'asc';
						var desc = 'desc';
						//table_html += '&nbsp;&nbsp;<a href="#" onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+asc+'\',\''+sort_val+'\')"><img src="../surveillance/dist/images/sort_asc.png" /></div>';
						//table_html += '&nbsp;&nbsp;<a href="#" onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+desc+'\',\''+sort_val+'\')"><img src="../surveillance/dist/images/sort_desc.png" /></div>';						
						table_html += "<table width='100%'>";
							table_html += "<tr>";
								table_html += "<td  class='header_sort_title "+set_extra_class+"'>";
								table_html += label_positions[i];
								table_html += "</td>";
								table_html += "<td style='vertical-align:middle;'>";
									table_html += "<table width='100%'>";
										table_html += "<tr>";
											table_html += "<td height='10px;'>";
											if(sort_type_set=="asc"){
											table_html += '<img  class="sort_asc" onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+asc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_asc_active.png?" + Math.random()+' />';
											}else{
											table_html += '<img  class="sort_asc" onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+asc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_asc_inactive.png?" + Math.random()+' />';	
											}
											table_html += "</td>";
										table_html += "</tr>";
										table_html += "<tr>";
											table_html += "<td>";
											if(sort_type_set=="desc"){
												table_html += '<img  class="sort_desc"  onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+desc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_desc_active.png?" + Math.random()+' />';
											}else{
												table_html += '<img  class="sort_desc"  onClick="window.callSort(\''+tablelist.settings.index+'\',\''+label_positions[i]+'\',\''+desc+'\',\''+sort_val+'\')" src='+cmnlocDetails.partial_homefolder+"dist/images/tbl_sort_desc_inactive.png?" + Math.random()+' />';
											}											
											table_html += "</td>";
										table_html += "</tr>";
									table_html += "</table>";
								table_html += "</td>";
							table_html += "</tr>";
						table_html += "</table>";
					}else{
						table_html += label_positions[i];
					}
					table_html += "</td>";
				}
			}
		}
		
		for(var k=data_obj_count+1; k<=tablelist.settings.columns; k++){
			$.each( tablelist.settings.positions, function( k1, v1 ) {
				if(v1==k){
					var set_extra_class = k1.toLowerCase();
					set_extra_class =set_extra_class.replace(" ","_");
					table_html += "<td class='header_title "+set_extra_class+"'>"+k1+"</td>";
				}
			});				
		}			
		table_html += "</tr>";

		//console.log("Data rows");	
		// Data Rows	
		var rows_count = 0;
		var end_record_no = (tablelist.settings.pagination.page_no * tablelist.settings.pagination.records_per_page);
		var begin_record_no = end_record_no - tablelist.settings.pagination.records_per_page;
		if(end_record_no>=tablelist.settings.pagination.total_records){
			end_record_no = tablelist.settings.pagination.total_records;
		}
		//console.log(label_positions);
		for(var i=begin_record_no;i<end_record_no;i++){
			table_html += "<tr class='rows'>";		
			for(var j=0;j<label_positions.length;j++){
				
				if(label_positions[j]!=''){
					$.each( obj[i], function( key, value ) {
							if(key==label_positions[j]){
								var func_found_flag=0, classname_found_flag=0, urllink_flag=0;
								$.each( tablelist.settings.columns_specification, function( k2, v2 ) {
									if(key==k2){
										var data_obj = obj[i];
										table_html += "<td ";
										//console.log(tablelist.textTransformation());
										
										if(v2.hasOwnProperty("classname")){
											classname_found_flag=1;
											//console.log(v2.classname);
											table_html += "class='"+key+" "+tablelist.callFunction(v2.classname,obj[i])+"'";
										}else{
											if(classname_found_flag==0){
												table_html += "class='"+key+"'";
											}
										}
										if(v2.hasOwnProperty("urllink")){
											urllink_flag=1;
											table_html += " data-url='"+tablelist.callFunction(v2.urllink,obj[i])+"'";
										}
										table_html += ">";
										if(v2.hasOwnProperty("func")){
											func_found_flag=1;
											table_html += tablelist.callFunction(v2.func,obj[i]);
										}else{
											table_html += value;
										}
										table_html += "</td>";
										
									}
								});			
								if(func_found_flag==0 && classname_found_flag==0){				
									table_html += "<td>"+value+"</td>";
								}
							}
					});
				}
			}
			for(var k=data_obj_count+1; k<=tablelist.settings.columns; k++){
				$.each( tablelist.settings.positions, function( k1, v1 ) {
					$.each( tablelist.settings.columns_specification, function( k2, v2 ) {
						if(v1==k && k1==k2){
							var data_obj = obj[i];
							//console.log(v2.func);
							//console.log(tablelist.callFunction(v2.func,obj[i]));
							table_html += "<td class='"+tablelist.callFunction(v2.classname,obj[i])+"'>"+tablelist.callFunction(v2.func,obj[i])+"</td>";
						}
					});
				});				
			}			
			table_html += "</tr>";
			rows_count++;
			if(tablelist.settings.pagination.records_per_page==rows_count){
				break;
			}
		}
		
		if(tablelist.settings.pagination.show == 1 && tablelist.settings.pagination.position == "bottom"){
			table_html += "<tr>";
			var width = '100%';
			table_html += this.renderTablePagination(this.settings,width);
			table_html += "</tr>";
		}else if(tablelist.settings.viewall.show == 1 && tablelist.settings.pagination.total_records>=tablelist.settings.pagination.records_per_page){
			table_html += "<tr>";
			table_html += "<td width='100%' colspan='"+tablelist.settings.columns+"' class='view_all'>";
			table_html += "<br/>"+tablelist.textTransformation().viewAll(tablelist.settings.index);
			table_html += "</td>";
			table_html += "</tr>";
		}
		table_html += "</table>";
		
		$(tablelist.settings.destination_selector+tablelist.settings.destination).html(table_html);
		$( "tr.rows td" ).on( "click", function() {
		  window.location = $( this ).attr("data-url");
		});
		
	}	
	tablelist.setIndex = function(){
		
		//console.log("Indexing");
		var found_flag = 0;
		var current_key_index = 0;
		for(var i=0;i<objKeysArr.length;i++){
			if(objKeysArr[i]==tablelist.settings.key){
				found_flag = 1;
				current_key_index = i;
			}
		}
		if(found_flag==0){
			objKeysArr.push(tablelist.settings.key);
			tablelist.settings.index = index;
			objIndexArr[index] = tablelist;
			index = index + 1;
		}else{
			tablelist.settings.index = current_key_index;
			objIndexArr[current_key_index] = tablelist;
		}
	}
	return tablelist;
}

