/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const mrktRply={
    priceChart:{"prcRef":{}},
    volumeChart:{"volRef":{}},
    dataRef:{response:[],slResponse:[],rResponse:[],fullDt:[],intrvlHldr:0},
    slider:{slide:{}},
    animControl:{}
};
let url="/surveillance/";

mrktRply.initObj=function(){
    $("#mkt-grpahRrcVol").empty();
    $("#mkt-prcVolLgnd").empty();
    $("#mkt-slider").empty(); 
    
    mrktRply.priceChart.initObj();
    mrktRply.volumeChart.initObj();
    mrktRply.sliderFunc();
    mrktRply.animControl.initObj();
}
 mrktRply.animControl.initObj=function(){
       mrktRply.animControl.registerHndlr();
 }
 mrktRply.animControl.registerHndlr=function(){
     let ids=["mkt-ctrlPause","mkt-ctrlPly","mkt-ctrlSpd","mkt-ctrlrply"];
     $.each(ids,function(index,node){
         $("#"+node).on("click",function(evt){
             evt.stopPropagation();
             switch(evt.target.id){
                 case "mkt-ctrlPause" :mrktRply.animControl.pause();
                                            break;
                 case "mkt-ctrlPly" : mrktRply.animControl.play();
                                            break;
                 case "mkt-ctrlSpd" :   
                                            break;
                 case "mkt-ctrlrply":  
                                        mrktRply.animControl.reply();
                                      
                                        break;
                 
             }
         });
     });
     
 }
 mrktRply.animControl.play=function(){
     $("#mkt-ctrlPause").parent().removeClass("hide");
     $("#mkt-ctrlPly").parent().addClass("hide");
      mrktRply.priceChart.intervalUpdate();
 }
 mrktRply.animControl.pause=function(){
     $("#mkt-ctrlPause").parent().addClass("hide");
     $("#mkt-ctrlPly").parent().removeClass("hide");
      clearInterval(mrktRply.dataRef.intrvlHldr);
 }
 mrktRply.animControl.reply=function(){
     $("#mkt-grpahRrcVol").empty();
    $("#mkt-prcVolLgnd").empty();
    $("#mkt-slider").empty(); 
  
    mrktRply.priceChart.initObj();
    mrktRply.volumeChart.initObj();
       mrktRply.sliderFunc();
 }
 mrktRply.animControl.speedCtrl=function(){
     
 }
mrktRply.sliderFunc=function(){
let obj=mrktRply.priceChart.prcRef;
let slObj={
            xAxis:d3.scaleLinear().range([mrktRply.priceChart.prcRef.m.l, mrktRply.priceChart.prcRef.mw-10]).clamp(true),
            create:function(){
                 let node=d3.select("#mkt-slider");
                  let nodeIrElem=node.append("div").attr("class", "mkt-sld-line");
                  let nodeCrElem=node.append("div").attr("class", "mkt-sld-path");
                  slObj.nodeRelem=nodeCrElem.append("div").attr("class", "mkt-sld-circle");
                  slObj.nodeRelem.append("span").attr("id","dateReferer");
                 /* let node=d3.select("#mkt-slider").append("svg").attr("width",obj.w)
         .attr("class","slidelyChrt")
          .attr("height",obj.h)
          .attr('viewBox', '0 0 ' + obj.mw + ' ' + obj.mh)
          .attr('preserveAspectRatio', 'xMinYMin');
     //lcobj.svg=lcobj.svgRef.append("g");
    obj.Slsvg=obj.svg.append('g').attr("transform", "translate("+(0)+","+ (0) + ")").attr("class","prcChartLyout").attr("width",obj.mw-obj.m.l-obj.m.r);*/
                  
                return node;
            },
            animate:function(value){
                slObj.nodeRelem.style("left",parseInt(mrktRply.slider.slide.xAxis(mrktRply.priceChart.prcRef.parser(value.date) ))+"px");
                                      /*(parseInt(mrktRply.priceChart.prcRef.xScale(mrktRply.priceChart.prcRef.parser(value.date)))-parseInt(10)) + "px");
                 d3.select("#dateReferer").html(value.date);*/
            },
            initFunc:function(value){
                mrktRply.slider.slide.xAxis.domain(d3.extent(mrktRply.dataRef.response, function(d) { 
                                                return mrktRply.priceChart.prcRef.parser(d.date); 
                }));
                if($.isArray(value)){
                  d3.select("#dateReferer").html(value[0].date);  
                }else{
                    mrktRply.slider.slide.animate(value);
                    d3.select("#dateReferer").html(value.date);  
                }
                
                
            }
            
           
} 
slObj.create();
     
mrktRply.slider.slide=slObj;
return slObj;
/*
var dispatch = d3.dispatch("sliderChange");
slider.call(d3.drag()
    .on("start", function() {
      dispatch.call("sliderChange",this,x.invert(d3.mouse(sliderTray.node())[0]));
      d3.event.sourceEvent.preventDefault();
    })
    .on("drag", function() {
      dispatch.call("sliderChange",this,x.invert(d3.mouse(sliderTray.node())[0]));
      d3.event.sourceEvent.preventDefault();
    }));

dispatch.on("sliderChange.slider", function(value) {
  sliderHandle.style("left", x(value) + "px")
});*/


}
/**Volume chart **/
mrktRply.volumeChart.initObj=function(){
    let self=mrktRply.volumeChart.volRef;
      self={
          w:$("#mkt-prcVol").width(),
          h:150,
          id:"mkt-grpahRrcVol",
          m:{
              t:10,
              b:10,
              r:10,
              l:50
          }               
      }
        self.nodeRef=d3.select("#"+self.id);
        self.mw=(self.w)-(self.m.l)-(self.m.r);
        self.mh=(self.h)-(self.m.t)-(self.m.b);
        self.xScale=d3.scaleLinear().range([self.m.l, self.mw-10]);
        self.yScale=d3.scaleLinear().range([self.mh, self.m.b]);       
         self.svg=self.nodeRef.append("svg").attr("width",self.w)
         .attr("class","volChrtLyout")
          .attr("height",self.h)
          .attr('viewBox', '0 0 ' + self.mw + ' ' + self.mh)
          .attr('preserveAspectRatio', 'xMinYMin');
        self.vsvg=self.svg.append('g').attr("transform", "translate("+(0)+","+ (0) + ")").attr("class","volChrtGelem");
        self.parser = function(d){
             let newDt=new Date();
             let newT=d.split(":");
             return new Date(newDt.getFullYear(),newDt.getMonth(),newDt.getDay(),newT[0],newT[1],newT[2]);
         }
       /* self.xScale.domain(d3.extent(self.data, function(d) { 
                                                return self.parser(d.date); 
        }));
        self.yScale.domain([0, d3.max(self.data, function(d) { 
            return Math.max(d.Volume); 
        })]);*/
      mrktRply.volumeChart.volRef=self;
                            
}
mrktRply.volumeChart.initData=function(data){
       mrktRply.volumeChart.volRef.data=data;
       d3.select(".volChrtGelem").selectAll("*").remove(); 
       mrktRply.volumeChart.axisGen();
       mrktRply.volumeChart.barGen();
    
}
mrktRply.volumeChart.axisGen=function(){
      let self=mrktRply.volumeChart.volRef; 
      self.xScale.domain(d3.extent(mrktRply.dataRef.response, function(d) { 
                                                return self.parser(d.date); 
        }));
        self.yScale.domain([0, d3.max(mrktRply.dataRef.response, function(d) { 
            return Math.max(d.Volume); 
        })]);
     
        
    
    let lgndTxt=self.vsvg.append('g').attr("transform", "translate("+(self.m.l-30)+","+ (self.h/2) + ")");
           lgndTxt.append('text')
              .attr("class", "lgndYaxisTxt")
              .attr("transform", "rotate(-90)")
              .text("Volume");

        self.vsvg.append("g").attr("class", "x axis")
                .attr("transform", "translate(0,"+ (self.mh) + ")")
                .call(d3.axisBottom(self.xScale));

           self.vsvg.append("g")
                .attr("class", "y axis")
                .attr("transform", "translate(" + (self.m.l) + ",0)")
                .call(d3.axisLeft(self.yScale));
     self.ygridlines=function(){
           return d3.axisLeft(self.yScale)
        .ticks(5)
       }
       self.vsvg.append("g")			
      .attr("class", "grid")
      .attr("transform", "translate("+self.m.l+", 0 )")
      .call(self.ygridlines()
          .tickSize(-self.mw)
          .tickFormat("")
      )
      
    mrktRply.volumeChart.volRef=self;
}
mrktRply.volumeChart.barGen=function(){
     let self=mrktRply.volumeChart.volRef; 
      self.rectCont=self.vsvg.append("g")
           .attr("transform", "translate(" + 0 + ",0)")
          .attr("class","rectBar");
   self.rectCont.selectAll('rect').data(self.data).enter().append("rect")
              .attr("x", function(d, i) {
                 return self.xScale(self.parser(d.date));
              })
              .attr("y", function(d) {                  
                            return self.mh - self.yScale(d.Volume);                     
              }).attr("fill","#946697").attr("width",20).attr("height",function(d){
        return self.yScale(d.Volume); 
    });
   
}
/**Volume chart **/
/**Price Chart***/
mrktRply.priceChart.initObj=function(){
      let lcobj={
          w:$("#mkt-prcVol").width(),
          h:150,
          id:"mkt-grpahRrcVol",
          m:{
              t:10,
              b:20,
              r:10,
              l:50
          }               
      }
        lcobj.nodeRef=d3.select("#"+lcobj.id);
        lcobj.mw=(lcobj.w)-(lcobj.m.l)-(lcobj.m.r);
        lcobj.mh=(lcobj.h)-(lcobj.m.t)-(lcobj.m.b);
        lcobj.xScale=d3.scaleLinear().range([lcobj.m.l, lcobj.mw-10]);
        lcobj.yScale=d3.scaleLinear().range([lcobj.mh, lcobj.m.b]);
        lcobj.svg=lcobj.nodeRef.append("svg").attr("width",lcobj.w)
         .attr("class","pricelyChrt")
          .attr("height",lcobj.h)
          .attr('viewBox', '0 0 ' + lcobj.mw + ' ' + lcobj.mh)
          .attr('preserveAspectRatio', 'xMinYMin');
     //lcobj.svg=lcobj.svgRef.append("g");
      lcobj.psvg=lcobj.svg.append('g').attr("transform", "translate("+(0)+","+ (0) + ")").attr("class","prcChartLyout").attr("width",lcobj.mw-lcobj.m.l-lcobj.m.r);
     mrktRply.priceChart.prcRef=lcobj;
      mrktRply.priceChart.priceChartDtGen(lcobj);
                            
}
mrktRply.priceChart.priceChartDtGen=function(lcobj){
     lcobj.parser = function(d){
         let newDt=new Date();
         let newT=d.split(":");
         return new Date(newDt.getFullYear(),newDt.getMonth(),newDt.getDay(),newT[0],newT[1],newT[2]);
     }
    d3.csv(url+"json/data.csv",null,function(response){        
       mrktRply.dataRef.fullDt=jQuery.extend(true, [], response);
        mrktRply.dataRef.response=response.slice(0,15);
        mrktRply.dataRef.rResponse=response.splice(0,1);
        mrktRply.dataRef.slResponse=response.splice(0,14);
        mrktRply.volumeChart.initData(mrktRply.dataRef.rResponse);       
        mrktRply.priceChart.updateprcChart(lcobj);
        mrktRply.slider.slide.initFunc(mrktRply.dataRef.rResponse);
       //mrktRply.priceChart.intervalUpdate(lcobj);
        mrktRply.priceChart.legendGen(lcobj);
        mrktRply.dt=15;
        
    });
}
mrktRply.priceChart.intervalUpdate=function(intrVlRef){
     if(!intrVlRef){
         intrVlRef=3000;
     }
   let Intervl=setInterval(function(){            
            let res=0,resBid=0,resTrd=0,resultdt;    
               if(mrktRply.dataRef.fullDt.length==mrktRply.dt){
                      clearInterval(Intervl);
                   return;
                  }
               if(mrktRply.dataRef.slResponse.length==1){
                   let resultDt=mrktRply.dataRef.fullDt.slice(mrktRply.dt,mrktRply.dt+1);
                  mrktRply.dataRef.response.push(resultDt[0]);
                  mrktRply.dataRef.slResponse.push(resultDt[0]);
                  mrktRply.dataRef.response.splice(0,1);
                  mrktRply.dataRef.rResponse.splice(0,1);
                  
                    mrktRply.dt++; 
               }
      
                for(let i=0;i<1;i++){
                    if(((mrktRply.dataRef.slResponse)%2)==0){
                        res=9;
                        resBid=-5;
                        resTrd=-15;
                    }else{
                        res=-4;
                        resBid=10;
                        resTrd=25;
                    }
                    mrktRply.dataRef.rResponse.push({
                        "date":mrktRply.dataRef.slResponse[i]["date"],
                        "askPrice":parseInt(mrktRply.dataRef.slResponse[i]["askPrice"])+res,
                        "bidPrice":parseInt(mrktRply.dataRef.slResponse[i]["bidPrice"])+resBid,
                        "tradePrice":parseInt(mrktRply.dataRef.slResponse[i]["tradePrice"])+resTrd,
                        "Volume":parseInt(mrktRply.dataRef.slResponse[i]["Volume"])+resTrd
                    });
                    resultdt=mrktRply.dataRef.slResponse[i];
                    mrktRply.dataRef.slResponse.splice(0,1);
                }
                
                 mrktRply.volumeChart.initData(mrktRply.dataRef.rResponse);
                  mrktRply.slider.slide.initFunc(resultdt);
                 mrktRply.priceChart.updateprcChart(); 
                 
                 
    },intrVlRef)
   
   mrktRply.dataRef.intrvlHldr=Intervl;

}
mrktRply.priceChart.updatePriceChrtDomain=function(lcobj){
    d3.select(".prcChartLyout").selectAll("*").remove(); 
       lcobj.xScale.domain(d3.extent(mrktRply.dataRef.response, function(d) { 
                                               
                                                return lcobj.parser(d.date); 
        }));
        lcobj.yScale.domain([0, d3.max(mrktRply.dataRef.response, function(d) { 
            return Math.max(d.askPrice, d.bidPrice,d.tradePrice); 
        })]);
    
   lcobj.data=mrktRply.dataRef.rResponse;
    let lgndTxt=lcobj.psvg.append('g').attr("transform", "translate("+(lcobj.m.l-30)+","+ (lcobj.h/2) + ")");
           lgndTxt.append('text')
              .attr("class", "lgndYaxisTxt")
              .attr("transform", "rotate(-90)")
              .text("Price");

        lcobj.psvg.append("g").attr("class", "x axis")
                .attr("transform", "translate(0,"+ (lcobj.mh) + ")")
                .call(d3.axisBottom(lcobj.xScale));

           lcobj.psvg.append("g")
                .attr("class", "y axis")
                .attr("transform", "translate(" + (lcobj.m.l) + ",0)")
                .call(d3.axisLeft(lcobj.yScale));
    lcobj.ygridlines=function(){
           return d3.axisLeft(lcobj.yScale)
        .ticks(5)
       }
     lcobj.psvg.append("g")			
      .attr("class", "grid")
      .attr("transform", "translate("+lcobj.m.l+", 0 )")
      .call(lcobj.ygridlines()
          .tickSize(-lcobj.mw)
          .tickFormat("")
      )
     mrktRply.priceChart.prcRef=lcobj;
}
mrktRply.priceChart.legendGen=function(lcobj){
   
     lcobj.lgdData=[{
        name:"BidPrice",
        color:"#4987B4"
    
    },{
        name:"Ask Price",
        color:"#F2BA2A"
    },{
        name:"Trade Price",
        color:"#00ADA7"
    },{
        name:"NBBO",
        color:"#FF8331"
    }];
   let lgndSvg=d3.select("#mkt-prcVolLgnd").append("svg")
                .attr("width",lcobj.w)
                .attr("class","prcLgnd")
                .attr("height",30)
                .attr('viewBox', '0 0 ' + lcobj.mw + ' ' + 30)
                .attr('preserveAspectRatio', 'xMinYMin');
   let lgndG= lgndSvg.append("g").attr("transform","translate(0,"+0+")").selectAll('g').data(lcobj.lgdData).enter().append('g');
    lgndG.attr("transform", function(d, i) {
                  return "translate(" + i * (lcobj.mw / lcobj.lgdData.length) + "," + 0 + ")";
              });

    lgndG.append('rect').attr('width', 20).attr('height', 20).style('fill', function(d) {
                  if (d.color) {
                      return d.color;
                  }
              })
              .style('stroke', function(d) {
                  if (d.color) {
                      return d.color;
                  }});
     lgndG.append('text')
              .attr("class", "lgndTxt")
              .attr('x', 20+10)
              .attr('y', 15)
              .text(function(d) {
                  return d.name;
              });
     mrktRply.priceChart.prcRef=lcobj;
}
mrktRply.priceChart.pathGen=function(lcobj){
    lcobj.psvg.path= lcobj.psvg.append('g').attr("transform", "translate("+(0)+","+ (0) + ")");
                    lcobj.psvg.path.append('path')
                        .attr("class","askp")
                        .attr('d', lcobj.askGen(lcobj.data))
                        .attr('stroke', '#F2BA2A')
                        .attr('stroke-width', 2)
                        .attr('fill', 'none');
                    lcobj.psvg.path.append('path')
                        .attr("class","bidP")
                        .attr('d', lcobj.bidGen(lcobj.data))
                        .attr('stroke', '#4987B4')
                        .attr('stroke-width', 2)
                        .attr('fill', 'none');
                     lcobj.psvg.path.append('path')
                        .attr("class","tradeP")
                        .attr('d', lcobj.tradeGen(lcobj.data))
                        .attr('stroke', '#00ADA7')
                        .attr('stroke-width', 2)
                        .attr('fill', 'none');
     mrktRply.priceChart.prcRef=lcobj;
}
mrktRply.priceChart.lineDtGen=function(lcobj){
                lcobj.askGen = d3.line()
                        .x(function(d) {
                            return lcobj.xScale(lcobj.parser(d.date));
                        })
                        .y(function(d) {
                            return lcobj.yScale(d.askPrice);
                        })
                        .curve(d3.curveLinear);
                      lcobj.bidGen = d3.line()
                        .x(function(d) {
                            return lcobj.xScale(lcobj.parser(d.date));
                        })
                        .y(function(d) {
                            return lcobj.yScale(d.bidPrice);
                        })
                        .curve(d3.curveLinear);
                     lcobj.tradeGen = d3.line()
                        .x(function(d) {
                            return lcobj.xScale(lcobj.parser(d.date));
                        })
                        .y(function(d) {
                            return lcobj.yScale(d.tradePrice);
                        })
                        .curve(d3.curveLinear);
     mrktRply.priceChart.prcRef=lcobj;
}
mrktRply.priceChart.linePointsGen=function(lcobj){
            lcobj.psvg.path.selectAll('.askDot')
            .data(lcobj.data)
            .enter().append('circle')
            .attr('class', 'askDot')
            .attr('stroke', '#F2BA2A')
            .attr('fill', '#F2BA2A')
            .attr('r', 4)
            .attr('cx',function(d){
                return lcobj.xScale(lcobj.parser(d.date))
            })
            .attr('cy',function(d){
                return lcobj.yScale(d.askPrice)
            });
           lcobj.psvg.path.selectAll('.bidDot')
          .data(lcobj.data)
          .enter().append('circle')
          .attr('class', 'bidDot')
           .attr('stroke', '#4987B4')
            .attr('fill', '#4987B4')
            .attr('r', 4)
            .attr('cx', function(d){
                return lcobj.xScale(lcobj.parser(d.date))
            })
            .attr('cy', function(d){
                return lcobj.yScale(d.bidPrice)
            });
           lcobj.psvg.path.selectAll('.tradeDot')
              .data(lcobj.data)
              .enter().append('circle')
             .attr('class', 'tradeDot')
             .attr('stroke', '#00ADA7')
             .attr('fill', '#00ADA7')
                .attr('r', 4)
                 .attr('cx', function(d){
                return lcobj.xScale(lcobj.parser(d.date))
            })
            .attr('cy', function(d){
                return lcobj.yScale(d.tradePrice)
            });
     mrktRply.priceChart.prcRef=lcobj;
}
mrktRply.priceChart.updateprcChart=function(){
   let lcobj=mrktRply.priceChart.prcRef;
               d3.select(".prcChartLyout").selectAll("*").remove();              
                mrktRply.priceChart.updatePriceChrtDomain(lcobj); 
                mrktRply.priceChart.lineDtGen(lcobj);  
                mrktRply.priceChart.pathGen(lcobj);
                mrktRply.priceChart.linePointsGen(lcobj);
}
/**Price Chart**/