/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const networkObj = {
    graphObj: {},
    fltrObj: [],
    baseUri: "",
    sHdr: $("#ntwrkConncLink"),
    grphCnt: $("#ntwrk-reasoning"),
};
networkObj.initLocaleStr=function(data,l){
	networkObj.lc=data;
	networkObj.fillLoc(data);
	networkObj.initObj(data,l);
}
networkObj.fillLoc=function(d){	
	let s=[{id:"ntwrkConncLink",txt:d.connections},{id:"networkTitle",txt:d.networks},
		    {id:"lgInvlEmp",txt:d.invlEMp},{id:"lgOrgn",txt:d.organizationsC},
		    {id:"lgTckrc",txt:d.tickerC},{id:"tblIdType",txt:d.type},
		    {id:"tblIdDate",txt:d.date},{id:"tblIdDesc",txt:d.descrip},
		    {id:"tblIdScore",txt:d.weight},
		    {id:"selectCntnDtls",txt:d.concdetails}];
		for(let i=0;i<s.length;i++){
			cmnFunc.fillIdNode(s[i]);
		}		
}
$(document).ready(function(){
	   cmnFunc.localeStr({ref:networkObj,func:"initLocaleStr"});
});
networkObj.initObj = function (data,l) {
    networkObj.alert = cmnFunc.getQueryParameters();
    let objRef = {
        type: "GET",
        url: cmnlocDetails.alertOvrSrvc + networkObj.alert.alertid + "/network?connection=people&connection=organization&connection=ticker&connectiontype=e-mail&connectiontype=chat&&connectiontype=trade",
        dataType: "json",
        ref: networkObj,
        func: "asyncData"
    };
   
    cmnAsync.asynccall(objRef);

    autoHeader.generate("mnuNetwork");
    networkObj.baseUri = cmnlocDetails.alertOvrSrvc + networkObj.alert.alertid + "/network";
}

networkObj.asyncData = function (obj) {
	 if(obj.statusText&&obj.statusText.toLowerCase()!="success"){
	        $(".alrtContent").css("display","none");
	        cmnFunc.errorDialog();
	        return;
	    }  
	    
    let lc=networkObj.lc,node = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "alrtStCont clearfix"
        }],
        appendTo: $("#ntwrk-headerNode")
    });
    networkObj.dataObj = obj;
   
    if (obj.network.length > 0) {
    	 $("#networkTitle").html(obj.network[0].source.entityname+lc.ntwrkconnect);
        dNode = networkObj.dataconstruct(obj.network);
        networkObj.initNtwrkGrph({
            idNode: "ntwrk-reasoning",
            dt: dNode
        });
    } else {
        networkObj.grphCnt.html(cmnFunc.createDmNode({
            node: "div",
            attr: [{
                node: "class",
                value: "emptyNts"
            }],
            html: lc.nrecordavl
        }));
    }

   
}
networkObj.dataconstruct = function (data) {
    let obj = {
            entities: [],
            relations: []
        },
        e = [],
        l = [],
        arr = [],
        dest = [];

    for (let index in data) {
        let prop = data[index],
            eNode = {
                id: "",
                name: "",
                img: "",
                type: ""
            },
            rNode = {
                source: "",
                target: "",
                type: "",
                evidence: []
            };
        eNode.id = prop.target.entityid;
        arr.push(eNode.id);     
        eNode.name = prop.target.entityname;
      /*  eNode.img = cmnlocDetails.imgService + prop.target.entityreferenceid + ".png";*/
        eNode.type = prop.target.entitytype.trim();
        rNode.source = prop.source.entityid;
        rNode.target = prop.target.entityid;
        dest.push(rNode.target)
        rNode.type = prop.target.entitytype.trim();
        rNode.evidence = prop.evidences;
        obj.entities.push(eNode);
        obj.relations.push(rNode);
        if (index == (data.length - 1)) {
            let eNode = {};
            eNode.id = prop.source.entityid;
            arr.push(eNode.id);
            eNode.name = prop.source.entityname;
       /*     eNode.img = cmnlocDetails.imgService + prop.source.entityreferenceid + ".png";*/
            eNode.type = prop.source.entitytype.trim();
            obj.entities.push(eNode);
        }
    }


    return obj;
}
networkObj.initNtwrkGrph = function (l) {
    let _l = {},
        idRefNode = $("#" + l.idNode);
    networkObj.grphCnt.html(" ");
    if ($("#ntwrk-Gnr-Graph").length > 0) {
        $("#ntwrk-Gnr-Graph").remove();
    }
    _l.w = idRefNode.width();
    _l.h = 500;
    _l.svgObj = d3.select(idRefNode.selector).append("svg").attr("width", _l.w).attr("height", _l.h).attr("id", "ntwrk-Gnr-Graph");
    _l.svg = _l.svgObj.append('g').attr("width", _l.w - 20).attr("height", _l.h - 30).attr("transform", "translate(" + [20, 20] + ")");
    _l.color = d3.scaleOrdinal(d3.schemeCategory20);
    _l.tooldiv = d3.select("body").append("div")
        .attr("class", "svgtip")
        .style("opacity", 0);
  _l.simulation = d3.forceSimulation()
.force("link", d3.forceLink().id(function(d) {
    return d.id; }).distance(150))
    .force("collide", d3.forceCollide().radius(50))
    .force("center", d3.forceCenter((_l.w)/2, (_l.h) / 2))
     .force("charge",d3.forceManyBody())
     .force("y", d3.forceY(0))
     .force("x", d3.forceX(0));
    _l.dt = l.dt;
    networkObj.graphObj = _l;
    networkObj.dataGenerator(_l.dt);
}
networkObj.rReset = function (l) {
    l.selectAll("*").remove();
}
networkObj.rLinksGen = function (_l) {
    let lc=networkObj.lc,ref = _l.svg.append("g")
        .attr("class", "links")
        .selectAll("line")
        .data(_l.dlinks)
        .enter().append("line")
        .attr("stroke-width", function (d) {
            return 5
        })
        .style("stroke", "#ccc")
        .on("click", function (d) {
    
            networkObj.sHdr.html(lc.ntwrkcnctBtwn+" " + d.source.name.replace(/(?:\\[rn])+/g, "") + " "+lc.and+" " + d.target.name.replace(/(?:\\[rn])+/g, " "));
            networkObj.dynTblData({
                data: d.evidence
            });
            d3.selectAll(".links line").style("stroke", "#ccc");
            d3.select(this).style("stroke", "#000");
        });
    return ref;
}
networkObj.rNodeGen = function (_l) {
    let node = _l.svg.selectAll(".node")
        .data(_l.dnodes)
        .enter().append("g")
        .attr("class", "node")
        .call(d3.drag());
    node.append("circle").attr("r", function (d, i) {
            let len=_l.dnodes.length;
       return len>10?(400/len):40;         
        });
    networkObj.rFillNodeGenr(node, _l);
    networkObj.rTxtNodeGenr(node, _l);
 
    return node;
}
networkObj.rFillNodeGenr = function (node, _l) {
    node.attr("fill", function (d, i) {
        if (d.type == "ticker") {
            return "#d90916";
        } else if (d.type == "organization") {
            return "#009584";
        } else if (d.type == "people") {
            return "#0095B9"
        
        }
    });
}
networkObj.rTxtNodeGenr = function (node, _l) {
    node.append("text").attr("class", "nodeText")
        .attr("dy", "0.3em").attr("fill", "#ffffff")
        .text(function (d) {
            return cmnFunc.initials(d.name);
        }).style("text-anchor", "middle").on("mouseover", function (d) {
            _l.tooldiv.transition()
                .duration(200)
                .style("opacity", 1);
            _l.tooldiv.html(d.name.toUpperCase())
                .style("left", (d3.event.pageX - 60) + "px")
                .style("top", (d3.event.pageY - 30) + "px");
        })
   

}

networkObj.rpreGraph = function (l) {

    l.simulation.nodes(l.dnodes).on("tick", ticked);

    function ticked() {
        let length = l.dnodes.length - 1,
            nodeLen = (l.w - 50) / (length - 1),
            nodeHeight = (l.h - 30) / (length - 1);
        l.nodeRef.attr("transform",
            function (d, i) {
        	
                return "translate(" + d.x + "," + d.y + ")";
            });
        l.linkRef.attr("x1", function (d) {
                return d.source.x;
            })
            .attr("y1", function (d) {
                return d.source.y;
            })
            .attr("x2", function (d) {
                return d.target.x;
            })
            .attr("y2", function (d) {
                return d.target.y;
            });


    }
    l.simulation.force("link")
        .links(l.dlinks);
    for (var i = 0,
            n = Math.ceil(Math.log(l.simulation.alphaMin()) / Math.log(1 - l.simulation.alphaDecay())); i < n;
        ++i
    ) {
        l.simulation.tick();
    }
   
}
networkObj.dataGenerator = function (data) {
    let _l = networkObj.graphObj;
    _l.dt = data;
    networkObj.rReset(_l.svg);
    _l.dnodes = data.entities;
    _l.dlinks = data.relations;
    _l.linkRef = networkObj.rLinksGen(_l);
    _l.nodeRef = networkObj.rNodeGen(_l);
    networkObj.rpreGraph(_l);


}

/**network table **/
networkObj.tblLinkGen = function (obj) {
    let anchor, link, qdata = "?loc="+cmnEvidences.loc+"&alertid=" + networkObj.alert.alertid + "&evidenceid=" + obj.evidenceid + "&partyid=" + obj.partyid;
    if (obj.type && obj.type.trim().toLowerCase() == "e-mail") {
        link = cmnlocDetails.partial_homefolder + "email/index.html" + qdata;
    } else if (obj.type && obj.type.trim().toLowerCase() == "voice") {
        link = cmnlocDetails.partial_homefolder + "voice/index.html" + qdata;
    } else if (obj.type && obj.type.trim().toLowerCase() == "chat") {
        link = cmnlocDetails.partial_homefolder + "chat/index.html" + qdata;
    }else if (obj.type && obj.type.trim().toLowerCase() == "anomaly") {
        link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" +  qdata +"&source=anomaly";
    } else if (obj.type && obj.type.trim().toLowerCase() == "sentiment") {
        link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" +  qdata +"&source=sentiment";
    } else if (obj.type && obj.type.trim().toLowerCase() == "emotion") {
        link = cmnlocDetails.partial_homefolder + "involvedemployees/index.html" +   qdata + "&source=emotion";
    } else if (obj.type && obj.type.trim().toLowerCase() == "network") {
        link = cmnlocDetails.partial_homefolder + "network/index.html" + qData;
    }
     else if (obj.type && obj.type.trim().toLowerCase() == "trade") {
        link = cmnlocDetails.partial_homefolder + "tradedetail/index.html" + qData;
    }
    if (link) {
        
        return link;
    } else {
     
        return false;
    }
}
networkObj.dynTblData = function (obj) {
	let lc=networkObj.lc;
    if (obj && obj.data.length > 0) {
        $("#tblDfTxt").addClass("hide");
        $("#eviDupl").addClass("hide");
        var obj = {
            tblId: 'evidencedetail',
            pagination: {
                node: 'pageCmpnnt',
                'recPerPg': 10
            },
            dataObj: obj.data,
            tblObj: {
                headerObj: [{
                	 field: lc.weight,
                     sortFld: {
                         dataType: "numeric",
                         field: "riskscore",
                         func: function (dt) {
                             let dtRef = parseInt(dt * 100);
                             return parseInt(dtRef);
                         }
                     },
                     class: "tw20"
                 },{
                        field: lc.type,
                        class: "tw20",
                        sortFld: {
                            field: "type"                           
                        },
                    },
                    {
                        field: lc.date,
                        class: "tw20",
                        sortFld: {
                            dataType: "numeric",
                            field: "date",
                            func: function (dt) {                            
                                return new Date(dt);
                            }
                        },
                    },
                    {
                        field: lc.descrip,
                        class: "tw40"
                    }
                   ],
                tbdyobj: [{
                    field: "riskscore",
                    format: function (fld, data, obj) {
                        let dtRef = parseInt(data * 100);
                        cmnFunc.scoreColor({
                            score: dtRef
                        });
                           
                             fld.addClass(cmnFunc.scoreColor({"score":dtRef}));  
                            
                            return fld.html(dtRef + "%");
                        }
                    },{
                        field: "type",
                        format: function (fld, data, obj) {
                        	fld.attr("title",data);
                            return fld.html(data);
                        }
                    },
                    {
                        field: "date",
                        format: function (fld, data, obj) {
                            return fld.html(cmnFunc.convertNotesDate(data));
                        }
                    },
                    {
                        field: "description",
                        format: function (fld, data, obj) {
                        	fld.attr("title",data);
                           return fld.html(data);
                        }
                    },
                ],
                trRowClickFunc:function(tr,obj){
                    let flg=networkObj.tblLinkGen(obj);
                    if(flg){
                        let t=$(tr);
                        t.on("click",function(){
                           window.location=flg; 
                        });
                        t.addClass("evidenceTbl");
                    }
                }
            
            },
            
        }
        tableFunc.create(obj);
    } else {
        $("#tblDfTxt").removeClass("hide");
        $("#eviDupl").removeClass("hide");
        if ($("#evidencedetail tbody").length > 0) {
            $("#evidencedetail tbody").remove();
        }
    }

}
/**network table **/