/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
let noteSummaryPage = {
    logUser: cmnFunc.getCookie("id"),
    isEditing: false //store editing status
};
noteSummaryPage.assigned_person = "";
noteSummaryPage.assignedtoemployeeid="";
$(document).ready(function() {
    cmnFunc.localeStr({
        ref: noteSummaryPage,
        func: "initDtObj"
    });
});
noteSummaryPage.fillLoc = function(d) {
    let s = [{
        id: "ntsSummry",
        txt: d.ntsSummary
    }, {
        id: "genPdf",
        txt: d.genPdf
    }, {
        id: "note-agree",
        txt: d.agree
    }, {
        id: "note-disagree",
        txt: d.disAgree
    }, {
        id: "note-disagree",
        txt: d.disAgree
    }];
    let c = [{
        id: "ntsMnHdrSec",
        txt: d.agreeToAlert
    }, {
        id: "ntsSubHdrSec",
        txt: d.summryOfDecision
    }, {
        id: "cncel",
        txt: d.cancel
    }];
    for (let i = 0; i < s.length; i++) {
        cmnFunc.fillIdNode(s[i]);
    }
    for (let i = 0; i < c.length; i++) {
        cmnFunc.fillClassNode(c[i]);
    }
}
noteSummaryPage.initDtObj = function(data, l) {
    noteSummaryPage.fillLoc(data);
    noteSummaryPage.lc = data;
    noteSummaryPage.init();
    noteSummaryPage.initEvnts();
}
noteSummaryPage.initEvnts = function() {
    var excempt = [37, 38, 39, 40, 46, 8, 36, 35];
    $(".user_explanation.agree").focusout(function() {
        var element = $(this);
        if (!element.text().replace(" ", "").length) {
            element.empty();
        }
    });
    $(".user_explanation.disagree").focusout(function() {
        var element = $(this);
        if (!element.text().replace(" ", "").length) {
            element.empty();
        }
    });
    $("[contenteditable='true']").each(function(index, elem) {
        var $elem = $(elem);
        var length = 250;
        if (!isNaN(length)) {
            $elem.on('keydown', function(evt) {
                if (excempt.indexOf(evt.which) === -1 && $elem.text().length > length) {
                    evt.preventDefault();
                    return false;
                }
            });
        }
    });
}
noteSummaryPage.init = function() {
    let queryParams = cmnFunc.getQueryParameters();
    let spinN = cmnFunc.createDmNode({
        node: "div",
        attr: [{
                node: "class",
                value: "survellianceLoader"
            },
            {
                node: "id",
                value: "nts_loader"
            }
        ],
        appendTo: $("#generated_content")
    });
    header.init("alrtOvr-headerNode");
    /* $(".note_back_icon").on("click",function(evt){
	    window.history.back();
	});*/
    $(".user_explanation.agree").html('');
    $(".user_explanation.disagree").html('');
    let urlref = "";
    urlref = cmnlocDetails.alertOvrSrvc + queryParams.alertid + "?forHeader=true";

    let objRef = {
        type: "GET",
        url: urlref,
        data: JSON.stringify({ "authorname": logOutfunc.usrname() }),
        dataType: "json",
        ref: noteSummaryPage,
        func: "getAlertData"
    };
    cmnAsync.asynccall(objRef);

}

noteSummaryPage.getAlertData = function(obj) {

    let queryParams = cmnFunc.getQueryParameters();
    let objRef = {
        type: "GET",
        url: cmnlocDetails.notesSrvc + queryParams.alertid + "/notes",
        data: JSON.stringify({ "authorname": logOutfunc.usrname() }),
        dataType: "json",
        ref: noteSummaryPage,
        func: "addContent"
    }

    cmnAsync.asynccall(objRef);
}

noteSummaryPage.addContent = function(res) {

    $("#nts_loader").remove();
    if (res.notes.length == 0) {
        let no_data_obj = cmnFunc.createDmNode({
            node: "div",
            html: "No Data",
            attr: [{
                node: "class",
                value: "no-notes"
            }]
        });
        $('#generated_content').append(no_data_obj);
        $('.generate-pdf').addClass("disabled");
        $('#note-agree').addClass("disabled");
        $('#note-disagree').addClass("disabled");
        return false;
    }

    $('.generate-pdf').addClass("disabled");
    $('#note-agree').addClass("disabled");
    $('#note-disagree').addClass("disabled");
    noteSummaryPage.assigned_person = res.alert.assignedtoid ? res.alert.assignedtoid : 0;
    noteSummaryPage.assignedtoemployeeid = res.alert.assignedtoemployeeid ? res.alert.assignedtoemployeeid : "";
    if (res.alert.alertactionstatus != null) {
        $('.generate-pdf').removeClass("disabled");
    } else {
        if (noteSummaryPage.logUser == noteSummaryPage.assignedtoemployeeid ) {
            $('#note-agree').removeClass("disabled");
            $('#note-disagree').removeClass("disabled");
        }
    }

    for (var i = 0; i < res.notes.length; i++) {
        var content = noteSummaryPage.buildContent(res.notes[i], res.alert.alertactionstatus);
        $('#generated_content').append(content);
        $(".save_note_block").hide();
        $(".delete_note_block").hide();
    }

    var title = "",
        desc = "",
        content = "";
    $(".generate-pdf").on("click", function() {
        noteSummaryPage.getPDF();
    });
    $(".cancel").on("click", function() {
        let id = $(this).attr('data-id'),
            imgDesc = $(".note_" + id + " .img_desc"),
            usrCont = $(".note_" + id + " .user_content"),
            hdr = $(".note_" + id + " .title h4");

        if (imgDesc.length > 0) {
            //imgDesc.html(desc);
            imgDesc.html($(".note_" + id + " .old_note_content").html());
            imgDesc.removeClass("userActiveTxt");
            imgDesc.attr("contentEditable", false);
        } else {
            // usrCont.html(content);
            usrCont.html($(".note_" + id + " .old_note_content").html());
            usrCont.removeClass("userActiveTxt");
            usrCont.attr("contentEditable", false);
        }
        hdr.html(title);
        hdr.attr("contentEditable", false);
        $(".note_" + id + " .save_note_block").hide();
        $(".note_" + id + " .note_delete_icon").removeClass("hide");
        $(".note_" + id + " .note_edit_icon").removeClass("hide");
        $(".note_" + id + " .old_note_content").remove();
        $(".note_" + id + " .save-note-error").remove();
        noteSummaryPage.isEditing = false;
    });
    $(".save").on("click", function() {
        var id = $(this).attr('data-id');
        var reference = "";

        $(".note_" + id + " .save-note-error").remove();
        title = $(".note_" + id + " .title h4").html();
        if ($(".note_" + id + " .img_desc").html() == "" || $(".note_" + id + " .img_desc").html() == null || $(".note_" + id + " .img_desc").html() == undefined) {
            content = $(".note_" + id + " .user_content").text().trim();
        } else {
            content = $(".note_" + id + " .img_desc").text().trim();
        }

        content = content.replace(/\s\s+/g, ' ');
        reference = $(".note_" + id + " .reference").html();
        var dtObj = {};
        dtObj.note = {};
        dtObj.note.authorid = cmnFunc.getCookie("id");
        dtObj.note.content = content;
        dtObj.note.authorname = logOutfunc.usrname();
        dtObj.note.notetitle = title;
        dtObj.note.reference = reference;
        var qData = cmnFunc.getQueryParameters();
        let objRef = {
            type: "PUT",
            url: cmnlocDetails.notesSrvc + qData.alertid + "/note/" + id,
            dataType: "json",
            data: JSON.stringify(dtObj),
            func: function(res) {
                if (res.status != 200) {
                    let err = res.responseText.split(/:(.+)/)[1] ? res.responseText.split(/:(.+)/)[1] : res.responseText;
                    $(".note_" + id + " .save_note_block")
                        .prepend('<span class="save-note-error"><b>Error saving notes:</b> ' + err + '</span>');
                } else {
                    $(".note_" + id + " .save-note-error").remove();
                    $(".note_" + id + " .title h4").attr("contentEditable", false);
                    $(".note_" + id + " .img_desc").attr("contentEditable", false);
                    $(".note_" + id + " .img_desc").removeClass("userActiveTxt");
                    $(".note_" + id + " .user_content").attr("contentEditable", false);
                    $(".note_" + id + " .user_content").removeClass("userActiveTxt");
                    $(".note_" + id + " .note_edit_icon").removeClass("hide");
                    $(".note_" + id + " .note_delete_icon").removeClass("hide");
                    $(".note_" + id + " .save_note_block").hide();
                    noteSummaryPage.updatedNote();
                    noteSummaryPage.isEditing = false;
                }
            }
        }

        $(".note_" + id + " .old_note_content").remove();
        cmnAsync.asynccall(objRef);
    });
    $(".yes").on("click", function() {
        var id = $(this).attr('data-id');
        $(".note_" + id + " .delete_note_block").hide();
        $(".note_" + id).remove();
        var qData = cmnFunc.getQueryParameters();
        let objRef = {
            type: "DELETE",
            url: cmnlocDetails.notesSrvc + qData.alertid + "/note/" + id,
            data: JSON.stringify({ "authorname": logOutfunc.usrname() }),
            dataType: "json",
            ref: noteSummaryPage,
            func: "deletedNote"
        }

        cmnAsync.asynccall(objRef);
    });
    $(".no").on("click", function() {
        var id = $(this).attr('data-id');
        $(".note_" + id + " .delete_note_block").hide();
        $(".note_" + id + " .note_edit_icon").removeClass("hide");
        $(".note_" + id + " .note_delete_icon").removeClass("hide");
    });
    $("img.note_delete_icon").on("click", function() {
        var id = $(this).attr('data-id');
        $(this).addClass("hide");
        $(".note_" + id + " .delete_note_block").show();
        $(".note_" + id + " .note_edit_icon").addClass("hide");
    });
    $("img.note_edit_icon").on("click", function() {
        if (noteSummaryPage.isEditing) {
            return;
        }

        noteSummaryPage.isEditing = true;
        let id = $(this).attr('data-id'),
            imgDesc = $(".note_" + id + " .img_desc"),
            usrCont = $(".note_" + id + " .user_content"),
            hdr = $(".note_" + id + " .title h4");

        $(this).addClass("hide");
        $(".note_" + id + " .note_delete_icon").addClass("hide");
        title = hdr.html();
        hdr.attr("contentEditable", true);
        if (imgDesc.length > 0) {
            // desc = imgDesc.html();
            imgDesc.attr("contentEditable", true);
            imgDesc.addClass("userActiveTxt");

            $(".note_" + id).append('<div class="old_note_content hidden">' + imgDesc.html() + '</div>');
        } else {
            // content = usrCont.html();
            usrCont.attr("contentEditable", true);
            usrCont.addClass("userActiveTxt");
            usrCont.focus();
            cmnFunc.setEndOfContenteditable(usrCont[0]);

            //save the current note content
            $(".note_" + id).append('<div class="old_note_content hidden">' + usrCont.html() + '</div>');
        }
        $(".note_" + id + " .save_note_block").show();
    });
}
noteSummaryPage.getPDF = function() {
    var alert = cmnFunc.getQueryParameters();
    window.open(cmnlocDetails.alertOvrSrvc + alert.alertid + "/print");
}


noteSummaryPage.notify = function(text) {
    let div_obj = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "notify_user"
        }]
    });
    let p_obj = cmnFunc.createDmNode({
        node: "p",
        html: text,
        appendTo: div_obj
    });
    $('body').append(div_obj);
    window.setTimeout(function() {
        $('.notify_user').remove();
    }, 3000);
}

noteSummaryPage.deletedNote = function(obj) {
    let l = noteSummaryPage.lc;
    noteSummaryPage.notify(l.ntshasdeleted);
}

noteSummaryPage.updatedNote = function(obj) {
    let l = noteSummaryPage.lc;
    noteSummaryPage.notify(l.ntshasUpdated);
}
noteSummaryPage.convertNotesDate = function(objdt) {
    var dt = new Date(objdt);
    var month = new Array();
    var date_str = "";
    month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    let h = dt.getHours();
    let mi = dt.getMinutes();
    let t = (((h > 12) ? h - 12 : h) + ":" + ((mi > 9) ? mi : "0" + mi)) + " " + ((h >= 12) ? "pm" : "am");
    return date_str + " at " + t;
}
noteSummaryPage.convertNotesTime = function(objtime) {
    var ampm = "am";
    if (parseInt(objtime.substr(0, 2)) < 12) {
        ampm = "am";
    } else {
        ampm = "pm";
    }
    return objtime.substr(0, 5) + " " + ampm;
}
noteSummaryPage.buildContent = function(info, alert_status) {
    let content = '',
        l = noteSummaryPage.lc;

    if (info.attachment) {
        content = '<div class="row content_box note_' + info.noteid + '"> <div class="col-xs-7 left_content"> <div class="title">' +
            '<h4 contentEditable="false">' + info.notetitle + '</h4>';
        if (alert_status == null && noteSummaryPage.logUser == info.authorid) {
            content += '<div class="action_icons"><img class="note_edit_icon" data-id=' + info.noteid + ' src="../dist/images/notes_edit_icon.png" />' +
                '<img class="note_delete_icon" data-id=' + info.noteid + ' src="../dist/images/note_delete_icon.png" /></div>';
        }
        content += '</div>' +
            '<div class="del-img-section"><div class="delete_note_block">' + l.ntsSureDel + '<div class="yes-no-section"><button class="yes" data-id=' + info.noteid + '>' + l.yes + '</button> or <button class="no" data-id=' + info.noteid + ' >' + l.no + '</button></div></div>' +
            '<img class="user_content_img" src="data:image/png;base64,' + info.attachment + '" /> </div>' +
            '</div><div class="col-xs-4 col-sm-offset-1 "><div class="title"></div><div class="note_meta">' +
            '<div class="img_desc" contentEditable="false">' + (info.content != null ? info.content : "") + '</div>' +
            '<div class="save_note_block"><button class="cancel butn secButton" data-id=' + info.noteid + '>' + l.cancel + '</button> <button class="save butn priButton" data-id=' + info.noteid + ' >' + l.save + '</button></div>' +
            '<p><b>' + l.reference + ':</b> <span class="reference">' + info.reference + '</span></p>' +
            '<p><b>' + l.dateSaved + ':</b> ' + noteSummaryPage.convertNotesDate(info.epochtime) + '</p>' +
            '<p><b>' + l.author + ':</b> ' + info.authorname + '</p>' +
            '</div></div></div>';
    } else {
        content = '<div class="row content_box note_' + info.noteid + '"> <div class="col-xs-7 left_content"> <div class="title">' +
            '<h4 contentEditable="false">' + info.notetitle + '</h4>';
        if (alert_status == null && noteSummaryPage.logUser == info.authorid) {
            content += '<div class="action_icons"><img class="note_edit_icon" data-id=' + info.noteid + ' src="../dist/images/notes_edit_icon.png" />' +
                '<img class="note_delete_icon" data-id=' + info.noteid + ' src="../dist/images/note_delete_icon.png" /></div>';
        }
        content += '</div>' +
            '<div class="del-img-section"><div class="delete_note_block">' + l.ntsSureDel + '<div class="yes-no-section"><button class="yes" data-id=' + info.noteid + '>' + l.yes + '</button> or <button class="no" data-id=' + info.noteid + ' >' + l.no + '</button></div></div>' + '<div class="user_content" contentEditable="false">' + info.content + '</div>' +
            '</div><div class="save_note_block"><button class="cancel butn secButton" data-id=' + info.noteid + '>' + l.cancel + '</button> <button class="save butn priButton" data-id=' + info.noteid + ' >' + l.save + '</button></div>' +
            '</div><div class="col-xs-4 col-sm-offset-1"><div class="title"></div><div class="note_meta">' +
            '<p><b>' + l.reference + ':</b> <span class="reference">' + info.reference + '</span></p>' +
            '<p><b>' + l.dateSaved + ':</b> ' + noteSummaryPage.convertNotesDate(info.epochtime) + '</p>' +
            '<p><b>' + l.author + ':</b> ' + info.authorname + '</p>' +
            '</div></div></div>';
    }

    return content;
}

noteSummaryPage.showModal = function(id) {
    $('#' + id).removeClass('hide');
    $(".decError").addClass("hide");
}

noteSummaryPage.hideModal = function(id) {
    $('.user_explanation').html('');
    $('#' + id).addClass('hide');
    $(".decError").addClass("hide");
}

noteSummaryPage.finalDecision = function(decision) {
    // if(decision=="agree"){
    // 	$('.generate-pdf').removeClass("disabled");
    // }else if(decision=="disagree"){
    // 	$('.generate-pdf').removeClass("disabled");
    // }

    let queryParams = cmnFunc.getQueryParameters();
    let urlref = "";
    urlref = cmnlocDetails.alertOvrSrvc + "action/" + queryParams.alertid;
    let obj = {};
    obj.alertactionstatus = decision;
    let tmp = $('.user_explanation.' + decision).html().trim();
    tmp = tmp.replace(/(\r\n|\n|\r)/gm, "");
    tmp = tmp.replace("\t", "");
    if (tmp == "") {
        $(".decError").removeClass("hide");
        return false;
    } else {
        $(".decError").addClass("hide");
    }
    obj.alertactioncomments = tmp;
    obj.authorname = logOutfunc.usrname();
    let objRef = {
        type: "PUT",
        url: urlref,
        dataType: "json",
        data: JSON.stringify(obj),
        ref: noteSummaryPage,
        func: "setAgreeDisAgree"
    };
    cmnAsync.asynccall(objRef);
}
noteSummaryPage.setAgreeDisAgree = function(obj) {
    let l = noteSummaryPage.lc;
    noteSummaryPage.hideModal('agree_modal');
    noteSummaryPage.hideModal('disagree_modal');
    if (obj.status == 200) {
        $('#note-agree').addClass("disabled");
        $('#note-disagree').addClass("disabled");
        $('.generate-pdf').removeClass("disabled");
        noteSummaryPage.notify(l.ntshasUpdated);
    } else {
        $('.generate-pdf').addClass("disabled");
        noteSummaryPage.notify(l.insrtErr);
    }
}