/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const srchObj = {
    loader: $("#cover-spin"),
    srchSessionFlds: {},
    baseQuery: cmnlocDetails.service + "/surveillanceui/v1/index/search/indent=on&wt=json",
    init: function () {
        let h = window.location.hash,
            st = JSON.parse(sessionStorage.getItem("searchStack"));
        alrtSrchObj.init();
        emplySrchObj.init();
        comuSrchObj.init();
        header.init("si-adv-hdrcnt");
        srchObj.initEvents();
        if (Object.keys(st).length > 0) {
            srchObj.srchSessionFlds = st;
        }
        if (h == "#si-adv-Employee") {
            srchObj.disPlyTabs("si-adv-Employee");
            srchObj.fillFmFlds(emplySrchObj);

        }
        if (h == "#si-adv-Alert") {
            srchObj.disPlyTabs("si-adv-Alert");
            srchObj.fillFmFlds(alrtSrchObj);
        }
        if (h == "#si-adv-EcommSearch") {
            srchObj.disPlyTabs("si-adv-EcommSearch");
            srchObj.fillFmFlds(comuSrchObj);
            comuSrchObj.voiceCommids = srchObj.srchSessionFlds.voiceCommids ? srchObj.srchSessionFlds.voiceCommids : [];
            if (srchObj.srchSessionFlds.advSrch) {
                $("#advSrchQury").val(srchObj.srchSessionFlds.advSrch);
                $("#advClear").removeClass("hidden");
                comuSrchObj.advSrch(srchObj.srchSessionFlds.advSrch);
            }


        }
        if (h.length == 0) {
            window.location.hash = "#si-adv-Alert";
            alrtSrchObj.submitFm();
            srchObj.srchSessionFlds = {};
        }
    },
    typeAhesdFtr: function (d) {
        srchObj.alrtTypeHdFr = d.alerttypes;
    },
    convertTimeDate: function (date) {
        let d = date.split("T");
        let y = d[0].split("-");
        let t = d[1].split(":");
        let r = cmnFunc.convertNotesDate(new Date(y[0], y[1] - 1, y[2]));
        let f = r + " " + t[0] + ":" + t[1] + ":" + t[2].split("Z")[0];
        return f;
    },
    initEvents: function () {
        $(".srchTabsMnu").on("click", function (evt) {
            evt.preventDefault();
            evt.stopPropagation();
            srchObj.disPlyTabs(evt);
        });
        $(".tglArwNode").on("click", function (evt) {
            evt.stopPropagation();
            srchObj.accorDtglMnu(evt);
        });
        alrtSrchObj.initEvents();
        comuSrchObj.initEvents();
    },

    fillFmFlds: function (ref) {
        for (let k in srchObj.srchSessionFlds) {
            let node = $("#" + k),
                id = node.attr("id");
            if (node.length > 0) {
                if (node.attr("type") == "checkbox") {
                    if (id == "checkecomVoice") {
                        $("#ecommChnlVcCnt").show();

                        //  comuSrchObj.voiceCnt($("#ecommChnlVcCnt"));
                        node.prop("checked", true);
                        comuSrchObj.chkVoicefldsEnDis(false);
                    } else {
                        node.prop("checked", true);
                    }

                } else {
                    if (id == "ecommVlhdDur" || id == "ecommVlhdDir") {
                        let d = "data-id=" + id;
                        $('[' + d + ']').val(srchObj.srchSessionFlds[k]);
                        node.val(srchObj.srchSessionFlds[k]);
                    } else {
                        node.val(srchObj.srchSessionFlds[k]);
                    }

                }
            }
        }
        ref["submitFm"].call();
    },
    cnstrctDateformat: function (dtObj) {
        date = dtObj.date;
        year = date.getFullYear();
        month = date.getMonth() + 1;
        dt = date.getDate();
        if (dt < 10) {
            dt = '0' + dt;
        }
        if (month < 10) {
            month = '0' + month;
        }
        return month + dtObj.delimiter + dt + dtObj.delimiter + year;
    },
    clearFlds: function (node) {
        $(node).find(':input').each(function () {
            if (this.type == 'checkbox' || this.type == 'radio') {
                this.checked = false;
            } else {
                $(this).val('');
            }
        });
    },
    accorDtglMnu: function (evt) {
        let pNode = evt.target.parentNode,
            node = $(evt.target);
        if (node.hasClass("accrDwn")) {
            node.removeClass("accrDwn");
            node.addClass("accrUp");
            $("#" + pNode.parentNode.id).find("[data-id='" + pNode.id + "']").addClass("hide");
        } else if (node.hasClass("accrUp")) {
            node.addClass("accrDwn");
            node.removeClass("accrUp");
            $("#" + pNode.parentNode.id).find("[data-id='" + pNode.id + "']").removeClass("hide");
        }
    },
    disPlyTabs: function (evt) {
        let resNode = (evt.target && evt.target.id) ? evt.target.id : evt,
            idNode = $("#" + resNode + "Cnt"),
            nodeId = resNode;
        $(".hglghtMnuItem").removeClass("hglghtMnuItem");
        $(".srchTbBdyCnt").removeClass("show");
        $(".srchTbBdyCnt").addClass("hide");
        idNode.removeClass("hide");
        idNode.addClass("show");
        $("#" + nodeId).parent().addClass("hglghtMnuItem");
        if (evt.target && evt.target.id) {
            window.location.hash = "#" + resNode;
            srchObj.clearInitFlds(idNode);
            srchObj.srchSessionFlds = {};
        }

    },
    clearInitFlds: function (idNode) {
        srchObj.clearFlds(idNode);
        let id = idNode[0].id;
        if (id == "si-adv-AlertCnt") {
            alrtSrchObj.submitFm();
        } else if (id == "si-adv-EmployeeCnt") {
            emplySrchObj.submitFm();
        } else if (id == "si-adv-EcommSearchCnt") {
            comuSrchObj.submitFm();
        }
    },
    btnCnstructor: function (refNode) {
        let applyBtn, clearBtn, l = srchObj.lc;
        clearBtn = cmnFunc.createDmNode({
            node: "button",
            attr: [{ node: "class", value: "butn secButton" },
            { node: "id", value: refNode.pretxt + "ClrBtn" }
            ],
            html: l.clear,
            appendTo: refNode.cntNode
        });
        applyBtn = cmnFunc.createDmNode({
            node: "button",
            attr: [{ node: "class", value: "butn priButton" },
            { node: "id", value: refNode.pretxt + "empAplyBtn" }
            ],
            html: l.apply,
            appendTo: refNode.cntNode
        });
        return { "apply": applyBtn, "clear": clearBtn };
    },
    conAlrTypeDom: function (node) {
        let pNode = node.pNode,
            srcArr = node.srcArr,
            len = node.srcArr.length;
        for (let i = 0; i < len; i++) {
            let onjDt = srcArr[i];
            let outrDiv = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: onjDt.outrCls }], appendTo: pNode });
            let lblNode = cmnFunc.createDmNode({ node: "label", attr: [{ node: "for", value: onjDt.inId }, { node: "class", value: onjDt.lblCls }], html: onjDt.html, appendTo: outrDiv });
            let inNode = cmnFunc.createElemnt({
                node: "input",
                attr: [{ node: "type", value: "text" },
                { node: "class", value: onjDt.inCls },
                { node: "id", value: onjDt.inId },
                { node: "placeHolder", value: onjDt.inplcHdr }
                ],
                appendTo: lblNode
            });
            inNode.on("focus", function () {
                var t = $(this).parent();
                t.addClass("activeInput");
            });
            inNode.on("blur", function () {
                var t = $(this).parent();
                t.removeClass("activeInput");
            });
            if (onjDt.ref && onjDt.func) {
                onjDt.ref[onjDt.func].apply(onjDt.ref, [inNode]);
            }
        }
    },
    chkBoxCnt: function (obj) {
        let pNode, len = obj.nodes.length;
        pNode = obj.pNode;
        for (let i = 0; i < len; i++) {
            let tmpD, lblNode, inNode, objNode = obj.nodes[i];
            tmpD = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "checkbox" }], appendTo: pNode });
            lblNode = cmnFunc.createDmNode({ node: "label", attr: [{ node: "class", value: "alsChkFnt" }], appendTo: tmpD });
            inNode = cmnFunc.createElemnt({
                node: "input",
                attr: [{ node: "type", value: "checkbox" },
                { node: "id", value: "check" + objNode.id }
                ],
                appendTo: lblNode
            });
            inNode.on("click", function (evt) {
                evt.stopPropagation();
                //networkObj.filterChk(evt);
            });
            lblNode.append(objNode.text);
        }

    },
    framedtObj: function (start, end) {
        let startNode = $("#" + start),
            endNode = $("#" + end),
            refNode, result, s = startNode.val(),
            e = endNode.val();
        if (s) {
            let d, sLen = s.split(' ').length,
                dtm = (sLen > 1) ? s.split(' ') : s;
            let result = (sLen > 1) ? dtm[0] : dtm;
            d = new Date(Date.UTC(result.split("/")[2], result.split("/")[0] == "01" ? 0 : result.split("/")[0] - 1, result.split("/")[1]));
            if (sLen == 1) {
                d.setUTCHours(0, 0, 0, 0);
            } else {
                let arr = dtm[1].split(":");
                d.setUTCHours(arr[0], arr[1], arr[2], 0);
            }
            refNode = d.toISOString() + " TO ";
            srchObj.srchSessionFlds[start] = s;
            if (e) {
                let d, eLen = e.split(' ').length;
                dtm = (eLen > 1) ? e.split(' ') : e;
                let result = (eLen > 1) ? dtm[0] : dtm;;
                d = new Date(Date.UTC(result.split("/")[2], result.split("/")[0] == "01" ? 0 : result.split("/")[0] - 1, result.split("/")[1]));
                if (eLen == 1) {
                    d.setUTCHours(23, 59, 59, 59);
                } else {
                    let arr = dtm[1].split(":");
                    d.setUTCHours(arr[0], arr[1], arr[2], 0);
                }
                refNode = refNode + d.toISOString();

                srchObj.srchSessionFlds[end] = e;
            }
        }
        result = refNode ? "[" + refNode + "]" : false;
        return result;
    },
    frameFldObj: function (fldArr) {
        let txtRef = [],
            rStr;
        for (let i = 0; i < fldArr.length; i++) {
            let obj = fldArr[i],
                node = $("#" + obj.id),
                vNode = node.val();
            if (vNode) {
                srchObj.srchSessionFlds[obj.id] = vNode;
                txtRef.push(obj.val + ":" + vNode);
            }
        }
        rStr = txtRef.length > 0 ? txtRef.join(" AND ") : false;
        return rStr;
    },
    frameChkObj: function (chkArr) {
        let rArr = [];
        for (let i = 0; i < chkArr.length; i++) {
            let obj = chkArr[i];
            if ($("#" + obj.id).is(':checked')) {
                if (obj.val) {
                    srchObj.srchSessionFlds[obj.id] = "checked";
                    rArr.push(obj.val);
                }

            }
        }
        return rArr.join(",");
    },
    dtValidator: function (obj) {
        let dAr = obj.dt,
            s = $("#" + dAr.start),
            e = $("#" + dAr.end),
            result = true,
            l = srchObj.lc;
        if (s.val() != "" && e.val() != "") {
            if (cmnFunc.dateValidator("mm/dd/yy", s.val())) {
                result = true;
            } else {
                result = false;
                srchObj.loadErrorNode({ txt: l.errStratDt, node: obj.node });
                //srchObj.loadErrorNode({txt:"Alert Id is required.",node:alrtSrchObj.errorNode});

            }
            if (result) {
                result = cmnFunc.dateValidator("mm/dd/yy", e.val());
                if (result) {
                    if (new Date(e.val()) >= new Date(s.val())) {
                        result = true;
                    } else {
                        result = false;
                        srchObj.loadErrorNode({ txt: l.errStrtEnd, node: obj.node });
                    }
                } else {
                    srchObj.loadErrorNode({ txt: l.errEndDt, node: obj.node });
                }
            } else {
                if (result) {
                    srchObj.clrErrorNode({ node: obj.node });
                }
                return result;
            }
            if (result) {
                srchObj.clrErrorNode({ node: obj.node });
            }
            return result;
        } else if (s.val() == "" && e.val() == "") {
            if (result) {
                srchObj.clrErrorNode({ node: obj.node });
            }
            return true;
        } else {
            srchObj.loadErrorNode({ txt: l.errStrtEndReq, node: obj.node });
            return false;
        }

    },
    clrErrorNode: function (obj) {
        obj.node.html("");
    },
    loadErrorNode: function (obj) {
        obj.node.html(obj.txt);
    }


};
const alrtSrchObj = {
    bQuery: "",
    errNode: "",
    initEvents: function () {
        $('*[data-id="alsStrtDt"]').on("click", function (evt) {
            evt.stopPropagation();
            $("#alsStrtDt").datepicker("show");
        });
        $("#alsStrtDt").datepicker({
            beforeShow: function (input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            maxDate: new Date(),
            onSelect: function (date) {
                $("#alsEndDt").datepicker("option", "minDate", date);
            }
        });
        $('*[data-id="alsEndDt"]').on("click", function (evt) {
            evt.stopPropagation();
            $("#alsEndDt").datepicker("show");
        });
        $("#alsEndDt").datepicker({
            beforeShow: function (input, inst) {
                $('#ui-datepicker-div').addClass("alrtDtpick");
            },
            maxDate: new Date()
        });
    },
    init: function () {
        let aBtn, errorNode, l = srchObj.lc;
        alrtSrchObj.cnsrtAlrStatus();
        alrtSrchObj.cnsrtAlrtType();
        aBtn = srchObj.btnCnstructor({ cntNode: $("#alrtBtnGrp"), pretxt: "alr" });
        $(aBtn.apply).on("click", function (evt) {
            evt.stopPropagation();
            alrtSrchObj.submitFm(evt);
        });
        $(aBtn.clear).on("click", function (evt) {
            evt.stopPropagation();
            srchObj.clearFlds("#alsUlFldList");
            alrtSrchObj.submitFm(evt);
        });
        errorNode = cmnFunc.createDmNode({
            node: "p",
            attr: [{ node: "class", value: "highlighterRed" }, { node: "id", value: "alrtErrNode" }],
            html: ""
        });
        errorNode.insertBefore($("#alsUlFldList"));
        alrtSrchObj.errorNode = errorNode;
        $("#artSrchRcrSts").html(l.nrecordavl);
    },

    submitFm: function () {
        let alDtFldArr, alTypFldArr, alStFldArr, s = $("#alsStrtDt"),
            e = $("#alsEndDt"),
            l = srchObj.lc;
        alDtFldArr = { start: "alsStrtDt", end: "alsEndDt" };
        alTypFldArr = [{ id: "alrAlertId", val: "alertid" }, { id: "alrEmpName", val: "tradernames" }, { id: "alrAlertType", val: "alerttype" }, { id: "alrTicker", val: "ticker" }];
        alStFldArr = [{ id: "checkalrNew", val: "New" }, { id: "checkalrProgress", val: "IN PROGRESS" },
        { id: "checkalrAutEsc", val: "Automatically Escalated" },
        { id: "checkalrMnuEsc", val: "Manually Escalated" },
        { id: "checkalrRejected", val: "REJECTED" }, { id: "checkalrClosed", val: "CLOSED" }
        ];

        if (srchObj.dtValidator({ dt: alDtFldArr, node: alrtSrchObj.errorNode })) {

            alrtSrchObj.frameQueryParams(alDtFldArr, alTypFldArr, alStFldArr);
        }


    },

    frameQueryParams: function (dFld, tFld, stFld) {
        alrtSrchObj.bQuery = "";
        srchObj.srchSessionFlds = {};
        let dtFld = srchObj.framedtObj(dFld.start, dFld.end),
            fldArr = srchObj.frameFldObj(tFld),
            chkArr = srchObj.frameChkObj(stFld),
            objRef,
            fldTxt = ["doctype:alert"],
            chkTxt = "";
        if (dtFld) {
            fldTxt.push("alert_dt:" + dtFld);
        }
        if (fldArr) {
            fldTxt.push(fldArr);
        }
        if (chkArr) {
            fldTxt.push("alertstatus:" + chkArr);
        }
        alrtSrchObj.bQuery = "&q=" + (fldTxt.length > 0 ? fldTxt.join(" AND ") : "");
        alrtSrchObj.dynAlrtSrchData();
    },
    asyncData: function (data) {
        console.log(data);
        alrtSrchObj.dynTblData(data);
    },
    cnsrtAlrStatus: function () {
        let refNd = $("#alrStatusCnt"),
            l = srchObj.lc;
        let chkObj = {
            pNode: cmnFunc.createDmNode({ node: "div", attr: [{ node: "data-id", value: "alrStatus" }, { node: "class", value: "hide" }], appendTo: refNd }),
            nodes: [{ id: "alrNew", text: l.newFld },
            { id: "alrProgress", text: l.inProgress },
            { id: "alrAutEsc", text: l.automatEsc },
            { id: "alrMnuEsc", text: l.manuEsc },
            { id: "alrRejected", text: l.rejected },
            { id: "alrClosed", text: l.closed }
            ]
        };
        srchObj.chkBoxCnt(chkObj);
    },
    cnsrtAlrtType: function () {
        let refNode = $("#alrTypeCnt"),
            l = srchObj.lc;
        let refObj = {
            pNode: cmnFunc.createDmNode({ node: "div", attr: [{ node: "data-id", value: "alrAlrtType" }], appendTo: refNode }),
            srcArr: [{
                outrCls: "form-group",
                html: l.alertType,
                lblCls: "alsHdrFnt posrel",
                inCls: "form-control inputTxt",
                inId: "alrAlertType",
                inplcHdr: l.alertType,
                ref: alrtSrchObj,
                func: "genAlrtTyFthr"
            },
            {
                outrCls: "form-group",
                html: l.employeeName,
                inCls: "form-control inputTxt",
                lblCls: "alsHdrFnt",
                inId: "alrEmpName",
                inplcHdr: l.srchNm
            }, {
                outrCls: "form-group",
                html: l.ticker,
                inCls: "form-control inputTxt",
                lblCls: "alsHdrFnt",
                inId: "alrTicker",
                inplcHdr: l.srcTicker
            }, {
                outrCls: "form-group",
                html: l.alertId,
                lblCls: "alsHdrFnt",
                inCls: "form-control inputTxt",
                inId: "alrAlertId",
                inplcHdr: l.srchId
            }
            ]

        };
        srchObj.conAlrTypeDom(refObj);
    },
    getWords: function (v, d) {
        let valDt = v.trim();
        if (valDt.length > 0) {
            let ob = [];
            for (let dt = 0; dt < d.length; dt++) {
                let o = d[dt],
                    words = new Array();
                if (o) {
                    let t = o.trim();
                    let j = -1;
                    let correct = 1;
                    while (correct == 1 && ++j < valDt.length) {
                        if ((t.charAt(j)).toLowerCase() != (valDt.charAt(j)).toLowerCase()) {
                            correct = 0;
                        }
                    }
                    if (correct == 1) {
                        words[words.length] = t;
                    }

                }
                if (words.length > 0) {
                    ob.push(words);
                }

            }

            return ob;


        } else {
            let dr = [];
            for (let dt = 0; dt < d.length; dt++) {
                let o = d[dt];
                if (o) {
                    dr.push(o);
                }
            }
            return dr;
        }


    },
    genAlrtTyFthr: function (node) {
        if ($("#alrt-tyhdf").length > 0) {
            $("#alrt-tyhdf").remove();
        }
        let m = cmnFunc.createDmNode({
            node: "ul",
            attr: [{ node: "id", value: "alrt-tyhdf" },
            { node: "class", value: "alrt-tSrch hide" }
            ]
        });
        $(node).after(m);
        node.on("keyup", function () {
            setTimeout(function () {
                let vl = node.val();
                m.empty();

                let w = alrtSrchObj.getWords(vl, srchObj.alrtTypeHdFr);
                if (w.length > 0) {
                    m.removeClass("hide");
                    for (let z = 0; z < w.length; z++) {
                        let y = cmnFunc.createDmNode({ node: "li", attr: [{ node: "class", value: "" }, { node: "data-val", value: w[z] }], html: w[z], appendTo: m });
                        y.on("click", function (e) {
                            e.stopPropagation();
                            m.addClass("hide");
                            setTimeout(function () {
                                node.val(y.attr('data-val'));
                            }, 0);

                        });
                    }
                } else {
                    m.addClass("hide");
                }

            }, 30);
        });
    },
    dynAlrtSrchData: function (objDt) {
        let obj = (objDt && objDt.response) ? objDt.response : objDt;
        let qDt = alrtSrchObj.bQuery + "&start=" + (obj && obj.start ? obj.start : 0) +
            "&rows=" + (obj && obj.rowsPerpage ? obj.rowsPerpage : 15) + "&sort=" + (obj && obj.sort ? obj.sort.param : "alert_score") + (obj && obj.sort ? " " + obj.sort.ord : " desc");

        let srchQuery = srchObj.baseQuery,
            objRef = {
                type: "GET",
                url: encodeURI(srchQuery + qDt),
                dataType: "json",
                ref: obj && obj.ref ? obj.ref : alrtSrchObj,
                func: obj && obj.func ? obj.func : "asyncData"
            };
        cmnAsync.asynccall(objRef);
    },
    sortFldData: function (p, o) {
        alrtSrchObj.dynAlrtSrchData({ sort: { param: p, ord: o } });
    },
    dynTblData: function (obj) {
        let dtObj = obj.response,
            l = srchObj.lc;
        if (dtObj.docs.length > 0) {
            $("#alrtRecTbl").removeClass("hide");
            $("#alrtTblCnt").removeClass("hide");
            $("#artSrchRcrSts").addClass("hide");
        } else {
            $("#alrtTblCnt").addClass("hide");
            $("#alrtRecTbl").addClass("hide");
            $("#artSrchRcrSts").removeClass("hide");

        }
        var obj = {
            tblId: 'alrtRecTbl',
            pagination: {
                node: 'pageCmpnnt',
                recPerPg: 15,
                start: dtObj.start,
                numFound: dtObj.numFound,
                ref: alrtSrchObj,
                func: "dynAlrtSrchData"
            },
            dataObj: dtObj.docs,
            tblObj: {
                headerObj: [{
                    field: l.score,
                    sortFld: {
                        param: "alert_score",
                        ref: alrtSrchObj,
                        func: "sortFldData"
                    },
                    class: "tw10"
                },
                {
                    field: l.type,
                    class: "tw14",
                    sortFld: {
                        param: "alerttype",
                        ref: alrtSrchObj,
                        func: "sortFldData"
                    }
                },
                {
                    field: l.date,
                    class: "tw10",
                    sortFld: {
                        param: "alert_dt",
                        ref: alrtSrchObj,
                        func: "sortFldData"
                    }
                },
                { field: l.status, class: "tw15" },
                { field: l.id, class: "tw8" },
                {
                    field: l.astClassC,
                    class: "tw19",
                    sortFld: {
                        param: "assetclass",
                        ref: alrtSrchObj,
                        func: "sortFldData"
                    }
                },
                { field: l.ticker, class: "tw13" }
                ],
                tbdyobj: [{
                    field: "alert_score",
                    format: function (fld, data) {
                        let dt = parseInt(data * 100);
                        fld.addClass(cmnFunc.scoreColor({ score: dt }));
                        fld.html(parseInt(dt) + "%");
                        return fld;
                    }
                },
                {
                    field: "alerttype",
                    format: function (fld, data) {
                        fld.attr("title", data);
                        fld.html(data);
                        return fld;
                    }
                },
                {
                    field: "alert_dt",
                    format: function (fld, data) {
                        let dt = srchObj.cnstrctDateformat({ date: new Date(data.split("T")[0]), delimiter: "/" });
                        fld.html(cmnFunc.convertNotesDate(dt));
                        return fld;
                    }
                },
                {
                    field: "alertstatus",
                    format: function (fld, data) {
                        fld.attr("title", data);
                        fld.html(data);
                        return fld;
                    }
                },
                { field: "alertid" },
                {
                    field: "assetclass",
                    format: function (fld, data) {
                        fld.attr("title", data);
                        fld.html(data);
                        return fld;
                    }
                },
                {
                    field: "ticker",
                    format: function (fld, data) {
                        fld.attr("title", data);
                        fld.html(data);
                        return fld;
                    }
                }
                ],
                trRowClickFunc: function (tr, obj) {
                    let anchor, link, qData;
                    qData = "?loc=" + cmnEvidences.loc + "&alertid=" + obj.alertid;
                    link = cmnlocDetails.partial_homefolder + "alert/index.html" + qData;
                    if (link) {
                        let t = $(tr);
                        t.on("click", function () {
                            window.location = link;
                        });
                        t.addClass("evidenceTbl");
                    }

                }
            }
        }
        tableFunc.create(obj);
    }
};
const emplySrchObj = {
    init: function () {
        let eBtn;
        emplySrchObj.empFldsCnstrct();
        emplySrchObj.roleCnstruct();
        eBtn = srchObj.btnCnstructor({ cntNode: $("#empBtnGrp"), pretxt: "emp" });
        $(eBtn.apply).on("click", function (evt) {
            evt.stopPropagation();
            emplySrchObj.submitFm();
        });
        $(eBtn.clear).on("click", function (evt) {
            evt.stopPropagation();
            srchObj.clearFlds("#empUlFldList");
            emplySrchObj.submitFm();
        });

        $("#employeeSrchRcrSts").html("No records available.");
    },
    submitFm: function () {
        let empFlds, empRoleFlds;
        empFlds = [{ id: "empName", val: "name" }, { id: "empId", val: "employeeid" }];
        empRoleFlds = [{ id: "checkempTrdr", val: "Trader" }, { id: "checkempBanker", val: "Banker" }];
        emplySrchObj.frameQueryParams(empFlds, empRoleFlds);
    },
    frameQueryParams: function (tFld, stFld) {
        emplySrchObj.bQuery = "";
        srchObj.srchSessionFlds = {};
        let fldArr = srchObj.frameFldObj(tFld),
            chkArr = srchObj.frameChkObj(stFld),
            fldTxt = ["doctype:party"],
            empLoc = $("#empLocation").val();
        if (fldArr) {
            fldTxt.push(fldArr);
        }
        if (empLoc) {
            fldTxt.push("(city:" + empLoc + " OR " + "state:" + empLoc + ")");
        }
        if (chkArr) {
            fldTxt.push("role:" + chkArr);
        }
        emplySrchObj.bQuery = "&q=" + (fldTxt.length > 0 ? fldTxt.join(" AND ") : "");
        emplySrchObj.dynAlrtSrchData();
    },
    dynAlrtSrchData: function (objDt) {
        let obj = (objDt && objDt.response) ? objDt.response : objDt;
        let qDt = emplySrchObj.bQuery + "&start=" + (obj && obj.start ? obj.start : 0) +
            "&rows=" + (obj && obj.rowsPerpage ? obj.rowsPerpage : 15);
        let srchQuery = srchObj.baseQuery,
            objRef = {
                type: "GET",
                url: encodeURI(srchQuery + qDt),
                dataType: "json",
                ref: obj && obj.ref ? obj.ref : emplySrchObj,
                func: obj && obj.func ? obj.func : "asyncData"
            };
        cmnAsync.asynccall(objRef);
    },
    asyncData: function (data) {
        let objData = data.response.docs,
            length = objData.length;
        if (length > 0) {
            $("#employeeSrchRcrSts").addClass("hide");
            $("#empPgTblCmnt").removeClass("hide");
            $("#empPageCmpnnt").removeClass("hide");

        } else {
            $("#empPageCmpnnt").addClass("hide");
            $("#empPgTblCmnt").addClass("hide");
            $("#employeeSrchRcrSts").removeClass("hide");
        }
        new pagination({
            'node': "empPageCmpnnt",
            'recPerPg': 15,
            'tblId': "employProfileCnt",
            'dataObj': {
                'response': data.response
            },
            calbckObj: {
                'ref': emplySrchObj,
                'func': "dynAlrtSrchData"
            },
            'tblGentr': {
                'ref': emplySrchObj,
                'callbck': 'costrctEmpProfile'
            }
        });
        //emplySrchObj.costrctEmpProfile(data);
    },
    costrctEmpProfile: function (data) {

        let objData = data.docs,
            length = objData.length,
            l = srchObj.lc;
        let idNode = $("#employProfileCnt"),
            userDt = [{ id: l.riskRating, val: "riskrating" }, { id: l.id, val: "partyid" },
            { id: l.activeAlerts, val: "activealerts" }, { id: l.pastViolations, val: "pastviolations" }
            ];
        $("#employProfileCnt").empty();
        if (length > 0) {
            $("#employeeSrchRcrSts").addClass("hide");
            $("#empPgTblCmnt").removeClass("hide");
            $("#empPageCmpnnt").removeClass("hide");

        } else {
            $("#empPageCmpnnt").addClass("hide");
            $("#empPgTblCmnt").addClass("hide");
            $("#employeeSrchRcrSts").removeClass("hide");
        }
        for (let index = 0; index < length; index++) {
            let nodeObj = objData[index],
                empLocDt = [],
                q = cmnFunc.getQueryParameters(),
                pNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "empBox" }], appendTo: idNode }),
                imgCnt = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "clearfix imgCnt" }], appendTo: pNode }),
                imgRcnt = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "empfltlft" }], appendTo: imgCnt }),
                imgLcnt = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "empfltrgt" }], appendTo: imgCnt }),
                imgRef = cmnFunc.createDmNode({
                    node: "div",
                    attr: [{ node: "class", value: "cirDiv" }],
                    appendTo: imgRcnt
                }),
                imgpRef = cmnFunc.createDmNode({ node: "span", html: cmnFunc.initials(nodeObj.name), appendTo: imgRef }),
                empNm = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "empUsrNm" }], html: nodeObj.name, appendTo: imgLcnt }),
                emploc = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "empUsrLoc" }], appendTo: imgLcnt }),
                dlNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "clearfix empDLlist" }], appendTo: pNode }),
                anchrNode = cmnFunc.createDmNode({ node: "a", attr: [{ node: "class", value: "empAnchrLnk" }], html: l.viewProfile, appendTo: pNode });
            cmnFunc.addEventListeners({
                node: anchrNode,
                listener: "click",
                func: function () {
                    let qData = "?loc=" + cmnEvidences.loc + "&partyid=" + nodeObj.partyid;
                    window.location.replace(cmnlocDetails.partial_homefolder + "involvedemployees/index.html" + qData);

                }
            });
            for (let i = 0; i < userDt.length; i++) {
                let userObj = userDt[i];
                let pNode = cmnFunc.createDmNode({ node: "p", appendTo: dlNode });
                if (userObj.val == 'riskrating') {
                    let dt = parseInt(nodeObj[userObj.val] * 100);
                    nodeObj[userObj.val] = parseInt(dt) + "%";
                }
                cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "empdt" }], html: userObj.id + ":", appendTo: pNode });
                cmnFunc.createDmNode({ node: "span", html: nodeObj[userObj.val], appendTo: pNode });
            }
            if (nodeObj.role) {
                empLocDt.push(nodeObj.role);
            }
            if (nodeObj.city) {
                empLocDt.push(nodeObj.city);
            }
            if (nodeObj.state) {
                empLocDt.push(nodeObj.state);
            }
            if (empLocDt.length > 0) {
                emploc.html(empLocDt.join(", "));
            }

        }
    },
    empFldsCnstrct: function () {
        let refNode = $("#srchEmpFlds"),
            l = srchObj.lc;
        let refObj = {
            pNode: refNode,
            srcArr: [{
                outrCls: "form-group",
                html: l.employeeName,
                lblCls: "alsHdrFnt",
                inCls: "form-control inputTxt",
                inId: "empName",
                inplcHdr: l.srchNm
            }, {
                outrCls: "form-group",
                html: l.employeeId,
                inCls: "form-control inputTxt",
                lblCls: "alsHdrFnt",
                inId: "empId",
                inplcHdr: l.srchId
            }, {
                outrCls: "form-group",
                html: l.location,
                inCls: "form-control inputTxt",
                lblCls: "alsHdrFnt",
                inId: "empLocation",
                inplcHdr: l.srchLoc
            }]
        };
        srchObj.conAlrTypeDom(refObj);
    },
    roleCnstruct: function () {
        let refNd = $("#srchEmpRoleCnt"),
            l = srchObj.lc;
        let chkObj = {
            pNode: refNd,
            nodes: [{ id: "empTrdr", text: l.trader }, { id: "empBanker", text: l.banker }]
        };
        cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "alsHdrFnt" }], html: l.role, appendTo: refNd });
        srchObj.chkBoxCnt(chkObj);
    }

};
const comuSrchObj = {
    errorNode: "",
    voiceCommids: [],
    initEvents: function () {
        $.timepicker.datetimeRange(
            $("#ecommStrtDt"),
            $("#ecommEndDt"), {
                timeInput: true,
                timeFormat: 'HH:mm:ss',
                beforeShow: function (input, inst) {
                    $('#ui-datepicker-div').addClass("alrtDtpick");
                    $("#ecommStrtDt").datetimepicker("option", {
                        maxDate: new Date()
                    });
                }

            }
        );
        $('*[data-id="ecommStrtDt"]').on("click", function (evt) {
            evt.stopPropagation();
            $("#ecommStrtDt").datepicker("show");
        });
        // $("#ecommStrtDt").datepicker({
        //     beforeShow: function(input, inst) {
        //         $('#ui-datepicker-div').addClass("alrtDtpick");
        //     },

        //     onSelect: function(date) {
        //         $("#ecommEndDt").datepicker("option", "minDate", date);
        //     },
        //     maxDate: new Date()
        // });
        $('*[data-id="ecommEndDt"]').on("click", function (evt) {
            evt.stopPropagation();
            $("#ecommEndDt").datepicker("show");
        });
        // $("#ecommEndDt").datepicker({
        //     beforeShow: function(input, inst) {
        //         $('#ui-datepicker-div').addClass("alrtDtpick");
        //     },
        //     maxDate: new Date()
        // });
    },
    handleBulk: function (res) {
        $("#srchSIModal").remove();
        srchObj.loader.addClass("hide");
        let dNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "cfmDlg bulOrdr" }], appendTo: $("body") });

        if (res["archive_file_location"]) {
            let t = "<p>Voice archive saved at below location:-</p>" +
                "<p style='font-size:0.8em'>" + res["archive_file_location"] + "</p>";
            dNode.html(t);
            cmnFunc.stsdialog(dNode, { ref: comuSrchObj, func: "unChkEvidences" });
        } else {
            dNode.html("<p class=\"txtCaptcntr\">Error Occurred</p>");
            cmnFunc.stsdialog(dNode);
        }

    },
    unChkEvidences: function () {
        var arr = $.extend(true, [], comuSrchObj.voiceCommids);
        arr.forEach(function (i) {
            let n = $("#" + i);
            if ($(n).length > 0) {
                $(n).prop('checked', false).trigger("change");
            }

        });


    },
    radioGenerator: function (node) {
        let t = ["all", "audio", "transcript", "metadata", "analysis"];
        let optAllHldr = $("<div class=\"srchAllHldr\"></div>").appendTo(node);
        let optNodeHldr = $("<div class=\"srchoptMnuHldr\"></div>").appendTo(node);
        for (let i = 0; i < t.length; i++) {
            let div = $("<div class=\"srchChkbx\"></div>").appendTo(t[i] == "all" ? optAllHldr : optNodeHldr),
                lbl = $("<label></label>").appendTo(div),
                rdo = $("<input type=\"checkbox\" name=\"vctrnsc\" id='" + (t[i] + "_ref") + "'>").appendTo(lbl),
                txt = t[i];
            rdo.val(txt);
            rdo.after(txt.capitalize());
            $(rdo).on('click', function () {
                let id = $(this).attr('id');
                if (id == "all_ref") {
                    $("input[name=vctrnsc]").prop('checked', $(this).prop("checked"));
                }
            });
        }

    },
    init: function () {
        let cBtn, errorNode;
        comuSrchObj.chnlCnt($("#ecommChlCnt"));
        comuSrchObj.inputFlds($("#ecommEmpFlds"));
        comuSrchObj.emtionFlds($("#ecommEmotionCnt"), "ecommEmotion");
        comuSrchObj.conceptFlds($("#ecommConceptsCnt"), "ecommConcepts");
        comuSrchObj.classificationFlds($("#ecommClassCnt"), "ecommClass");
        cBtn = srchObj.btnCnstructor({ cntNode: $("#ecommBtnGrp"), pretxt: "ecomm" });
        comuSrchObj.voiceCnt($("#ecommChnlVcCnt"));
        $(cBtn.apply).on("click", function (evt) {
            evt.stopPropagation();
            comuSrchObj.submitFm(evt);
        });


        $("#chnlVcsort").on("change", function (evt) {
            evt.stopPropagation();
            let o = ($(this).val()).split(",");
            comuSrchObj.sortFldData(o[0], o[1]);
        });


        $("#exportVcBtn,#exportVcAllBtn").on("click", function (evt) {
            evt.stopPropagation();
            let btnNode = evt.target.id;
            let dNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "cfmDlg bulOrdr" }], appendTo: $("body") });
            let pDiv = $("<div class=\"rdoHdr\">Voice</div>").appendTo(dNode);
            let cDiv = $("<div class=\"srchkBxcntr\"></div>").appendTo(dNode);
            comuSrchObj.radioGenerator(cDiv);
            let temp, mdlRef = $("#srchSIModal");
            if (mdlRef.length > 0) {
                mdlRef.remove();
            }
            temp = $("<div id=\"srchSIModal\" class=\"modal\"><div class=\"modal-content\"><div class=\"model-contentHldr\"> <div class=\"clearfix\"><span class=\"search-si-close\">&times;</span></div>" +
                "<div id=\"srchExphdr\">Export Files</div><p id=\"srchSubExphdr\">Select the file formats you would like in our export.</p><div id=\"searchSITxtCntr\"></div></div><div id=\"srchExpBtnHldr\" class=\"clearfix\"><button id=\"srExpCmn\" class=\"priButton\">Export</button>" +
                "<button class=\"secButton\" id=\"srchExpCncl\">Cancel</button></div></div></div>");
            $(temp).appendTo($("body"));
            $(".search-si-close,#srchExpCncl").on("click", function (evt) {
                $("#srchSIModal").remove();
            });

            $("#searchSITxtCntr").html(dNode);
            $("#srchSIModal").css("display", "block");
            $("#srExpCmn").on("click", function () {
                srchObj.loader.removeClass("hide");
                let o = [],
                    chkRels = [];

                o = srchObj.srchSessionFlds["voiceCommids"]

                if ($("#all_ref").prop("checked")) {
                    chkRels.push("all");
                } else {
                    $.each($('input[name=vctrnsc]:checked'), function (index, node) {
                        chkRels.push($(node).val());
                    });
                }

                let dtObj = {
                    "exportoptions": chkRels,
                    "communicationids": o
                };

                let objRef = {
                    type: "POST",
                    url: cmnlocDetails.partial_hostname + "/SIFSVoiceDataService/voice/v1/bulk",
                    dataType: "json",
                    data: JSON.stringify(dtObj),
                    ref: comuSrchObj,
                    func: "handleBulk"
                };
                cmnAsync.asynccall(objRef);

            });




            //comuSrchObj.submitFm(evt);
        });
        $("#checkecomVoice").on("change", function (evt) {
            if ($(this).prop("checked")) {
                comuSrchObj.chkVoicefldsEnDis(false);
                // $("#ecommChnlVcCnt").removeClass("hide");
                // $("#ecommChnlVcCnt").slideDown();
                // $("#vcAdvSearch").removeClass("hide");
                //comuSrchObj.voiceCnt($("#ecommChnlVcCnt"));
            } else {

                comuSrchObj.chkVoicefldsEnDis(true);
                //  $("#ecommChnlVcCnt").slideUp();
                // $("#ecommChnlVcCnt").addClass("hide");<1
                //$("#vcAdvSearch").addClass("hide");
                // $('[data-id="ecommVoice"]').remove();
                // srchObj.srchSessionFlds.advSrch = null;
                //$("#advSrchQury").val("");
                //  $("#advClear").addClass("hidden");
                // comuSrchObj.submitFm();
            }
        });
        $(cBtn.clear).on("click", function (evt) {
            evt.stopPropagation();
            srchObj.clrErrorNode({ node: comuSrchObj.errorNode });
            srchObj.clearFlds("#commUlFldList");
            srchObj.srchSessionFlds.advSrch = null;
            $("#ecommChnlVcCnt").hide();
            $("#advSrchQury").val("");
            //$("#vcAdvSearch").addClass("hide");
            comuSrchObj.submitFm();
        });
        $("#advSrchQury").on("keydown", function () {
            if (this.value.length > 0) {
                $("#advClear").removeClass("hidden");
            } else {
                $("#advClear").addClass("hidden");
            }
        });
        $("#advClear").on("click", function (evt) {
            evt.stopPropagation();
            srchObj.clearFlds("#commUlFldList");
            srchObj.srchSessionFlds.advSrch = null;
            $("#advSrchQury").val("");
            $("#advClear").addClass("hidden");
            comuSrchObj.submitFm();
        });
        $("#advBtnsrch").on("click", function (evt) {
            evt.stopPropagation();
            //$("#advsrchTxtCntr").removeClass("hide");
            comuSrchObj.advSrch($("#advSrchQury").val());

        });
        // $("#advBtnsrch").on("click", function(evt) {
        //     evt.stopPropagation();
        //     $("#advsrchTxtCntr").addClass("hide");
        //     comuSrchObj.advSrch($("#advSrchQury").val());
        //     //$("#advSrchQury").val("");
        // });
        errorNode = cmnFunc.createDmNode({
            node: "p",
            attr: [{ node: "class", value: "highlighterRed" }, { node: "id", value: "ecommErrNode" }],
            html: ""
        });
        errorNode.insertBefore($("#commUlFldList"));
        comuSrchObj.errorNode = errorNode;
        $("#ecommSrchRcrSts").html("No records available.");


    },
    advSrch: function (d) {
        srchObj.clearFlds("#commUlFldList");
        $("#ecommSnFltr").html('');
        if (d == "") {
            srchObj.srchSessionFlds.advSrch = null;
            comuSrchObj.submitFm();
        } else {
            // srchObj.srchSessionFlds.checkecomVoice = true;
            srchObj.srchSessionFlds.advSrch = d;
            comuSrchObj.bQuery = "&q=" + d;
            comuSrchObj.dynAlrtSrchData();
        }

    },
    voiceCnt: function (node) {

        let l = srchObj.lc,
            refObj = {
                pNode: cmnFunc.createDmNode({ node: "div", attr: [{ node: "data-id", value: "ecommVoice" }, { node: "class", value: "hide" }], appendTo: node }),
                srcArr: [{
                    outrCls: "form-group",
                    html: "Login Name",
                    lblCls: "alsHdrFnt",
                    inCls: "form-control inputTxt",
                    inId: "ecomVcLgName",
                    inplcHdr: "Enter Login name"
                }, {
                    outrCls: "form-group",
                    html: "Phone",
                    inCls: "form-control inputTxt",
                    lblCls: "alsHdrFnt",
                    inId: "ecomVcPhone",
                    inplcHdr: "(+1)-XXX-XXX-XXXX"
                }, {
                    outrCls: "form-group",
                    html: "Extension",
                    inCls: "form-control inputTxt",
                    lblCls: "alsHdrFnt",
                    inId: "ecomVcExtension",
                    inplcHdr: "XXXXXXX"
                }, {
                    outrCls: "form-group",
                    html: "Device Id",
                    inCls: "form-control inputTxt",
                    lblCls: "alsHdrFnt",
                    inId: "ecomVcDevice",
                    inplcHdr: "Enter Device ID"
                }, {
                    outrCls: "form-group",
                    html: "Duration",
                    inCls: "form-control inputTxt hide",
                    lblCls: "alsHdrFnt",
                    inId: "ecommVlhdDur",
                    inplcHdr: "Select call Duration"
                }, {
                    outrCls: "form-group",
                    html: "Direction",
                    inCls: "form-control inputTxt hide",
                    lblCls: "alsHdrFnt",
                    inId: "ecommVlhdDir",
                    inplcHdr: "Enter To Phone No"
                }]
            },
            inDuration, inDirection, slDuration, slDirection, duOpt = [{
                val: "",
                html: "Select"
            }, {
                val: "[ 0 TO 59]",
                html: "< 1 Minute"
            }, {
                val: "[ 60 TO 299]",
                html: "1 Minute but < 5 Minutes"
            }, {
                val: "[ 299 TO 1799]",
                html: "5 Minutes but < 30 Minutes"
            }, {
                val: "[ 1800 TO 3599]",
                html: "30 Minutes but < 1 Hour"
            }, {
                val: "[ 3599 TO *]",
                html: "> 1 Hour"
            }],
            diOpt = [{
                val: "",
                html: "Select"
            }, {
                val: "Initiated",
                html: "Initiated"
            }, {
                val: "Received",
                html: "Received"
            }];
        srchObj.conAlrTypeDom(refObj);
        slDuration = $("<select class=\"form-control inputTxt\" data-id=\"ecommVlhdDur\"></select>");
        slDirection = $("<select class=\"form-control inputTxt\" data-id=\"ecommVlhdDir\"></select>");
        $("#ecommVlhdDur").after(slDuration);
        $("#ecommVlhdDir").after(slDirection);
        $.each(duOpt, function (index, value) {
            slDuration.append(
                $('<option></option>').val(value.val).html(value.html)
            );
        });
        $.each(diOpt, function (index, value) {
            slDirection.append(
                $('<option></option>').val(value.val).html(value.html)
            );
        });
        slDuration.on("change", function () {
            $("#ecommVlhdDur").val(this.value);
        });
        slDirection.on("change", function () {
            $("#ecommVlhdDir").val(this.value);
        });
        if ($("#checkecomVoice").prop("checked")) {
            comuSrchObj.chkVoicefldsEnDis(false);

        } else {
            comuSrchObj.chkVoicefldsEnDis(true);
        }


    },
    chkVoicefldsEnDis: function (flg) {
        if (flg) {
            $("#ecommChnlVcCnt").find('input:text, select')
                .each(function () {
                    $(this).prop('disabled', true);
                    $(this).addClass('disabled');
                    $(this).val('');
                });
        } else {
            $("#ecommChnlVcCnt").find('input:text, select')
                .each(function () {
                    $(this).prop('disabled', false);
                    $(this).removeClass('disabled');
                });
        }

    },
    submitFm: function (evt) {
        let commDtFlds, commChnlFlds, commempFlds, commEvdFlds, commVcFlds;
        commDtFlds = { start: "ecommStrtDt", end: "ecommEndDt" };
        commChnlFlds = [{ id: "checkecomEmail", val: "e-mail" }, { id: "checkecomVoice", val: "voice" }, { id: "checkecomChat", val: "chat" }];
        commempFlds = [{ id: "ecomEmpName", val: "comminitiatorname" }, { id: "ecomEmpId", val: "alertid" }, { id: "ecomEmpEntity", val: "entity" }, { id: "ecomLexId", val: "lexicon_ss" }];
        commEvdFlds = [{ id: "checkecommAnger", val: "anger" }, { id: "checkecommHappy", val: "joy" }, { id: "checkecommSad", val: "sad" },
        { id: "checkecommNegativity", val: "negative" }, { id: "checkecommPositivity", val: "positive" },
        { id: "checkecommRecruitVictims", val: "recruitvictims" },
        { id: "checkecommRecruitConspirators", val: "recruitconspirators" },
        { id: "checkecommConfidential", val: "confidential" }, { id: "checkecommNConfidential", val: "non-confidential" },
        { id: "checkecommPersonal", val: "personal" }, { id: "checkecommBusiness", val: "business" },
        { id: "checkecommPromotional", val: "promotional" },
        { id: "checkecommNews", val: "news" }, { id: "checkecommAnnouncement", val: "announcement" },
        { id: "checkecommTrading", val: "trading" }, { id: "checkecommNTrading", val: "non-trading" }
        ];
        if ($("#checkecomVoice").prop("checked")) {
            commVcFlds = [{ id: "ecomVcExtension", val: "personalextension" },
            { id: "ecomVcDevice", val: "deviceid" }, { id: "ecommVlhdDur", val: "callduration" }, { id: "ecommVlhdDir", val: "calldirection" }
            ];
            // $("#vcAdvSearch").removeClass("hide");
        }

        if (evt && evt.target) {
            srchObj.clrErrorNode({ node: comuSrchObj.errorNode });
            srchObj.srchSessionFlds.advSrch = null;
            $("#advSrchQury").val("");
            if (srchObj.dtValidator({ dt: commDtFlds, node: comuSrchObj.errorNode })) {
                comuSrchObj.frameQueryParams(commDtFlds, commempFlds, commEvdFlds, commChnlFlds, commVcFlds);
            }
        } else {
            if (srchObj.srchSessionFlds.advSrch) {
                return false;
            }
            srchObj.clrErrorNode({ node: comuSrchObj.errorNode });
            comuSrchObj.frameQueryParams(commDtFlds, commempFlds, commEvdFlds, commChnlFlds, commVcFlds, true);
        }
    },
    createStsNode: function (txt, pNode) {
        let s = cmnFunc.createDmNode({ node: "span", attr: [{ node: "class", value: "cmnStCnt" }], html: txt, appendTo: pNode });
    },
    createGroupStatusnodes: function (array, pNode) {

        $.each(array, function (index, node) {
            let r = "";
            node = node.replace("(", "");
            node = node.replace(")", "");
            node = node.split("OR");
            $.each(node, function (i, n) {
                r = n.split(":")[0];
                // comuSrchObj.createStsNode(r.capitalize(), pNode);

            });
        });
    },
    frameQueryParams: function (dFld, tFld, stFld, commChnlFlds, commVcFlds = undefined, clearFld = false) {
        comuSrchObj.bQuery = "";
        let statusCntr = $("#ecommSnFltr");
        statusCntr.html('');
        if (!clearFld) {
            srchObj.srchSessionFlds = {};
            srchObj.srchSessionFlds["voiceCommids"] = comuSrchObj.voiceCommids;
            srchObj.srchSessionFlds.advSrch = null;
        }


        let dtFld = srchObj.framedtObj(dFld.start, dFld.end),
            fldArr = srchObj.frameFldObj(tFld),
            chkArr = srchObj.frameChkObj(stFld),
            objRef, fldChnlFlds = srchObj.frameChkObj(commChnlFlds),
            fldTxt = ["doctype:comm"],
            chkTxt = "",
            vcFldArr;
        if (commVcFlds) {
            vcFldArr = srchObj.frameFldObj(commVcFlds);
            if (vcFldArr) {
                let arr = vcFldArr.split(" AND ");
                comuSrchObj.createGroupStatusnodes(arr, statusCntr);
            }
        }
        if (dtFld) {
            fldTxt.push("commstarttime:" + dtFld);
            comuSrchObj.createStsNode('Time Range', statusCntr);
        }
        if (commVcFlds) {
            let lgVal = $("#ecomVcLgName").val(),
                phone = $("#ecomVcPhone").val();
            if (lgVal) {
                srchObj.srchSessionFlds["ecomVcLgName"] = lgVal;
                comuSrchObj.createStsNode('Login name', statusCntr);
                fldTxt.push("(commparticipantscontact:" + lgVal + " OR " + "comminitiatorcontact :" + lgVal + ")");
            }
            if (phone) {
                phone = "" + phone;
                srchObj.srchSessionFlds["ecomVcPhone"] = phone;
                comuSrchObj.createStsNode('phone', statusCntr);
                fldTxt.push("(comminitiatorcontact:\"" + phone + "\" OR " + "commparticipantscontact :\"" + phone + "\" OR " + "phonenumber :\"" + phone + "\")");
            }
        }
        if (fldArr) {
            let r = "comminitiatorname:" + $("#ecomEmpName").val();
            fldArr = fldArr.replace(r, "(" + r + " OR " + "commparticipantsname:" + $("#ecomEmpName").val() + ")");
            fldTxt.push(fldArr);
            let arr = fldArr.split(" AND ");
            comuSrchObj.createGroupStatusnodes(arr, statusCntr);
        }
        if (vcFldArr) {
            fldTxt.push(vcFldArr);
        }
        if (chkArr) {
            let arr = chkArr.split(","),
                fstr;
            comuSrchObj.createGroupStatusnodes(arr, statusCntr);
            fstr = ("commtags:(" + '"' + arr.join('" OR "') + '"' + ")" + " OR " + "classification:(" + '"' + arr.join('" OR "') + '"' + ")");
            fldTxt.push("(" + fstr + ")");
        }
        if (fldChnlFlds) {

            let arr = fldChnlFlds.split(","),
                ind = arr.indexOf("voice");
            comuSrchObj.createGroupStatusnodes(arr, statusCntr);
            if (ind > -1) {
                let str = "(commchannel:(voice)";
                arr.splice(ind, 1);
                if (arr.length > 0) {
                    str = str + " OR " + "(commtype:(" + arr.join(" OR ") + "))";
                }
                fldTxt.push(str + ")");
            } else {
                fldTxt.push("commtype:" + "(" + fldChnlFlds.split(",").join(" OR ") + ")");
            }

        }
        //if ($("#ecomEmpId").val() == "") {
        // comuSrchObj.bQuery = "&q=" + (fldTxt.length > 0 ? fldTxt.join(" AND ") : "");
        // } else {
        //     comuSrchObj.bQuery = "&q=" + (fldTxt.length > 0 ? fldTxt.join(" AND ") : "");
        // }
        comuSrchObj.bQuery = "&q=" + (fldTxt.length > 0 ? fldTxt.join(" AND ") : "") + "&fq=((commtype:(e-mail OR chat)) OR commchannel:(voice))";
        comuSrchObj.dynAlrtSrchData();
    },
    asyncData: function (data) {
        comuSrchObj.dynTblData(data);
    },
    dynAlrtSrchData: function (objDt) {
        let obj = (objDt && objDt.response) ? objDt.response : objDt;
        if (comuSrchObj.sort) {
            obj.sort = {};
            obj.sort.param = comuSrchObj.sort.param;
            obj.sort.ord = comuSrchObj.sort.ord;
        }
        let qDt = comuSrchObj.bQuery + "&start=" + (obj && obj.start ? obj.start : 0) +
            "&rows=" + (obj && obj.rowsPerpage ? obj.rowsPerpage : 15) + "&sort=" + (obj && obj.sort ? obj.sort.param : "commstarttime") + (obj && obj.sort ? " " + obj.sort.ord : " desc");

        let srchQuery = srchObj.baseQuery,
            objRef = {
                type: "GET",
                url: encodeURI(srchQuery + qDt),
                dataType: "json",
                ref: obj && obj.ref ? obj.ref : comuSrchObj,
                func: obj && obj.func ? obj.func : "asyncData"
            };
        cmnAsync.asynccall(objRef);
    },
    sortFldData: function (p, o) {
        comuSrchObj.sort = { param: p, ord: o };
        comuSrchObj.dynAlrtSrchData({ sort: { param: p, ord: o } });

    },
    dynRowClick: function (obj) {
        let anchor, link, qData;
        dObj = $("#ecomEmpId").val();
        if (dObj != "") {
            let arr = obj.alertid,
                _index, evidenceDtls;
            _index = arr.indexOf(dObj);
            evidenceDtls = obj.alertevidenceids[_index].split(",");
            qData = "?alertid=" + obj.alertid[_index] + "&evidenceid=" + evidenceDtls[0] + "&partyid=" + obj.comminitiatorid[0];
        } else {
            if (obj.alertid && obj.commchannel.toLowerCase() != "voice") {
                evidenceDtls = obj.alertevidenceids ? obj.alertevidenceids[0].split(",") : undefined;
                qData = "?alertid=" + obj.alertid[0] + "&evidenceid=" + ((evidenceDtls != undefined) ? evidenceDtls[0] : 0) + "&partyid=" + obj.comminitiatorid;
            } else {
                qData = "?commid=" + obj.commid;
            }

        }

        if (obj.commtype && obj.commtype.toLowerCase() == "e-mail") {
            link = cmnlocDetails.partial_homefolder + "email/index.html" + qData + "&search=true";
        } else if (obj.commchannel && obj.commchannel.toLowerCase() == "voice") {
            link = cmnlocDetails.partial_homefolder + "voice/index.html" + qData + "&search=true";
        } else if (obj.commtype && obj.commtype.toLowerCase() == "chat") {
            link = cmnlocDetails.partial_homefolder + "chat/index.html" + qData + "&search=true";
        }

        if (link) {
            return link;
        } else {
            return false;
        }
    },
    dynTblData: function (obj) {
        comuSrchObj.voiceAllArray = [];
        let dtObj = obj.response,
            l = srchObj.lc;
        if (dtObj.docs.length > 0) {
            $("#ecommSrchRcrSts").addClass("hide");
            $("#commTblCnt").removeClass("hide");
            $("#chlTblCnt").removeClass("hide");
        } else {
            $("#chlTblCnt").addClass("hide");
            $("#comPgCmpnnt").addClass("hide");
            $("#ecommSrchRcrSts").removeClass("hide");
        }
        if (srchObj.srchSessionFlds.voiceCommids && srchObj.srchSessionFlds.voiceCommids.length > 0) {
            $("#exportVcBtn,#exportVcAllBtn").removeClass("disabled");
            $("#exportVcBtn,#exportVcAllBtn").prop("disabled", false);
        }
        new pagination({
            'node': "comPgCmpnnt",
            'recPerPg': 15,
            'tblId': "commRecTbl",
            'dataObj': {
                'response': dtObj
            },
            calbckObj: {
                'ref': comuSrchObj,
                'func': "dynAlrtSrchData"
            },
            'tblGentr': {
                'ref': comuSrchObj,
                'callbck': 'constChnlProfile'
            }
        });
    },
    constChnlProfile: function (data) {
        let d = data.docs,
            n = $("#commRecTbl"),
            flag = false;
        n.empty();
        $("#exportVcAllBtn").prop("disabled", true);
        $("#exportVcAllBtn").addClass("disabled");
        for (let i = 0; i < d.length; i++) {
            let oref = d[i],
                node;
            if (oref.commchannel == "voice") {
                if (!flag) {
                    $("#exportVcAllBtn").prop("disabled", false);
                    $("#exportVcAllBtn").removeClass("disabled");
                    flag = true;
                }
                node = comuSrchObj.crteVcSpec(oref, n);
            } else if (oref.commtype == "e-mail") {
                node = comuSrchObj.crteEmSpec(oref, n);
            } else if (oref.commtype == "chat") {
                node = comuSrchObj.crteChtSpec(oref, n);
            }
            $(node).on("click", function (evt) {
                evt.stopPropagation();
                let flg = comuSrchObj.dynRowClick(oref);
                if (flg) {
                    if (evt.target.className != "voiceInput") {
                        window.location = flg;
                    }
                }
            });
        }

    },
    crteChkBx: function (obj, node) {
        let value = false;
        if (srchObj.srchSessionFlds.voiceCommids && srchObj.srchSessionFlds.voiceCommids.indexOf(obj.commid) > -1) {
            value = true;
        }
        comuSrchObj.voiceAllArray.push(obj.commid);
        let chk = cmnFunc.createElemnt({
            node: "input",
            attr: [{ node: "type", value: "checkbox" },
            { node: "class", value: "voiceInput" },
            { node: "id", value: obj.commid }
            ],
            appendTo: node
        });
        $(chk).prop("checked", value);
        $(chk).on("change", function (evt) {
            evt.stopPropagation();
            if ($(this).prop("checked") && comuSrchObj.voiceCommids.indexOf(this.id) == -1) {
                comuSrchObj.voiceCommids.push(this.id);
            } else {
                $("#vslctAll").prop('checked', false);
                comuSrchObj.voiceCommids.splice(comuSrchObj.voiceCommids.indexOf(this.id), 1);
            }
            if (comuSrchObj.voiceCommids.length > 0) {
                $("#exportVcBtn").removeClass("disabled");
                $("#exportVcBtn").prop("disabled", false);
            } else {
                $("#exportVcBtn").addClass("disabled");
                $("#exportVcBtn").prop("disabled", true);
            }
            srchObj.srchSessionFlds["voiceCommids"] = comuSrchObj.voiceCommids;
        });
    },
    crteVcSpec: function (o, node) {
        let dt = parseInt(o["confidence_score"] * 100),
            initiObj, rcvrObj, partiObj,
            robj, temp = "<div class=\"row chnlRow\">" +
                "<div class=\"chnl-banr\"><span class=\"checkHldr\"></span><span class=\"chnl-cnt\">" + o.commchannel.capitalize() + "</span><span class=\"chnl-date\">" + srchObj.convertTimeDate(o.commstarttime) + "</span></div>" +
                "<div class=\"col-xs-4\"><div class=\"chl-nm\">" + o.comminitiatorname + "</div><div class=\"chl-desc\">" + o.description + "</div></div>" +
                "<div class=\"col-xs-4 chlInitiator\">" +
                "<dl><dt>Receiver</dt><dd class=\"chlvcRcr\"></dd><dt class=\"chmrt10\">Confidence Score</dt>" +
                "<dd class=\"chlvcScr\">" + parseInt(dt) + "%" + "</dd></dl >" +
                "</div>" +
                "<div class=\"col-xs-4 chlParticipants\"><dl><dt>Initiator</dt><dd class=\"chlvcIntr\"></dd><dt>Duration</dt><dd>" + o["callduration"] + (" sec") + "</dd></dl></div>" +
                "</div>";
        robj = $(temp).appendTo(node);
        comuSrchObj.crteChkBx(o, robj.find(".checkHldr")[0]);
        initiObj = $(robj.find(".chlvcIntr")[0]);
        rcvrObj = $(robj.find(".chlvcRcr")[0]);
        initiObj.append("<span>" + ((o.comminitiatorname != "") ? o.comminitiatorname : "NA") + "</span>");
        initiObj.append("<span>" + ((o.comminitiatorcontact != "") ? o.comminitiatorcontact : "NA") + "</span>");
        partiObj = (o.commparticipantsname && o.commparticipantsname.length > 0) ? o.commparticipantsname : [];
        if (partiObj.length > 0) {
            $.each(partiObj, function (index, node) {
                let div = $("<div></div>").appendTo(rcvrObj);
                $("<span>" + node + "</span>").appendTo(div);
                $("<span>" + o.commparticipantscontact[index] + "</span>").appendTo(div);
            });
        } else {
            rcvrObj.append("<span>NA</span>");
        }

        return robj;

    },
    crteEmSpec: function (o, node) {
        let robj, temp = "<div class=\"row chnlRow\">" +
            "<div class=\"chnl-banr\"><span class=\"chnl-cnt\">" + o.commtype.capitalize() + "</span><span class=\"chnl-date\">" + srchObj.convertTimeDate(o.commstarttime) + "</span></div>" +
            "<div class=\"col-xs-4\"><div class=\"chl-nm\">" + o.comminitiatorname + "</div><div class=\"chl-desc\">" + o.description + "</div></div>" +
            "<div class=\"col-xs-4 chlInitiator\">" +
            "<dl><dt>To</dt><dd class=\"chlvcRcr\">" + (o.commparticipantscontact ? o.commparticipantscontact.join('<br />') : "NA") + "</dd></dl>" +
            "</div>" +
            "<div class=\"col-xs-4 chlParticipants\"><dl><dt>From</dt><dd>" + o["comminitiatorcontact"] + "</dd></dl></div>" +
            "</div>";
        robj = $(temp).appendTo(node);
        return robj;
    },
    crteChtSpec: function (o, node) {
        let robj, temp = "<div class=\"row chnlRow\">" +
            "<div class=\"chnl-banr\"><span class=\"chnl-cnt\">" + o.commtype.capitalize() + "</span><span class=\"chnl-date\">" + srchObj.convertTimeDate(o.commstarttime) + "</span></div>" +
            "<div class=\"col-xs-4\"><div class=\"chl-nm\">" + o.comminitiatorname + "</div><div class=\"chl-desc\">" + o.description + "</div></div>" +
            "<div class=\"col-xs-4 chlInitiator\">" +
            "<dl><dt>Initiator</dt><dd class=\"chlvcRcr\">" + (o.comminitiatorcontact ? o.comminitiatorcontact : "NA") + "</dd></dl>" +
            "</div>" +
            "<div class=\"col-xs-4 chlParticipants\"><dl><dt>Participants</dt><dd>" + (o["commparticipantscontact"] ? o["commparticipantscontact"].join('<br />') : "NA") + "</dd></dl></div>" +
            "</div>";
        robj = $(temp).appendTo(node);
        return robj;
    },
    chnlCnt: function (node) {
        let l = srchObj.lc,
            chkObj = {
                pNode: node,
                nodes: [{ id: "ecomEmail", text: l.email }, { id: "ecomVoice", text: l.voice }, { id: "ecomChat", text: l.chat }]
            };
        cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "alsHdrFnt" }], html: l.channel, appendTo: node });
        srchObj.chkBoxCnt(chkObj);
    },
    inputFlds: function (node) {
        let l = srchObj.lc,
            refObj = {
                pNode: node,
                srcArr: [{
                    outrCls: "form-group",
                    html: l.employeeName,
                    lblCls: "alsHdrFnt",
                    inCls: "form-control inputTxt",
                    inId: "ecomEmpName",
                    inplcHdr: l.srchNm
                }, {
                    outrCls: "form-group",
                    html: l.entity,
                    inCls: "form-control inputTxt",
                    lblCls: "alsHdrFnt",
                    inId: "ecomEmpEntity",
                    inplcHdr: l.srchEntity
                }, {
                    outrCls: "form-group",
                    html: l.alertId,
                    inCls: "form-control inputTxt",
                    lblCls: "alsHdrFnt",
                    inId: "ecomEmpId",
                    inplcHdr: l.srchId
                }, {
                    outrCls: "form-group",
                    html: "Lexicon",
                    inCls: "form-control inputTxt",
                    lblCls: "alsHdrFnt",
                    inId: "ecomLexId",
                    inplcHdr: "Enter lexicon"
                }]
            };
        srchObj.conAlrTypeDom(refObj);
    },
    emtionFlds: function (node, dataNode) {
        let l = srchObj.lc,
            chkObj = {
                pNode: cmnFunc.createDmNode({ node: "div", attr: [{ node: "data-id", value: dataNode }, { node: "class", value: "hide" }], appendTo: node }),
                nodes: [{ id: "ecommAnger", text: l.anger },
                { id: "ecommHappy", text: l.happy },
                { id: "ecommSad", text: l.sad },
                { id: "ecommNegativity", text: l.negitivity },
                { id: "ecommPositivity", text: l.positivity }
                ]
            };
        srchObj.chkBoxCnt(chkObj);
    },
    conceptFlds: function (node, dataNode) {
        let l = srchObj.lc,
            chkObj = {
                pNode: cmnFunc.createDmNode({ node: "div", attr: [{ node: "data-id", value: dataNode }, { node: "class", value: "hide" }], appendTo: node }),
                nodes: [{ id: "ecommRecruitVictims", text: l.recruitVictim },
                { id: "ecommRecruitConspirators", text: l.recuitCosnpi }
                ]
            };
        srchObj.chkBoxCnt(chkObj);
    },
    classificationFlds: function (node, dataNode) {
        let l = srchObj.lc,
            chkObj = {
                pNode: cmnFunc.createDmNode({ node: "div", attr: [{ node: "data-id", value: dataNode }, { node: "class", value: "hide" }], appendTo: node }),
                nodes: [{ id: "ecommConfidential", text: l.confidential },
                { id: "ecommNConfidential", text: l.nonconfidential },
                { id: "ecommPersonal", text: l.personal },
                { id: "ecommBusiness", text: l.business },
                { id: "ecommPromotional", text: l.promotional },
                { id: "ecommNews", text: l.news },
                { id: "ecommAnnouncement", text: l.announcement },
                { id: "ecommTrading", text: l.trading },
                { id: "ecommNTrading", text: l.nonTrading }
                ]
            };
        srchObj.chkBoxCnt(chkObj);
    },
};
srchObj.fillLoc = function (d) {
    let s = [{ id: "si-adv-Alert", txt: d.alertSearchC }, { id: "si-adv-Employee", txt: d.empsearchC },
    { id: "si-adv-EcommSearch", txt: d.cmnSearchC }, { id: "alsTimRan", txt: d.timerange },
    { id: "alsTimRan", txt: d.timerange }, { id: "alrtLcstatus", txt: d.status }, { id: "ecomTimRan", txt: d.timerange },
    { id: "e-emtion", txt: d.emotion }, { id: "e-cncpts", txt: d.concepts }, { id: "e-classfctn", txt: d.classification }
    ],
        c = [{ id: "flterby", txt: d.filterby }, { id: "lclTo", txt: d.toTxt }],
        l = [{ id: "alsStrtDt", txt: d.startdt }, { id: "alsEndDt", txt: d.enddt }, { id: "ecommStrtDt", txt: d.startdt }, { id: "ecommEndDt", txt: d.enddt }];
    for (let i = 0; i < s.length; i++) {
        cmnFunc.fillIdNode(s[i]);
    }
    for (let i = 0; i < c.length; i++) {
        cmnFunc.fillClassNode(c[i]);
    }
    for (let i = 0; i < l.length; i++) {
        cmnFunc.fillLblNode(l[i]);
    }
}
srchObj.localeStr = function (data, l) {

    srchObj.lc = data;
    srchObj.fillLoc(data);
    srchObj.init();
    let objRef = {
        type: "GET",
        url: cmnlocDetails.alertOvrSrvc + "types",
        dataType: "json",
        func: "typeAhesdFtr",
        ref: srchObj
    };
    cmnAsync.asynccall(objRef);
}
$(document).ready(function () {
    cmnFunc.localeStr({ ref: srchObj, func: "localeStr" });
});