var frontrun = {};
frontrun.init = function(item) {
    let t = tradeDetail.tGraph;
    t.margin = { top: 50, right: 40, bottom: 100, left: 30 },
        t.brMargin = { top: 440, right: 40, bottom: 70, left: 30 },
        t.width = $("#tradeChrt").width() - t.margin.left - t.margin.right,
        t.height = 560 - t.margin.top - t.margin.bottom,
        t.brHeight = 560 - t.brMargin.top - t.brMargin.bottom;
    t.svg = d3.select("#tradeChrt").append("svg")
        .attr("width", t.width + t.margin.left + t.margin.right)
        .attr("height", t.height + t.margin.top + t.margin.bottom)
        .attr("viewBox", "0 0" + " " + t.width + " 560")
        .attr("preserveAspectRatio", "xMidYMid meet");
    t.tooldiv = d3.select("body").append("div")
        .attr("class", "svgtip")
        .style("opacity", 0);


    t.timeParser = d3.timeParse("%Y-%m-%dT%H:%M:%S");
    t.line = d3.line()
        .x(function(d) {
            return t.rangeX(d.date);
        })
        .y(function(d) {
            return t.rangeY(d.price);
        });
    t.line2 = d3.line()
        .x(function(d) {
            return t.rangebrX(d.date);
        })
        .y(function(d) {
            return t.rangebrY(d.price);
        });
    t.volume = d3.line()
        .x(function(d) { return t.rangeX(d.date); })
        .y(function(d) { return t.rangeVolumeY(d.volume); });
    frontrun.spoofRangeAxisConstruct(t);
    frontrun.dataGenerator(item);
}
frontrun.spoofRangeAxisConstruct = function(t) {
    t.rangeX = d3.scaleTime().range([0, t.width - t.margin.left]);
    t.rangeY = d3.scaleLinear().range([t.height, 30]);
    t.rangeVolumeY = d3.scaleLinear().range([t.height, 0]);
    t.rangeVolumebrY = d3.scaleLinear().range([t.brHeight, t.brHeight - 5]);
    t.rangebrY = d3.scaleLinear().range([t.brHeight, 0]);
    t.rangebrX = d3.scaleTime().range([0, t.width - t.margin.left]);

}
frontrun.dataGenerator = function(item) {
    let t = tradeDetail,
        objRef, qData = cmnFunc.getQueryParameters(),
        srcUrl;
    srcUrl = cmnlocDetails.partial_homefolder + "tradedetail/json/tradechart.json";
    objRef = {
        type: "GET",
        url: srcUrl,
        dataType: "json",
        ref: frontrun,
        func: "spoofingDataGraph"

    };
    cmnAsync.asynccall(objRef);
}
frontrun.spoofingDataGraph = function(res) {
    let t = tradeDetail.tGraph,
        data = [],
        mrktPrice, trArrow = [],
        dt = res;
    trLen = dt["tradeevidence"].length;
    mrktPrice = dt["tradesample"].length;
    for (let i = 0; i < mrktPrice; i++) {
        let o = {},
            mp = dt["tradesample"][i];

        o.date = new Date(mp.tsdate + " " + mp.tstime),
            o.dateTime = mp.tsdate + " " + mp.tstime,
            o.price = +mp.tsprice,
            o.volume = +mp.tsquantity

        data.push(o);
    }
    for (let i = 0; i < trLen; i++) {
        let tr = {},
            o = dt["tradeevidence"][i];
        tr.date = new Date(o.date + " " + o.time);
        tr.volume = +o.volume;
        tr.type = o.name;
        tr.price = +o.price;
        trArrow.push(tr);
    }
    t.tradeArrow = trArrow;
    t.data = data;
    frontrun.spoofingDomain(t);
}
frontrun.spoofingDomain = function(t) {
    t.rangeX.domain(d3.extent(t.data, function(d) { return d.date; }));
    t.rangeY.domain(d3.extent(t.data, function(d) { return d.price; }));
    t.rangeVolumeY.domain(d3.extent(t.data, function(d) { return +d.volume; }));
    t.rangebrX.domain(t.rangeX.domain());
    t.rangebrY.domain(t.rangeY.domain());
    tradeDetail.brush(t);
    tradeDetail.spoofingCnstrctGrpah(t);

}