/************************************************************************

Licensed Materials - Property of IBM

IBM Surveillance Insights for Financial Services

© Copyright IBM Corp. 2017

US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

************************************************************************/
const voiceCnt = {
    voiceCntDtObj: {},
    tagArr: []
};
voiceCnt.init = function(data, l) {
    let thisRef = voiceCnt.voiceCntDtObj,
        objRef;
    thisRef.qData = cmnFunc.getQueryParameters();
    if (thisRef.qData.alertid) {
        objRef = {
            type: "GET",
            url: cmnlocDetails.alertOvrSrvc + thisRef.qData.alertid + "/commevidences/" + thisRef.qData.evidenceid,
            dataType: "json",
            ref: voiceCnt,
            func: "initBdyDt"
        };
    } else {
        objRef = {
            type: "GET",
            url: cmnlocDetails.service + "/commservice/v1/communication/" + thisRef.qData.commid,
            dataType: "json",
            ref: voiceCnt,
            func: "initBdyDt"
        };
    }

    cmnAsync.asynccall(objRef);

    if (thisRef.qData.search) {
        header.init("headerNode");
        $(".brdCrumSec").addClass("brdAdvVoiceSec");
        $("body").addClass("srchTrue");

    } else {
        autoHeader.generate('mnuOverView', false);
    }



}
voiceCnt.evidenceDtls = function() {
    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.service + "/alertservice/v1/alert/getallriskentitymaster",
        dataType: "json",
        func: function(data) {
            if (data.status = 200) {
                voiceCnt.genEvidences(data);

            }

        }

    };
    cmnAsync.asynccall(objhdrRef);

}
voiceCnt.genEvidences = function(d) {
    let n = $("#vEvidenceSec"),
        r = d.riskindicator,
        lbl, sel, div, input, p, risk = voiceCnt.evidenceIndicators;

    n.empty();
    lbl = $("<label for='evidenceSelFld'>Evidence Type</label>");
    lbl.appendTo(n);
    sel = $("<select name=\"evidenceSelFld\" id=\"evidenceSelFld\" class=\"inputTxt\"></select>");
    sel.appendTo(n);
    $('<option>').val("").text("Select").appendTo(sel);
    for (let i = 0; i < r.length; i++) {
        let o = r[i];

        if ((risk.indexOf(o["riskindicatorid"])) == -1) {
            $('<option>').val(o["risk_lookup_code"]).text(o["risk_indicator_name"]).appendTo(sel);
        }

    }
    div = $("<div id=\"slidecontainer\" class=\"posrel\"></div>");
    $("<label for='myRange'>Risk Probability</label>").appendTo(div);
    input = $("<div class = \"slider\" id =\"myRange\"></div>");
    p = $("<p>Value: <span id = \"demo\">0</span></p>");
    $(sel).on("change", function() {
        if ($(this).val() == "") {
            $("#eviSelbtn").prop("disabled", true);
        } else {
            $("#eviSelbtn").prop("disabled", false);
        }
    });
    div.appendTo(n);
    input.appendTo(div);
    p.appendTo(div);
    let uiSlider = noUiSlider.create($('#myRange')[0], {
        start: 0,
        step: 1,
        connect: [true, false],
        range: {
            'min': 0,
            'max': 10
        }
    });

    uiSlider.on('change', function(d) {
        $("#demo").html((parseInt(d[0]) / 10));
    });

    //    document.getElementById("myRange").oninput = function() {
    //        $("#demo").html(this.value);
    //    }
}
voiceCnt.submitEvidences = function() {
    let resArr = [],
        e = voiceCnt.voiceCntDtObj.resObj,
        d = new Date();
    if (e.commparticipantsid) {
        for (let i = 0; i < e.commparticipantsid.length; i++) {
            let obj = { role: "participant", partyid: parseInt(e.commparticipantsid[i]) };
            resArr.push(obj);
        }
    }
    if (e.comminitiatorid) {
        resArr.push({ role: "primary", partyid: parseInt(e.comminitiatorid) });
    }

    let reqObj = {
        alert: {
            evidences: [{
                involvedparties: resArr,
                riskindicator: $("#evidenceSelFld").val(),
                riskscore: parseFloat($("#demo").html()),
                description: $("#evidenceSelFld option:selected").text(),
                commid: voiceCnt.voiceCntDtObj.commId,
                type: "Voice",
                timestamp: (d.getMonth() + 1) + "/" + d.getDate() + "/" + d.getFullYear() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds()
            }]
        }
    };
    let objhdrRef = {
        type: "POST",
        url: cmnlocDetails.service + "/alertservice/v1/alert/createEvidence",
        dataType: "json",
        data: JSON.stringify(reqObj),
        func: function(data) {
            if (data.status == 200) {
                $("#emlTypeCnt").append("<p>" + reqObj.alert.evidences[0]["description"] + "</p>")
                $("#evidenceSelFld option[value='" + $("#evidenceSelFld").val() + "']").remove();
                $("#eviSelbtn").prop("disabled", true);
            } else {
                alert(data.message);
            }

        }

    };
    cmnAsync.asynccall(objhdrRef);
}
voiceCnt.initBdyDt = function(obj) {

    if (obj.statusText && obj.statusText.toLowerCase() != "success") {
        $(".alrtContent").css("display", "none");
        cmnFunc.errorDialog();
        return;
    }
    if (Object.keys(obj).length == 0) {
        $(".alrtContent").css("display", "none");
        cmnFunc.errorDialog();
        return;
    }
    voiceCnt.voiceCntDtObj.commId = obj.communicationDetails.communicationId;

    voiceCnt.initEvnt();
    voiceCnt.createDtlCnt(obj, $("#emlDlCnt"));
    voiceCnt.initAnnotate(obj);
    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.modelService + "tag/alltags",
        dataType: "json",
        ref: cmnEvidences,
        func: "crTagFunc",
        params: {
            "commId": obj.communicationDetails.communicationId,
            "alertId": voiceCnt.voiceCntDtObj.qData.alertid
        }
    };
    cmnAsync.asynccall(objhdrRef);
    if (voiceCnt.voiceCntDtObj.qData.search) {
        voiceCnt.evidenceDtls();
    }

}

voiceCnt.removeAnnotate = function(n) {
    let objhdrRef, sel, objAnotate = {
        "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138,
        "entityjson": {
            "entitytypeid": "",
            "entitytext": ""
        }
    };
    sel = window.getSelection();
    if (sel.anchorNode == null) {
        alert("Please select annotation to remove");
    }
    let dsource = $(sel.anchorNode).parents("dd");
    let c;
    if (sel.anchorNode.nodeName == "SPAN") {
        c = $(sel.anchorNode).attr("class");
        objAnotate.entityjson.entitytext = sel.toString();
    } else {
        c = $(sel.anchorNode.parentElement).attr("class");
        if (sel.anchorNode.parentElement.nodeName == "SPAN" && c.search("sec") >= 0) {
            objAnotate.entityjson.entitytext = sel.toString();
        } else {
            alert("Please select Annotation");
            return false;
        }
    }


    let selLen = sel.toString();
    selLen = selLen.trim();

    objAnotate.entityjson.entitytypeid = c ? c.split("sec")[1] : null;

    objhdrRef = {
        type: "DELETE",
        url: cmnlocDetails.service + "/communicationservice/v1/communication/" + voiceCnt.voiceCntDtObj.commId + "/removecommunicationannotations/",
        dataType: "json",
        data: JSON.stringify(objAnotate),
        func: function(data) {
            if (data.status == 200 && data["annotation_removed"]) {
                let dsource = $(sel.anchorNode).parents("dd");
                let spnArray = dsource.find("span").map(function() {
                    let o = {};
                    o.text = $(this).text()
                    o.class = $(this).attr("class");
                    o.color = $(this).css('backgroundColor')
                    return o;
                }).get();
                let d = dsource.text();
                d = d.replace(/  +/g, ' ');
                let reg = new RegExp(objAnotate.entityjson.entitytext.trim(), "gi");
                let resStr = sel.toString();
                for (let i = 0; i < spnArray.length; i++) {

                    let reg = new RegExp(spnArray[i]["text"], "gi"),
                        nSpan;
                    if (spnArray[i]["class"] == c) {
                        d = d.replaceAll(reg, resStr);
                        continue;
                    }
                    nSpan = "<span class=\"&secCls\" style=\"background:&secBck\" onclick=\"voiceCnt.onSpanEvent(this)\">&inHtml</span>";
                    nSpan = nSpan.replace("&secCls", spnArray[i]["class"]);
                    nSpan = nSpan.replace("&secBck", spnArray[i]["color"]);
                    nSpan = nSpan.replace("&inHtml", spnArray[i]["text"]);
                    d = d.replaceAll(reg, nSpan);
                }

                dsource.html(d);


            } else {
                alert(data.message);
            }

        }

    };
    cmnAsync.asynccall(objhdrRef);
}
voiceCnt.sendAnnotate = function(n) {
    let id = n.attr("id"),
        txt = n.attr("data-txt"),
        colr = n.attr("data-color"),
        objhdrRef, sel, objAnotate = {
            "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138,
            "entityjson": {
                "entitytypeid": "",
                "entitytext": "",
                "entitytype": txt
            }
        };
    sel = window.getSelection();
    let selLen = sel.toString();
    selLen = selLen.trim();
    if (selLen.length > 0) {
        objAnotate.entityjson.entitytext = (sel.toString()).trim();
    } else {
        alert("Please select Text");
        return false;
    }
    objAnotate.entityjson.entitytypeid = id ? id.split("_")[1] : null;

    objhdrRef = {
        type: "POST",
        url: cmnlocDetails.service + "/communicationservice/v1/communication/" + voiceCnt.voiceCntDtObj.commId + "/createcommunicationannotations/",
        dataType: "json",
        data: JSON.stringify(objAnotate),
        func: function(data) {
            if (data.status == 200) {
                let dsource = $(sel.focusNode).parents("dd");
                let spnArray = dsource.find("span").map(function() {
                    let o = {};
                    o.text = $(this).text()
                    o.class = $(this).attr("class");
                    o.color = $(this).css('backgroundColor')
                    return o;
                }).get();
                let d = dsource.text();
                d = d.replace(/  +/g, ' ');
                let reg = new RegExp(objAnotate.entityjson.entitytext.trim(), "gi");
                let resStr = sel.toString();
                d = d.replaceAll(reg, "<span style=background:" + colr + " onclick=\"voiceCnt.onSpanEvent(this)\" class=sec" + objAnotate.entityjson.entitytypeid + ">" + resStr.trim() + "</span>");
                for (let i = 0; i < spnArray.length; i++) {
                    let reg = new RegExp(spnArray[i]["text"], "gi"),
                        nSpan;
                    nSpan = "<span class=\"&secCls\" style=\"background:&secBck\" onclick=\"voiceCnt.onSpanEvent(this)\">&inHtml</span>";
                    nSpan = nSpan.replace("&secCls", spnArray[i]["class"]);
                    nSpan = nSpan.replace("&secBck", spnArray[i]["color"]);
                    nSpan = nSpan.replace("&inHtml", spnArray[i]["text"]);
                    d = d.replaceAll(reg, nSpan);
                }

                dsource.html(d);

            } else {
                alert(data ? data.message : "No response");
            }

        }

    };
    cmnAsync.asynccall(objhdrRef);
}
voiceCnt.convertNotesDate = function(objdt) {
    var dt = new Date(objdt);
    var month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var date_str = "";
    var n = month[dt.getMonth()];
    date_str = n + " " + dt.getDate() + ", " + dt.getFullYear();
    let h = dt.getHours();
    let mi = dt.getMinutes();
    let t = (((h > 12) ? h - 12 : h) + ":" + ((mi > 9) ? mi : "0" + mi)) + " " + ((h >= 12) ? "pm" : "am");
    return date_str + " at " + t;
}
voiceCnt.annotateResult = function(data) {
    let node = $('#vc-annotList'),
        dNode, bNode;
    node.html(" ");
    node.removeClass("hide");
    dNode = cmnFunc.createDmNode({ node: "div", attr: [{ node: "class", value: "annotHldr" }], appendTo: node });
    for (let i = 0; i < data.length; i++) {
        let c = {},
            d = data[i];
        c.t = cmnFunc.createDmNode({
            node: "div",
            attr: [{
                node: "class",
                value: "radio"
            }],
            appendTo: dNode
        });
        c.l = cmnFunc.createDmNode({
            node: "label",
            attr: [{
                node: "class",
                value: "alsChkFnt"
            }],
            appendTo: c.t
        });
        c.in = cmnFunc.createElemnt({
            node: "input",
            attr: [{
                    node: "type",
                    value: "radio",
                }, {
                    node: "name",
                    value: "annotate",
                }, {
                    node: "id",
                    value: "anno_" + d.entitytypeid,
                },
                {
                    node: "data-txt",
                    value: d.entitytypename,
                }
            ],
            appendTo: c.l
        });
        c.l.append(d.entitytypename.capitalize());
    }
    bNode = cmnFunc.createDmNode({ node: "button", attr: [{ node: "class", value: "text-center vcBtn btn btn-info" }], html: "Add", appendTo: dNode });
    bNode.on("click", function() {
        let n = $('input[name=annotate]:checked'),
            id = n.attr("id"),
            txt = n.attr("data-txt"),
            objhdrRef, sel, objAnotate = {
                "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138,
                "entityjson": {
                    "entitytypeid": "",
                    "entitytext": "",
                    "entitytype": txt
                }
            };
        sel = window.getSelection();

        objAnotate.entityjson.entitytypeid = id ? id.split("_")[1] : null;
        objAnotate.entityjson.entitytext = sel.toString();
        objhdrRef = {
            type: "POST",
            url: cmnlocDetails.service + "/communicationservice/v1/communication/" + voiceCnt.voiceCntDtObj.commId + "/createcommunicationannotations/",
            dataType: "json",
            data: JSON.stringify(objAnotate),
            func: function(data) {

                dNode.remove();
            }

        };
        cmnAsync.asynccall(objhdrRef);

    });
}
voiceCnt.accorDtglMnu = function(evt) {
        let pNode = $(evt.target.parentNode),
            node = $(evt.target),
            n = $(node);
        if (n.hasClass("accrDwn")) {
            n.removeClass("accrDwn");
            n.addClass("accrUp");
            if ((pNode.parent()[0].id) == "vcAnnotations") {
                $("#vEvidenceSec").addClass("adjHght");
            }
            $("#" + pNode.parent()[0].id).find("[data-rcv='" + pNode.attr("data-src") + "']").addClass("hide");
        } else if (n.hasClass("accrUp")) {
            n.addClass("accrDwn");
            n.removeClass("accrUp");
            if ((pNode.parent()[0].id) == "vcAnnotations") {
                $("#vEvidenceSec").removeClass("adjHght");
            }
            $("#" + pNode.parent()[0].id).find("[data-rcv='" + pNode.attr("data-src") + "']").removeClass("hide");
        }

    },
    voiceCnt.initEvnt = function() {
        let alrt = voiceCnt.voiceCntDtObj.qData;
        $(".voiceTrsHdr li").on("click", function(node) {
            let id = $(this).attr("data-id");
            if (id == "voiceEntityHndlr") {
                voiceCnt.initAnnotate();
            }
            $(".voiceTxtCntr").addClass("hide");
            $(".voiceTrsHdr li").removeClass("highTab");
            $("#" + id).removeClass("hide");
            $(this).addClass("highTab");
        });
        $(".tglArwNode").on("click", function(evt) {
            evt.stopPropagation();
            voiceCnt.accorDtglMnu(evt);
        });
        $("#eviSelbtn").on("click", function(evt) {
            evt.stopPropagation();
            if ($("#evidenceSelFld").val() != "") {
                voiceCnt.submitEvidences();

            } else {
                alert("Please select Evidence type");
            }

        });

        $("#vc-annotate").on("click", function() {
            if (voiceCnt.annotation) {
                voiceCnt.annotateResult(voiceCnt.annotation);
            } else {
                voiceCnt.annotationApi({ ref: voiceCnt, func: "annotateResult" })
            }

        });





    }

voiceCnt.convertNotesTime = function(objtime) {
    var ampm = "am";
    if (parseInt(objtime.substr(0, 2)) < 12) {
        ampm = "AM";
    } else {
        ampm = "PM";
    }
    return objtime.substr(0, 5) + " " + ampm;
}
voiceCnt.removeUnwantedCharacters = function(d) {
    let email_str = d;
    if (email_str == undefined || email_str == "" || email_str == null) {
        return "";
    }
    email_str = email_str.replace(/\\n|\\r\\n|\\r/g, '<br/>');
    email_str = email_str.replace(/\\uFFFD/g, "'");
    return email_str;
}
voiceCnt.getAllKeyWords = function(obj) {

    let evidence_url = cmnlocDetails.service + "/surveillanceui/v1/index/search/fl=all_keywords,keywordtime_ss,commparticipantsid,comminitiatorid&indent=on&q=commid:" + obj.communicationDetails.communicationId + "%20AND%20doctype:comm&wt=json";
    let objBehEvidencedata = {
        type: "GET",
        url: evidence_url,
        dataType: "json",
        ref: voiceCnt,
        func: "showTranscript",
        params: obj
    };
    cmnAsync.asynccall(objBehEvidencedata);

}
voiceCnt.showTranscript = function(data, obj) {
    voiceCnt.voiceCntDtObj.keywords = (data.response.numFound > 0) ? (data.response.docs[0]["all_keywords"] ? data.response.docs[0]["all_keywords"] : []) : [];
    voiceCnt.voiceCntDtObj.keytime = (data.response.numFound > 0) ? (data.response.docs[0]["keywordtime_ss"] ? data.response.docs[0]["keywordtime_ss"] : []) : [];
    voiceCnt.voiceCntDtObj.resObj = (data.response.numFound > 0) ? data.response.docs[0] : [];

    let id = $("#voiceKeyHndlr"),
        d = voiceCnt.voiceCntDtObj.keywords,
        len = d.length,
        t = voiceCnt.voiceCntDtObj.keytime,
        dl = cmnFunc.createDmNode({ node: "dl", attr: [{ node: "class", value: "keyWrdlst emlDtLst  dl-horizontal" }], appendTo: id });

    for (let i = 0; i < d.length; i++) {
        let di = d[i],
            dd, dt, achr;
        achr = $("<p>" + ((t && t.length > 0) ? t[i] : (i + 1)) + "</p>");

        dt = cmnFunc.createDmNode({ node: "dt", attr: [{ node: "class", value: "keySpkr" }], html: achr, appendTo: dl });
        dd = cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "keySpeech" }], html: di, appendTo: dl });
    }
    let evidence_url = cmnlocDetails.partial_hostname + "/SIFSVoiceDataService/voice/v1/" + obj.communicationDetails.communicationId;
    let objBehEvidencedata = {
        type: "GET",
        url: evidence_url,
        dataType: "json",
        ref: voiceCnt,
        func: "genUtterences"
    };
    cmnAsync.asynccall(objBehEvidencedata);
}
voiceCnt.findKeywords = function(s) {
    let re = voiceCnt.genEntityData(s);
    let k = voiceCnt.voiceCntDtObj.keywords,
        len = k.length,
        r = null;
    for (let i = 0; i < k.length; i++) {
        let j = k[i].trim();
        if (re.toLowerCase().search(j.toLowerCase()) >= 0) {
            if (r == null) {
                r = re;
            }
            let searchMask = j;
            let regEx = new RegExp('(' + searchMask + ')', "ig");
            let replaceMask = j;
            r = r.replace(regEx, "<span class=\"txtHglt\">$1</span>");

        }
    }
    if (r == null) {
        r = re;
    }
    return r;
}
voiceCnt.genUtterences = function(d) {
    if (d.status && d.status != 200) {
        let j = JSON.parse(d.responseText);
        $("#voice-mainContainer").html(cmnFunc.createDmNode({ node: "dl", attr: [{ node: "class", value: "norecord" }], html: j.message }));
        return false;
    }
    voiceCnt.annotateSpchObj = d;
    let ref = $("#vcTransTxtHndlr"),
        dl = cmnFunc.createDmNode({ node: "dl", attr: [{ node: "class", value: "utrList emlDtLst  dl-horizontal" }], appendTo: ref }),
        data = d.transcript,
        len = data.length,
        alrt = voiceCnt.voiceCntDtObj.qData;
    voiceCnt.createVoiceCntDtl(d.audiourl);
    for (let i = 0; i < len; i++) {
        let da = data[i],
            dd, dt, spkr = (da.Speaker).split(" ");
        spkr[1] = parseInt(spkr[1]) + 1;
        dt = cmnFunc.createDmNode({
            node: "dt",
            attr: [{ node: "class", value: "utrSpkr" }],
            html: "<a href=\"#\">" + (spkr.join(" ")) + "</a>",
            appendTo: dl
        });

        dd = cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "utrSpeech" }], html: voiceCnt.findKeywords(da.Speech), appendTo: dl });
        dt.click(function(evt) {
            evt.preventDefault;
            voiceCnt.audioPlayer.setCurrentTime(da.starttime);

            if (voiceCnt.audioPlayer.pause) {
                voiceCnt.audioPlayer.play();
            }
        });
    }

    voiceCnt.voiceMetadata(d, $("#emlDlCnt"));

}
voiceCnt.createDtlCnt = function(obj, idNode) {
    let lc = voiceCnt.lc,
        alrt = voiceCnt.voiceCntDtObj.qData,
        objRef, pNobj, dtLstObj, adtldt, tagsArray, tagsElem, tglstObj = { node: "Tags", val: "tags", locstr: lc.tags },
        evType,
        lstArr = [{ node: "Date", val: "date", locstr: lc.date },
            { node: "ID", val: "partyid", locstr: lc.id },
            { node: "Type", val: "type", locstr: lc.type },
            { node: "Weight", val: "riskscore", locstr: lc.weight },
            { node: "Involved", val: "partyname", locstr: lc.involved },
            { node: "Mentioned", val: "mentioned", locstr: lc.mentioned }
        ],
        len = lstArr.length;
    obj.riskscore = Math.round(cmnFunc.roundScore(obj.riskscore)) + "%";
    objRef = obj;
    voiceCnt.evidenceIndicators = [];
    pNobj = cmnFunc.createDmNode({ node: "p", attr: [{ node: "class", value: "emlDesc" }], html: objRef.description, appendTo: idNode });
    dtLstObj = cmnFunc.createDmNode({ node: "dl", attr: [{ node: "class", value: "emlDtLst dl-horizontal" }], appendTo: idNode });
    let rpObj = cmnFunc.getQueryParameters();
    if (alrt.alertid) {
        for (let i = 0; i < len; i++) {
            let result = lstArr[i];
            cmnFunc.createDmNode({ node: "dt", attr: [{ node: "class", value: "emlDtLstdt" }], html: result.locstr + ":", appendTo: dtLstObj });
            if (result.val == "partyname") {
                let party_url = cmnlocDetails.partial_homefolder + "involvedemployees/index.html?alertid=" + rpObj.alertid + "&partyid=" + objRef["partyid"];
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: "<a href='" + party_url + "'>" + objRef[result.val] + "</a>", appendTo: dtLstObj });
            } else if (result.val == "date") {
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: voiceCnt.convertNotesDate(objRef[result.val]), appendTo: dtLstObj });
            } else if (result.val == "mentioned") {
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: voiceCnt.removeUnwantedCharacters(objRef[result.val]), appendTo: dtLstObj });
            } else {
                cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdd" }], html: objRef[result.val], appendTo: dtLstObj });
            }
        }


    }
    cmnFunc.createDmNode({ node: "dt", attr: [{ node: "class", value: "emlDtLstdt" }], html: "Evidence Type:", appendTo: dtLstObj });
    evType = cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdt" }, { node: "id", value: "emlTypeCnt" }], appendTo: dtLstObj });
    if (typeof obj.evidences !== "undefined") {
        for (let i = 0; i < obj.evidences.length; i++) {
            let e = obj.evidences[i];
            voiceCnt.evidenceIndicators.push(e.riskindicatorid);
            $("<p>" + e.riskindicator + "</p>").appendTo(evType);
        }
    }



    cmnFunc.createDmNode({ node: "dt", attr: [{ node: "class", value: "emlDtLstdt" }], html: tglstObj.locstr + ":", appendTo: dtLstObj });
    tagsElem = cmnFunc.createDmNode({ node: "dd", attr: [{ node: "class", value: "emlDtLstdt" }, { node: "id", value: "emlStsIdCnt" }], appendTo: dtLstObj });
    /**Tag Functionality**/
    // voiceCnt.voiceCntDtObj.tagArr=
    voiceCnt.tagArr = objRef.communicationDetails.tags ? objRef.communicationDetails.tags.tags : [];
    cmnEvidences.setTagArr(voiceCnt.tagArr);
    for (let i = 0; i < voiceCnt.tagArr.length; i++) {
        let div, spn;
        div = cmnFunc.createStatusNode();
        div.html(voiceCnt.tagArr[i]);
        div.removeClass("cmnStCnt");
        div.addClass("delTagNode");
        spn = cmnFunc.createDmNode({
            node: "span",
            attr: [{
                    node: "class",
                    value: "delTagNd"
                },
                {
                    node: "data-id",
                    value: voiceCnt.tagArr[i]
                }
            ],
            html: "&nbsp;",
            appendTo: div
        });
        cmnFunc.addEventListeners({
            node: spn,
            listener: "click",
            ref: cmnEvidences,
            func: "crDynTagRemoveNodes"
        });
        div.appendTo(tagsElem);
    }
    adtldt = cmnFunc.createDmNode({
        node: "div",
        attr: [{
            node: "class",
            value: "cmnStCnt tag-plus"
        }, {
            node: "id",
            value: "tagPlus"
        }],
        "html": '<span class="glyphicon glyphicon-plus"></span>',
        appendTo: tagsElem
    });

    cmnFunc.addEventListeners({
        node: adtldt,
        listener: "click",
        ref: cmnEvidences,
        func: "genTagsCnt"
    });

}
voiceCnt.formatPhoneNumber = function(n) {
    let r = n.split("-"),
        re = [],
        result;
    if (r.length == 1) {
        return n;
    }
    re[1] = "(" + r[1] + ")";
    re[0] = "+1 ";
    re[2] = r[2] + '-' + r[3];
    result = re.join(" ");
    return result;


}
voiceCnt.voiceMetadata = function(obj, idNode) {
        let hdrDt, vcCntr = $(idNode).after("<div id=\"voiceMetaContainer\"></div>"),
            node = $("#voiceMetaContainer"),
            d = obj.metadata,
            vobj = voiceCnt.voiceCntDtObj.resObj,
            dtLstObj, lstArr = [{
                    node: "Date",
                    val: voiceCnt.convertNotesDate(d.CallStartTimeStamp),
                    locstr: "Date"
                }, {
                    node: "Transcription Score",
                    val: parseInt(cmnFunc.roundScore(d["confidence_score"])) + "%",
                    locstr: "Confidence Score"
                }, {
                    node: "Duration",
                    val: (((new Date(d.CallEndTimeStamp).getTime()) - (new Date(d.CallStartTimeStamp).getTime())) / 1000) + " sec",
                    locstr: "Duration"
                }, {
                    node: "Initiator",
                    val: "riskscore",
                    locstr: "Initiator"
                }, {
                    node: "Receiver",
                    val: "partyname",
                    locstr: "Receiver"
                }

            ],
            len = lstArr.length;
        hdrDt = $(node).append("<h4 class=\"sdsecHdr\">Voice Meta Data</h4>");
        $(node).append("<span class=\"brdrline w100\">&nbsp;</span>");
        dtLstObj = cmnFunc.createDmNode({
            node: "dl",
            attr: [{
                node: "class",
                value: "emlDtLst mrgT30 dl-horizontal"
            }],
            appendTo: node
        });
        for (let i = 0; i < len; i++) {
            let result = lstArr[i];
            cmnFunc.createDmNode({
                node: "dt",
                attr: [{
                    node: "class",
                    value: "emlDtLstdt"
                }],
                html: result.locstr + ":",
                appendTo: dtLstObj
            });
            if (result.node == "Receiver") {
                let dd = cmnFunc.createDmNode({
                    node: "dd",
                    attr: [{
                        node: "class",
                        value: "emlDtLstdd"
                    }],
                    html: "",
                    appendTo: dtLstObj
                });
                let p = d.Participants,
                    plen = p.length;
                if (plen > 0) {
                    for (let i = 0; i < plen; i++) {

                        let r = p[i],
                            party_url, dmNode,
                            d = cmnFunc.createDmNode({
                                node: "div",
                                attr: [{
                                    node: "class",
                                    value: ""
                                }],
                                appendTo: dd
                            });

                        //d.append("<p><span class=\"glyphicon glyphicon-user mrgr10\"></span>" + r.Name + "</p>");
                        if (r.partyId) {
                            party_url = cmnlocDetails.partial_homefolder + "involvedemployees/index.html?&partyid=" + r.partyId;
                            dmNode = "<a href='" + party_url + "'><span class=\"glyphicon glyphicon-user mrgr10\"></span>" + r.Name.capitalize() + "</a>";
                        } else {
                            dmNode = "<p><span class=\"glyphicon glyphicon-user mrgr10\"></span>" + r.Name.capitalize() + "</p>";
                        }

                        d.append(dmNode);
                        if (r.ContactID && r.ContactID != "null") {
                            d.append("<p><span class=\"glyphicon glyphicon-earphone mrgr10\"></span>" + voiceCnt.formatPhoneNumber(r.ContactID) + "</p>");
                        }


                    }
                } else {
                    dd.append("<p>N/A</p>");
                }

            } else if (result.node == "Initiator") {
                let dd = cmnFunc.createDmNode({
                        node: "dd",
                        attr: [{
                            node: "class",
                            value: "emlDtLstdd"
                        }],
                        html: "",
                        appendTo: dtLstObj
                    }),
                    party_url;
                if (d.Initiator.partyId) {
                    party_url = cmnlocDetails.partial_homefolder + "involvedemployees/index.html?&partyid=" + d.Initiator.partyId;
                    dd.append("<a href='" + party_url + "'><span class=\"glyphicon glyphicon-user mrgr10\"></span>" + d.Initiator.Name.capitalize() + "</a>");
                } else {
                    dd.append("<p><span class=\"glyphicon glyphicon-user mrgr10\"></span>" + d.Initiator.Name.capitalize() + "</p>");
                }
                if (d.Initiator.ContactID) {
                    dd.append("<p><span class=\"glyphicon glyphicon-earphone mrgr10\"></span>" + voiceCnt.formatPhoneNumber(d.Initiator.ContactID) + "</p>");
                }


            } else {
                cmnFunc.createDmNode({
                    node: "dd",
                    attr: [{
                        node: "class",
                        value: "emlDtLstdd"
                    }],
                    html: result.val,
                    appendTo: dtLstObj
                });
            }
        }
    }
    /**Tag Functionality**/
voiceCnt.createVoiceCntDtl = function(obj) {


    function base64Encode(str) {
        var CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
        var out = "",
            i = 0,
            len = str.length,
            c1, c2, c3;
        while (i < len) {
            c1 = str.charCodeAt(i++) & 0xff;
            if (i == len) {
                out += CHARS.charAt(c1 >> 2);
                out += CHARS.charAt((c1 & 0x3) << 4);
                out += "==";
                break;
            }
            c2 = str.charCodeAt(i++);
            if (i == len) {
                out += CHARS.charAt(c1 >> 2);
                out += CHARS.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
                out += CHARS.charAt((c2 & 0xF) << 2);
                out += "=";
                break;
            }
            c3 = str.charCodeAt(i++);
            out += CHARS.charAt(c1 >> 2);
            out += CHARS.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
            out += CHARS.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6));
            out += CHARS.charAt(c3 & 0x3F);
        }
        return out;
    }

    $.ajax({
        url: cmnlocDetails.partial_hostname + obj,
        mimeType: "text/plain; charset=x-user-defined"
    }).done(function(res) {
        voiceCnt.srcUrl = 'data:audio/wav;base64,' + base64Encode(res);
        voiceCnt.createAudioPlayer(voiceCnt.srcUrl);
    });
}
voiceCnt.createAudioPlayer = function(audio) {
    let wavesurfer = WaveSurfer.create({
        container: '#audio-player',
        waveColor: '#6E32C9',
        progressColor: 'purple'
    });
    wavesurfer.load(audio);
    $("#vcPlyBtn").on("click", function(evt) {
        evt.stopPropagation();
        $("#vcPauseBtn").removeClass("hide");
        $("#vcPlyBtn").addClass("hide");
        wavesurfer.playPause();

    });
    $("#vcPauseBtn").on("click", function(evt) {
        evt.stopPropagation();
        wavesurfer.playPause();
        $("#vcPauseBtn").addClass("hide");
        $("#vcPlyBtn").removeClass("hide");
    });
    $("#vcRwdBtn").on("click", function(evt) {
        evt.stopPropagation();
        let p = wavesurfer.getCurrentTime();
        wavesurfer.skip(((p - 3) > 3) ? -3 : 0);
    });
    wavesurfer.on("ready", function() {
        $(".loadHide").removeClass("hide");
    });
    wavesurfer.on("waveform-ready", function() {
        $(".loadHide").removeClass("hide");
    });
    wavesurfer.on("audioprocess", function() {
        let timeleft, timeline, s, m, duration, currentTime, tl, ts, tm;
        /**current time**/
        timeline = document.getElementById('duration_time');
        s = parseInt((wavesurfer.getCurrentTime()) % 60);
        m = parseInt(((wavesurfer.getCurrentTime()) / 60) % 60);
        if (timeline != null && timeline != undefined) {
            if (s < 10) {
                timeline.innerHTML = m + ':0' + s;
            } else {
                timeline.innerHTML = m + ':' + s;
            }
        }
        /**Time left**/
        timeleft = document.getElementById('timeleft');
        duration = parseInt(wavesurfer.getDuration());
        currentTime = parseInt(wavesurfer.getCurrentTime());
        tl = duration - currentTime;
        ts = tl % 60;
        tm = Math.floor(tl / 60) % 60;
        ts = ts < 10 ? "0" + ts : ts;
        tm = tm < 10 ? tm : tm;
        if (isNaN(tm) == false && isNaN(ts) == false) {
            timeleft.innerHTML = tm + ":" + ts;
        } else {
            return true;
        }

    });

    // voiceCnt.audioPlayer = new WaveSurfer.create(audio, {
    //     alwaysShowControls: true,
    //     features: ['playpause', 'progress', 'volume'],
    //     audioVolume: 'horizontal',
    //     audioHeight: 70,
    //     iPadUseNativeControls: true,
    //     iPhoneUseNativeControls: true,
    //     AndroidUseNativeControls: true,
    //     success: function(media, domElement, player) {
    //         // Countup
    //         media.addEventListener("loadedmetadata", function() {
    //             console.log('mediaElement.duration:' + media.duration);
    //         });
    //         media.addEventListener("timeupdate", function() {
    //             let timeleft, timeline, s, m, duration, currentTime, tl, ts, tm;
    //             /**current time**/

    //             timeline = document.getElementById('duration');
    //             s = parseInt(media.currentTime % 60);
    //             m = parseInt((media.currentTime / 60) % 60);
    //             if (timeline != null && timeline != undefined) {
    //                 if (s < 10) {
    //                     timeline.innerHTML = m + ':0' + s;
    //                 } else {
    //                     timeline.innerHTML = m + ':' + s;
    //                 }
    //             }
    //             /**Time left**/
    //             timeleft = document.getElementById('timeleft');
    //             duration = parseInt(media.duration);
    //             currentTime = parseInt(media.currentTime);
    //             tl = duration - currentTime;
    //             ts = tl % 60;
    //             tm = Math.floor(tl / 60) % 60;
    //             ts = ts < 10 ? "0" + ts : ts;
    //             tm = tm < 10 ? tm : tm;
    //             if (isNaN(tm) == false && isNaN(ts) == false) {
    //                 timeleft.innerHTML = tm + ":" + ts;
    //             } else {
    //                 return true;
    //             }
    //         }, false);
    //     },
    //     error: function(mediaElement, originalNode, instance) {
    //         var info = document.getElementById("info");
    //         info.innerHTML = "No Audio Found";
    //     }
    // });
}
voiceCnt.initLocaleStr = function(data, l) {
    voiceCnt.lc = data;
    voiceCnt.fillLoc(data);
    voiceCnt.init(data, l);
}
voiceCnt.fillLoc = function(d) {
    let s = [{ id: "voicedtltxt", txt: d.details }, { id: "voiceTscriptTxt", txt: d.vcetranscript }];
    for (let i = 0; i < s.length; i++) {
        cmnFunc.fillIdNode(s[i]);
    }
}
voiceCnt.editCmpltToggle = function(t) {
    let vc = $("#vcEvidences"),
        ra = $("#rmvAnnot");
    if (t) {
        vc.addClass("vcDisNone");
        ra.addClass("vcDisNone");
    } else {
        vc.removeClass("vcDisNone");
        ra.removeClass("vcDisNone");
    }
}
voiceCnt.createEditBtn = function() {
    $(".vsStatsHdrBtn").remove();
    voiceCnt.editCmpltToggle(false);
    let b = $("<button class='vsStatsHdrBtn priButton'>Edit</button>");
    $(".backLinkBtn").after(b);
    $(b).on("click", function() {
        let objhdrRef = {
            type: "POST",
            url: cmnlocDetails.service + "/communicationservice/v1/communication/" + voiceCnt.voiceCntDtObj.commId + "/createreviewlock/",
            dataType: "json",
            data: JSON.stringify({
                "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138
            }),
            func: function(data) {
                if (data["review_lock_created"]) {
                    voiceCnt.editStatus = true;
                    voiceCnt.createCompleteBtn();
                    voiceCnt.btndisEnable(false);
                } else {
                    alert(data.message);
                }

            }

        };
        cmnAsync.asynccall(objhdrRef);
    });

}
voiceCnt.btndisEnable = function(val) {
    $(".vcAntBtn").prop("disabled", val);
    voiceCnt.editCmpltToggle(!val);
}
voiceCnt.createCompleteBtn = function() {
    $(".vsStatsHdrBtn").remove();
    voiceCnt.editCmpltToggle(true);
    let b = $("<button class='vsStatsHdrBtn priButton'>Finish Editing</button>");
    $(".backLinkBtn").after(b);
    $(b).on("click", function() {
        let objhdrRef = {
            type: "POST",
            url: cmnlocDetails.service + "/communicationservice/v1/communication/" + voiceCnt.voiceCntDtObj.commId + "/updatereviewstatus/",
            dataType: "json",
            data: JSON.stringify({
                "reviewerid": cmnFunc.getCookie("id") ? cmnFunc.getCookie("id") : 10138,
                "reviewstatus": 1
            }),
            func: function(data) {
                if (data["review_lock_updated"]) {
                    voiceCnt.createEditBtn();
                    voiceCnt.editStatus = false;
                    voiceCnt.btndisEnable(true);

                } else {
                    alert(data);
                }

            }

        };
        cmnAsync.asynccall(objhdrRef);

    });
}
voiceCnt.initAnnotate = function(obj) {
    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.service + "/communicationservice/v1/communication/" + voiceCnt.voiceCntDtObj.commId + "/getallcommunicationedits/",
        dataType: "json",
        func: function(d) {

            if (voiceCnt.voiceCntDtObj.qData.search) {
                if (d.communication && d.communication.reviewstatus == 0 && (cmnFunc.getCookie("id") == d.communication.reviewerid)) {
                    voiceCnt.createCompleteBtn();
                    voiceCnt.annotationApi(false);
                } else {
                    voiceCnt.createEditBtn();
                    voiceCnt.annotationApi(true);
                }
            } else {
                voiceCnt.annotationApi(true);
            }
            voiceCnt.annotationEvObj = d;
            voiceCnt.getAllKeyWords(obj);

        }

    };
    cmnAsync.asynccall(objhdrRef);
}
voiceCnt.onSpanEvent = function(el) {
    var sel = window.getSelection(),
        range;
    window.setTimeout(function() {
        range = document.createRange(); //range object
        range.selectNodeContents(el); //sets Range
        sel.removeAllRanges(); //remove all ranges from selection
        sel.addRange(range); //add Range to a Selection.
    }, 1);
}
voiceCnt.genEntityData = function(s) {
    let k = voiceCnt.annotationEvObj.communication.entityjson ? voiceCnt.annotationEvObj.communication.entityjson.annotations : "",
        len = k.length,
        r = null;


    for (let i = 0; i < k.length; i++) {
        let t = k[i],
            c, bck, nSpan;
        t.entitytext = t.entitytext.trim();
        if (s.toLowerCase().search(t.entitytext.toLowerCase()) >= 0 && t.entitytext.trim() != "") {
            if (r == null) {
                r = s;
            }
            nSpan = "<span class=\"&secCls\" style=\"background:&secBck\" onclick=\"voiceCnt.onSpanEvent(this)\">&inHtml</span>";
            nSpan = nSpan.replace("&secCls", "sec" + t.entitytypeid);
            nSpan = nSpan.replace("&secBck", t.entitycolorcode);

            let searchMask = t.entitytext;
            let regEx = new RegExp('(' + searchMask + ')', "ig");
            let replaceMask = t.entitytext;
            nSpan = nSpan.replace("&inHtml", "$1");
            r = r.replace(regEx, nSpan);
            // r = r.replaceAll(t.entitytext.trim(), nSpan);
        }
    }
    if (r == null) {
        r = s;
    }
    return r;
}
voiceCnt.genAnntLegend = function(flag) {
    let o = voiceCnt.annotation,
        node = $("#vcAnnotBtns");
    node.empty();

    for (let i = 0; i < o.length; i++) {
        let r = o[i],
            b, s;
        b = $("<button class='vcAntBtn'></button>");
        b.appendTo(node);
        s = $("<span class='vcBtnSec'></span>");
        s.appendTo(b);
        s.html((r.entitytypename.capitalize()).replace(/([A-Z])/g, ' $1').trim());
        b.attr("id", "vc_" + r.entitytypeid);
        b.attr("data-txt", r.entitydesc);
        b.attr("data-color", r.entitycolorcode);
        b.css("background", r.entitycolorcode);
        b.css("color", cmnFunc.HSLColorContrast(r.entitycolorcode));


        $(b).on("click", function(evt) {
            evt.stopPropagation();
            voiceCnt.sendAnnotate($(this));
        });

    }
    let b = $("<button class='vcAntBtn secButton' id='rmvAnnot'></button>");
    b.appendTo(node);
    b.html("Remove Annotation");

    $(b).on("click", function(evt) {
        evt.stopPropagation();
        voiceCnt.removeAnnotate($(this));
    });
    voiceCnt.btndisEnable(flag);


}
voiceCnt.annotationApi = function(o) {
    let objhdrRef = {
        type: "GET",
        url: cmnlocDetails.service + "/alertservice/v1/alert/allentitytypes",
        dataType: "json",
        func: function(data) {
            voiceCnt.annotation = data;
            voiceCnt.genAnntLegend(o);


        }

    };
    cmnAsync.asynccall(objhdrRef);
}
$(document).ready(function() {
    cmnFunc.localeStr({ ref: voiceCnt, func: "initLocaleStr" });
});